var accountListTable;
var deviceListTable;

$(document).ready(function () {

    $("#menu_a_account").css("color", "orangered");
    $("#menu_span_account").css("color", "orangered");
    $("#menu_icon_account").css("color", "orangered");

    checkLoginCookie();
    btAddAccount();
    deleteUserClickListener();
    btAccountEditClickListener();
    btEditUserApply();
    confirmNewPassword();
    $('.collapse').collapse();

    accountListTable = $('#table-account-list').DataTable({
        responsive: true,
        // "paging": false,
        // "ordering": true,
        // "info": true
    });

    deviceListTable = $('#table-device-list').DataTable({
        responsive: true,
        // "paging": false,
        // "ordering": true,
        // "info": true
    });
    getUserRole();
    getAccountList();
});

/**
 * Get user info
 */
function getUserRole() {

    var userId = readCookie(COOKIE_USER_INFO);

    $.ajax({
        url: dbServerInfo.ip + "/api/user_info/" + userId,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            if (returnData.result.toUpperCase() != "OK") {
                $("#panel_create_account").hide();
                $("#panel_account_list").hide();
                $("#panel_device_permission").hide();
            } else {
                //check role is Administrator or not, 1:Administrator, 2:Member
                if (returnData.role != 1) {
                    $("#panel_create_account").hide();
                    $("#panel_account_list").hide();
                    $("#panel_device_permission").hide();
                } else {
                    $("#panel_create_account").show();
                    $("#panel_account_list").show();
                }
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
        }
    });
}

/**
 *  Get Account List
 */
function getAccountList() {

    accountListTable.clear().draw();

    $.ajax({
        url: dbServerInfo.ip + "/api/user_list",
        type: "GET",
        dataType: 'json',
        success: function (data) {

            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
                console.log("feedback =  " + data.message[0].account);
            }

            var jsonArrayIndex = 0;

            var select_account_list = "";

            $('#select_account_list').find('option').remove();

            if (data.result != "OK") {
                //    showErrorToast(obj.message);
            } else {
                //  showSuccessToast(obj.message);
                for (jsonArrayIndex = 0; jsonArrayIndex < data.message.length; jsonArrayIndex++) {

                    //for account list table
                    var account_table_row = "<tr   style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\">" +
                        "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + data.message[jsonArrayIndex].id + "</td>" +
                        "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + data.message[jsonArrayIndex].account + "</td>" +
                        "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + getRoleName(data.message[jsonArrayIndex].role) + "</td>" +
                        "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + data.message[jsonArrayIndex].email + "</td>" +
                        "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + data.message[jsonArrayIndex].date + "</td>" +
                        "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">  <button  type=\"button\" data-id=\"" + data.message[jsonArrayIndex].id + "\" class=\"btn btn-primary bt-account-edit\" title=\"Edit\">" +
                        "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>" +
                        "  </button></td>";

                    if (data.message[jsonArrayIndex].id > 1) {
                        account_table_row = account_table_row + "<td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\"><button data-id=\"" + data.message[jsonArrayIndex].id + "\" type=\"button\"  class=\"btn  bt-delete\" title=\"Delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\">" +
                            "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>" +
                            "                </button></td></tr>";
                    } else {
                        //remain person id = 1 forever
                        account_table_row = account_table_row + "<td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\"></td></tr>";
                    }
                    accountListTable.row.add($(account_table_row)).draw();

                    //for device permission to use account list
                    if (data.message[jsonArrayIndex].role > 1) {
                        select_account_list = select_account_list + "<option value=" + data.message[jsonArrayIndex].id + ">" + data.message[jsonArrayIndex].account + "</option>";
                    }
                }

                $("#select_account_list").append(select_account_list);

              //  getAllDeviceByUserPermission($("#select_account_list").val());

            }


        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ", thrownError);
            }
            showErrorToast("Get account list failed !");
        }
    });
}

/**
 * Account edit click listener
 */
function btAccountEditClickListener() {
    $("body").on("click", ".bt-account-edit", function () {
        if (isDebugMode) {
            console.log("id = " + $(this).attr("data-id"));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/user_info/" + $(this).attr("data-id"),
            type: "GET",
            crossDomain: true,
            dataType: 'json',
            success: function (returnData) {
                if (isDebugMode) {
                    console.log("success" + JSON.stringify(returnData));
                }
                if (returnData.result.toUpperCase() != "OK") {
                    showErrorToast("Get account info failed !");
                } else {
                    if(returnData.id > 1){
                        $('#select_account_role_modal option').each(function(){
                          //  $('option').each(function() {
                                if(!this.selected) {
                                    $(this).attr('disabled', false);
                                }
                           // });
                        });
                    }else{
                        $('#select_account_role_modal option').each(function(){
                         //   $('option').each(function() {
                                if(!this.selected) {
                                    $(this).attr('disabled', true);
                                }
                          //  });
                        });
                    }
                    $("#modify-account-modal-title").text("Edit - " + returnData.account);
                    $("#input-add-account-modal").val(returnData.account);
                    $("#input-add-mail-modal").val(returnData.email);
                    //1: administrator, 2: Member
                    if (returnData.role > 1) {
                        $("#select_account_role_modal").val(2);
                    } else {
                        $("#select_account_role_modal").val(1);
                    }
                    $("#bt-account-edit-apply").attr("data-id", returnData.id);
                    $("#modify-account-modal").modal("show");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error");
                    console.log(xhr.status);
                    console.log(thrownError);
                }
            }
        });

    });
}

//add account
function btAddAccount() {

    $("#btn-add-account").click(function () {


        if ($("#input-add-account").val().length > 0) {

        } else {
            showErrorToast("Account can't be empty !");
            return;
        }

        if ($("#input-add-pw").val().length > 0) {

        } else {
            showErrorToast("Password can't be empty !");
            return;
        }

        if ($("#input-add-email").val().length > 0) {

        } else {
            showErrorToast("Email can't be empty !");
            return;
        }


        if (isEmail($("#input-add-email").val())) {

        } else {
            showErrorToast("Email format error !");
            return;
        }

        var post_data = "account=" + $("#input-add-account").val() + "&pw=" + $("#input-add-pw").val() + "&role=" + $("#select_account_role_create").val() + "&email=" + $("#input-add-email").val();

        $.ajax({
            url: dbServerInfo.ip + "/api/add_user",
            data: post_data,
            type: "POST",
            success: function (data) {
                if (isDebugMode) {
                    console.log("feedback =  " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast(obj.message);
                } else {
                    showSuccessToast(obj.message);
                    getAccountList();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Add account failed !");
            }
        });
    });
}

/**
 * Get role name
 * @param role : 1: Administrator, 2: Member
 * @returns {string}
 */
function getRoleName(role) {
    if (role > 1) {
        return "Member";
    } else {
        return "Administrator";
    }
}

/**
 * Delete user click listener
 */
function deleteUserClickListener() {

    $("body").on("click", ".bt-delete", function () {

        var id = $(this).attr("data-id");
        var post_data = "id=" + $(this).attr("data-id");
        var rowObject = $(this).parents('tr');

        $.ajax({
            url: dbServerInfo.ip + "/api/del_user",
            data: post_data,
            type: "POST",
            success: function (returnData) {
                if (isDebugMode) {
                    console.log("success" + JSON.stringify(returnData));
                }

                var obj = jQuery.parseJSON(returnData);
                if (obj.result != "OK") {
                    showErrorToast(obj.message);
                } else {
                    accountListTable.row(rowObject).remove().draw();
                    showSuccessToast(obj.message);
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error");
                    console.log(xhr.status);
                    console.log(thrownError);
                }
                showErrorToast("Delete account failed !");
            }
        });
    });
}

/**
 * Button edit user apply
 */
function btEditUserApply() {

    $("#bt-account-edit-apply").click(function () {

        if ($("#input-add-account-modal").val().length > 0) {

        } else {
            showErrorToast("Username can't be empty !");
            return;
        }


        if ($("#input-add-mail-modal").val().length > 0) {

        } else {
            showErrorToast("Email can't be empty !");
            return;
        }


        if (isEmail($("#input-add-mail-modal").val())) {

        } else {
            showErrorToast("Email format error !");
            return;
        }

        var post_data = "account=" + $("#input-add-account-modal").val() + "&id=" + $("#bt-account-edit-apply").attr("data-id") + "&role=" + $("#select_account_role_modal").val() + "&mail=" + $("#input-add-mail-modal").val();

        $.ajax({
            url: dbServerInfo.ip + "/api/edit_user",
            data: post_data,
            type: "POST",
            success: function (data) {
                if (isDebugMode) {
                    console.log("feedback =  " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast(obj.message);
                } else {
                    showSuccessToast(obj.message);
                    getAccountList();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Update account failed !");
            }
        });
    });
}

/**
 * Confirm new password
 */
function confirmNewPassword() {

    $("#confirm-password-bt").click(function () {

        if ($("#input-old-password").val().length > 0) {
            if (isDebugMode) {
                console.log("old-password not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("old-password is empty");
            }
            showErrorToast("Please enter old password !");
            return;
        }

        if ($("#input-new-password1").val().length > 0) {
            if (isDebugMode) {
                console.log("new-password 1 not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("new-password 1 is empty");
            }
            showErrorToast("Please enter new password !");
            return;
        }

        if ($("#input-new-password2").val().length > 0) {
            if (isDebugMode) {
                console.log("new-password 2 not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("new-password 2 is empty");
            }
            showErrorToast("Please enter confirm password !");
            return;
        }

        if ($("#input-new-password1").val() === $("#input-new-password2").val()) {
            if (isDebugMode) {
                console.log("new-password is the same");
            }
        } else {
            if (isDebugMode) {
                console.log("new-password not the same");
            }
            showErrorToast("New password not the same !");
            return;
        }

        var data = "id=" + $("#span_user_account").attr("data-id") + "&old=" + $("#input-old-password").val() + "&new=" + $("#input-new-password1").val();
        $.ajax({
            url: dbServerInfo.ip + "/api/change_password",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                // console.log("parser result = " + obj.result);
                if (obj.result != "OK") {
                    showErrorToast("Change password failed !");
                } else {
                    showSuccessToast("Change password successful");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Change password failed !");
            }
        });
    });
}
