var mappingTable;
var txMap = new Object(); // or var map = {};
var rxMap = new Object();
var presetRXMap;
var presetTXMap;
var aspeedWorker;
var iteWorker;
var isInitialUI;

var txGroupMap = new Object();//store current tx group content
var rxGroupMap = new Object();//store current rx group content
var clusterMap = new Object();

$(document).ready(function () {
   // if (isDebugMode) {
        console.log("audio js");
   // }

    $("#menu_a_audio").css("color", "orangered");
    $("#menu_span_audio").css("color", "orangered");
    $("#menu_icon_audio").css("color", "orangered");

    isInitialUI = true;
    checkLoginCookie();
    $().dndPageScroll();
    //Initial hide table view
    $("#div_mapping_table_list").hide();

    mappingTable = $('#mapping-table-dt').DataTable({
        responsive: true,
        searching: true,
        paging: false,
        ordering: false,
        info: true
    });

    $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
        $($.fn.dataTable.tables(true)).DataTable()
            .columns.adjust()
            .responsive.recalc();
    });
    //Initial dataTable - End
    $('.dropdown-toggle').dropdown();

    //getUserID();
    initial();
    showPresetModalClickListener();
    modalPresetChangeListener();
    presetModalApplyClickEvent();
    presetCommitClickEvent();
    modifyNameApply();
    bubbleClickListener();
    switchNoticeModalApplyBt();
    cecONClickListener();
    cecOFFClickListener();
    get_group_list();
    groupDropItemListener();
    subStreamingClickListener();
});

/**
 * Initial to check system type is ASpeed or ITE
 *
 * Decide which type to start, also start that type web worker!
 */
function initial() {
    if (isDebugMode) {
        console.log("Mapping initial");
    }

    var isASpeed = false;

    if (readCookie(COOKIE_SYSTEM_TYPE) === "true") {
        //ASpeed
        if (isDebugMode) {
            console.log("SYSTEM_TYPE ASpeed Mode");
        }
        isASpeed = true;
        //getASpeedDeviceInfo();
        getASpeedDeviceInfoByGroup();
    } else {
        //ITE
        if (isDebugMode) {
            console.log("SYSTEM_TYPE ITE Mode");
        }
        isASpeed = false;
        // getITEDeviceInfo();
    }
    getDefaultUIType(isASpeed);
}


/**
 * Get user id
 */
function getUserID() {
    var userId = readCookie(COOKIE_USER_INFO);
    var data = "id=" + userId;

    $.ajax({
        url: dbServerInfo.ip + "/api/user_device_permission",
        data: data,
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("user_device_permission = " + data);
            }

            if (obj.result != "OK") {
                showErrorToast("Get account device permission failed !");
            } else {

                for (jsonArrayIndex = 0; jsonArrayIndex < obj.message.length; jsonArrayIndex++) {
                    devicePermissionMap[obj.message[jsonArrayIndex].mac] =
                        new devicePermissionObject(obj.message[jsonArrayIndex].released);

                    console.log("mac = " + obj.message[jsonArrayIndex].mac + " released = " + devicePermissionMap[obj.message[jsonArrayIndex].mac].released);
                }
            }
            initial();
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("user_device_permission error ");
            }
            //  showErrorToast("Change password failed !");
        }
    });

}


/**
 * Update ASpeed device info every 7 seconds
 */
function startASpeedWorker() {
    if (typeof (Worker) !== "undefined") {
        if (typeof (aspeedWorker) == "undefined") {
            aspeedWorker = new Worker("../js/updateASpeedDeviceInfoWorker.js");
        }

        aspeedWorker.postMessage(WORKER_START_EVENT);

        aspeedWorker.onmessage = function (event) {

            if (isDebugMode) {
                console.log("worker receive = " + JSON.stringify(event.data.data));
            }

            // jsonData = event.data.data;
            // sortResults('host_name', true, jsonData);
            // console.log("json = " + JSON.stringify(jsonData));

            if (event.data.status) {
                if (isInitialUI) {
                    updateASpeed(true, event.data.data);
                    isInitialUI = false;
                } else {
                    updateASpeed(false, event.data.data);
                }
            } else {
                showErrorToast("Request timeout !");
            }
        };
    } else {
        if (isDebugMode) {
            console.log("Sorry, your browser does not support Web Workers...");
        }
        showErrorToast("Sorry, your browser does not support Web Workers...");
    }
}

function sortResults(prop, asc) {
    jsonData.sort(function (a, b) {
        if (asc) {
            return (a[prop] > b[prop]) ? 1 : ((a[prop] < b[prop]) ? -1 : 0);
        } else {
            return (b[prop] > a[prop]) ? 1 : ((b[prop] < a[prop]) ? -1 : 0);
        }
    });
}

/**
 * Get devices status(RX & TX)
 * */
function getASpeedDeviceInfo() {

    $(".loading").show();

    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("ASpeed success" + JSON.stringify(returnData));
                console.log("data count = " + returnData.length);
            }
            cleanAllDragList();
            cleanAllTable();
            var rx_table_rows = "", tx_table_rows = "", mapping_table_rows = "";
            var tx_list = "", rx_list = "";
            var jsonArrayIndex = 0;
            var dropdown_tx_item = "";
            var txCounter = 0, rxCounter = 0;
            txMap = new Object(); // or var map = {};
            rxMap = new Object();
            // var txMap = new Object(); // or var map = {};
            // var rxMap = new Object();
            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {

                //true: user can use this device; false: can't use
                if (checkDevicePermission(returnData[jsonArrayIndex].mac)) {
                    if (returnData[jsonArrayIndex].type != "r") {

                        // draw TX table ------ begin
                        var device_id = returnData[jsonArrayIndex].id;
                        var group_ip = "";
                        var drop_status_style = "";

                        //group ip
                        group_ip = createGroupIP(device_id);

                        //cal mac address --- start
                        var mac = macFormat(returnData[jsonArrayIndex].mac.toString());
                        //cal mac address --- end

                        var imgPath = "";

                        if (returnData[jsonArrayIndex].alive != "n") {
                            imgPath = doesFileExistForInitial("../snapshot/" + returnData[jsonArrayIndex].mac + ".jpg");
                            dropdown_tx_item += "<li class=\"tx_item\" data-group=\"" + device_id + "\"><a><span style='color: rgb(100, 108, 128)'>" + statusHtml(returnData[jsonArrayIndex].alive, true)
                                + "  " + returnData[jsonArrayIndex].host_name + "</span></a></li>";
                            drop_status_style = 1;
                        } else {
                            //non alive
                            imgPath = "../snapshot/offline.bmp";
                            drop_status_style = 0.5;
                        }

                        txCounter = txCounter + 1;
                        // draw tx drag item --- Start
                        if ((txCounter % 2) == 1) {
                            if (isDebugMode) {
                                console.log("TX add row");
                            }
                            tx_list += "<div class='row' id=\"tx_row_" + Math.floor(txCounter / 2) + "\" >";
                        }

                        // tx_list += "<div id=\"tx_" + returnData[jsonArrayIndex].mac + "\" data-pin=\"" + returnData[jsonArrayIndex].pin + "\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" data-id=\"" + returnData[jsonArrayIndex].id + "\" class=\"col-xs-6 draggable\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"opacity:" + drop_status_style + "\">\n" +
                        //     "                <div class=\"card\">" +
                        //     // "                       <div style=\"width: 100%;height: 20px;text-align: right\"><span class=\"glyphicon glyphicon-pencil modify_name\" aria-hidden=\"true\" title=\"Modify device name\" style='cursor: pointer'></span></div>" +
                        //     "                     <div style=\"width: 100%;height: 130px;text-align: center; margin-bottom: 5px\"><img id=\"" + returnData[jsonArrayIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"pointer-events: none;height: 100%;width: 70%;display:block;margin:auto; \"></div>\n" +
                        //     "                    <h4 id=\"" + returnData[jsonArrayIndex].mac + "_name\" style=\"display: inline;\">" + getDeviceName(returnData[jsonArrayIndex]) + "</h4><h4 style=\"display: inline;\"> <span data-mac=\"" + returnData[jsonArrayIndex].mac + "\" class=\"glyphicon glyphicon-pencil modify_name\" aria-hidden=\"true\" title=\"Modify device name\" style='cursor: pointer'></span></h4>" +
                        //     "                    <div style=\"margin-top: 5px\">" +
                        //     "                       <img id=\"" + returnData[jsonArrayIndex].mac + "_lightbulb\" data-alive=\"" + returnData[jsonArrayIndex].alive + "\" data-type=\"" + returnData[jsonArrayIndex].type + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class=\"shiny\" src=\"../img/lightbulb.png\" style=\"max-width: 40px;cursor: pointer;height: 32px;\" >" +
                        //     "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_id\" type=\"button\" class=\"btn btn-success btn-sm\" style=\"display: inline;pointer-events: none; \">" +
                        //     "                            <span class=\"glyphicon glyphicon-expand\" aria-hidden=\"true\"></span> " + returnData[jsonArrayIndex].id +
                        //     "                            </button>" +
                        //     "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_ip\" type=\"button\" class=\"btn btn-primary btn-sm\" style=\"display: inline;pointer-events: none; \">" +
                        //     "                            <span class=\"glyphicon glyphicon-globe\" aria-hidden=\"true\"></span> " + returnData[jsonArrayIndex].ip + "</button>" +
                        //     "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_count\" type=\"button\" data-count=0 class=\"btn btn-warning btn-sm\" style=\"display: inline; pointer-events: none; \">" +
                        //     "                            <span class=\"glyphicon glyphicon-user\" aria-hidden=\"true\"></span> <span id=\"" + returnData[jsonArrayIndex].mac + "_count_span\">0</span>" +
                        //     "                        </button>" +
                        //     "                    </div>" +
                        //     "</div></div>";


                        tx_list += "<div id=\"tx_" + returnData[jsonArrayIndex].mac + "\"  data-mac=\"" + returnData[jsonArrayIndex].mac + "\" data-audio_id=\"" + returnData[jsonArrayIndex].subscriber_audio_id + "\" data-ip=\"" + returnData[jsonArrayIndex].ip  + "\" data-pin=\"" + returnData[jsonArrayIndex].pin + "\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" data-id=\"" + returnData[jsonArrayIndex].id + "\" class=\"col-xs-6 draggable\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"opacity:" + drop_status_style + "\">\n" +
                            "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                            "  <div class=\"no_pad\"> <div class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                            "                     <div class=\"no_pad\" style='width: 100%;'><span id=\"" + returnData[jsonArrayIndex].mac + "_id\" style='font-size: 16px;cursor:default;margin-right:10px;float:right;border-radius:20px;display:block;color: white;margin-top:20px;text-align: " +
                            "                           center;border-width:2px;border-style: solid;border-color: rgb(113,143,171);width: 80px;background: rgb(247,151,29,0);'> #&nbsp " + returnData[jsonArrayIndex].subscriber_audio_id + " </span></div>" +
                            " <div style='width: 100%;margin-top:120px;'><span id=\"" + returnData[jsonArrayIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display:inline-block;'>&nbsp&nbsp" + returnData[jsonArrayIndex].host_name +
                            "                   </span><span id=\"" + returnData[jsonArrayIndex].mac + "_modify_name\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                            "      <div  class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;border-radius: 10px 10px 0 0'>" +
                            "                            <img id=\"" + returnData[jsonArrayIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                            "      </div> </div></div>" +
                            "      <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\"><div class=\"card-footer col-xs-2 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 0px 10px\">" +
                            "                                  <img id=\"" + returnData[jsonArrayIndex].mac + "_lightbulb\" data-type=\"" + returnData[jsonArrayIndex].type + "\" data-alive=\"" + returnData[jsonArrayIndex].alive + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                            "                        </div>" +
                            "                        <div class=\"card-footer col-xs-8 no_pad\" style=\"background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                            "                            <span id=\"" + returnData[jsonArrayIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: rgb(100, 108, 128);font-size: 16px;padding-top: 8px;display: inline-block\">" + returnData[jsonArrayIndex].ip + "</span>" +
                            "                        </div>" +
                            "                        <div class=\"card-footer no_pad col-xs-2 right_bottom_corner\" style=\"background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 10px 0px\">" +
                            // "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_count\" type=\"button\" data-count=0 class=\"btn\" style=\"display: block; pointer-events: none;background: rgba(0,0,0,0) \">" +
                            // "                            <span class=\"glyphicon glyphicon-user\" aria-hidden=\"true\" style=\"font-size: 16px\"></span> <span id=\"" + returnData[jsonArrayIndex].mac + "_count_span\" style=\"font-size: 16px\">0</span>" +
                            // "                        </button>" +
                            "                        </div></div>" +
                            " </div>";

                        if ((txCounter % 2) == 0) {
                            tx_list += "</div><br>";
                        }
                        //for rx to mapping source name
                        // txMap[device_id] = new txObject(device_id, returnData[jsonArrayIndex].host_name, returnData[jsonArrayIndex].mac);
                        txMap[returnData[jsonArrayIndex].mac] = new txObject(device_id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);

                    } else {

                        //set rx map
                        rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]),
                            returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);
                        rxCounter = rxCounter + 1;
                    }
                }
            }
            // draw RX & Mapping table ------ begin
            rxCounter = 0;
            for (rxMapIndex in rxMap) {
                var source = "";
                var drop_status_style = "";

                var hasMatchTx = false;
                var sourceName = "";
                var sourceMac = "";
                var imgPath = "";
                var txAlive = false;

                var txMacMap = new Object();

                for (sourceIndex in txMap) {
                    if (txMap[sourceIndex].id === rxMap[rxMapIndex].id) {
                        txMacMap[txMap[sourceIndex].mac] = new txObject("", txMap[sourceIndex].name, txMap[sourceIndex].mac, txMap[sourceIndex].alive, txMap[sourceIndex].ip);
                        hasMatchTx = true;
                    }
                }

                if (Object.size(txMap) > 1) {
                    //tx has same group ID....
                    for (sourceIndex in txMacMap) {
                        if (txMacMap[sourceIndex].alive === "y") {
                            txAlive = true;
                            sourceName = txMacMap[sourceIndex].name;
                            sourceMac = txMacMap[sourceIndex].mac;
                            break;
                        }
                    }
                } else {
                    //tx group id is unique
                    for (sourceIndex in txMacMap) {
                        sourceName = txMacMap[sourceIndex].name;
                        sourceMac = txMacMap[sourceIndex].mac;
                        if (txMacMap[sourceIndex].alive === "y") {
                            txAlive = true;
                        } else {
                            txAlive = false;
                        }
                    }
                }

                if (hasMatchTx) {
                } else {
                    sourceName = "N/A";
                }

                if (rxMap[rxMapIndex].status == "y") {
                    drop_status_style = "1";
                    //draw mapping table ------ start
                    mapping_table_rows = "<tr id=\"mapping_" + rxMap[rxMapIndex].mac + "_row\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">" + rxMap[rxMapIndex].id +
                        "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">" + rxMap[rxMapIndex].name + "</span></td>" +
                        "<td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;color: rgb(100, 108, 128)\">" + "RX</span>"
                        + "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">"
                        + "     <div class=\"dropdown\">" +
                        "                        <button style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\" class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                        "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\">\n" + source +
                        "                        <span class=\"caret\"></span>" +
                        "                        </button>" +
                        "                        <ul class=\"dropdown-menu dropdown-mapping\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                        "                        </ul>" +
                        "                    </div></tr>";


                    mappingTable.row.add($(mapping_table_rows)).draw();
                    //draw mapping table ------ end
                    if (hasMatchTx) {
                        if (txAlive) {
                            imgPath = doesFileExistForInitial("../snapshot/" + sourceMac + ".jpg");
                        } else {
                            imgPath = "../snapshot/nosignal.bmp";
                        }
                    } else {
                        source = "N/A";
                        imgPath = "../snapshot/nosignal.bmp";
                    }
                } else {
                    drop_status_style = "0.5";
                    imgPath = "../snapshot/offline.bmp";
                }

                rxCounter = rxCounter + 1;
                //draw RX drag item ------ start
                if ((rxCounter % 2) == 1) {
                    if (isDebugMode) {
                        console.log("RX add row");
                    }
                    rx_list += "<div class='row' id=\"rx_row_" + Math.floor(rxCounter / 2) + "\" >";
                }


                rx_list += "<div id=\"rx_" + rxMap[rxMapIndex].mac + "\" style=\"border-radius: 0 0 10px 10px\" data-audio_id=\"" +  rxMap[rxMapIndex].publisher_audio_id + "\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-status=\"" + rxMap[rxMapIndex].status + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\"  data-pin=\"" + rxMap[rxMapIndex].pin + "\" class=\"col-xs-6\" ondrop=\"Drop(event)\" ondragover=\"AllowDrop(event)\" ondragleave=\"LeaveDrop(event)\" style=\"opacity:" + drop_status_style + "\">" +
                    "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                    "  <div class=\"no_pad\"> <div class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                    "                     <div class=\"no_pad\" style='width: 100%;'><span id=\"" + rxMap[rxMapIndex].mac + "_id\" style='font-size: 16px;cursor:default;margin-right:10px;float:right;border-radius:20px;display: block;color: white;margin-top:20px;text-align: " +
                    "                           center;border-width: 2px;border-style: solid;border-color: rgb(113,143,171);width: 80px;background: rgb(247,151,29,0)'> #&nbsp " + rxMap[rxMapIndex].publisher_audio_id + " </span></div>" +
                    "                     <div style='width: 100%;margin-top:120px;'> <span id=\"" + rxMap[rxMapIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display: inline-block;'>&nbsp&nbsp" + rxMap[rxMapIndex].name + "</span>" +
                    "                 <span id=\"" + rxMap[rxMapIndex].mac + "_modify_name\" data-status=\"" + rxMap[rxMapIndex].status + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                    "      <div  class=\"no_pad\"  style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;right: -6%;border-radius: 10px 10px 0 0'>" +
                    "                            <img id=\"" + rxMap[rxMapIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                    "      </div> </div></div>" +

                    "    <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\"> <div class=\"card-footer col-xs-1 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                    "                          <img id=\"" + rxMap[rxMapIndex].mac + "_lightbulb\" data-type=\"r\" data-alive=\"" + rxMap[rxMapIndex].alive + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                    "                        </div>" +
                    "                        <div class=\"card-footer col-xs-7 no_pad\" style=\"background: background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                    "                            <span id=\"" + rxMap[rxMapIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: rgb(100, 108, 128);font-size: 16px;padding-top: 8px;display: inline-block\">" + rxMap[rxMapIndex].ip + "</span>" +
                    "                        </div>" +
                    // "                        <div class=\"card-footer col-xs-2 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);;height: 40px;padding-top: 2px;\">" +
                    // "                         <input id=\"" + rxMap[rxMapIndex].mac + "_mute\"  data-ip=\"" + rxMap[rxMapIndex].ip + "\" data-style=\"ios\" class=\"mute-toggle\" type=\"checkbox\"  data-toggle=\"toggle\" data-onstyle=\"success\"\n" +
                    // "                               data-offstyle=\"danger\" data-size=\"small\">" +
                    // "                        </div>" +
                    "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;margin-right: 7%;\">" +
                    "                                <button id=\"" + rxMap[rxMapIndex].mac + "_cec_on\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" class=\"btn cec_on\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='rgb(26,188,114)';borderChange(this.id, 'rgb(26,188,114)')\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;height: 28px;width:50px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">ON</button> " +
                    "                        </div>" +
                    "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                    "                                 <button id=\"" + rxMap[rxMapIndex].mac + "_cec_off\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='red';borderChange(this.id, 'red');\" class=\"btn cec_off\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;width:50px;height: 28px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">OFF</button> " +
                    "                        </div>" +
                    " </div>" +
                    "</div> ";

                if ((rxCounter % 2) == 0) {
                    rx_list += "</div><br>";
                }
                //draw RX drag item ------ end
            }
            // draw RX & Mapping table ------ end

            // Draw drag item end element -------- start
            if (rxCounter > 0) {
                if ((rxCounter % 2) != 0) {
                    if (isDebugMode) {
                        console.log("RX need end");
                    }
                    rx_list += "</div><br>";
                }
                $("#rx-area").after(rx_list);
                $("#span-rx-count").text(rxCounter);
            } else {
                $("#span-rx-count").text("0");
            }

            if (txCounter > 0) {
                if ((txCounter % 2) != 0) {
                    if (isDebugMode) {
                        console.log("TX need end");
                    }
                    tx_list += "</div><br>";
                }
                $("#tx-area").after(tx_list);
                $("#span-tx-count").text(txCounter);
                $(".dropdown-mapping").append(dropdown_tx_item);//add tx item to the drop menu (mapping table)
                dropDownASpeedListener();
            } else {
                $("#span-tx-count").text("0");
            }
            // Draw drag item end element -------- end

            // $("#" + rxMap[rxMapIndex].mac + "_mute").bootstrapToggle({
            //     on: '',
            //     off: '',
            // });

            rxMuteToggleListener();
            // //update TX used count ----- start
            for (rxMapIndex in rxMap) {
                for (sourceIndex in txMap) {
                    if (txMap[sourceIndex].id === rxMap[rxMapIndex].id) {
                        if (rxMap[rxMapIndex].status === "y") {
                            $("#" + txMap[sourceIndex].mac + "_count").attr("data-count", (parseInt($("#" + txMap[sourceIndex].mac + "_count").attr("data-count")) + 1));
                            $("#" + txMap[sourceIndex].mac + "_count_span").text(parseInt($("#" + txMap[sourceIndex].mac + "_count").attr("data-count")));
                        }
                        break;
                    }
                }

                if (rxMap[rxMapIndex].alive === 'n') {
                    $("#" + rxMap[rxMapIndex].mac + "_mute").prop('checked', false).bootstrapToggle('destroy').bootstrapToggle({
                        on: '',
                        off: '',
                    });
                } else {
                    $("#" + rxMap[rxMapIndex].mac + "_mute").prop('checked', true).bootstrapToggle('destroy').bootstrapToggle({
                        on: '',
                        off: '',
                    });
                }
                //  }
                //  $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle('enable');
            }
            // //update TX used count ----- end
            showModifyNameModal();
            startASpeedWorker();
            $(".loading").hide();
            //   showSuccessToast("To get device status successful");
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
            $(".loading").hide();
        }
    });
}

/**
 * Show modify name modal (ASpeed)
 */
function showModifyNameModal() {
    $(".modify_name").click(function (e) {
        if (isDebugMode) {
            console.log("modify_name " + $(this).attr("data-status"));
        }
        if ($(this).attr("data-status") === "y") {
            $("#bt-modify-name-apply").attr("data-mac", $(this).attr("data-mac"));
            $("#input-new-name").val("");
            $("#modify-name-modal").modal("show");
        } else {
            showWarningToast("Only online device can modify name !");
        }
    });
}

function switchNoticeModalApplyBt() {
    $("#bt-switch-channel-apply").click(function (e) {
        if (isDebugMode) {
            console.log("ip = " + $(this).attr("data-rx_ip") + " - channel = " + $(this).attr("data-channel"));
        }
        switchChannel($(this).attr("data-rx_ip"), $(this).attr("data-channel"));
        $("#switch-channel-modal").modal("hide");
    });
}


/**
 * Show modify name modal (ITE)
 */
function showITEModifyNameModal() {
    $(".ite_modify_name").click(function (e) {
        if (isDebugMode) {
            console.log("ite modify_name " + $(this).parent().parent().parent().attr("data-status"));
        }
        if ($(this).parent().parent().parent().attr("data-status") === "y") {
            $("#bt-ite-modify-name-apply").attr("data-mac", $(this).attr("data-mac"));
            $("#input-ite-new-name").val("");
            $("#ite-modify-name-modal").modal("show");
        } else {
            showWarningToast("Only online device can modify name !");
        }
    });
}

/**
 * Stop ASpeed worker
 */
function stopASpeedWorker() {
    if (typeof (aspeedWorker) != "undefined") {
        aspeedWorker.terminate();
        aspeedWorker = undefined;
        if (isDebugMode) {
            console.log("stop ASpeed Worker");
        }
    }
}

/**
 * Stop ITE worker
 */
function stopITEWorker() {
    if (typeof (iteWorker) != "undefined") {
        iteWorker.terminate();
        iteWorker = undefined;
        if (isDebugMode) {
            console.log("stop ITE Worker");
        }
    }
}

/**
 * Modify name apply button click event
 */
function modifyNameApply() {
    $("#bt-modify-name-apply").click(function (e) {
        if ($("#input-new-name").val().length > 0) {
            var data = "mac=" + $(this).attr("data-mac") + "&value=" + $("#input-new-name").val();
            $.ajax({
                url: dbServerInfo.ip + "/api/set_hostname",
                data: data,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    if (obj.result == "OK") {
                        showSuccessToast("Set name Successful !");
                        //  updatePreView();
                        aspeedWorker.postMessage(WORKER_UPDATE_INFO_EVENT);
                    } else {
                        showErrorToast("Set name failed !");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    showErrorToast("Set name failed !");
                }
            });
        } else {
            showErrorToast("Name can't be empty !");
        }
    });

    $("#bt-ite-modify-name-apply").click(function (e) {
        if ($("#input-ite-new-name").val().length > 0) {

            var jsonData = {
                "mac": $(this).attr("data-mac"),
                "name": $("#input-ite-new-name").val()
            }

            if (isDebugMode) {
                console.log("json = " + JSON.stringify(jsonData));
            }

            $.ajax({
                url: dbServerInfo.ip + "/api/ite/name",
                data: jsonData,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    if (obj.result == "OK") {
                        showSuccessToast("Set name Successful !");
                    } else {
                        showErrorToast("Set name failed !");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    showErrorToast("Set name failed !");
                }
            });
        } else {
            showErrorToast("Name can't be empty !");
        }
    });


}
/**
 * Refresh button click listener
 * */
function btRefresh() {
    $("#bt-refresh").click(function () {
        stopASpeedWorker();
        stopITEWorker();
        if (readCookie(COOKIE_SYSTEM_TYPE) === "true") {
            //ASpeed
            if (isDebugMode) {
                console.log("ASpeed Mode");
            }
            $("#bt-show-save_as").show();
            $("#bt-show-recall").show();
            $("#bt-show-preset").show();
            // getASpeedDeviceInfo();
            getASpeedDeviceInfoByGroup();
        } else {
            //ITE
            if (isDebugMode) {
                console.log("ITE Mode");
            }
            $("#bt-show-save_as").hide();
            $("#bt-show-recall").hide();
            $("#bt-show-preset").hide();
            // getITEDeviceInfo();
        }
    });
}

/**
 * Allow drop listener
 * */
function AllowDrop(event) {
    if (isDebugMode) {
        console.log("AllowDrop");
    }
    event.preventDefault();
    var data = event.currentTarget.id;
    if (isDebugMode) {
        console.log("id = " + data);
    }
    document.getElementById(data).classList.add("borderBox");
}

/**
 * Drop listener, will switch rx channel (ASpeed)
 * */
function Drop(event) {
    event.preventDefault();
    document.getElementById(event.currentTarget.id).classList.remove("borderBox");
    if ($("#" + event.dataTransfer.getData("text")).attr("data-status") != "y") {
        showErrorToast("This transmitter is off-line !");
    } else {
        if ($("#" + event.currentTarget.id).attr("data-status") != "y") {
            showErrorToast("This receiver is off-line !");
        } else {
            console.log("text=" + event.dataTransfer.getData("text"));
            var tx_ip = $("#" + event.dataTransfer.getData("text")).attr("data-ip");//group
            var rx_ip = $("#" + event.currentTarget.id).attr("data-ip");
            var rx_audio_id = $("#" + event.currentTarget.id).attr("data-audio_id");
            console.log("rx_ip=" + rx_ip + "&rx_audio_id=" + rx_audio_id);
            console.log("tx_ip=" + tx_ip);

            //start RX Publisher
            $.ajax({
                url: dbServerInfo.ip + "/api/api_start_rx_audio",
                data: "ip=" + rx_ip + "&audio_id=" + rx_audio_id,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    SwitchTXAudio(tx_ip, rx_audio_id);
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                }
            });
        }
    }
}

function SwitchTXAudio(tx_ip, rx_audio_id){
    //set TX toslink from RX
    $.ajax({
        url: dbServerInfo.ip + "/api/switch_audio",
        data: "ip=" + tx_ip + "&audio_id=" + rx_audio_id + "&switch_type=i",
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
                console.log("parser result = " + obj.result);
            }
            if (obj.result != "OK") {
            } else {
                showSuccessToast("Switch audio successful");
            }
            RecordTXSubscriberAudioChannel(tx_ip, rx_audio_id);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
        }
    });
}

function RecordTXSubscriberAudioChannel(tx_ip, rx_audio_id){

    $.ajax({
        url: dbServerInfo.ip + "/api/astparam_s",
        data: "ip=" + tx_ip + "&param=audio_return_subscriber&value=" + rx_audio_id,
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Save tx audio channel failed !");
        }
    });
}



/**
 * Check RX status is match some one video wall preset content
 * @param vwInfo : Video Wall Status info (RX)
 * @param rx_mac : MAC
 * @param rx_ip : IP address
 * @param tx_channel : TX channel
 * @constructor
 */
function CheckRXIsInVW(vwInfo, rx_mac, rx_ip, tx_channel) {

    if (isDebugMode) {
        console.log("CheckRXIsUSEVW h = " + vwInfo.h);
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/video_wall_preset",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }
            var isGoOn = true;
            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                if (isDebugMode) {
                    console.log("start to check vw " + (jsonArrayIndex + 1));
                }
                for (rxIndex = 0; rxIndex < returnData[jsonArrayIndex].rx_list.length; rxIndex++) {

                    if (rx_mac === returnData[jsonArrayIndex].rx_list[rxIndex].mac) {
                        if (isDebugMode) {
                            console.log("vw " + (jsonArrayIndex + 1) + " - " + returnData[jsonArrayIndex].rx_list[rxIndex].mac + " has !");
                        }
                        var rxVWObject = new vwObject(returnData[jsonArrayIndex].col, returnData[jsonArrayIndex].row, returnData[jsonArrayIndex].rx_list[rxIndex].vs_shift
                            , returnData[jsonArrayIndex].rx_list[rxIndex].ve_shift, returnData[jsonArrayIndex].rx_list[rxIndex].hs_shift, returnData[jsonArrayIndex].rx_list[rxIndex].he_shift
                            , returnData[jsonArrayIndex].rx_list[rxIndex].pos);

                        if (objDiff(rxVWObject, vwInfo)) {
                            console.log("the same");
                            isGoOn = false;
                            $("#span-switch-channel").html(" Do you want to switch channel ?  <br/> This Receiver is used video wall preset " + (1 + jsonArrayIndex) + " now.");
                            $("#bt-switch-channel-apply").attr("data-rx_ip", rx_ip);
                            $("#bt-switch-channel-apply").attr("data-channel", tx_channel);
                            $("#switch-channel-modal").modal("show");
                            break;
                        }
                    }
                }
                if (!isGoOn) {
                    break;
                }
            }

            if (isGoOn) {
                switchChannel(rx_ip, tx_channel);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
        }
    });
}

/**
 * Compare Video Wall info object is the same or not
 * @param object1
 * @param object2
 * @returns {boolean}
 */
function objDiff(object1, object2) {
    var isTheSame = true;
    $.each(object1, function (key, value) {
        if ((key === "l") || (key === "r")) {
            if (isDebugMode) {
                console.log((parseInt(object2[key] * (-1))) + ": " + value);
            }
            if ((parseInt(object2[key] * (-1))) === parseInt(value)) {
            } else {
                isTheSame = false;
            }

        } else {
            if (parseInt(object2[key]) === parseInt(value)) {
            } else {
                isTheSame = false;
            }
            if (isDebugMode) {
                console.log(object2[key] + ": " + value);
            }
        }
    });
    return isTheSame;
}

/**
 * Preset Drop listener (Preset)
 * */
function PresetAreaDrop(event) {
    event.preventDefault();
    // $("#target-container").appendTo(this);
    var data = event.dataTransfer.getData("Text");
    // console.log("target = " + event.target.id);

    // event.target.appendChild(document.getElementById(data));
    $("#preset-container").append(document.getElementById(data));
}

/**
 * RX Preset Drop listener (Preset)
 * */
function RXPresetAreaDrop(event) {
    event.preventDefault();
    var data = event.dataTransfer.getData("Text");
    console.log("document.getElementById(data) = " + $(document.getElementById(data)).attr("data-mac"));
    if (checkDevicePermission($(document.getElementById(data)).attr("data-mac"))) {
        $("#receiver-container").append(document.getElementById(data));
    } else {
        showWarningToast("Sorry ! You don't have this device permission !");
    }

}

/**
 * Allow drop listener
 * */
function PresetAllowDrop(event) {
    if (isDebugMode) {
        console.log("PresetAllowDrop");
    }
    event.preventDefault();
    var data = event.currentTarget.id;
    if (isDebugMode) {
        console.log("id = " + data);
    }
}

/**
 * Preset Leave drop listener (RX)
 * */
function PresetLeaveDrop(event) {
    if (isDebugMode) {
        console.log("PresetLeaveDrop");
    }
    event.preventDefault();
}

/**
 * Drop listener, will switch rx "all" channel
 * */
function rxAllDrop(event) {
    event.preventDefault();
    document.getElementById(event.currentTarget.id).classList.remove("borderBox");
    if ($("#" + event.dataTransfer.getData("text")).attr("data-status") != "y") {
        showErrorToast("This transmitter is off-line !");
    } else {
        var tx_id = $("#" + event.dataTransfer.getData("text")).attr("data-id");//group
        var tx_pin = $("#" + event.dataTransfer.getData("text")).attr("data-pin");//pin
        var tempRxArray = new Object();
        var tempRXindex = 0;


        for (rxIndex in rxMap) {
            if (rxMap[rxIndex].status === "y") {
                if (isDebugMode) {
                    console.log("on-line rx ip = " + rxMap[rxIndex].ip + "  rx pin = " + rxMap[rxIndex].pin + " online = " + rxMap[rxIndex].status + " mac = " + rxMap[rxIndex].mac);
                }
                tempRxArray[tempRXindex] = new rxObject(rxMap[rxIndex].group_id, rxMap[rxIndex].name,
                    rxMap[rxIndex].ip, rxMap[rxIndex].mac, rxMap[rxIndex].status, "");
                tempRXindex = tempRXindex + 1;
            }
        }

        if (isDebugMode) {
            console.log("rx on-line size = " + Object.size(tempRxArray));
        }

        if (Object.size(tempRxArray) > 0) {
            rxSwitchAllRecursive(tempRxArray, 0, tx_id);
        } else {
            showWarningToast("We don't have on-line RX device now !");
        }
    }
}

/**
 * Rx Switch ALL Recursive
 * @param RxArray
 *
 * @param currentIndex
 * @param txGroup
 */
function rxSwitchAllRecursive(RxArray, currentIndex, txGroup) {
    var index = currentIndex;

    if (isDebugMode) {
        console.log("cmd - ip=" + RxArray[currentIndex].ip + "&switch_id=" + txGroup + "&switch_type=z");
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/astswitch",
        data: "ip=" + RxArray[currentIndex].ip + "&switch_id=" + txGroup + "&switch_type=z",
        type: "POST",
        success: function (data) {
            // var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("Recursive success " + JSON.stringify(data));
            }
            index = index + 1;
            if (Object.size(RxArray) > index) {
                rxSwitchAllRecursive(RxArray, index, txGroup);
            } else {
                console.log("Recursive finish 1");
                showSuccessToast("Switch all finish !");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("Recursive failed " + JSON.stringify(data));
            }
            index = index + 1;
            if (Object.size(RxArray) > index) {
                rxSwitchAllRecursive(RxArray, index, txGroup);
            } else {
                console.log("Recursive finish 2");
                showSuccessToast("Switch all finish !");
            }
        }
    });
}


/**
 * Drop listener, will switch rx "all" channel
 * */
// function rxITEAllDrop(event) {
//     event.preventDefault();
//     document.getElementById(event.currentTarget.id).classList.remove("borderBox");
//     if ($("#" + event.dataTransfer.getData("text")).attr("data-status") != "y") {
//         showErrorToast("This transmitter is off-line !");
//     } else {
//         var tx_id = $("#" + event.dataTransfer.getData("text")).attr("data-id");//group
//         for (rxIndex in rxMap) {
//             if (rxMap[rxIndex].status === "y") {
//                 if (isDebugMode) {
//                     console.log("rx mac = " + rxMap[rxIndex].mac + " tx id = " + tx_id);
//                 }
//
//                 var jsonData = {
//                     "mac": rxMap[rxIndex].mac,
//                     "id": tx_id
//                 }
//
//                 if (isDebugMode) {
//                     console.log("json = " + JSON.stringify(jsonData));
//                 }
//
//                 $.ajax({
//                     url: dbServerInfo.ip + "/api/ite/group_id",
//                     data: jsonData,
//                     type: "POST",
//                     success: function (data) {
//                         var obj = jQuery.parseJSON(data);
//                         if (isDebugMode) {
//                             console.log("success " + JSON.stringify(data));
//                         }
//                     },
//                     error: function (xhr, ajaxOptions, thrownError) {
//                         if (isDebugMode) {
//                             console.log("error ");
//                         }
//                         showErrorToast(rxMap[rxIndex].name + " switch group ID failed !");
//                     }
//                 });
//             }
//         }
//         showSuccessToast("Switch all finish !");
//     }
// }

/**
 * RX mute toggle listener (ASpeed)
 */
function rxMuteToggleListener() {

    $('.mute-toggle').change(function () {
        var post_data = "";
        var togglestatus = true;

        if ($(this).is(':checked')) {
            togglestatus = true;
            post_data = "ip=" + $(this).attr("data-ip") + "&value=echo 0 > /sys/devices/platform/display/screen_off";
        } else {
            togglestatus = false;
            post_data = "ip=" + $(this).attr("data-ip") + "&value=echo 1 > /sys/devices/platform/display/screen_off";
        }

        if (isDebugMode) {
            console.log("post_data = " + post_data);
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("feedback = " + JSON.stringify(data));
                }

                if (obj.result == "OK") {
                    if (togglestatus) {
                        showSuccessToast("Turn on receiver Successful !");
                    } else {
                        showSuccessToast("Turn off receiver Successful !");
                    }
                } else {
                    if (togglestatus) {
                        showErrorToast("Turn on receiver failed !");
                    } else {
                        showErrorToast("Turn off receiver failed !");
                    }
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                if (togglestatus) {
                    showErrorToast("Turn on receiver failed !");
                } else {
                    showErrorToast("Turn off receiver failed !");
                }
            }
        });
    });
}

/**
 * Leave drop listener (RX)
 * */
function LeaveDrop(event) {
    // if (isDebugMode) {
    console.log("LeaveDrop");
    //   }
    event.preventDefault();
    var data = event.currentTarget.id;
    document.getElementById(data).classList.remove("borderBox");
}

/**
 * Drag listener (TX)
 * */
function Drag(event) {
    console.log("drag~~~~~~~");
    event.dataTransfer.setData("Text", event.currentTarget.id);
}

/**
 * Clean all table (TX, RX & Mapping)
 * */
function cleanAllTable() {
    // txTable.clear().draw();
    // rxTable.clear().draw();
    mappingTable.clear().draw();
}

/**
 * Clean all drag area (RX & TX)
 * */
function cleanAllDragList() {
    $('#tx-area').nextAll('div').remove();
    $('#tx-area').nextAll('br').remove();
    $('#rx-area').nextAll('div').remove();
    $('#rx-area').nextAll('br').remove();
}

function cleanTXDragList() {
    $('#tx-area').nextAll('div').remove();
    $('#tx-area').nextAll('br').remove();
}


function cleanRXDragList() {
    $('#rx-area').nextAll('div').remove();
    $('#rx-area').nextAll('br').remove();
}


/**
 * mapping table - source dropdown menu click listener (ASpeed)
 * */
function dropDownASpeedListener() {

    $('.dropdown').on('click', '.tx_item', function () {

        if (isDebugMode) {
            console.log("group = " + $(this).attr("data-group"));
            console.log("rx ip = " + $(this).parent().attr("data-ip"));
            console.log("rx pin = " + $(this).parent().attr("data-pin"));
        }

        var rx_ip = $(this).parent().attr("data-ip");
        var tx_id = $(this).attr("data-group");
        var rx_mac = $(this).parent().attr("data-mac");

        // if ($(this).parent().attr("data-pin") != "0000") {
        //     showErrorToast("This receiver can't switch channel !");
        // } else {
        //     switchChannel($(this).parent().attr("data-ip"), $(this).attr("data-group"));
        // }

        var post_data = "ip=" + rx_ip;

        $.ajax({
            url: dbServerInfo.ip + "/api/device_switch_pin",
            data: post_data,
            type: "POST",
            success: function (returnData) {
                var obj = jQuery.parseJSON(returnData);
                if (isDebugMode) {
                    console.log("success" + JSON.stringify(returnData));
                }
                if (parseInt(obj.result, 10) === 0) {
                    $.ajax({
                        url: dbServerInfo.ip + "/api/vw_info/" + rx_mac,
                        type: "GET",
                        crossDomain: true,
                        dataType: 'json',
                        success: function (returnData) {
                            if (isDebugMode) {
                                console.log("success" + JSON.stringify(returnData));
                            }
                            CheckRXIsInVW(new vwObject(parseInt(returnData.vw_h), parseInt(returnData.vw_v),
                                returnData.vw_u, returnData.vw_b, returnData.vw_l, returnData.vw_r, returnData.vw_pos), rx_mac, rx_ip, tx_id);
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            if (isDebugMode) {
                                console.log("error");
                                console.log(xhr.status);
                                console.log(thrownError);
                            }
                            showErrorToast("To set Device group ID occurred error !");
                        }
                    });
                } else {
                    showErrorToast("This receiver can't switch channel, pin value must be zero !");
                }

            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("To get Device switch pin status occurred error !" + thrownError);
            }
        });

    });
}

/**
 * mapping table - source dropdown menu click listener
 * */
function showPresetModalClickListener() {
    $("#bt-show-preset").click(function (e) {
        $("#modal-preset-list").val(0);
        $("#bt-preset-apply").attr("data-preset", 1);
        $("#preset_title").text("Preset 1 Content");
        calPresetWithCurrentRxStatus(0);
        $("#preset-modal").modal('show');
    });
}

/**
 * Preset modal, preset change listener
 */
function modalPresetChangeListener() {
    $("#modal-preset-list").on('change', function () {
        if (isDebugMode) {
            console.log("preset index = " + this.value);
        }
        $("#preset_title").text("Preset " + (parseInt(this.value) + 1) + " Content");
        $("#bt-preset-apply").attr("data-preset", (parseInt(this.value) + 1));
        calPresetWithCurrentRxStatus(this.value);
    });
}

/**
 * Compare preset content with current rx status
 * @param presetIndex : preset index
 */
function calPresetWithCurrentRxStatus(presetIndex) {

    presetRXMap = new Object();
    presetTXMap = new Object();
    var rx_list = "";
    var preset_content = "";
    var rx_dropdown_list = "";
    var tx_dropdown_list = "";
    $("#preset-rx-area").empty();
    $("#preset-container").empty();
    $("#receiver-container").empty();
    $("#modal-preset-rx-list").empty();
    $("#modal-preset-tx-list").empty();

    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {

            if (isDebugMode) {
                console.log("preset get device status");
            }

            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                if (returnData[jsonArrayIndex].type != "r") {
                    //tx
                    presetTXMap[returnData[jsonArrayIndex].mac] = new txObject(returnData[jsonArrayIndex].id, returnData[jsonArrayIndex].host_name,
                        returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);
                } else {
                    //rx
                    presetRXMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, returnData[jsonArrayIndex].host_name,
                        returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);
                }
            }

            $.ajax({
                url: dbServerInfo.ip + "/api/list_preset",
                type: "GET",
                success: function (data) {
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                        console.log("preset size = " + data[0].preset.length);
                    }

                    // set preset content --- start
                    if (data[0].preset[presetIndex].setting != null) {

                        var settingArray = data[0].preset[parseInt(presetIndex)].setting;

                        for (settingIndex in settingArray) {
                            if (settingArray[settingIndex].type === "r") {

                                var rxName = "";

                                if (typeof presetRXMap[settingArray[settingIndex].mac] === "undefined") {
                                    rxName = settingArray[settingIndex].host_name;
                                } else {
                                    rxName = presetRXMap[settingArray[settingIndex].mac].name;
                                }

                                var txContent = "";

                                for (txMapIndex in presetTXMap) {
                                    if (presetTXMap[txMapIndex].id === settingArray[settingIndex].id) {
                                        txContent += "<span  class=\"btn btn-danger preset-id\" data-rxname=\"" + rxName + "\" data-mac=\"" + settingArray[settingIndex].mac + "\" data-id=\""
                                            + presetTXMap[txMapIndex].id + "\">" + presetTXMap[txMapIndex].name + "</span>\n";
                                        break;
                                    }
                                }

                                if (txContent.length > 0) {
                                } else {
                                    //group id can't find tx, so set rx group id
                                    txContent += "<span  class=\"btn btn-warning preset-id\" data-rxname=\"" + rxName + "\" data-mac=\"" + settingArray[settingIndex].mac + "\" data-id=\""
                                        + settingArray[settingIndex].id + "\">" + settingArray[settingIndex].id + "</span>\n";
                                }

                                preset_content += "   <div id=\"" + settingArray[settingIndex].mac + "_preset\" data-mac=\"" + settingArray[settingIndex].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\"  style=\"margin: 5px\">\n" +
                                    "                            <span  class=\"btn btn-primary\" >" + rxName + "</span>\n" + txContent +
                                    "                        </div>";
                            }
                        }
                        $("#preset-container").append(preset_content);
                    }
                    // set preset content --- end
                    // set receiver content --- start
                    for (rxMapIndex in presetRXMap) {
                        var isPresetHas = false;
                        var txContent = "";

                        //true: user can use this device; false: can't use
                        if (checkDevicePermission(presetRXMap[rxMapIndex].mac)) {

                            rx_dropdown_list += "<option value=\"" + presetRXMap[rxMapIndex].mac + "\">" + presetRXMap[rxMapIndex].name + "</option>";
                        }


                        // rx_dropdown_list += "<option value=\"" + presetRXMap[rxMapIndex].mac + "\">" + presetRXMap[rxMapIndex].name + "</option>";

                        for (txMapIndex in presetTXMap) {
                            if (presetTXMap[txMapIndex].id === presetRXMap[rxMapIndex].id) {
                                txContent += "<span  class=\"btn btn-danger preset-id\" data-rxname=\"" + presetRXMap[rxMapIndex].name + "\" data-mac=\"" + presetRXMap[rxMapIndex].mac + "\" data-id=\"" + presetTXMap[txMapIndex].id + "\">" + presetTXMap[txMapIndex].name + "</span>\n";
                                break;
                            }
                        }

                        if (txContent.length > 0) {
                        } else {
                            txContent += "<span  class=\"btn btn-warning preset-id\" data-rxname=\"" + presetRXMap[rxMapIndex].name + "\" data-mac=\"" + presetRXMap[rxMapIndex].mac + "\" data-id=\"" + presetRXMap[rxMapIndex].id + "\">" + presetRXMap[rxMapIndex].id + "</span>\n";
                        }

                        //check preset content is in current rx or not
                        for (settingIndex in settingArray) {
                            if (presetRXMap[rxMapIndex].mac === settingArray[settingIndex].mac) {
                                isPresetHas = true;
                            }
                        }

                        if (!isPresetHas) {
                            if (checkDevicePermission(presetRXMap[rxMapIndex].mac)) {
                                rx_list += "   <div id=\"" + presetRXMap[rxMapIndex].mac + "_preset\"  class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                    "                            <span  class=\"btn btn-primary\" >" + presetRXMap[rxMapIndex].name + "</span>\n" + txContent +
                                    "                        </div>";
                            }
                        }

                    }


                    for (txMapIndex in presetTXMap) {
                        if (checkDevicePermission(presetTXMap[txMapIndex].mac)) {
                            tx_dropdown_list += "<option value=\"" + presetTXMap[txMapIndex].mac + "\">"
                                + presetTXMap[txMapIndex].name + "</option>";
                        }
                    }

                    $("#modal-preset-rx-list").append(rx_dropdown_list);
                    $("#modal-preset-tx-list").append(tx_dropdown_list);
                    $("#receiver-container").append(rx_list);
                    // set receiver content --- end
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    //  $(".loading").hide();
                    showErrorToast("Recall preset failed !");
                }
            });
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
        }
    });
}

/**
 * Preset modal commit button click listener
 */
function presetCommitClickEvent() {
    $("#bt-preset-commit").click(function () {
        if (isDebugMode) {
            console.log("bt-preset-commit");
            console.log("rx mac = " + $("#modal-preset-rx-list").val());
            console.log("tx mac = " + $("#modal-preset-tx-list").val());
            console.log("tx id = " + presetTXMap[$("#modal-preset-tx-list").val()].id);
            presetRXMap[$("#modal-preset-rx-list").val()].id = presetTXMap[$("#modal-preset-tx-list").val()].id;
        }
        $("#" + $("#modal-preset-rx-list").val() + "_preset").children().each(function () {
            if ($(this).hasClass("preset-id")) {
                if ($(this).hasClass("btn-warning")) {
                    $(this).removeClass("btn-warning");
                    $(this).addClass("btn-danger");
                }
                $(this).attr("data-id", presetTXMap[$("#modal-preset-tx-list").val()].id);
                $(this).text(presetTXMap[$("#modal-preset-tx-list").val()].name);
            }
        });
        showSuccessToast("Setting complete !");
    });
}


/**
 * RX list item click listener (Preset modal)
 */
function rxPresetItemClickEvent() {
    $(".rx-preset").click(function () {
        if (isDebugMode) {
            console.log("rx-preset");
        }
        if ($(this).hasClass("btn-primary")) {
            $(this).removeClass("btn-primary");
            $(this).addClass("non-selected");
        } else {
            $(this).addClass("btn-primary");
            $(this).removeClass("non-selected");
        }
    });
}

/**
 * preset recall item click listener
 * */
function presetRecallDropDownListener() {

    $('.dropdown').on('click', '.preset_recall_item', function () {

        if (isDebugMode) {
            console.log("index = " + $(this).attr("data-index"));
        }

        var presetIndex = parseInt($(this).attr("data-index")) - 1;
        currentTXMap = new Object();
        currentRXMap = new Object();

        $.ajax({
            url: dbServerInfo.ip + "/api/node_info",
            type: "GET",
            crossDomain: true,
            dataType: 'json',
            success: function (returnData) {

                if (isDebugMode) {
                    console.log("preset recall get device status");
                }

                for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                    if (returnData[jsonArrayIndex].type != "r") {
                        //tx
                        currentTXMap[returnData[jsonArrayIndex].mac] = new txObject(returnData[jsonArrayIndex].id, returnData[jsonArrayIndex].host_name,
                            returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);
                    } else {
                        //rx
                        currentRXMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, returnData[jsonArrayIndex].host_name,
                            returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);
                    }
                }

                $.ajax({
                    url: dbServerInfo.ip + "/api/list_preset",
                    type: "GET",
                    success: function (data) {
                        if (isDebugMode) {
                            console.log("success " + JSON.stringify(data));
                            //   console.log("preset size = " + data[0].preset.length);
                        }
                        var errorReport = "";
                        var errorCounter = 1;
                        $("#text-area-report").empty();//clean error message area modal

                        var presetDeviceArray = data[0].preset[presetIndex].setting;

                        if (presetDeviceArray != null) {
                            var sizeOfSelectedPresetGroup = data[0].preset.length;
                            if (isDebugMode) {
                                console.log("preset " + presetIndex + " device size = " + sizeOfSelectedPresetGroup);
                            }
                            presetSwitchRecursive(currentTXMap, currentRXMap, presetDeviceArray, 0, errorReport, errorCounter);
                        } else {
                            if (isDebugMode) {
                                console.log("setting is null");
                            }
                            showWarningToast("This preset is empty !");
                        }
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        //  $(".loading").hide();
                        showErrorToast("Recall preset failed !");
                    }
                });
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
            }
        });
    });
}

/**
 * Preset Switch Recursive
 * @param currentTXArray : current TX status array
 * @param currentRXArray : current RX status array
 * @param presetRxArray : preset rx array
 * @param currentIndex : handle which preset rx right now
 * @param errorMessage : error message
 * @param currentErrorCount : error rx devicex count
 */
function presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, currentIndex, errorMessage, currentErrorCount) {
    var index = currentIndex;
    // var errorReport = errorMessage;//error report
    // var errorCounter = currentErrorCount; // error rx device counter

    //check device is RX
    if (presetDeviceArray[index].type === "r") {
        //RX
        //check this is exist right now
        if (typeof currentRXArray[presetDeviceArray[index].mac] !== "undefined") {
            if (isDebugMode) {
                console.log("preset rx mac = " + presetDeviceArray[index].mac);
                console.log("rx status = " + currentRXArray[presetDeviceArray[index].mac].status);
            }
            //check rx is on-line right now
            if (currentRXArray[presetDeviceArray[index].mac].status === "y") {
                if (isDebugMode) {
                    console.log("rx is on-line id = " + presetDeviceArray[index].id + " pin = " + currentRXArray[presetDeviceArray[index].mac].pin);
                }
                //check rx pin is 0000 or not right now
                if (currentRXArray[presetDeviceArray[index].mac].pin != "0000") {
                    errorMessage += currentErrorCount + ". " + currentRXArray[presetDeviceArray[index].mac].name + " pin status need to be 0000. \n\n";
                    currentErrorCount += 1;
                    index = index + 1;
                    if (Object.size(presetDeviceArray) > index) {
                        presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                    } else {
                        if (isDebugMode) {
                            console.log("Recall preset finish 1");
                        }
                        showSuccessToast("Recall preset finish !");
                        if (errorMessage.length > 0) {
                            $("#text-area-report").append(errorMessage);
                            $("#preset-recall-report-modal").modal('show');
                        }
                    }
                } else {
                    //rx can switch
                    var data = "ip=" + currentRXArray[presetDeviceArray[index].mac].ip + "&switch_id=" + presetDeviceArray[index].id + "&switch_type=z";
                    console.log("recall preset rx - " + data);
                    $.ajax({
                        url: dbServerInfo.ip + "/api/astswitch",
                        data: data,
                        type: "POST",
                        success: function (data) {
                            // var obj = jQuery.parseJSON(data);
                            if (isDebugMode) {
                                console.log("Recall preset rx success " + JSON.stringify(data));
                            }
                            index = index + 1;
                            if (Object.size(presetDeviceArray) > index) {
                                presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                            } else {
                                if (isDebugMode) {
                                    console.log("Recall preset finish 2");
                                }
                                showSuccessToast("Recall preset finish !");
                                if (errorMessage.length > 0) {
                                    $("#text-area-report").append(errorMessage);
                                    $("#preset-recall-report-modal").modal('show');
                                }
                            }
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            if (isDebugMode) {
                                console.log("Recall preset rx failed " + JSON.stringify(data));
                            }
                            index = index + 1;
                            if (Object.size(presetDeviceArray) > index) {
                                presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                            } else {
                                if (isDebugMode) {
                                    console.log("Recall preset finish 3");
                                }
                                showSuccessToast("Recall preset finish !");
                                if (errorMessage.length > 0) {
                                    $("#text-area-report").append(errorMessage);
                                    $("#preset-recall-report-modal").modal('show');
                                }
                            }
                        }
                    });
                }
            } else {
                // rx is off-line right now
                if (isDebugMode) {
                    console.log("rx isn't alive");
                }
                errorMessage += currentErrorCount + ". " + currentRXArray[presetDeviceArray[index].mac].name + " is offline. \n\n";
                currentErrorCount += 1;
                index = index + 1;
                if (Object.size(presetDeviceArray) > index) {
                    presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                } else {
                    if (isDebugMode) {
                        console.log("Recall preset finish 4");
                    }
                    showSuccessToast("Recall preset finish !");
                    if (errorMessage.length > 0) {
                        $("#text-area-report").append(errorMessage);
                        $("#preset-recall-report-modal").modal('show');
                    }
                }
            }
        } else {
            //rx is not exist right now
            if (isDebugMode) {
                console.log("rx undefined");
            }
            if (presetDeviceArray[index].host_name.length > 0) {
                errorReport += currentErrorCount + ". " + "Receiver name " + presetDeviceArray[index].host_name + " is  not exist. \n\n";
                currentErrorCount += 1;
                index = index + 1;
                if (Object.size(presetDeviceArray) > index) {
                    presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                } else {
                    if (isDebugMode) {
                        console.log("Recall preset finish 5");
                    }
                    showSuccessToast("Recall preset finish !");
                    if (errorMessage.length > 0) {
                        $("#text-area-report").append(errorMessage);
                        $("#preset-recall-report-modal").modal('show');
                    }
                }
            }
        }
    } else {
        //TX
        if (typeof currentTXArray[presetDeviceArray[index].mac] !== "undefined") {
            if (isDebugMode) {
                console.log("preset tx mac = " + presetDeviceArray[index].mac);
                console.log("tx status = " + currentTXArray[presetDeviceArray[index].mac].alive);
            }
            //check tx is on-line right now
            if (currentTXArray[presetDeviceArray[index].mac].alive === "y") {
                if (isDebugMode) {
                    console.log("tx is on-line tx id = " + presetDeviceArray[index].id + " pin = " + currentTXArray[presetDeviceArray[index].mac].pin);
                }
                //rx can switch
                var data = "ip=" + currentTXArray[presetDeviceArray[index].mac].ip + "&switch_id=" + presetDeviceArray[index].id + "&switch_type=z";
                if (isDebugMode) {
                    console.log("recall preset tx - " + data);
                }
                $.ajax({
                    url: dbServerInfo.ip + "/api/astswitch",
                    data: data,
                    type: "POST",
                    success: function (data) {
                        // var obj = jQuery.parseJSON(data);
                        if (isDebugMode) {
                            console.log("Recall preset tx success " + JSON.stringify(data));
                        }
                        index = index + 1;
                        if (Object.size(presetDeviceArray) > index) {
                            presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                        } else {
                            if (isDebugMode) {
                                console.log("Recall preset finish 6");
                            }
                            showSuccessToast("Recall preset finish !");
                            if (errorMessage.length > 0) {
                                $("#text-area-report").append(errorMessage);
                                $("#preset-recall-report-modal").modal('show');
                            }
                        }
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("Recall preset tx failed " + JSON.stringify(data));
                        }
                        index = index + 1;
                        if (Object.size(presetDeviceArray) > index) {
                            presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                        } else {
                            if (isDebugMode) {
                                console.log("Recall preset finish 7");
                            }
                            showSuccessToast("Recall preset finish !");
                            if (errorMessage.length > 0) {
                                $("#text-area-report").append(errorMessage);
                                $("#preset-recall-report-modal").modal('show');
                            }
                        }
                    }
                });

            } else {
                // tx is off-line right now
                if (isDebugMode) {
                    console.log("tx isn't alive");
                }
                errorMessage += currentErrorCount + ". " + currentTXArray[presetDeviceArray[index].mac].name + " is offline. \n\n";
                currentErrorCount += 1;
                index = index + 1;
                if (Object.size(presetDeviceArray) > index) {
                    presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                } else {
                    if (isDebugMode) {
                        console.log("Recall preset finish 8");
                    }
                    showSuccessToast("Recall preset finish !");
                    if (errorMessage.length > 0) {
                        $("#text-area-report").append(errorMessage);
                        $("#preset-recall-report-modal").modal('show');
                    }
                }
            }
        } else {
            //tx is not exist right now
            if (isDebugMode) {
                console.log("tx undefined");
            }
            if (presetDeviceArray[index].host_name.length > 0) {
                errorMessage += currentErrorCount + ". " + "transmitter name " + presetDeviceArray[index].host_name + " is  not exist. \n\n";
                currentErrorCount += 1;
                index = index + 1;
                if (Object.size(presetDeviceArray) > index) {
                    presetSwitchRecursive(currentTXArray, currentRXArray, presetDeviceArray, index, errorMessage, currentErrorCount);
                } else {
                    if (isDebugMode) {
                        console.log("Recall preset finish 9");
                    }
                    showSuccessToast("Recall preset finish !");
                    if (errorMessage.length > 0) {
                        $("#text-area-report").append(errorMessage);
                        $("#preset-recall-report-modal").modal('show');
                    }
                }
            }
        }

    }
}

/**
 * preset save item click listener
 * */
function presetSaveDropDownListener() {

    $('.dropdown').on('click', '.preset_save_item', function () {

        if (isDebugMode) {
            console.log("index = " + $(this).attr("data-index"));
        }

        var data = "index=" + $(this).attr("data-index");
        var presetIndex = parseInt($(this).attr("data-index")) - 1;

        $.ajax({
            url: dbServerInfo.ip + "/api/save_preset",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                    console.log("parser result = " + obj.result);
                }

                if (obj.result != "OK") {
                    showErrorToast("Setting preset failed !");
                } else {
                    showSuccessToast("Setting preset successful");
                    if (presetIndex > -1) {
                        calPresetWithCurrentRxStatus(presetIndex);
                    }
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                //  $(".loading").hide();
                showErrorToast("Setting preset failed !");
            }
        });
    });
}

/**
 * Preset modal apply click event
 */
function presetModalApplyClickEvent() {
    $("#bt-preset-apply").click(function () {

        var data = {
            index: $(this).attr("data-preset"),
            setting: []
        };

        $('#preset-container').children('div').each(function () {
            $(this).children('span').each(function () {
                if ($(this).hasClass("preset-id")) {
                    data.setting.push({
                        "ip": "",
                        "type": "r",
                        "host_name": $(this).attr("data-rxname"),
                        "mac": $(this).attr("data-mac"),
                        "pin": "",
                        "id": $(this).attr("data-id"),
                        "uptime": "",
                        "alive": "",
                        "fw": "",
                        "osd_index": "0",
                        "rhost_name": ""
                    });
                }
            });
        });

        $.ajax({
            url: dbServerInfo.ip + "/api/node_info",
            type: "GET",
            crossDomain: true,
            dataType: 'json',
            success: function (returnData) {
                for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                    if (returnData[jsonArrayIndex].type != "r") {
                        //tx
                        data.setting.push({
                            "ip": "",
                            "type": "t",
                            "host_name": returnData[jsonArrayIndex].host_name,
                            "mac": returnData[jsonArrayIndex].mac,
                            "pin": "",
                            "id": returnData[jsonArrayIndex].id,
                            "uptime": "",
                            "alive": "",
                            "fw": "",
                            "osd_index": "0",
                            "rhost_name": ""
                        });
                    }
                }

                if (isDebugMode) {
                    console.log("modify preset json data = " + JSON.stringify(data));
                }

                $.ajax({
                    url: dbServerInfo.ip + "/api/modify_preset",
                    data: JSON.stringify(data),
                    type: "POST",
                    dataType: "json",
                    success: function (data) {
                        if (isDebugMode) {
                            console.log("success " + JSON.stringify(data));
                        }
                        if (data.result != "OK") {
                            //  $(".loading").hide();
                            showErrorToast("Setting preset failed !");
                        } else {
                            showSuccessToast("Setting preset successful");

                        }
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Setting preset failed !");
                    }
                });
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
            }
        });
    });
}

/**
 * switch channel
 * @param rx_ip : rx's IP
 * @param tx_group : tx's group ID
 */
function switchChannel(rx_ip, tx_group) {

    $.ajax({
        url: dbServerInfo.ip + "/api/astswitch",
        data: "ip=" + rx_ip + "&switch_id=" + tx_group + "&switch_type=z",
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
                console.log("parser result = " + obj.result);
            }
            if (obj.result != "OK") {
                //  $(".loading").hide();
                showErrorToast("Switch failed !");
            } else {
                showSuccessToast("Switch successful");
                //updatePreView();
                aspeedWorker.postMessage(WORKER_UPDATE_INFO_EVENT);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            //  $(".loading").hide();
            showErrorToast("Switch failed !");
        }
    });
}

/**
 * switch all rx channel
 * @param rx_ip : rx's IP
 * @param tx_group : tx's group ID
 */
function switchRXAllChannel(rx_ip, tx_group) {
    $.ajax({
        url: dbServerInfo.ip + "/api/astswitch",
        data: "ip=" + rx_ip + "&switch_id=" + tx_group + "&switch_type=z",
        type: "POST",
        success: function (data) {
            // var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            // $(".loading").hide();
            showErrorToast("Switch failed !");
        }
    });
}

/**
 * Update PreView (Refresh)
 */
function updateASpeed(isFirstTime, returnData) {

    var tempTxMap = new Object();
    var tempRxMap = new Object();
    var dropdown_tx_item = "";
    for (var jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {


        var deviceStatusStyle = "1";
        if (returnData[jsonArrayIndex].alive != "y") {
            deviceStatusStyle = "0.5";
        }

        //update TX info - start
        if (returnData[jsonArrayIndex].type != "r") {

            if (isDebugMode) {
                console.log("tx size = " + Object.size(txMap));
            }

            //check tx is alive
            if (returnData[jsonArrayIndex].alive != "n") {
                dropdown_tx_item += "<li class=\"tx_item\" data-group=\"" + returnData[jsonArrayIndex].id + "\"><a><span style='color: rgb(100, 108, 128)'>" +
                    statusHtml(returnData[jsonArrayIndex].alive, true) + "  " + returnData[jsonArrayIndex].host_name + "</a></span></li>";
            }

            //check mac is exist
            var isMacExist = false;
            for (index in txMap) {
                if (returnData[jsonArrayIndex].mac === txMap[index].mac) {
                    isMacExist = true;
                }
            }

            if (!isMacExist) {

                if (($("#ul-group").attr("data-current_id") === '0') || typeof (clusterMap[returnData[jsonArrayIndex].mac]) !== "undefined") {
                    //all devices
                    if (isDebugMode) {
                        console.log("tx " + returnData[jsonArrayIndex].mac + " not exist ! ip = " + returnData[jsonArrayIndex].ip);
                    }
                    //mac isn't exist
                    var txCounter = Object.size(txMap);
                    var newTX = "";
                    var imgPah = "";

                    if (returnData[jsonArrayIndex].alive == "y") {
                        imgPath = doesFileExistForInitial("../snapshot/" + returnData[jsonArrayIndex].mac + ".jpg");
                    } else {
                        imgPath = "../snapshot/offline.bmp";
                    }

                    //add new TX
                    if ((txCounter % 2) == 0) {
                        newTX += "<div class='row' id=\"tx_row_" + Math.floor(txCounter / 2) + "\">";
                    }

                    newTX += "<div id=\"tx_" + returnData[jsonArrayIndex].mac + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" data-audio_id=\"" + returnData[jsonArrayIndex].subscriber_audio_id + "\"  data-mac=\"" + returnData[jsonArrayIndex].mac + "\" data-pin=\"" + returnData[jsonArrayIndex].pin + "\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" data-id=\"" + returnData[jsonArrayIndex].id + "\" class=\"col-xs-6 draggable\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"opacity:" + deviceStatusStyle + "\">\n" +
                        "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                        "  <div  class=\"no_pad\"> <div  class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                        "        <div  class=\"no_pad\" style=' width: 100%'><span data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class=\"substreaming\" id=\"" + returnData[jsonArrayIndex].mac + "_id\" style='font-size: 16px;cursor:pointer;margin-right:10px;float:right;border-radius:20px;display: block;color: white;margin-top:20px;text-align: " +
                        "                           center;border-width:2px;border-style: solid;border-color: rgb(113,143,171);width: 80px;background: rgb(247,151,29,0)'> #&nbsp " + returnData[jsonArrayIndex].subscriber_audio_id + " </span></div>" +
                        "    <div style='width: 100%;margin-top:120px;'><span id=\"" + returnData[jsonArrayIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display: inline-block;'>&nbsp&nbsp" + getDeviceName(returnData[jsonArrayIndex]) + "</span>" +
                        "     <span id=\"" + returnData[jsonArrayIndex].mac + "_modify_name\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                        "      <div   class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;border-radius: 10px 10px 0 0'>" +
                        "                            <img id=\"" + returnData[jsonArrayIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                        "      </div> </div></div>" +
                        "      <div   class=\"row no_pad device_footer_div\"  style='width: 100%;border-radius: 10px 10px 10px 10px;'><div class=\"card-footer col-xs-2 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 0px 10px\">" +
                        "                                  <img id=\"" + returnData[jsonArrayIndex].mac + "_lightbulb\" data-type=\"" + returnData[jsonArrayIndex].type + "\" data-alive=\"" + returnData[jsonArrayIndex].alive + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-8 no_pad\" style=\"background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                        "                            <span id=\"" + returnData[jsonArrayIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: white;font-size: 16px;padding-top: 8px;display: inline-block\">" + returnData[jsonArrayIndex].ip + "</span>" +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-2 right_bottom_corner no_pad\" style=\"background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 10px 0px\">" +
                        // "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_count\" type=\"button\" data-count=0 class=\"btn\" style=\"display: block; pointer-events: none;background: rgba(0,0,0,0) \">" +
                        // "                            <span class=\"glyphicon glyphicon-user\" aria-hidden=\"true\" style=\"font-size: 16px\"></span> <span id=\"" + returnData[jsonArrayIndex].mac + "_count_span\" style=\"font-size: 16px\">0</span>" +
                        // "                        </button>" +
                        "                        </div></div>" +
                        " </div>";


                    if ((txCounter % 2) == 0) {
                        //need to add new row
                        newTX += "</div><br>";
                        $("#tx-scope").append(newTX);
                    } else {
                        //non need to add new row
                        $("#tx_row_" + Math.floor(txCounter / 2)).append(newTX);
                    }
                    txMap[returnData[jsonArrayIndex].mac] = new txObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].mac,
                        returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);//used to count UI row
                    showModifyNameModal();

                }

            } else {

                //mac is exist
                $("#tx_" + returnData[jsonArrayIndex].mac).css('opacity', deviceStatusStyle);
                $("#tx_" + returnData[jsonArrayIndex].mac).attr("data-pin", returnData[jsonArrayIndex].pin);
                $("#tx_" + returnData[jsonArrayIndex].mac).attr("data-id", returnData[jsonArrayIndex].id);
                $("#tx_" + returnData[jsonArrayIndex].mac).attr("data-status", returnData[jsonArrayIndex].alive);
                $("#tx_" + returnData[jsonArrayIndex].mac).attr("data-ip", returnData[jsonArrayIndex].ip);
                $("#rx_" + returnData[jsonArrayIndex].mac).attr("data-audio_id", returnData[jsonArrayIndex].subscriber_audio_id);
                $("#" + returnData[jsonArrayIndex].mac + "_count").attr("data-count", 0);
                $("#" + returnData[jsonArrayIndex].mac + "_count_span").text(0);

                if (returnData[jsonArrayIndex].alive === "y") {
                    //check if the file exists
                    var imgPath = "";
                    switch (doesFileExist("../snapshot/" + returnData[jsonArrayIndex].mac + ".jpg")) {

                        case CHECK_IMAGE_EVENT_OK:
                            $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/" + returnData[jsonArrayIndex].mac + ".jpg");
                            break;

                        case CHECK_IMAGE_EVENT_SIZE_ISSUE:
                            if (isDebugMode) {
                                console.log("CHECK_IMAGE_EVENT_SIZE_ISSUE " + $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src"));
                            }
                            if ($("#" + returnData[jsonArrayIndex].mac + "_img").attr("src") === "../snapshot/offline.bmp") {
                                $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                            }
                            break;

                        case CHECK_IMAGE_EVENT_NOT_FOUND:
                            $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                            break;
                    }
                } else {
                    $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/offline.bmp");
                }
                $("#" + returnData[jsonArrayIndex].mac + "_name").text("\xa0\xa0" + getDeviceName(returnData[jsonArrayIndex]));
            }

            tempTxMap[returnData[jsonArrayIndex].mac] = new txObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].mac,
                returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);
            //update TX info - end
        } else {
            //update RX info - start
            if (isDebugMode) {
                console.log("rx size = " + Object.size(rxMap));
            }
            tempRxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]),
                returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);

            var isMacExist = false;
            for (index in rxMap) {
                if (returnData[jsonArrayIndex].mac === rxMap[index].mac) {
                    isMacExist = true;
                }
            }

            if (!isMacExist) {
                //check mac is not exist
                var rxCounter = Object.size(rxMap);
                var newRX = "";
                //add new TX
                if ((rxCounter % 2) == 0) {
                    newRX += "<div class='row' id=\"rx_row_" + Math.floor(rxCounter / 2) + "\">";
                }
                //check if the file exists
                var imgPath = "";
                //  var txMac = "";
                var isTxExist = false;
                var sourceMac = "";
                var sourceName = "";
                var txAlive = false;

                var txMacMap = new Object();

                for (sourceIndex in txMap) {
                    if (returnData[jsonArrayIndex].id === txMap[sourceIndex].id) {
                        txMacMap[txMap[sourceIndex].mac] = new txObject("", "", txMap[sourceIndex].mac, txMap[sourceIndex].alive, txMap[sourceIndex].ip);
                        isTxExist = true;
                    }
                }

                if (Object.size(txMacMap) > 1) {
                    //tx has same group ID....
                    for (sourceIndex in txMacMap) {
                        if (txMacMap[sourceIndex].alive === "y") {
                            isTxAlive = true;
                            sourceName = txMacMap[sourceIndex].name;
                            sourceMac = txMacMap[sourceIndex].mac;
                            break;
                        }
                    }
                } else {
                    //tx group id is unique
                    for (sourceIndex in txMacMap) {
                        sourceName = txMacMap[sourceIndex].name;
                        sourceMac = txMacMap[sourceIndex].mac;
                        if (txMacMap[sourceIndex].alive === "y") {
                            isTxAlive = true;
                        } else {
                            isTxAlive = false;
                        }
                    }
                }

                if (returnData[jsonArrayIndex].alive != "n") {
                    if (isTxExist) {
                        if (txAlive) {
                            imgPath = doesFileExistForInitial("../snapshot/" + sourceMac + ".jpg");
                        } else {
                            imgPath = "../snapshot/nosignal.bmp";
                        }
                    } else {
                        imgPath = "../snapshot/nosignal.bmp";
                    }
                } else {
                    imgPath = "../snapshot/offline.bmp";
                }


                if ($("#ul-group").attr("data-current_id") > 0) {
                    console.log("stop update during rx group selected");
                    rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].ip,
                        returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);
                    getASpeedDeviceInfoByGroup();
                } else {

                    newRX += "<div id=\"rx_" + returnData[jsonArrayIndex].mac + "\" data-audio_id=\"" + returnData[jsonArrayIndex].publisher_audio_id + "\"  data-mac=\"" + returnData[jsonArrayIndex].mac + "\"  data-status=\"" + returnData[jsonArrayIndex].alive + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\"  data-pin=\"" + returnData[jsonArrayIndex].pin + "\" class=\"col-xs-6\" ondrop=\"Drop(event)\" ondragover=\"AllowDrop(event)\" ondragleave=\"LeaveDrop(event)\" style=\"opacity:" + deviceStatusStyle + "\">\n" +
                        "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                        "  <div class=\"no_pad\"> <div  class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                        "      <div class=\"no_pad\" style=' width: 100%;'><span data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class=\"substreaming\" id=\"" + returnData[jsonArrayIndex].mac + "_id\" style='font-size: 16px;cursor:pointer;margin-right:10px;float:right;border-radius:20px;display: block;color: white;margin-top:20px;text-align: " +
                        "                           center;width: 80px;background: rgba(247,151,29,0);border-style: solid;border-color: rgb(113,143,171)'> #&nbsp " + returnData[jsonArrayIndex].publisher_audio_id + " </span></div>" +
                        "    <div style='width: 100%;margin-top:120px;'> <span id=\"" + returnData[jsonArrayIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display: inline-block;'>&nbsp&nbsp" + getDeviceName(returnData[jsonArrayIndex]) + "</span>" +
                        "     <span id=\"" + returnData[jsonArrayIndex].mac + "_modify_name\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                        "      <div  style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;border-radius: 10px 10px 0 0'>" +
                        "                            <img id=\"" + returnData[jsonArrayIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                        "      </div> </div></div>" +
                        "          <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\">" +
                        "                        <div class=\"card-footer col-xs-1 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 0px 10px\">" +
                        "                                  <img id=\"" + returnData[jsonArrayIndex].mac + "_lightbulb\" data-type=\"r\" data-alive=\"" + returnData[jsonArrayIndex].alive + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-7 no_pad\" style=\"background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                        "                            <span id=\"" + returnData[jsonArrayIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: white;font-size: 16px;padding-top: 8px;display: inline-block\">" + returnData[jsonArrayIndex].ip + "</span>" +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;margin-right: 7%;\">" +
                        "                                <button id=\"" + returnData[jsonArrayIndex].mac + "_cec_on\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class=\"btn cec_on\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='rgb(26,188,114)';borderChange(this.id, 'rgb(26,188,114)')\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;height: 28px;width:50px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">ON</button> " +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                        "                                 <button id=\"" + returnData[jsonArrayIndex].mac + "_cec_off\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='red';borderChange(this.id, 'red');\" class=\"btn cec_off\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;width:50px;height: 28px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">OFF</button> " +
                        "                        </div>" +
                        "</div>" +
                        " </div>";


                    if ((rxCounter % 2) == 0) {
                        newRX += "</div><br>";
                        $("#rx-scope").append(newRX);
                    } else {
                        //non need to add new row
                        $("#rx_row_" + Math.floor(rxCounter / 2)).append(newRX);
                    }
                    //rx preview image is according to tx preview
                    // $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle({
                    //     on: '',
                    //     off: '',
                    // });
                    rxMuteToggleListener();

                    if (returnData[jsonArrayIndex].alive != "n") {
                        $("#" + returnData[jsonArrayIndex].mac + "_mute").prop('checked', true).bootstrapToggle('destroy').bootstrapToggle({
                            on: '',
                            off: '',
                        });
                        $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle('enable');
                    } else {
                        $("#" + returnData[jsonArrayIndex].mac + "_mute").prop('checked', false).bootstrapToggle('destroy').bootstrapToggle({
                            on: '',
                            off: '',
                        });
                        $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle('disable');
                    }
                    rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].ip,
                        returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);//used to count UI row
                    showModifyNameModal();
                }

                // rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].ip,
                //     returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);//used to count UI row
                // showModifyNameModal();
            } else {

                var isTxExist = false;
                var sourceMac = "";
                var sourceName = "";
                var isTxAlive = false;
                var imgPath = "";
                var txMacMap = new Object();

                for (sourceIndex in txMap) {
                    if (returnData[jsonArrayIndex].id === txMap[sourceIndex].id) {
                        txMacMap[txMap[sourceIndex].mac] = new txObject("", "", txMap[sourceIndex].mac, txMap[sourceIndex].alive, txMap[sourceIndex].ip);
                        isTxExist = true;
                    }
                }

                if (Object.size(txMacMap) > 1) {
                    //tx has same group ID....
                    for (sourceIndex in txMacMap) {
                        if (txMacMap[sourceIndex].alive === "y") {
                            isTxAlive = true;
                            sourceName = txMacMap[sourceIndex].name;
                            sourceMac = txMacMap[sourceIndex].mac;
                            break;
                        }
                    }
                } else {
                    //tx group id is unique
                    for (sourceIndex in txMacMap) {
                        sourceName = txMacMap[sourceIndex].name;
                        sourceMac = txMacMap[sourceIndex].mac;
                        if (txMacMap[sourceIndex].alive === "y") {
                            isTxAlive = true;
                        } else {
                            isTxAlive = false;
                        }
                    }
                }

                if (returnData[jsonArrayIndex].alive != "n") {

                    //  if (isFirstTime) {
                    // $("#" + returnData[jsonArrayIndex].mac + "_mute").prop('checked', true).bootstrapToggle('destroy').bootstrapToggle({
                    //     on: '',
                    //     off: '',
                    // });
                    //  }
                    $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle('enable');


                    if (isTxExist) {
                        if (isTxAlive) {

                            switch (doesFileExist("../snapshot/" + sourceMac + ".jpg")) {

                                case CHECK_IMAGE_EVENT_OK:
                                    $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/" + sourceMac + ".jpg");
                                    break;

                                case CHECK_IMAGE_EVENT_SIZE_ISSUE:

                                    if ($("#" + returnData[jsonArrayIndex].mac + "_img").attr("src") === "../snapshot/offline.bmp") {
                                        $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                                    } else if ($("#" + returnData[jsonArrayIndex].mac + "_img").attr("src") === "../snapshot/" + sourceMac + ".jpg") {
                                        if (isDebugMode) {
                                            console.log("CHECK_IMAGE_EVENT_SIZE_ISSUE didnt change anything "
                                                + " rx src = " + $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src") + " new src = " + sourceMac);
                                        }
                                    } else {
                                        if (isDebugMode) {
                                            console.log("CHECK_IMAGE_EVENT_SIZE_ISSUE change to no signal");
                                        }
                                        $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                                    }
                                    break;

                                case CHECK_IMAGE_EVENT_NOT_FOUND:
                                    $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                                    break;
                            }
                        } else {
                            $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                        }
                    } else {
                        $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/nosignal.bmp");
                    }
                } else {
                    $("#" + returnData[jsonArrayIndex].mac + "_mute").prop('checked', false).bootstrapToggle('destroy').bootstrapToggle({
                        on: '',
                        off: '',
                    });
                    $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle('disable');
                    // imgPath = "../snapshot/offline.bmp";
                    $("#" + returnData[jsonArrayIndex].mac + "_img").attr("src", "../snapshot/offline.bmp");
                }

                $("#" + returnData[jsonArrayIndex].mac + "_mute").attr("data-ip", returnData[jsonArrayIndex].ip);
                //update rx source preview
                $("#" + returnData[jsonArrayIndex].mac + "_img").removeClass();
                $("#" + returnData[jsonArrayIndex].mac + "_img").addClass("img-fluid");
                $("#" + returnData[jsonArrayIndex].mac + "_img").addClass(sourceMac + "_rx_img");

                $("#rx_" + returnData[jsonArrayIndex].mac).css('opacity', deviceStatusStyle);
                $("#rx_" + returnData[jsonArrayIndex].mac).attr("data-pin", returnData[jsonArrayIndex].pin);
                $("#rx_" + returnData[jsonArrayIndex].mac).attr("data-id", returnData[jsonArrayIndex].id);
                $("#rx_" + returnData[jsonArrayIndex].mac).attr("data-audio_id", returnData[jsonArrayIndex].publisher_audio_id);
                $("#rx_" + returnData[jsonArrayIndex].mac).attr("data-status", returnData[jsonArrayIndex].alive);
                $("#" + returnData[jsonArrayIndex].mac + "_name").text("\xa0\xa0" + getDeviceName(returnData[jsonArrayIndex]));
            }
            //update RX info - end
        }

        //update TX & RX info
        //  $("#" + returnData[jsonArrayIndex].mac + "_id").html("<span class=\"glyphicon glyphicon-expand\" aria-hidden=\"true\"> </span> " + returnData[jsonArrayIndex].id);
        //$("#" + returnData[jsonArrayIndex].mac + "_id").text("#\xa0\xa0" + returnData[jsonArrayIndex].id);
        if(returnData[jsonArrayIndex].type != "r"){
            $("#" + returnData[jsonArrayIndex].mac + "_id").text("#\xa0\xa0" + returnData[jsonArrayIndex].subscriber_audio_id);
        }else{
            $("#" + returnData[jsonArrayIndex].mac + "_id").text("#\xa0\xa0" + returnData[jsonArrayIndex].publisher_audio_id);
        }
        //  $("#" + returnData[jsonArrayIndex].mac + "_ip").html("<span class=\"glyphicon glyphicon-globe\" aria-hidden=\"true\"></span> " + returnData[jsonArrayIndex].ip);
        $("#" + returnData[jsonArrayIndex].mac + "_ip").text(returnData[jsonArrayIndex].ip);
        $("#" + returnData[jsonArrayIndex].mac + "_lightbulb").attr("data-ip", returnData[jsonArrayIndex].ip);
        $("#" + returnData[jsonArrayIndex].mac + "_lightbulb").attr("data-alive", returnData[jsonArrayIndex].alive);
        $("#" + returnData[jsonArrayIndex].mac + "_modify_name").attr("data-status", returnData[jsonArrayIndex].alive);

        $("#" + returnData[jsonArrayIndex].mac + "_cec_on").attr("data-ip", returnData[jsonArrayIndex].ip);
        $("#" + returnData[jsonArrayIndex].mac + "_cec_off").attr("data-ip", returnData[jsonArrayIndex].ip);

    }

    var deviceCount = 0;
    $('.cec_off').each(function(i, obj) {
        deviceCount++;
    });
    $("#span-rx-count").text(deviceCount);

    //clean TX delete device - start
    for (txIndex in txMap) {
        var isExist = false;
        for (tempIndex in tempTxMap) {
            if (txMap[txIndex].mac === tempTxMap[tempIndex].mac) {
                isExist = true;
            }
        }

        if (!isExist) {
            if (isDebugMode) {
                console.log("mac " + txMap[txIndex].mac + " is delete !");
            }
            // getASpeedDeviceInfo();//get all again (position change)
            getASpeedDeviceInfoByGroup();
            return;
        }
    }
    //clean TX delete device - end

    //clean RX delete device - start
    for (rxIndex in rxMap) {
        var isExist = false;
        for (tempIndex in tempRxMap) {
            if (rxMap[rxIndex].mac === tempRxMap[tempIndex].mac) {
                isExist = true;
            }
        }

        if (!isExist) {
            if (isDebugMode) {
                console.log("mac " + rxMap[rxIndex].mac + " is delete !");
            }
            // getASpeedDeviceInfo();//get all again (position change)
            getASpeedDeviceInfoByGroup();
            return;
        }
    }
    //clean RX delete device - end

    txMap = tempTxMap;
    rxMap = tempRxMap;
    tempTxMap = null;
    tempRxMap = null;
    // mappingTable.clear().draw();
    if ($("#ul-group").attr("data-current_id") > 0) {
        $("#span-tx-count").text(Object.size(txGroupMap));
    } else {
        $("#span-tx-count").text(Object.size(txMap));
    }

    // if ($("#ul-rx-group").attr("data-current_id") > 0) {
    //     $("#span-rx-count").text(Object.size(rxGroupMap));
    // } else {
    //     $("#span-rx-count").text(Object.size(rxMap));
    // }
    // $("#span-rx-count").text(Object.size(rxMap));
    // $("#span-tx-count").text(Object.size(txMap));

    //update TX used count ----- start
    for (rxMapIndex in rxMap) {

        var isTxExist = false;
        var sourceMac = "";
        var sourceName = "";

        var txMacMap = new Object();

        for (sourceIndex in txMap) {
            if (rxMap[rxMapIndex].id === txMap[sourceIndex].id) {
                txMacMap[txMap[sourceIndex].mac] = new txObject("", txMap[sourceIndex].name, txMap[sourceIndex].mac, txMap[sourceIndex].alive, txMap[sourceIndex].ip);
                isTxExist = true;
            }
        }

        if (Object.size(txMacMap) > 1) {
            //tx has same group ID....
            for (sourceIndex in txMacMap) {
                if (txMacMap[sourceIndex].alive === "y") {
                    isTxAlive = true;
                    sourceName = txMacMap[sourceIndex].name;
                    sourceMac = txMacMap[sourceIndex].mac;
                    break;
                }
            }
        } else {
            //tx group id is unique
            for (sourceIndex in txMacMap) {
                sourceName = txMacMap[sourceIndex].name;
                sourceMac = txMacMap[sourceIndex].mac;
                if (txMacMap[sourceIndex].alive === "y") {
                    isTxAlive = true;
                } else {
                    isTxAlive = false;
                }
            }
        }

        //check id is exist or not (check is new RX or not)
        if ($(".form-control").val().length > 0) {

            if (isDebugMode) {
                console.log("user search...");
            }

            if ($("#mapping_" + rxMap[rxMapIndex].mac + "_row").length) {
                $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(3).empty();

                //re draw mapping table ------ start
                if (rxMap[rxMapIndex].status === "y") {
                    //update mapping table --- start
                    $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(0).text("<span style=\"color: rgb(100, 108, 128)!important;\">" + rxMap[rxMapIndex].id + "</span>");//group
                    $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(1).text("<span style=\"color: rgb(100, 108, 128)!important;\">" + rxMap[rxMapIndex].name + "</span>");//name
                    //update mapping table --- end
                    if (isTxExist) {
                        $("#" + sourceMac + "_count").attr("data-count", (parseInt($("#" + sourceMac + "_count").attr("data-count")) + 1));
                        $("#" + sourceMac + "_count_span").text(parseInt($("#" + sourceMac + "_count").attr("data-count")));
                        $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(3).append(" <div class=\"dropdown\"><button class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                            "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\"><span class=\"title_text_color\">" + sourceName + "</span>" +
                            "                        <span class=\"caret\"></span>" +
                            "                        </button>" +
                            "                        <ul class=\"dropdown-menu dropdown-mapping\" style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                            "                        </ul>" +
                            "                    </div>");
                    } else {
                        $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(3).append(" <div class=\"dropdown\"><button class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                            "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\"><span class=\"title_text_color\">N/A</span>" +
                            "                        <span class=\"caret\"></span>" +
                            "                        </button>" +
                            "                        <ul class=\"dropdown-menu dropdown-mapping\" style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                            "                        </ul>" +
                            "                    </div>");
                    }

                } else {
                    var rowObject = $("#mapping_" + rxMap[rxMapIndex].mac + "_row");
                    mappingTable.row(rowObject).remove().draw();
                }
                //re draw mapping table ------ end
            }
        } else {

            if (isDebugMode) {
                console.log("user not search...");
            }

            if ($("#mapping_" + rxMap[rxMapIndex].mac + "_row").length) {
                $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(3).empty();

                //re draw mapping table ------ start
                if (rxMap[rxMapIndex].status === "y") {
                    //update mapping table --- start
                    $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(0).html("<span style=\"color: rgb(100, 108, 128)!important;\">" + rxMap[rxMapIndex].id + "</span>");//group
                    $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(1).html("<span style=\"color: rgb(100, 108, 128)!important;\">" + rxMap[rxMapIndex].name + "</span>");//name
                    //update mapping table --- end
                    if (isTxExist) {
                        $("#" + sourceMac + "_count").attr("data-count", (parseInt($("#" + sourceMac + "_count").attr("data-count")) + 1));
                        $("#" + sourceMac + "_count_span").text(parseInt($("#" + sourceMac + "_count").attr("data-count")));
                        $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(3).append(" <div class=\"dropdown\"><button class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                            "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\" style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\"><span class=\"title_text_color\">" + sourceName + "</span>" +
                            "                        <span class=\"caret\"></span>" +
                            "                        </button>" +
                            "                        <ul class=\"dropdown-menu dropdown-mapping\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                            "                        </ul>" +
                            "                    </div>");
                    } else {
                        $("#mapping_" + rxMap[rxMapIndex].mac + "_row").find('td').eq(3).append(" <div class=\"dropdown\"><button class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                            "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\" style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\"><span class=\"title_text_color\">N/A</span>" +
                            "                        <span class=\"caret\"></span>" +
                            "                        </button>" +
                            "                        <ul class=\"dropdown-menu dropdown-mapping\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                            "                        </ul>" +
                            "                    </div>");
                    }
                } else {
                    var rowObject = $("#mapping_" + rxMap[rxMapIndex].mac + "_row");
                    mappingTable.row(rowObject).remove().draw();
                }
                //re draw mapping table ------ end
            } else {
                //add new rx to mapping table ------ start
                if (rxMap[rxMapIndex].status === "y") {

                    if (isTxExist) {
                        $("#" + sourceMac + "_count").attr("data-count", (parseInt($("#" + sourceMac + "_count").attr("data-count")) + 1));
                        $("#" + sourceMac + "_count_span").text(parseInt($("#" + sourceMac + "_count").attr("data-count")));
                    }

                    if (sourceName.length > 0) {
                    } else {
                        sourceName = "N/A";
                    }

                    var mapping_table_rows = "<tr id=\"mapping_" + rxMap[rxMapIndex].mac + "_row\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;color: rgb(100, 108, 128)\">" + rxMap[rxMapIndex].id
                        + "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\"><span style='color: rgb(100, 108, 128)'>" + rxMap[rxMapIndex].name + "</span></td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;color: rgb(100, 108, 128)\">" + "RX"
                        + "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;)\">"
                        + "     <div class=\"dropdown\">" +
                        "                        <button class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                        "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\" style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\" >" + sourceName +
                        "                        <span class=\"caret\"></span>" +
                        "                        </button>" +
                        "                        <ul class=\"dropdown-menu dropdown-mapping\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                        "                        </ul>" +
                        "                    </div></tr>";

                    mappingTable.row.add($(mapping_table_rows)).draw();
                }
                //add new rx to mapping table ------ end
            }
        }
    }
    $(".dropdown-mapping").append(dropdown_tx_item);//add tx item to the drop menu (mapping table)
    //dropDownASpeedListener();
    //update TX used count ----- end
}

/**
 * Get default UI type
 */
function getDefaultUIType(isAspeed) {
    $.ajax({
        url: dbServerInfo.ip + "/api/system_config",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
            }

            if (data.type === "false") {
                if (isDebugMode) {
                    console.log("UI table mode");
                }
                $("#div_mapping_drog_list").hide();
                $("#div_mapping_table_list").show();
                if (isAspeed) {
                    $("#rx_all").hide();
                } else {
                    $("#ite_rx_all").hide();
                }
                $("#bt-hamburger").find('span').addClass("glyphicon-menu-hamburger");
                $("#bt-hamburger").find('span').removeClass("glyphicon-th-large");
            } else {
                if (isDebugMode) {
                    console.log("UI drag drop mode");
                }
                $("#div_mapping_table_list").hide();
                $("#div_mapping_drog_list").show();
                if (isAspeed) {
                    $("#rx_all").show();
                } else {
                    $("#ite_rx_all").show();
                }
                $("#bt-hamburger").find('span').removeClass("glyphicon-menu-hamburger");
                $("#bt-hamburger").find('span').addClass("glyphicon-th-large");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
        }
    });
}

/**
 * Bubble button click
 */
function bubbleClickListener() {
    $("body").on("click", ".shiny", function () {
        if ($(this).attr("data-alive") === "n") {
            showErrorToast("Offline device can't turn on red bubble light !");
        } else {
            var imgObject = $(this);
            var device_ip = $(this).attr("data-ip");
            if (isDebugMode) {
                console.log("device ip = " + device_ip);
            }
            $(this).attr("src", "../img/red_bubble.png");

            var post_data = "";

            post_data = "ip=" + device_ip + "&value=cat /sys/devices/platform/leds/leds/button_link/N_Led";

            $.ajax({
                url: dbServerInfo.ip + "/api/ast_sendcmd",
                data: post_data,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    imgObject.attr("src", "../img/lightbulb.png");
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    imgObject.attr("src", "../img/lightbulb.png");
                    showErrorToast("Blink LED failed !");
                }
            });
        }
    });
}

/**
 * CEC ON button click
 */
function cecONClickListener() {
    $("body").on("click", ".cec_on", function () {
        var post_data = "ip=" + $(this).attr("data-ip") + "&value=cec_send 40:04\n";
        if (isDebugMode) {
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                showSuccessToast("HDMI CEC turn on successful !");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("HDMI CEC turn on failed !");
            }
        });
    });
}

/**
 * CEC OFF button click
 */
function cecOFFClickListener() {
    $("body").on("click", ".cec_off", function () {
        var post_data = "ip=" + $(this).attr("data-ip") + "&value=cec_send f0:36\n";
        if (isDebugMode) {
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                showSuccessToast("HDMI CEC turn off successful !");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("HDMI CEC turn off failed !");
            }
        });
    });
}

/**
 * Get Group List
 */
function get_group_list() {

    $.ajax({
        url: dbServerInfo.ip + "/api/group_list",
        type: "GET",
        dataType: 'json',
        success: function (data) {

            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
                console.log("feedback =  " + data.message[0].name);
            }

            $('#select_group').find('option').remove();

            var jsonArrayIndex = 0;

            var select_group_list = "";

            //  select_group_list = " <option selected value=\"0\" > -- Without Group -- </option>";

            select_group_list = "<li class=\"group_item\" data-id=\"0\" data-name=\"ALL DEVICES\" data-offset=\"-11\" >" +
                "<span>\xa0\xa0  ALL DEVICES</span> </li>";

            if (data.result != "OK") {
                //    showErrorToast(obj.message);
            } else {

                for (jsonArrayIndex = 0; jsonArrayIndex < data.message.length; jsonArrayIndex++) {
                    // select_group_list = select_group_list + "<option value=" + data.message[jsonArrayIndex].id + ">" + data.message[jsonArrayIndex].name + "</option>";
                    select_group_list = select_group_list + "<li class=\"group_item\"   data-id=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                        "<span> \xa0\xa0 " + data.message[jsonArrayIndex].name + "</span> </li>";
                    // switch (data.message[jsonArrayIndex].img_type) {
                    //     case image_type_jpg:
                    //         if (checkFileIsExist("/group/tx/" + data.message[jsonArrayIndex].id + ".jpg")) {
                    //             select_group_list = select_group_list + "<li class=\"tx_group_item\"  data-id=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\"  data-offset=\"-11\" >" +
                    //                 "<img src=\"../group/tx/" + data.message[jsonArrayIndex].id + ".jpg\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </li>";
                    //         } else {
                    //             select_group_list = select_group_list + "<li class=\"tx_group_item\"   data-id=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                    //                 "<img src=\"../group/bzb.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </li>";
                    //         }
                    //         break;
                    //
                    //     case image_type_png:
                    //         if (checkFileIsExist("/group/tx/" + data.message[jsonArrayIndex].id + ".png")) {
                    //             select_group_list = select_group_list + "<li class=\"tx_group_item\"   data-id=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                    //                 "<img src=\"../group/tx/" + data.message[jsonArrayIndex].id + ".png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </li>";
                    //         } else {
                    //             select_group_list = select_group_list + "<li class=\"tx_group_item\"   data-id=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                    //                 "<img src=\"../group/bzb.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </li>";
                    //         }
                    //         break;
                    //
                    //
                    //     default:
                    //         select_group_list = select_group_list + "<li class=\"tx_group_item\"   data-id=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                    //             "<img src=\"../group/bzb.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </li>";
                    //         break;
                    //
                    // }
                }
                $("#ul-group").attr("data-current_id", 0);
                $("#ul-group").append(select_group_list);

                //   $("#select_preset_group").append(select_group_list);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ", thrownError);
            }
            showErrorToast("Get group info failed !");
        }
    });
}

function groupDropItemListener() {
    $('.dropdown').on('click', '.group_item', function () {

        $("#bt-group-content").text($(this).text());
        cleanTXDragList();
        cleanRXDragList();
        if ($(this).attr("data-id") > 0) {
            var data = "group_id=" + $(this).attr("data-id")
            var group_id = $(this).attr("data-id");
            $.ajax({
                url: dbServerInfo.ip + "/api/device_by_group",
                data: data,
                type: "GET",
                success: function (data) {
                    console.log("feedback =  " + JSON.stringify(data));
                    var obj = jQuery.parseJSON(data);
                    var tx_list = "";
                    if (obj.result != "OK") {
                        showErrorToast("Get group info failed !");
                    } else {
                        clusterMap = new Object();
                        for (index in obj.message) {
                            console.log("mac = ", obj.message[index].mac);
                            clusterMap[obj.message[index].mac] = new txObject("", "", "", "", "", "");
                        }
                        $("#ul-group").attr("data-current_id", group_id);
                        mappingTable.clear().draw();
                        getASpeedDeviceInfoByGroup();
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error " + thrownError);
                    }
                    //  $(".loading").hide();
                    showErrorToast("Get group info failed !");
                }
            });
        } else {
            $("#ul-group").attr("data-current_id", 0);
            cleanTXDragList();
            cleanRXDragList();
            getASpeedDeviceInfoByGroup();
            $("#bt-group-content").text("ALL DEVICES");
        }
    });
}

function getASpeedDeviceInfoByGroup() {

    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("ASpeed success" + JSON.stringify(returnData));
                console.log("data count = " + returnData.length);
            }
            cleanAllDragList();
            cleanAllTable();
            var rx_table_rows = "", tx_table_rows = "", mapping_table_rows = "";
            var tx_list = "", rx_list = "";
            var jsonArrayIndex = 0;
            var dropdown_tx_item = "";
            var txCounter = 0, rxCounter = 0;
            txMap = new Object(); // or var map = {};
            rxMap = new Object();
            txGroupMap = new Object();
            rxGroupMap = new Object();
            // var txMap = new Object(); // or var map = {};
            // var rxMap = new Object();
            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {

                if (returnData[jsonArrayIndex].type != "r") {

                    var device_id = returnData[jsonArrayIndex].id;
                    var group_ip = "";
                    var drop_status_style = "";
                    //group ip
                    group_ip = createGroupIP(device_id);
                    var mac = macFormat(returnData[jsonArrayIndex].mac.toString());

                    //check user select what group
                    if ($("#ul-group").attr("data-current_id") > 0) {

                        //check device is in the group
                        if (typeof (clusterMap[returnData[jsonArrayIndex].mac]) !== "undefined") {
                            txGroupMap[returnData[jsonArrayIndex].mac] = new txObject("", "", "", "", "");
                            // draw TX table ------ begin
                            var imgPath = "";

                            if (returnData[jsonArrayIndex].alive != "n") {
                                imgPath = doesFileExistForInitial("../snapshot/" + returnData[jsonArrayIndex].mac + ".jpg");
                                dropdown_tx_item += "<li class=\"tx_item\" data-group=\"" + device_id + "\"><a><span style='color: rgb(100, 108, 128)'>" + statusHtml(returnData[jsonArrayIndex].alive, true)
                                    + "  " + returnData[jsonArrayIndex].host_name + "</span></a></li>";
                                drop_status_style = 1;
                            } else {
                                //non alive
                                imgPath = "../snapshot/offline.bmp";
                                drop_status_style = 0.5;
                            }

                            txCounter = txCounter + 1;
                            // draw tx drag item --- Start
                            if ((txCounter % 2) == 1) {
                                if (isDebugMode) {
                                    console.log("TX add row");
                                }
                                tx_list += "<div class='row' id=\"tx_row_" + Math.floor(txCounter / 2) + "\" >";
                            }

                            tx_list += "<div id=\"tx_" + returnData[jsonArrayIndex].mac + "\"  data-audio_id=\"" +  returnData[jsonArrayIndex].subscriber_audio_id + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" data-ip=\"" + returnData[jsonArrayIndex].ip   + "\" data-pin=\"" + returnData[jsonArrayIndex].pin + "\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" data-id=\"" + returnData[jsonArrayIndex].id + "\" class=\"col-xs-6 draggable\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"opacity:" + drop_status_style + "\">\n" +
                                "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                                "  <div class=\"no_pad\"> <div class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                                "                     <div class=\"no_pad\" style='width: 100%;'><span data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class=\"substreaming\" id=\"" + returnData[jsonArrayIndex].mac + "_id\" style='font-size: 26px;cursor:pointer;margin-right:10px;float:right;border-radius:20px;display:block;color: white;margin-top:20px;text-align: " +
                                "                           center;border-width:4px;border-style: solid;border-color: rgb(113,143,171);width: 130px;background: rgb(247,151,29,0)'> #&nbsp " + returnData[jsonArrayIndex].id + " </span></div>" +
                                " <div style='width: 100%;margin-top:120px;'><span id=\"" + returnData[jsonArrayIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display:inline-block;'>&nbsp&nbsp" + returnData[jsonArrayIndex].host_name +
                                "                   </span><span id=\"" + returnData[jsonArrayIndex].mac + "_modify_name\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                                "      <div  class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;border-radius: 10px 10px 0 0'>" +
                                "                            <img id=\"" + returnData[jsonArrayIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                                "      </div> </div></div>" +
                                "      <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\"><div class=\"card-footer col-xs-2 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 0px 10px\">" +
                                "                                  <img id=\"" + returnData[jsonArrayIndex].mac + "_lightbulb\" data-type=\"" + returnData[jsonArrayIndex].type + "\" data-alive=\"" + returnData[jsonArrayIndex].alive + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                                "                        </div>" +
                                "                        <div class=\"card-footer col-xs-8 no_pad\" style=\"background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                                "                            <span id=\"" + returnData[jsonArrayIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: white;font-size: 16px;padding-top: 8px;display: inline-block\">" + returnData[jsonArrayIndex].ip + "</span>" +
                                "                        </div>" +
                                "                        <div class=\"card-footer no_pad col-xs-2 right_bottom_corner\" style=\"background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 10px 0px\">" +
                                // "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_count\" type=\"button\" data-count=0 class=\"btn\" style=\"display: block; pointer-events: none;background: rgba(0,0,0,0) \">" +
                                // "                            <span class=\"glyphicon glyphicon-user\" aria-hidden=\"true\" style=\"font-size: 16px\"></span> <span id=\"" + returnData[jsonArrayIndex].mac + "_count_span\" style=\"font-size: 16px\">0</span>" +
                                // "                        </button>" +
                                "                        </div></div>" +
                                " </div>";

                            if ((txCounter % 2) == 0) {
                                tx_list += "</div><br>";
                            }
                        }


                    } else {

                        var imgPath = "";

                        if (returnData[jsonArrayIndex].alive != "n") {
                            imgPath = doesFileExistForInitial("../snapshot/" + returnData[jsonArrayIndex].mac + ".jpg");
                            dropdown_tx_item += "<li class=\"tx_item\" data-group=\"" + device_id + "\"><a><span style='color: rgb(100, 108, 128)'>" + statusHtml(returnData[jsonArrayIndex].alive, true)
                                + "  " + returnData[jsonArrayIndex].host_name + "</span></a></li>";
                            drop_status_style = 1;
                        } else {
                            //non alive
                            imgPath = "../snapshot/offline.bmp";
                            drop_status_style = 0.5;
                        }

                        txCounter = txCounter + 1;
                        // draw tx drag item --- Start
                        if ((txCounter % 2) == 1) {
                            if (isDebugMode) {
                                console.log("TX add row");
                            }
                            tx_list += "<div class='row' id=\"tx_row_" + Math.floor(txCounter / 2) + "\" >";
                        }

                        tx_list += "<div id=\"tx_" + returnData[jsonArrayIndex].mac + "\"  data-audio_id=\"" +  returnData[jsonArrayIndex].subscriber_audio_id + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\"  data-mac=\"" + returnData[jsonArrayIndex].mac + "\" data-pin=\"" + returnData[jsonArrayIndex].pin + "\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" data-id=\"" + returnData[jsonArrayIndex].id + "\" class=\"col-xs-6 draggable\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"opacity:" + drop_status_style + "\">\n" +
                            "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                            "  <div class=\"no_pad\"> <div class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                            "                     <div class=\"no_pad\" style='width: 100%;'><span data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class=\"substreaming\" id=\"" + returnData[jsonArrayIndex].mac + "_id\" style='font-size: 26px;cursor:pointer;margin-right:10px;float:right;border-radius:20px;display:block;color: white;margin-top:20px;text-align: " +
                            "                           center;border-width:4px;border-style: solid;border-color: rgb(113,143,171);width: 130px;background: rgb(247,151,29,0)'> #&nbsp " + returnData[jsonArrayIndex].id + " </span></div>" +
                            " <div style='width: 100%;margin-top:120px;'><span id=\"" + returnData[jsonArrayIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display:inline-block;'>&nbsp&nbsp" + returnData[jsonArrayIndex].host_name +
                            "                   </span><span id=\"" + returnData[jsonArrayIndex].mac + "_modify_name\" data-status=\"" + returnData[jsonArrayIndex].alive + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                            "      <div  class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;border-radius: 10px 10px 0 0'>" +
                            "                            <img id=\"" + returnData[jsonArrayIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                            "      </div> </div></div>" +
                            "      <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\"><div class=\"card-footer col-xs-2 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 0px 10px\">" +
                            "                                  <img id=\"" + returnData[jsonArrayIndex].mac + "_lightbulb\" data-type=\"" + returnData[jsonArrayIndex].type + "\" data-alive=\"" + returnData[jsonArrayIndex].alive + "\" data-ip=\"" + returnData[jsonArrayIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                            "                        </div>" +
                            "                        <div class=\"card-footer col-xs-8 no_pad\" style=\"background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                            "                            <span id=\"" + returnData[jsonArrayIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: white;font-size: 16px;padding-top: 8px;display: inline-block\">" + returnData[jsonArrayIndex].ip + "</span>" +
                            "                        </div>" +
                            "                        <div class=\"card-footer no_pad col-xs-2 right_bottom_corner\" style=\"background: rgba(0,0,0,0);height: 40px;padding-top: 2px;border-radius: 0 0 10px 0px\">" +
                            // "                        <button id=\"" + returnData[jsonArrayIndex].mac + "_count\" type=\"button\" data-count=0 class=\"btn\" style=\"display: block; pointer-events: none;background: rgba(0,0,0,0) \">" +
                            // "                            <span class=\"glyphicon glyphicon-user\" aria-hidden=\"true\" style=\"font-size: 16px\"></span> <span id=\"" + returnData[jsonArrayIndex].mac + "_count_span\" style=\"font-size: 16px\">0</span>" +
                            // "                        </button>" +
                            "                        </div></div>" +
                            " </div>";

                        if ((txCounter % 2) == 0) {
                            tx_list += "</div><br>";
                        }
                    }

                    //for rx to mapping source name
                    // txMap[device_id] = new txObject(device_id, returnData[jsonArrayIndex].host_name, returnData[jsonArrayIndex].mac);
                    txMap[returnData[jsonArrayIndex].mac] = new txObject(device_id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);

                } else {

                    //set rx map
                    rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]),
                        returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);
                    rxCounter = rxCounter + 1;
                }

            }
            // draw RX & Mapping table ------ begin
            rxCounter = 0;
            for (rxMapIndex in rxMap) {

                var source = "";
                var drop_status_style = "";

                var hasMatchTx = false;
                var sourceName = "";
                var sourceMac = "";
                var imgPath = "";
                var txAlive = false;

                var txMacMap = new Object();

                for (sourceIndex in txMap) {
                    if (txMap[sourceIndex].id === rxMap[rxMapIndex].id) {
                        txMacMap[txMap[sourceIndex].mac] = new txObject("", txMap[sourceIndex].name, txMap[sourceIndex].mac, txMap[sourceIndex].alive, txMap[sourceIndex].ip);
                        hasMatchTx = true;
                    }
                }

                if (Object.size(txMap) > 1) {
                    //tx has same group ID....
                    for (sourceIndex in txMacMap) {
                        if (txMacMap[sourceIndex].alive === "y") {
                            txAlive = true;
                            sourceName = txMacMap[sourceIndex].name;
                            sourceMac = txMacMap[sourceIndex].mac;
                            break;
                        }
                    }
                } else {
                    //tx group id is unique
                    for (sourceIndex in txMacMap) {
                        sourceName = txMacMap[sourceIndex].name;
                        sourceMac = txMacMap[sourceIndex].mac;
                        if (txMacMap[sourceIndex].alive === "y") {
                            txAlive = true;
                        } else {
                            txAlive = false;
                        }
                    }
                }

                if (hasMatchTx) {
                } else {
                    sourceName = "N/A";
                }

                if ($("#ul-group").attr("data-current_id") > 0) {
                    //check device is in the group
                    if (typeof (clusterMap[rxMap[rxMapIndex].mac]) !== "undefined") {

                        if (rxMap[rxMapIndex].status == "y") {
                            drop_status_style = "1";
                            //draw mapping table ------ start
                            mapping_table_rows = "<tr id=\"mapping_" + rxMap[rxMapIndex].mac + "_row\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">" + rxMap[rxMapIndex].id +
                                "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">" + rxMap[rxMapIndex].name + "</span></td>" +
                                "<td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;color: rgb(100, 108, 128)\">" + "RX</span>"
                                + "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">"
                                + "     <div class=\"dropdown\">" +
                                "                        <button style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\" class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                                "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\">\n" + source +
                                "                        <span class=\"caret\"></span>" +
                                "                        </button>" +
                                "                        <ul class=\"dropdown-menu dropdown-mapping\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                                "                        </ul>" +
                                "                    </div></tr>";


                            mappingTable.row.add($(mapping_table_rows)).draw();
                            //draw mapping table ------ end
                            if (hasMatchTx) {
                                if (txAlive) {
                                    imgPath = doesFileExistForInitial("../snapshot/" + sourceMac + ".jpg");
                                } else {
                                    imgPath = "../snapshot/nosignal.bmp";
                                }
                            } else {
                                source = "N/A";
                                imgPath = "../snapshot/nosignal.bmp";
                            }
                        } else {
                            drop_status_style = "0.5";
                            imgPath = "../snapshot/offline.bmp";
                        }

                        rxCounter = rxCounter + 1;
                        //draw RX drag item ------ start
                        if ((rxCounter % 2) == 1) {
                            if (isDebugMode) {
                                console.log("RX add row");
                            }
                            rx_list += "<div class='row' id=\"rx_row_" + Math.floor(rxCounter / 2) + "\" >";
                        }
                        rxGroupMap[rxMap[rxMapIndex].mac] = new txObject("", "", "", "", "");
                        rx_list += "<div id=\"rx_" + rxMap[rxMapIndex].mac + "\" data-audio_id=\"" +  rxMap[rxMapIndex].publisher_audio_id + "\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-status=\"" + rxMap[rxMapIndex].status + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\"  data-pin=\"" + rxMap[rxMapIndex].pin + "\" class=\"col-xs-6\" ondrop=\"Drop(event)\" ondragover=\"AllowDrop(event)\" ondragleave=\"LeaveDrop(event)\" style=\"opacity:" + drop_status_style + "\">" +
                            "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                            "  <div class=\"no_pad\"> <div class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                            "                     <div class=\"no_pad\" style='width: 100%;'><span data-ip=\"" + rxMap[rxMapIndex].ip + "\" class=\"substreaming\" id=\"" + rxMap[rxMapIndex].mac + "_id\" style='font-size: 26px;cursor:pointer;margin-right:10px;float:right;border-radius:20px;display: block;color: white;margin-top:20px;text-align: " +
                            "                           center;border-width: 4px;border-style: solid;border-color: rgb(113,143,171);width: 130px;background: rgb(247,151,29,0)'> #&nbsp " + rxMap[rxMapIndex].id + " </span></div>" +
                            "                     <div style='width: 100%;margin-top:120px;'> <span id=\"" + rxMap[rxMapIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display: inline-block;'>&nbsp&nbsp" + rxMap[rxMapIndex].name + "</span>" +
                            "                 <span id=\"" + rxMap[rxMapIndex].mac + "_modify_name\" data-status=\"" + rxMap[rxMapIndex].status + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                            "      <div  class=\"no_pad\"  style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;right: -6%;border-radius: 10px 10px 0 0'>" +
                            "                            <img id=\"" + rxMap[rxMapIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                            "      </div> </div></div>" +

                            "    <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\"> <div class=\"card-footer col-xs-1 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                            "                          <img id=\"" + rxMap[rxMapIndex].mac + "_lightbulb\" data-type=\"r\" data-alive=\"" + rxMap[rxMapIndex].alive + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                            "                        </div>" +
                            "                        <div class=\"card-footer col-xs-7 no_pad\" style=\"background: background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                            "                            <span id=\"" + rxMap[rxMapIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: white;font-size: 16px;padding-top: 8px;display: inline-block\">" + rxMap[rxMapIndex].ip + "</span>" +
                            "                        </div>" +
                            // "                        <div class=\"card-footer col-xs-2 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);;height: 40px;padding-top: 2px;\">" +
                            // "                         <input id=\"" + rxMap[rxMapIndex].mac + "_mute\"  data-ip=\"" + rxMap[rxMapIndex].ip + "\" data-style=\"ios\" class=\"mute-toggle\" type=\"checkbox\"  data-toggle=\"toggle\" data-onstyle=\"success\"\n" +
                            // "                               data-offstyle=\"danger\" data-size=\"small\">" +
                            // "                        </div>" +
                            "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;margin-right: 7%;\">" +
                            "                                <button id=\"" + rxMap[rxMapIndex].mac + "_cec_on\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" class=\"btn cec_on\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='rgb(26,188,114)';borderChange(this.id, 'rgb(26,188,114)')\" style=\"color:white;margin-top: 8%;display: flex;justify-content: center;align-items: center;height: 28px;width:50px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">ON</button> " +
                            "                        </div>" +
                            "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                            "                                 <button id=\"" + rxMap[rxMapIndex].mac + "_cec_off\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='red';borderChange(this.id, 'red');\" class=\"btn cec_off\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;width:50px;height: 28px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">OFF</button> " +
                            "                        </div>" +
                            " </div>" +
                            "</div> ";

                        if ((rxCounter % 2) == 0) {
                            rx_list += "</div><br>";
                        }
                        //draw RX drag item ------ end

                    }

                } else {
                    if (rxMap[rxMapIndex].status == "y") {
                        drop_status_style = "1";
                        //draw mapping table ------ start
                        mapping_table_rows = "<tr id=\"mapping_" + rxMap[rxMapIndex].mac + "_row\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">" + rxMap[rxMapIndex].id +
                            "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">" + rxMap[rxMapIndex].name + "</span></td>" +
                            "<td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;color: rgb(100, 108, 128)\">" + "RX</span>"
                            + "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">"
                            + "     <div class=\"dropdown\">" +
                            "                        <button style=\"border-color: rgb(100, 108, 128);color: rgb(100, 108, 128)!important;\" class=\"btn btn-default dropdown-toggle\" type=\"button\" " +
                            "                        id=\"dropdownMenu1\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\">\n" + source +
                            "                        <span class=\"caret\"></span>" +
                            "                        </button>" +
                            "                        <ul class=\"dropdown-menu dropdown-mapping\" aria-labelledby=\"dropdownMenu1\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-pin=\"" + rxMap[rxMapIndex].pin + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" >" +
                            "                        </ul>" +
                            "                    </div></tr>";


                        mappingTable.row.add($(mapping_table_rows)).draw();
                        //draw mapping table ------ end
                        if (hasMatchTx) {
                            if (txAlive) {
                                imgPath = doesFileExistForInitial("../snapshot/" + sourceMac + ".jpg");
                            } else {
                                imgPath = "../snapshot/nosignal.bmp";
                            }
                        } else {
                            source = "N/A";
                            imgPath = "../snapshot/nosignal.bmp";
                        }
                    } else {
                        drop_status_style = "0.5";
                        imgPath = "../snapshot/offline.bmp";
                    }

                    rxCounter = rxCounter + 1;
                    //draw RX drag item ------ start
                    if ((rxCounter % 2) == 1) {
                        if (isDebugMode) {
                            console.log("RX add row");
                        }
                        rx_list += "<div class='row' id=\"rx_row_" + Math.floor(rxCounter / 2) + "\" >";
                    }

                    rx_list += "<div id=\"rx_" + rxMap[rxMapIndex].mac + "\" style=\"border-radius: 0 0 10px 10px\" data-audio_id=\"" +  rxMap[rxMapIndex].publisher_audio_id + "\"data-mac=\"" + rxMap[rxMapIndex].mac + "\" data-status=\"" + rxMap[rxMapIndex].status + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\"  data-pin=\"" + rxMap[rxMapIndex].pin + "\" class=\"col-xs-6\" ondrop=\"Drop(event)\" ondragover=\"AllowDrop(event)\" ondragleave=\"LeaveDrop(event)\" style=\"opacity:" + drop_status_style + "\">" +
                        "<div class=\"col-xs-12 no_pad\"  style=\"text-align: center;width: 100%;height: 150px;position:relative;right: 1.3%\">" +
                        "  <div class=\"no_pad\"> <div class=\"no_pad\" style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0; z-index: 10;text-align: left'>" +
                        "                     <div class=\"no_pad\" style='width: 100%;'><span  data-ip=\"" + rxMap[rxMapIndex].ip + "\" class=\"substreaming\" id=\"" + rxMap[rxMapIndex].mac + "_id\" style='font-size: 26px;cursor:pointer;margin-right:10px;float:right;border-radius:20px;display: block;color: white;margin-top:20px;text-align: " +
                        "                           center;border-width: 4px;border-style: solid;border-color: rgb(113,143,171);width: 130px;background: rgb(247,151,29,0)'> #&nbsp " + rxMap[rxMapIndex].id + " </span></div>" +
                        "                     <div style='width: 100%;margin-top:120px;'> <span id=\"" + rxMap[rxMapIndex].mac + "_name\" style='font-size: 16px;cursor:default;color: white;text-align: left;display: inline-block;'>&nbsp&nbsp" + rxMap[rxMapIndex].name + "</span>" +
                        "                 <span id=\"" + rxMap[rxMapIndex].mac + "_modify_name\" data-status=\"" + rxMap[rxMapIndex].status + "\" class=\"glyphicon glyphicon-pencil modify_name\" title=\"Modify device name\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" style='display:inline-block;color: white;padding-left: 3px;cursor: pointer'></span></div></div>" +
                        "      <div  class=\"no_pad\"  style=' width: 100%;height: 100%;position: absolute;top: 0;left: 0;bottom: 0;right: -6%;border-radius: 20px 20px 0 0'>" +
                        "                            <img id=\"" + rxMap[rxMapIndex].mac + "_img\" src=\"" + imgPath + "\" class=\"img-fluid\" style=\"width:100%;;margin:auto;pointer-events: none;display: inline-block;border-radius: 10px 10px 0 0;aspect-ratio: 16/ 6.2;\" alt=\"image\">" +
                        "      </div> </div></div>" +

                        "    <div class=\"row no_pad device_footer_div\" style=\"width: 100%;border-radius: 10px 10px 10px 10px;\"> <div class=\"card-footer col-xs-1 no_pad left_bottom_corner\" style=\"text-align:center;background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                        "                          <img id=\"" + rxMap[rxMapIndex].mac + "_lightbulb\" data-type=\"r\" data-alive=\"" + rxMap[rxMapIndex].alive + "\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" class='shiny' src='../img/lightbulb.png' style='display: block;height: 32px;cursor:pointer;padding-top: 5px;padding-left: 10px'>" +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-7 no_pad\" style=\"background: background: rgba(0,0,0,0);text-align: center;height: 40px;padding-top: 2px\">" +
                        "                            <span id=\"" + rxMap[rxMapIndex].mac + "_ip\" aria-hidden=\"true\" style=\"color: white;font-size: 16px;padding-top: 8px;display: inline-block\">" + rxMap[rxMapIndex].ip + "</span>" +
                        "                        </div>" +
                        // "                        <div class=\"card-footer col-xs-2 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);;height: 40px;padding-top: 2px;\">" +
                        // "                         <input id=\"" + rxMap[rxMapIndex].mac + "_mute\"  data-ip=\"" + rxMap[rxMapIndex].ip + "\" data-style=\"ios\" class=\"mute-toggle\" type=\"checkbox\"  data-toggle=\"toggle\" data-onstyle=\"success\"\n" +
                        // "                               data-offstyle=\"danger\" data-size=\"small\">" +
                        // "                        </div>" +
                        "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;margin-right: 7%;\">" +
                        "                                <button id=\"" + rxMap[rxMapIndex].mac + "_cec_on\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" class=\"btn cec_on\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='rgb(26,188,114)';borderChange(this.id, 'rgb(26,188,114)')\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;height: 28px;width:50px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">ON</button> " +
                        "                        </div>" +
                        "                        <div class=\"card-footer col-xs-1 right_bottom_corner no_pad\" style=\"background: background: rgba(0,0,0,0);height: 40px;padding-top: 2px;\">" +
                        "                                 <button id=\"" + rxMap[rxMapIndex].mac + "_cec_off\" data-ip=\"" + rxMap[rxMapIndex].ip + "\" onmouseout=\"this.style.color='rgb(100, 108, 128)';borderChange(this.id, 'rgb(100, 108, 128)')\" onmouseover=\"this.style.color='red';borderChange(this.id, 'red');\" class=\"btn cec_off\" style=\"color:rgb(100, 108, 128);margin-top: 8%;display: flex;justify-content: center;align-items: center;width:50px;height: 28px;border-radius: 30px;background: linear-gradient(rgb(16, 24, 36),rgb(27, 38, 55));border-style: solid;border-color: rgb(100, 108, 128);\">OFF</button> " +
                        "                        </div>" +
                        " </div>" +
                        "</div> ";

                    if ((rxCounter % 2) == 0) {
                        rx_list += "</div><br>";
                    }
                    //draw RX drag item ------ end
                }
            }
            // draw RX & Mapping table ------ end

            // Draw drag item end element -------- start
            if (rxCounter > 0) {
                if ((rxCounter % 2) != 0) {
                    if (isDebugMode) {
                        console.log("RX need end");
                    }
                    rx_list += "</div><br>";
                }
                $("#rx-area").after(rx_list);
                $("#span-rx-count").text(rxCounter);
            } else {
                $("#span-rx-count").text("0");
            }

            if (txCounter > 0) {
                if ((txCounter % 2) != 0) {
                    if (isDebugMode) {
                        console.log("TX need end");
                    }
                    tx_list += "</div><br>";
                }

                $("#tx-area").after(tx_list);
                $("#span-tx-count").text(txCounter);
                $(".dropdown-mapping").append(dropdown_tx_item);//add tx item to the drop menu (mapping table)
                dropDownASpeedListener();
            } else {
                $("#span-tx-count").text("0");
            }
            // Draw drag item end element -------- end

            // $("#" + rxMap[rxMapIndex].mac + "_mute").bootstrapToggle({
            //     on: '',
            //     off: '',
            // });

            rxMuteToggleListener();
            // //update TX used count ----- start
            for (rxMapIndex in rxMap) {
                for (sourceIndex in txMap) {
                    if (txMap[sourceIndex].id === rxMap[rxMapIndex].id) {
                        if (rxMap[rxMapIndex].status === "y") {
                            $("#" + txMap[sourceIndex].mac + "_count").attr("data-count", (parseInt($("#" + txMap[sourceIndex].mac + "_count").attr("data-count")) + 1));
                            $("#" + txMap[sourceIndex].mac + "_count_span").text(parseInt($("#" + txMap[sourceIndex].mac + "_count").attr("data-count")));
                        }
                        break;
                    }
                }

                if (rxMap[rxMapIndex].alive === 'n') {
                    $("#" + rxMap[rxMapIndex].mac + "_mute").prop('checked', false).bootstrapToggle('destroy').bootstrapToggle({
                        on: '',
                        off: '',
                    });
                } else {
                    $("#" + rxMap[rxMapIndex].mac + "_mute").prop('checked', true).bootstrapToggle('destroy').bootstrapToggle({
                        on: '',
                        off: '',
                    });
                }
                //  }
                //  $("#" + returnData[jsonArrayIndex].mac + "_mute").bootstrapToggle('enable');
            }
            // //update TX used count ----- end
            showModifyNameModal();
            startASpeedWorker();
            $(".loading").hide();
            //   showSuccessToast("To get device status successful");
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
            $(".loading").hide();
        }
    });
}

function subStreamingClickListener() {
    $("body").on("click", ".substreaming", function () {
        console.log("click substreaming =" + $(this).attr("data-ip"));

        // var src =  dbServerInfo.ip + "/api/mjpg?ip=" + $(this).attr("data-ip");
        var src = "http://" + $(this).attr("data-ip") + ":8080/?action=stream&w=320&h=240&fps=25&bw=8000&as=20"
        console.log("src = " + src);
        var newImage = "<img id=\"img_sub_streaming\" src=\"" + src + "\" />"

        if ($('#img_sub_streaming').length > 0) {
            $("#img_sub_streaming").remove();
        }

        $(".sub-streaming-modal-body").append(newImage);
        $("#sub-streaming-modal").modal("show");
    });

    $(".btn-streaming-close").click(function (e) {
        if ($('#img_sub_streaming').length > 0) {
            $("#img_sub_streaming").remove();
        }
    });
}