var txMap = new Object(); // or var map = {};
var rxMap = new Object();
var allDeviceDBMap = new Object();

$(document).ready(function () {

    $("#menu_a_group").css("color", "orangered");
    $("#menu_span_group").css("color", "orangered");
    $("#menu_icon_group").css("color", "orangered");

    checkLoginCookie();

    $('.collapse').collapse();

    getUserRole();
    getDeviceList();

    //Group
    create_group_click_listener();
    get_group_list();
    group_content_select_listener();
    delete_group_click_listener();
    btSaveGroupContent();
    //btSaveGroupContent();
    //get_group_list();

    //RX Group
    //get_rx_group_list();
    //create_rx_group_click_listener();
    //delete_rx_group_click_listener();
    //device_rx_group_content_select_listener();
    //btSaveRXGroupContent();
    btShowRXIconModal();

    //TX Group
    //get_tx_group_list();
    //create_tx_group_click_listener();
    //delete_tx_group_click_listener();
    //device_tx_group_content_select_listener();
    //btSaveTXGroupContent();
    btShowTXIconModal();
    //   apply_group_click_listener();
    $(".dropzone").change(function () {
        readFile(this);
    });

    $(".tx_dropzone").change(function () {
        readTXFile(this);
    });
});

function create_group_click_listener() {

    $("#creat-group-bt").click(function (e) {
        if ($("#input-create-group-name").val().length > 0) {

        } else {
            showErrorToast("Name can't be empty !");
            return
        }

        var rx_mac_json = {
            rx_mac: []
        };

        if (isDebugMode) {
            console.log("json = " + JSON.stringify(rx_mac_json));
        }

        var data = "name=" + $("#input-create-group-name").val() + "&rx_mac=" + JSON.stringify(rx_mac_json);

        $.ajax({
            url: dbServerInfo.ip + "/api/group",
            data: data,
            type: "POST",
            success: function (data) {

                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast(obj.message);
                } else {
                    get_group_list();
                    $("#tx-area-list").empty();
                    $("#group-tx-area-list").empty();
                    $("#rx-area-list").empty();
                    $("#group-rx-area-list").empty();
                    $("#input-group-content-name").val("");
                    showSuccessToast(obj.message);
                }

            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error " + thrownError);
                }
                //  $(".loading").hide();
                showErrorToast("Create group failed !");
            }
        });

    });
}

function btShowTXIconModal() {
    $("#btn-tx-icon").click(function (e) {

        if ($("#select_tx_group").val() > 0) {
            $('#tx-icon-modal').modal('show');
        } else {
            showErrorToast("Please select TX group first !");
        }
    });
}

function btShowRXIconModal() {
    $("#btn-rx-icon").click(function (e) {

        if ($("#select_rx_group").val() > 0) {
            $('#rx-icon-modal').modal('show');
        } else {
            showErrorToast("Please select RX group first !");
        }
    });
}


/**
 * Get user info
 */
function getUserRole() {

    var userId = readCookie(COOKIE_USER_INFO);

    $.ajax({
        url: dbServerInfo.ip + "/api/user_info/" + userId,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            if (returnData.result.toUpperCase() != "OK") {
                $("#panel_create_account").hide();
                $("#panel_account_list").hide();
                $("#panel_device_permission").hide();
            } else {
                //check role is Administrator or not, 1:Administrator, 2:Member
                if (returnData.role != 1) {
                    $("#panel_create_account").hide();
                    $("#panel_account_list").hide();
                    $("#panel_device_permission").hide();
                } else {
                    $("#panel_create_account").show();
                    $("#panel_account_list").show();
                }
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
        }
    });
}

function getDeviceList() {
    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            //if (isDebugMode) {
            console.log("success" + JSON.stringify(returnData));
            // }
            $("#tx-area-list").empty();
            $("#group-tx-area-list").empty();
            $("#rx-area-list").empty();
            $("#group-rx-area-list").empty();

            // var select_tx_list = " <option disabled selected value='0'> -- Select Transmitters -- </option>";
            //var group_rx_others = "";

            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {


                if (checkDevicePermission(returnData[jsonArrayIndex].mac)) {
                    if (returnData[jsonArrayIndex].type != "r") {

                        var device_id = returnData[jsonArrayIndex].id;
                        txMap[returnData[jsonArrayIndex].mac] = new txObject(device_id, getDeviceName(returnData[jsonArrayIndex]), returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);
                        // select_tx_list = select_tx_list + "<option value=" + returnData[jsonArrayIndex].mac + ">" + getDeviceName(returnData[jsonArrayIndex]) + "</option>";
                    } else {

                        rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]),
                            returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);

                        // group_rx_others += "   <div id=\"" + returnData[jsonArrayIndex].mac + "_preset\"  data-mac=\"" + returnData[jsonArrayIndex].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                        //     "<span  class=\"btn btn-primary\" >" + getDeviceName(returnData[jsonArrayIndex]) + "</span></div>";
                    }
                }
            }
            // $("#rx-area-list").append(group_rx_others);
            // $("#select_group_tx").append(select_tx_list);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            showErrorToast("Get all device failed !");
        }
    });
}


/**
 * RX Group Drop listener (Preset)
 * */
function GroupAreaDrop(event) {
    event.preventDefault();
    // $("#target-container").appendTo(this);
    var data = event.dataTransfer.getData("Text");
    // console.log("target = " + event.target.id);
    // event.target.appendChild(document.getElementById(data));
    var data = event.dataTransfer.getData("Text");
    if ($("#" + data).attr("data-type") === "t") {
    } else {
        $("#group-rx-area-list").append(document.getElementById(data));
    }
}

/**
 *  TX Group Drop listener (Preset)
 * */
function txGroupAreaDrop(event) {
    event.preventDefault();
    // $("#target-container").appendTo(this);
    var data = event.dataTransfer.getData("Text");
    if ($("#" + data).attr("data-type") === "r") {

    } else {
        // event.target.appendChild(document.getElementById(data));
        $("#group-tx-area-list").append(document.getElementById(data));
    }
}

/**
 * Allow drop listener
 * */
function GroupRXAllowDrop(event) {
    if (isDebugMode) {
        console.log("PresetAllowDrop");
    }
    event.preventDefault();


    var data = event.currentTarget.id;
    if (isDebugMode) {
        console.log("id = " + data);
    }
}

/**
 * Allow drop listener
 * */
function GroupTXAllowDrop(event) {
    if (isDebugMode) {
        console.log("PresetAllowDrop");
    }
    event.preventDefault();
    var data = event.currentTarget.id;
    if (isDebugMode) {
        console.log("id = " + data);
    }
}

/**
 * Preset Leave drop listener (RX)
 * */
function GroupLeaveDrop(event) {
    if (isDebugMode) {
        console.log("PresetLeaveDrop");
    }
    event.preventDefault();
}


/**
 * Group Drop listener (Preset)
 * */
function OthersRXAreaDrop(event) {
    event.preventDefault();
    // $("#target-container").appendTo(this);
    var data = event.dataTransfer.getData("Text");
    if ($("#" + data).attr("data-type") === "t") {

    } else {
        $("#rx-area-list").append(document.getElementById(data));
    }

    // event.target.appendChild(document.getElementById(data));
    // $("#rx-area-list").append(document.getElementById(data));
}

/**
 * Group Drop listener (Preset)
 * */
function OthersTXAreaDrop(event) {
    event.preventDefault();
    // $("#target-container").appendTo(this);
    var data = event.dataTransfer.getData("Text");
    // console.log("target = " + event.target.id);
    if ($("#" + data).attr("data-type") === "r") {

    } else {
        // event.target.appendChild(document.getElementById(data));
        $("#tx-area-list").append(document.getElementById(data));
    }
}

/**
 * Allow drop listener
 * */
function OthersAllowDrop(event) {
    if (isDebugMode) {
        console.log("PresetAllowDrop");
    }
    event.preventDefault();
    var data = event.currentTarget.id;
    if (isDebugMode) {
        console.log("id = " + data);
    }
}

/**
 * Preset Leave drop listener (RX)
 * */
function OthersLeaveDrop(event) {
    if (isDebugMode) {
        console.log("PresetLeaveDrop");
    }
    event.preventDefault();
}

/**
 * Drag listener (TX)
 * */
function Drag(event) {
    event.dataTransfer.setData("Text", event.currentTarget.id);
}

// function delete_tx_group_click_listener() {
//
//     $("#btn-del-tx-group-content").click(function (e) {
//
//         if ($("#select_tx_group").val() > 0) {
//         } else {
//             showErrorToast("Please select group first !");
//             return
//         }
//
//         var data = "id=" + $("#select_tx_group").val();
//
//         $.ajax({
//             url: dbServerInfo.ip + "/api/del_tx_device_group",
//             data: data,
//             type: "POST",
//             success: function (data) {
//                 var obj = jQuery.parseJSON(data);
//                 if (obj.result != "OK") {
//                     showErrorToast(obj.message);
//                 } else {
//                     get_tx_group_list();
//                     $("#tx-area-list").empty();
//                     $("#group-tx-area-list").empty();
//                     $("#select_group_tx").val(0);
//                     $("#input-tx-group-content-name").val("");
//                     showSuccessToast(obj.message);
//                 }
//             },
//             error: function (xhr, ajaxOptions, thrownError) {
//                 if (isDebugMode) {
//                     console.log("error " + thrownError);
//                 }
//                 //  $(".loading").hide();
//                 showErrorToast("Delete group failed !");
//             }
//         });
//     });
// }

function delete_group_click_listener() {

    $("#btn-del-group-content").click(function (e) {

        if ($("#select_group").val() > 0) {
        } else {
            showErrorToast("Please select group first !");
            return
        }

        var data = "id=" + $("#select_group").val();

        $.ajax({
            url: dbServerInfo.ip + "/api/del_group",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast(obj.message);
                } else {
                    showSuccessToast(obj.message);

                    var mac_json = {
                        mac: []
                    };

                    $('#group-tx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    data = "group_id=0&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    mac_json = {
                        mac: []
                    };
                    $('#group-rx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    data = "group_id=0&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    //reset tx to group id 0
                    mac_json = {
                        mac: []
                    };

                    $('#tx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    data = "group_id=0&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    //reset rx to group id 0
                    mac_json = {
                        mac: []
                    };
                    $('#rx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    data = "group_id=0&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    get_group_list();

                    $("#tx-area-list").empty();
                    $("#group-tx-area-list").empty();
                    $("#rx-area-list").empty();
                    $("#group-rx-area-list").empty();
                    $("#input-group-content-name").val("");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error " + thrownError);
                }
                showErrorToast("Delete group failed !");
            }
        });
    });
}


// function create_tx_group_click_listener() {
//
//     $("#creat-tx-group-bt").click(function (e) {
//
//         console.log("create tx group");
//
//
//         if ($("#input-create-tx-group-name").val().length > 0) {
//
//         } else {
//             showErrorToast("Name can't be empty !");
//             return
//         }
//
//         var tx_mac_json = {
//             tx_mac: []
//         };
//
//         var data = "name=" + $("#input-create-tx-group-name").val() + "&tx_mac=" + JSON.stringify(tx_mac_json);
//
//         $.ajax({
//             url: dbServerInfo.ip + "/api/add_tx_device_group",
//             data: data,
//             type: "POST",
//             success: function (data) {
//
//                 var obj = jQuery.parseJSON(data);
//                 if (obj.result != "OK") {
//                     showErrorToast(obj.message);
//                 } else {
//                     get_tx_group_list();
//                     $("#tx-area-list").empty();
//                     $("#group-tx-area-list").empty();
//                     $("#select_group_tx").val(0);
//                     $("#input-tx-group-content-name").val("");
//                     showSuccessToast(obj.message);
//                 }
//
//             },
//             error: function (xhr, ajaxOptions, thrownError) {
//                 if (isDebugMode) {
//                     console.log("error " + thrownError);
//                 }
//                 //  $(".loading").hide();
//                 showErrorToast("Create tx group failed !");
//             }
//         });
//     });
// }
//
// function create_rx_group_click_listener() {
//
//     $("#creat-rx-group-bt").click(function (e) {
//
//         if ($("#input-create-rx-group-name").val().length > 0) {
//
//         } else {
//             showErrorToast("Name can't be empty !");
//             return
//         }
//
//
//         var rx_mac_json = {
//             rx_mac: []
//         };
//
//         console.log("json = " + JSON.stringify(rx_mac_json));
//
//
//         var data = "name=" + $("#input-create-rx-group-name").val() + "&rx_mac=" + JSON.stringify(rx_mac_json);
//
//         $.ajax({
//             url: dbServerInfo.ip + "/api/add_rx_device_group",
//             data: data,
//             type: "POST",
//             success: function (data) {
//
//                 var obj = jQuery.parseJSON(data);
//                 if (obj.result != "OK") {
//                     showErrorToast(obj.message);
//                 } else {
//                     get_rx_group_list();
//                     $("#rx-area-list").empty();
//                     $("#group-rx-area-list").empty();
//                     // $("#select_group_tx").val(0);
//                     $("#input-rx-group-content-name").val("");
//                     showSuccessToast(obj.message);
//                 }
//
//             },
//             error: function (xhr, ajaxOptions, thrownError) {
//                 if (isDebugMode) {
//                     console.log("error " + thrownError);
//                 }
//                 //  $(".loading").hide();
//                 showErrorToast("Create rx group failed !");
//             }
//         });
//     });
// }

// function apply_group_click_listener() {
//
//     $("#btn-apply-group-content").click(function (e) {
//
//         var tx_mac = $("#select_group_tx").val();
//         var tx_channel = "";
//
//         $.ajax({
//             url: dbServerInfo.ip + "/api/node_info",
//             type: "GET",
//             crossDomain: true,
//             dataType: 'json',
//             success: function (returnData) {
//                 if (isDebugMode) {
//                     console.log("success" + JSON.stringify(returnData));
//                 }
//
//                 for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
//
//                     if (returnData[jsonArrayIndex].mac === tx_mac) {
//                         console.log("find tx channel = " + returnData[jsonArrayIndex].id);
//                         tx_channel = returnData[jsonArrayIndex].id;
//                         break
//                     }
//                 }
//
//
//                 if (tx_channel.length > 0) {
//                     var time = 500;
//                     $('#group-rx-area-list').children('div').each(function () {
//
//                         var rx_mac = $(this).attr("data-mac");
//
//                         setTimeout(
//                             function () {
//                                 $.ajax({
//                                     url: dbServerInfo.ip + "/api/astswitch",
//                                     data: "ip=" + rxMap[rx_mac].ip + "&switch_id=" + tx_channel + "&switch_type=z",
//                                     type: "POST",
//                                     success: function (data) {
//                                         var obj = jQuery.parseJSON(data);
//                                         if (isDebugMode) {
//                                             console.log(JSON.stringify(data));
//                                         }
//                                     },
//                                     error: function (xhr, ajaxOptions, thrownError) {
//                                         if (isDebugMode) {
//                                             console.log("error ");
//                                         }
//                                         //  $(".loading").hide();
//                                         showErrorToast("Switch failed !");
//                                     }
//                                 });
//
//                             }, time);
//                         time += 500;
//                     })
//
//                     setTimeout(
//                         function () {
//                              showSuccessToast("Finished !");
//                         }, time);
//
//                 } else {
//                     showErrorToast("Transmitters isn't exist now!")
//                 }
//
//             },
//             error: function (xhr, ajaxOptions, thrownError) {
//                 showErrorToast("Get all device failed !");
//             }
//         });
//     });
// }

// function get_tx_group_list() {
//
//     $.ajax({
//         url: dbServerInfo.ip + "/api/tx_device_group_list",
//         type: "GET",
//         dataType: 'json',
//         success: function (data) {
//
//             if (isDebugMode) {
//                 console.log("feedback =  " + JSON.stringify(data));
//                 //  console.log("feedback =  " + data.message[0].name);
//             }
//
//             $('#select_tx_group').find('option').remove();
//
//             var jsonArrayIndex = 0;
//
//             var select_group_list = "";
//
//             select_group_list = " <option disabled selected value='0'> -- Select Group -- </option>";
//
//             if (data.result != "OK") {
//                 //    showErrorToast(obj.message);
//             } else {
//
//                 for (jsonArrayIndex = 0; jsonArrayIndex < data.message.length; jsonArrayIndex++) {
//                     select_group_list = select_group_list + "<option value=" + data.message[jsonArrayIndex].id + ">" + data.message[jsonArrayIndex].name + "</option>";
//                 }
//
//
//                 $("#select_tx_group").append(select_group_list);
//             }
//         },
//         error: function (xhr, ajaxOptions, thrownError) {
//             //  if (isDebugMode) {
//             console.log("error ", thrownError);
//             //   }
//             showErrorToast("Get tx group list failed !");
//         }
//     });
// }

function get_group_list() {

    $.ajax({
        url: dbServerInfo.ip + "/api/group_list",
        type: "GET",
        dataType: 'json',
        success: function (data) {

            //if (isDebugMode) {
            console.log("feedback =  " + JSON.stringify(data));
            //  console.log("feedback =  " + data.message[0].name);
            // }

            $('#select_group').find('option').remove();

            var jsonArrayIndex = 0;

            var select_group_list = "";

            select_group_list = " <option disabled selected value='0' style='color: black!important;'> -- Select Cluster -- </option>";

            if (data.result != "OK") {
                //    showErrorToast(obj.message);
            } else {

                for (jsonArrayIndex = 0; jsonArrayIndex < data.message.length; jsonArrayIndex++) {
                    select_group_list = select_group_list + "<option value=" + data.message[jsonArrayIndex].id + ">" + data.message[jsonArrayIndex].name + "</option>";
                }


                $("#select_group").append(select_group_list);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            //  if (isDebugMode) {
            console.log("error ", thrownError);
            //   }
            showErrorToast("Get group list failed !");
        }
    });
}

// function device_tx_group_content_select_listener() {
//
//     $('#select_tx_group').on('change', function () {
//
//         var data = "id=" + $(this).val();
//
//         $("#tx-area-list").empty();
//         $("#group-tx-area-list").empty();
//
//         $.ajax({
//             url: dbServerInfo.ip + "/api/tx_device_group_info",
//             data: data,
//             type: "POST",
//             success: function (data) {
//
//                 if (isDebugMode) {
//                     console.log("feedback =  " + JSON.stringify(data));
//                 }
//
//                 $("#tx-area-list")
//                 var obj = jQuery.parseJSON(data);
//                 if (obj.result != "OK") {
//                     showErrorToast("Get group info failed !");
//                 } else {
//
//                     $("#input-tx-group-content-name").val(obj.name);
//
//                     // if (typeof txMap[obj.tx_mac] === "undefined") {
//                     //     $("#select_group_tx").val(0);
//                     // } else {
//                     //     $("#select_group_tx").val(obj.tx_mac);
//                     // }
//
//                     var txContentMap = new Object();
//                     var group_tx_content = "";
//                     var group_tx_others = "";
//
//                     for (index in obj.tx_mac_json.tx_mac) {
//                         txContentMap[obj.tx_mac_json.tx_mac[index]] = new rxObject("", "", "", "", "", "");
//                     }
//
//                     for (index in txMap) {
//
//                         if (typeof txContentMap[txMap[index].mac] === "undefined") {
//                             group_tx_others += "   <div id=\"" + txMap[index].mac + "_preset\"  data-mac=\"" + txMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
//                                 "<span  class=\"btn btn-primary\" >" + txMap[index].name + "</span></div>";
//                         } else {
//                             group_tx_content += "   <div id=\"" + txMap[index].mac + "_preset\"  data-mac=\"" + txMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
//                                 "<span  class=\"btn btn-primary\" >" + txMap[index].name + "</span></div>";
//
//                         }
//                     }
//
//                     switch (obj.img_type) {
//                         case image_type_jpg:
//                             if (checkFileIsExist("/group/tx/" + obj.id + ".jpg")) {
//                                 $("#tx_icon_img").attr("src", "../group/tx/" + obj.id + ".jpg");
//                             } else {
//                                 $("#tx_icon_img").attr("src", "../group/bzb.png");
//                             }
//                             break;
//
//                         case image_type_png:
//                             if (checkFileIsExist("/group/tx/" + obj.id + ".png")) {
//                                 $("#tx_icon_img").attr("src", "../group/tx/" + obj.id + ".png");
//                             } else {
//                                 $("#tx_icon_img").attr("src", "../group/bzb.png");
//                             }
//                             break;
//
//                         default:
//                             $("#tx_icon_img").attr("src", "../group/bzb.png");
//                             break;
//                     }
//
//                     $("#tx-area-list").append(group_tx_others);
//                     $("#group-tx-area-list").append(group_tx_content);
//                     delete txContentMap;
//                 }
//
//             },
//             error: function (xhr, ajaxOptions, thrownError) {
//                 if (isDebugMode) {
//                     console.log("error " + thrownError);
//                 }
//                 //  $(".loading").hide();
//                 showErrorToast("Get group info failed !");
//             }
//         });
//     });
// }

function group_content_select_listener() {

    $('#select_group').on('change', function () {

        var data = "id=" + $(this).val();
        $("#tx-area-list").empty();
        $("#group-tx-area-list").empty();
        $("#rx-area-list").empty();
        $("#group-rx-area-list").empty();


        $.ajax({
            url: dbServerInfo.ip + "/api/group_info",
            data: data,
            type: "POST",
            success: function (data) {

                if (isDebugMode) {
                    console.log("feedback =  " + JSON.stringify(data));
                }

                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast("Get group info failed !");
                } else {

                    $("#input-group-content-name").val(obj.name);

                    getAllDeviceByGroup();
                }

            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error " + thrownError);
                }
                showErrorToast("Get group info failed !");
            }
        });

    });
}

function getAllDeviceByGroup() {

    var data = "group_id=" + $('#select_group').val();

    $.ajax({
        url: dbServerInfo.ip + "/api/all_device_by_group",
        data: data,
        type: "GET",
        success: function (data) {

            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
            }

            var obj = jQuery.parseJSON(data);
            if (obj.result != "OK") {
                showErrorToast("Get group info failed !");
            } else {

                allDeviceDBMap = new Object();
                for (index in obj.message) {
                    allDeviceDBMap[obj.message[index].mac] = obj.message[index].group_id;
                }
                getDeviceByGroup();
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error " + thrownError);
            }
            //  $(".loading").hide();
            showErrorToast("Get group info failed !");
        }
    });
}


function getDeviceByGroup() {

    var data = "group_id=" + $('#select_group').val();

    $.ajax({
        url: dbServerInfo.ip + "/api/device_by_group",
        data: data,
        type: "GET",
        success: function (data) {

            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
            }

            var obj = jQuery.parseJSON(data);
            if (obj.result != "OK") {
                showErrorToast("Get group info failed !");
            } else {

                var txContentMap = new Object();
                var rxContentMap = new Object();

                for (index in obj.message) {

                    if (txMap[obj.message[index].mac] === "undefined") {
                    } else {
                        txContentMap[obj.message[index].mac] = new rxObject("", "", "", "", "", "");
                    }

                    if (rxMap[obj.message[index].mac] === "undefined") {
                        rxContentMap[obj.message[index].mac] = new rxObject("", "", "", "", "", "");
                    } else {
                        rxContentMap[obj.message[index].mac] = new rxObject("", "", "", "", "", "");
                    }
                }


                var group_tx_content = "";
                var group_tx_others = "";

                for (index in txMap) {
                    if (typeof allDeviceDBMap[txMap[index].mac] === "undefined") {
                        //tx others
                        group_tx_others += "   <div id=\"" + txMap[index].mac + "_preset\"  data-type=\"t\" data-mac=\"" + txMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                            "<span  class=\"btn btn-warning\" >" + txMap[index].name + "</span></div>";

                    } else {

                        if (allDeviceDBMap[txMap[index].mac] === 0) {
                            //tx others
                            group_tx_others += "   <div id=\"" + txMap[index].mac + "_preset\"  data-type=\"t\" data-mac=\"" + txMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                "<span  class=\"btn btn-warning\" >" + txMap[index].name + "</span></div>";
                        } else {
                            if (typeof txContentMap[txMap[index].mac] === "undefined") {

                            } else {
                                //tx content
                                group_tx_content += "   <div id=\"" + txMap[index].mac + "_preset\"  data-type=\"t\" data-mac=\"" + txMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                    "<span  class=\"btn btn-warning\" >" + txMap[index].name + "</span></div>";

                            }
                        }
                    }
                }

                $("#tx-area-list").append(group_tx_others);
                $("#group-tx-area-list").append(group_tx_content);

                var group_rx_content = "";
                var group_rx_others = "";

                for (index in rxMap) {
                    if (typeof allDeviceDBMap[rxMap[index].mac] === "undefined") {
                        //rx others
                        group_rx_others += "   <div id=\"" + rxMap[index].mac + "_preset\"  data-type=\"r\" data-mac=\"" + rxMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                            "<span  class=\"btn btn-primary\" >" + rxMap[index].name + "</span></div>";

                    } else {

                        if (allDeviceDBMap[rxMap[index].mac] === 0) {
                            //rx others
                            group_rx_others += "   <div id=\"" + rxMap[index].mac + "_preset\"  data-type=\"r\" data-mac=\"" + rxMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                "<span  class=\"btn btn-primary\" >" + rxMap[index].name + "</span></div>";
                        } else {
                            if (typeof rxContentMap[rxMap[index].mac] === "undefined") {

                            } else {
                                //rx content
                                group_rx_content += "   <div id=\"" + rxMap[index].mac + "_preset\"  data-type=\"r\" data-mac=\"" + rxMap[index].mac + "\" class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                    "<span  class=\"btn btn-primary\" >" + rxMap[index].name + "</span></div>";

                            }
                        }
                    }
                }

                $("#rx-area-list").append(group_rx_others);
                $("#group-rx-area-list").append(group_rx_content);
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error " + thrownError);
            }
            //  $(".loading").hide();
            showErrorToast("Get group info failed !");
        }
    });
}

// function btSaveTXGroupContent() {
//
//     $("#btn-save-tx-group-content").click(function (e) {
//
//         if ($("#input-tx-group-content-name").val().length > 0) {
//
//         } else {
//             showErrorToast("Name can't be empty !");
//             return
//         }
//         // if($("#select_group_tx").find(":selected").index() > 0 ){
//         //
//         // }else{
//         //     showErrorToast("Please select Transmitter first !");
//         //     return
//         // }
//         var tx_mac_json = {
//             tx_mac: []
//         };
//
//         $('#group-tx-area-list').children('div').each(function () {
//             tx_mac_json.tx_mac.push($(this).attr("data-mac"))
//         });
//
//         //var data = "id=" + $("#select_group").val() + "&name=" + $("#input-group-content-name").val() + "&tx_mac=" + $("#select_group_tx").val() + "&rx_mac=" + JSON.stringify(rx_mac_json);
//         var data = "id=" + $("#select_tx_group").val() + "&name=" + $("#input-tx-group-content-name").val() + "&tx_mac_json=" + JSON.stringify(tx_mac_json);
//
//         $.ajax({
//             url: dbServerInfo.ip + "/api/update_tx_device_group_info",
//             data: data,
//             type: "POST",
//             success: function (data) {
//                 console.log("feedback =  " + JSON.stringify(data));
//                 var obj = jQuery.parseJSON(data);
//                 if (obj.result != "OK") {
//                     showErrorToast(obj.message);
//                 } else {
//
//                     $("#select_tx_group option").each(function () {
//                         if ($(this).val() === $("#select_tx_group").val()) {
//                             $(this).text($("#input-tx-group-content-name").val());
//                         }
//                     });
//                     showSuccessToast(obj.message);
//                 }
//             },
//             error: function (xhr, ajaxOptions, thrownError) {
//                 if (isDebugMode) {
//                     console.log("error " + thrownError);
//                 }
//                 //  $(".loading").hide();
//                 showErrorToast("Update group failed !");
//             }
//         });
//     });
// }
//
function btSaveGroupContent() {

    $("#btn-save-group-content").click(function (e) {

        if ($("#input-group-content-name").val().length > 0) {

        } else {
            showErrorToast("Name can't be empty !");
            return
        }

        var data = "id=" + $("#select_group").val() + "&name=" + $("#input-group-content-name").val();

        $.ajax({
            url: dbServerInfo.ip + "/api/update_group_info",
            data: data,
            type: "POST",
            success: function (data) {
               // console.log("feedback =  " + JSON.stringify(data));
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast(obj.message);
                } else {
                    $("#select_group option").each(function () {
                        if ($(this).val() === $("#select_group").val()) {
                            $(this).text($("#input-group-content-name").val());
                        }
                    });

                    var mac_json = {
                        mac: []
                    };

                    $('#group-tx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    var data = "group_id=" + $("#select_group").val() + "&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    mac_json = {
                        mac: []
                    };
                    $('#group-rx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    var data = "group_id=" + $("#select_group").val() + "&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    //reset tx to group id 0
                    mac_json = {
                        mac: []
                    };

                    $('#tx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    data = "group_id=0&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);

                    //reset rx to group id 0
                    mac_json = {
                        mac: []
                    };
                    $('#rx-area-list').children('div').each(function () {
                        console.log($(this).attr("data-mac"));
                        mac_json.mac.push($(this).attr("data-mac"));
                    });
                    data = "group_id=0&mac_json=" + JSON.stringify(mac_json);
                    setDeviceByGroup(data);
                    showSuccessToast("Update group successful !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error " + thrownError);
                }
                //  $(".loading").hide();
                showErrorToast("Update group failed !");
            }
        });
    });
}

function setDeviceByGroup(data) {

    $.ajax({
        url: dbServerInfo.ip + "/api/device_by_group",
        data: data,
        type: "POST",
        success: function (data) {
            console.log("feedback =  " + JSON.stringify(data));
            var obj = jQuery.parseJSON(data);
            // if (obj.result != "OK") {
            //     showErrorToast(obj.message);
            // } else {
            //     showSuccessToast(obj.message);
            // }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error " + thrownError);
            }
            //  $(".loading").hide();
         //   showErrorToast("Update group failed !");
        }
    });
}

/**
 * Code By Webdevtrick ( https://webdevtrick.com )
 * Read upload file
 * @param input : upload file
 */
function readFile(input) {
    if (isDebugMode) {
        console.log("readFile");
        console.log("input.files[0] = " + input.files[0] + " type = " + input.files[0].type.split('/')[1]);
    }

    if (input.files && input.files[0]) {
        if ((input.files[0].type.split('/')[1] === "png") || (input.files[0].type.split('/')[1] === "jpeg")) {
            var reader = new FileReader();
            reader.onload = function (e) {
                if (isDebugMode) {
                    console.log("file type = " + e.target.result);
                    console.log("file name = " + input.files[0].name.split('.').slice(0, -1).join('.'));
                }
                var image = new Image();
                image.src = e.target.result;
                image.onload = function () {
                    if (isDebugMode) {
                        console.log("image width = " + this.width + " height = " + this.height);
                    }
                    if (this.width > 1920) {
                        showWarningToast("Photo width can't over 1920 pixels !");
                    } else {
                        if (this.height > 1080) {
                            showWarningToast("Photo height can't over 1080 pixels !");
                        } else {
                            var checkType = checkPhotoType(input.files[0].name);
                            var base64result = e.target.result.split(',')[1];
                            if (isDebugMode) {
                                console.log("base64 = " + base64result);
                            }
                            switch (checkType) {
                                case image_type_jpg://jpg
                                    //   uploadRXIcon(true, input.files[0].name.split('.').slice(0, -1).join('.'), base64result);
                                    uploadRXIcon(true, $("#select_rx_group").val().toString(), base64result);
                                    break;
                                case image_type_png://png
                                    //    uploadRXIcon(false, input.files[0].name.split('.').slice(0, -1).join('.'), base64result);
                                    uploadRXIcon(false, $("#select_rx_group").val().toString(), base64result);
                                    break;
                            }
                            $('input[type="file"]').val(null);
                        }
                    }
                };
            };
            reader.readAsDataURL(input.files[0]);
        } else {
            $('input[type="file"]').val(null);
            showWarningToast("Only accept \"jpg\" and \"png\" file !");
        }
    } else {
        $('input[type="file"]').val(null);
        showErrorToast("Upload photo failed !");
    }
}

/**
 * Code By Webdevtrick ( https://webdevtrick.com )
 * Read upload file
 * @param input : upload file
 */
function readTXFile(input) {
    if (isDebugMode) {
        console.log("readFile");
        console.log("input.files[0] = " + input.files[0] + " type = " + input.files[0].type.split('/')[1]);
    }

    if (input.files && input.files[0]) {
        if ((input.files[0].type.split('/')[1] === "png") || (input.files[0].type.split('/')[1] === "jpeg")) {
            var reader = new FileReader();
            reader.onload = function (e) {
                if (isDebugMode) {
                    console.log("file type = " + e.target.result);
                    console.log("file name = " + input.files[0].name.split('.').slice(0, -1).join('.'));
                }
                var image = new Image();
                image.src = e.target.result;
                image.onload = function () {
                    if (isDebugMode) {
                        console.log("image width = " + this.width + " height = " + this.height);
                    }
                    if (this.width > 1920) {
                        showWarningToast("Photo width can't over 1920 pixels !");
                    } else {
                        if (this.height > 1080) {
                            showWarningToast("Photo height can't over 1080 pixels !");
                        } else {
                            var checkType = checkPhotoType(input.files[0].name);
                            var base64result = e.target.result.split(',')[1];
                            if (isDebugMode) {
                                console.log("base64 = " + base64result);
                            }
                            switch (checkType) {
                                case image_type_jpg://jpg
                                    //   uploadRXIcon(true, input.files[0].name.split('.').slice(0, -1).join('.'), base64result);
                                    uploadTXIcon(true, $("#select_tx_group").val().toString(), base64result);
                                    break;
                                case image_type_png://png
                                    //    uploadRXIcon(false, input.files[0].name.split('.').slice(0, -1).join('.'), base64result);
                                    uploadTXIcon(false, $("#select_tx_group").val().toString(), base64result);
                                    break;
                            }
                            $('input[type="file"]').val(null);
                        }
                    }
                };
            };
            reader.readAsDataURL(input.files[0]);
        } else {
            $('input[type="file"]').val(null);
            showWarningToast("Only accept \"jpg\" and \"png\" file !");
        }
    } else {
        $('input[type="file"]').val(null);
        showErrorToast("Upload photo failed !");
    }
}


/**
 * Upload photo to server (pi4)
 * @param type : true is jpg, false is png
 * @param filename : photo file name
 * @param base64String : photo base64 string
 */
function uploadTXIcon(type, filename, base64String) {

    var postData = "type=" + type + "&name=" + filename + "&data=" + base64String;
    if (isDebugMode) {
        console.log("postData = " + postData);
    }
    $.ajax({
        url: dbServerInfo.ip + "/api/upload_tx_group_icon",
        data: postData,
        cache: false,
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
            }
            // console.log("parser result = " + obj.result);
            if (obj.result != "OK") {
                showErrorToast("Upload photo failed !");

            } else {
                setTimeout(
                    function () {
                        if (type) {
                            $("#tx_icon_img").attr("src", "../group/tx/" + $("#select_tx_group").val() + ".jpg");
                        } else {

                            $("#tx_icon_img").attr("src", "../group/tx/" + $("#select_tx_group").val() + ".png");
                        }
                    }, 2000);
                showSuccessToast("Upload photo successful");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            // $(".loading").hide();
            showErrorToast("Upload photo failed !");
        }
    });
}


/**
 * Upload photo to server (pi4)
 * @param type : true is jpg, false is png
 * @param filename : photo file name
 * @param base64String : photo base64 string
 */
function uploadRXIcon(type, filename, base64String) {

    var postData = "type=" + type + "&name=" + filename + "&data=" + base64String;
    if (isDebugMode) {
        console.log("postData = " + postData);
    }
    $.ajax({
        url: dbServerInfo.ip + "/api/upload_rx_group_icon",
        data: postData,
        cache: false,
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
            }
            // console.log("parser result = " + obj.result);
            if (obj.result != "OK") {
                showErrorToast("Upload photo failed !");

            } else {
                setTimeout(
                    function () {
                        if (type) {
                            $("#rx_icon_img").attr("src", "../group/rx/" + $("#select_rx_group").val() + ".jpg");
                        } else {

                            $("#rx_icon_img").attr("src", "../group/rx/" + $("#select_rx_group").val() + ".png");
                        }
                    }, 2000);
                showSuccessToast("Upload photo successful");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            // $(".loading").hide();
            showErrorToast("Upload photo failed !");
        }
    });
}

/**
 * Check upload photo type (jpg or png)
 * @param fileName : upload file name
 * @returns {number} : 1 is jpg, 2 is png, -1 is another
 */
function checkPhotoType(fileName) {
    var fileTypes = ['jpg', 'png'];  //acceptable file types
    var extension = fileName.split('.').pop().toLowerCase();  //file extension from input file
    var isSuccess = fileTypes.indexOf(extension) > -1;  //is extension in acceptable types
    if (isSuccess) {
        switch (extension) {
            case 'jpg':
                return 1;
            case 'png':
                return 2;
            default:
                return -1;
        }
    } else {
        showWarningToast("Only accept \"jpg\" and \"png\" file !");
    }
}