var isDebugMode = false;
var COOKIE_LOGIN_NAME = "bzb-login";
var COOKIE_SYSTEM_TYPE = "bzb-system-type";
var COOKIE_USER_INFO = "bzb-user-info";
var webVersion = "Ver. 3.4";
var WORKER_START_EVENT = "WORKER_START_EVENT";
var WORKER_UPDATE_INFO_EVENT = "WORKER_UPDATE_INFO_EVENT";
var WORKER_UPDATE_TIMER_EVENT = "WORKER_UPDATE_TIMER_EVENT";
var CHECK_IMAGE_EVENT_OK = "CHECK_IMAGE_EVENT_OK";
var CHECK_IMAGE_EVENT_NOT_FOUND = "CHECK_IMAGE_EVENT_NOT_FOUND";
var CHECK_IMAGE_EVENT_SIZE_ISSUE = "CHECK_IMAGE_EVENT_SIZE_ISSUE";
var devicePermissionMap;
var image_type_jpg = 1;
var image_type_png = 2;

$(document).ready(function () {
    if (isDebugMode) {
        console.log("common.js initial");
    }
    devicePermissionMap = new Object();
    getUserInfo();
    initialSideBar();
    if (document.cookie.indexOf(COOKIE_SYSTEM_TYPE) > -1) {
        if (isDebugMode) {
            console.log("system cookie is exist");
        }
        if (readCookie(COOKIE_SYSTEM_TYPE) === "true") {
            //ASpeed
            //   $("#page-title").text("☰ HDMI over IP");
            document.title = "HDMI over IP";
            $("#nav_video_wall").show();
            $("#nav_event").show();
            $("#nav_osd").show();
        } else {
            //ITE
            $("#page-title").text("☰ EVOIP - Lite");
            document.title = "EVOIP - Lite";
            $("#nav_video_wall").hide();
            $("#nav_event").hide();
            $("#nav_osd").hide();
        }
    } else {
        //Default ASpeed
        createCookie(COOKIE_SYSTEM_TYPE, true, 2);
        //   $("#page-title").text("☰ HDMI over IP");
        document.title = "HDMI over IP";
        $("#nav_video_wall").show();
        $("#nav_osd").show();
    }
    addLogoutModalHtml();
    MenuMouseOverEvent();
});

/**
 *  Audio object
 * @param id : rx id.
 * @param name : rx name.
 * @param ip : rx ip.
 * @param mac : rx mac.
 * @param status : rx status (y:online, n: offline).
 * @param pin : rx pin.
 * @param audio_id : audio channel.
 */
function audioObject(id, name, ip, mac, alive, pin, publisher_audio_id, subscriber_audio_id) {
    this.id = id;
    this.name = name;
    this.ip = ip;
    this.mac = mac;
    this.alive = alive;
    this.publisher_audio_id = publisher_audio_id;
    this.subscriber_audio_id = subscriber_audio_id;
}

/**
 * RX Video Wall info
 * @param id
 * @param name
 * @param ip
 * @param mac
 * @param status
 * @param pin
 */
function vwObject(h, v, u, b, l, r, pos) {
    this.h = h;
    this.v = v;
    this.u = u;
    this.b = b;
    this.l = l;
    this.r = r;
    this.pos = pos;
}

function warningVWObject(mac, pos) {
    this.mac = mac;
    this.pos = pos;
}

/**
 * Device in DB (Device) object
 * @param mac
 * @param group_id
 */
function deviceObject(mac, group_id) {
    this.mac = mac;
    this.group_id = group_id;
}

/**
 *  RX object
 * @param id : rx id.
 * @param name : rx name.
 * @param ip : rx ip.
 * @param mac : rx mac.
 * @param status : rx status (y:online, n: offline).
 * @param pin : rx pin.
 */
function rxObject(id, name, ip, mac, status, pin) {
    this.id = id;
    this.name = name;
    this.ip = ip;
    this.mac = mac;
    this.status = status;
    this.pin = pin;
}

/**
 *  TX object
 * @param id : tx id.
 * @param name : tx name.
 * @param mac : tx mac.
 */
function txObject(id, name, mac, alive, ip) {
    this.id = id;
    this.name = name;
    this.mac = mac;
    this.alive = alive
    this.ip = ip;
}

/**
 *  Device Permission Object
 * @param mac : mac.
 * @param released : released.
 */
function devicePermissionObject(released) {
    this.released = released;
}


/**
 * Email Object
 */
function emailObject(name, id) {
    this.name = name;
    this.id = id;
}

function nameObject(name){
    this.name = name;
}


/**
 *  OSD object
 */
function osdObject() {
    this.name;
    this.type;
    this.alpha;
    this.mask;
    this.offtime;
    this.str;
    this.size;
    this.color;
    this.pos;
    this.x;
    this.y;
    this.pic;
}

/**
 * Get user info
 */
function getUserInfo() {

    var userId = readCookie(COOKIE_USER_INFO);

    $.ajax({
        url: dbServerInfo.ip + "/api/user_info/" + userId,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            if(returnData.result.toUpperCase() != "OK"){
                $("#span_user_account").text("");
            }else{
                $("#span_user_account").text(returnData.account);
                $("#span_user_account").attr("data-id", returnData.id);
                $("#span_user_account").attr("data-role", returnData.role);

                //hide video wall - (Member)
                if(returnData.role > 1){
                    $(".menu_group").hide();
                }
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
        }
    });
}

function checkDevicePermission(mac){

    var checkPermission = true;
    if (typeof (devicePermissionMap[mac]) === "undefined") {

    }else{

        if(devicePermissionMap[mac].released > 0){

        }else{

            checkPermission = false;
        }
    }
    // console.log("permission = " + checkPermission );
    return checkPermission;
}


/**
 * setup sidebar item & website version
 */
function initialSideBar() {
    //side menu item
    var sideBar = "  <div class=\"row col-sm-12 no_pad mouse-over-show-area\" style=\"margin-left: 3px;visibility: hidden;\">\n" +

        "                <div class=\"col-sm-12\" style=\"background: white;height: 100px;border-radius: 10px 10px 0px 0px;border-style: solid;border-color: rgb(30, 38, 51);background: linear-gradient(90deg,rgb(6, 24, 40),rgb(5, 22, 38));border-bottom: 0px\">\n" +
        "                    <img  alt=\"image\" src=\"../img/log_white.png\" style=\"max-width:100%;margin-top: 30px;\" >\n" +
        "                </div>" +
        "            </div>" +
        "            <div class=\"row col-sm-12 no_pad\" style=\"margin-left: 3px;\">\n" +
        "                <div id=\"menu_icon_empty_area\" class=\"col-sm-5 bzb-logo-small-area no_pad\" style=\"background: white;height: 40px;border-radius: 10px 10px 0px 0px;text-align: center;border-width:bold;border-style: solid;border-color: rgb(30, 38, 51);border-bottom: 0px;background: linear-gradient(90deg,rgb(6, 24, 40),rgb(5, 22, 38));\">\n" +
        //"                    <img  id=\"img_bzb_small_logo\" alt=\"image\" src=\"../img/bzb-gear-logo_small.png\" style=\"max-width:26px;height: 30px;padding-top: 8px;margin-right: 0.2vw\">\n" +
        "                </div>" +
        "                <div  class=\"col-sm-7 no_pad mouse-over-show-area\" style=\"background-color: white;height: 40px;visibility: hidden;background: linear-gradient(90deg,rgb(6, 24, 40),rgb(5, 22, 38));border-width:bold;border-style: solid;border-color: rgb(30, 38, 51);border-top: 0px;border-bottom: 0px;border-left: 0px;\">\n" +
        "                </div>" +
        "            </div>" +
        "            <div class=\"row col-sm-12 no_pad\" style=\"margin-left: 3px;overflow: hidden;height:auto;\" >" +
        "                <div id=\"menu_icon_area\" class=\"col-sm-5 no_pad bzb-menu-left-area\" style=\"background-color: white;border-radius: 0px 0px 10px 10px;border-width:bold;border-style: solid;border-color: rgb(30, 38, 51);border-top: 0px;background: linear-gradient(90deg,rgb(6, 24, 40),rgb(5, 22, 38));\">" +
        "<!--                    <div class=\"col-sm-12\"style=\"height: 200px\">-->" +
        "                   <div class=\"no_pad\" style=\"margin-top: 20px;text-align: center;height: 30px\">" +
        "                     <a href=\"mapping.html\"><i  id=\"menu_icon_mapping\" class=\"fa fa-caret-square-o-right siig_side_menu_item_icon_size\" ></i></a>" +
        "                   </div>" +
        "                   <div class=\"no_pad menu_audio\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                     <a href=\"audio.html\"><i  id=\"menu_icon_audio\" class=\"fa fa-audio-description siig_side_menu_item_icon_size\" ></i></a>" +
        "                   </div>" +
        "                   <div class=\"no_pad menu_audio_rr\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                     <a href=\"audio_rr.html\"><i  id=\"menu_icon_audio_rr\" class=\"fa fa-audio-description siig_side_menu_item_icon_size\" ></i></a>" +
        "                   </div>" +
        "                   <div class=\"no_pad menu_group\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                     <a href=\"cluster.html\"><i  id=\"menu_icon_group\" class=\"fa fa-list siig_side_menu_item_icon_size\" ></i></a>" +
        "                   </div>" +
        "                   <div class=\"no_pad menu_vw\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                    <a href=\"video_wall.html\" ><i id=\"menu_icon_video_wall\" class=\"fa fa-desktop siig_side_menu_item_icon_size\" ></i></a>" +
        "                   </div>" +
        "                   <div class=\"no_pad\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                    <a href=\"osd.html\"><i id=\"menu_icon_osd\" class=\"fa fa-picture-o siig_side_menu_item_icon_size\"></i></a>" +
        "                   </div>" +
        // "                   <div class=\"no_pad menu_schedule\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        // "                    <a href=\"schedule.html\"><i id=\"menu_icon_schedule\" class=\"fa fa-clock-o bzb_side_menu_item_icon_size\"></i></a>" +
        // "                   </div>" +
        // "                   <div class=\"no_pad\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        // "                    <a href=\"event.html\" ><i id=\"menu_icon_event\" class=\"fa fa-briefcase bzb_side_menu_item_icon_size\"></i></a>" +
        // "                   </div>" +
        "                   <div class=\"no_pad\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                    <a href=\"setup.html\"><i id=\"menu_icon_setup\" class=\"fa fa-cog siig_side_menu_item_icon_size\"></i></a>" +
        "                   </div>" +
        "                   <div class=\"no_pad\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                    <a href=\"history.html\" ><i id=\"menu_icon_history\" class=\"fa fa-newspaper-o siig_side_menu_item_icon_size\"></i></a>" +
        "                   </div>" +

        "                   <div class=\"no_pad\" style=\"margin-top: 10px;text-align: center;height: 30px\">" +
        "                    <a id=\"menu_icon_a_account\" href=\"account.html\" ><i id=\"menu_icon_account\" class=\"fa fa-user siig_side_menu_item_icon_size\"></i></a>" +
        "                   </div>" +

        "                   <div class=\"no_pad\" style=\"margin-top: 80px;text-align: center;padding-bottom: 6px\">" +
        "                    <a><i class=\"fas fa-sign-out-alt siig_side_menu_item_icon_size\"></i></a>\n" +
        "                   </div>" +
        "                </div>" +
        "                <div class=\"col-sm-7 no_pad mouse-over-show-area\" style=\"visibility: hidden;background: white;border-radius: 0px 0px 10px 0px; border-style: solid;border-color: rgb(30, 38, 51);background: linear-gradient(90deg,rgb(6, 24, 40),rgb(5, 22, 38));border-left: 0px;border-top: 0px;\">\n" +
        "                     <div class=\"no_pad\" style=\"   margin-top: 20px;height: 30px\">\n" +
        "                         <a id=\"menu_a_mapping\" href=\"mapping.html\"><span id=\"menu_span_mapping\" style=\"font-size: 14px;\" data-name=\"Mapping\" class=\"mouse-over-event-menu-item siig_title_text_color\">Mapping</span></a>\n" +
        "                     </div>" +
        "                     <div class=\"no_pad menu_audio\" style=\"   margin-top: 10px;height: 30px\">\n" +
        "                         <a id=\"menu_a_audio\" href=\"audio.html\"><span id=\"menu_span_audio\" style=\"font-size: 14px;\" data-name=\"Group\" class=\"mouse-over-event-menu-item siig_title_text_color\">Audio(TR)</span></a>\n" +
        "                     </div>" +
        "                     <div class=\"no_pad menu_audio_rr\" style=\"   margin-top: 10px;height: 30px\">\n" +
        "                         <a id=\"menu_a_audio_rr\" href=\"audio_rr.html\"><span id=\"menu_span_audio_rr\" style=\"font-size: 14px;\" data-name=\"Group\" class=\"mouse-over-event-menu-item siig_title_text_color\">Audio(RR)</span></a>\n" +
        "                     </div>" +
        "                     <div class=\"no_pad menu_group\" style=\"   margin-top: 10px;height: 30px\">\n" +
        "                         <a id=\"menu_a_group\" href=\"cluster.html\"><span id=\"menu_span_group\" style=\"font-size: 14px;\" data-name=\"Group\" class=\"mouse-over-event-menu-item siig_title_text_color\">Cluster</span></a>\n" +
        "                     </div>" +
        "                    <div class=\"no_pad menu_vw\" style=\"   margin-top: 10px;height: 30px\">\n" +
        "                        <a id=\"menu_a_video_wall\" href=\"video_wall.html\"><span id=\"menu_span_video_wall\"style=\"font-size: 14px;\" data-name=\"Video Wall\" class=\"mouse-over-event-menu-item siig_title_text_color\">Video Wall</span></a>\n" +
        "                    </div>" +
        "                    <div class=\"no_pad\" style=\"   margin-top: 10px;height: 30px\">\n" +
        "                        <a id=\"menu_a_osd\" href=\"osd.html\" ><span id=\"menu_span_osd\" style=\"font-size: 14px;\" data-name=\"OSD\" class=\"mouse-over-event-menu-item siig_title_text_color\">OSD</span></a>\n" +
        "                    </div>" +
        // "                    <div class=\"no_pad menu_schedule\" style=\"   margin-top: 10px;height: 30px\">\n" +
        // "                        <a id=\"menu_a_schedule\" href=\"schedule.html\" ><span id=\"menu_span_schedule\" style=\"font-size: 14px;\" data-name=\"OSD\" class=\"mouse-over-event-menu-item bzb_title_text_color\">Schedule</span></a>\n" +
        // "                    </div>" +
        // "                    <div class=\"no_pad\" style=\"   margin-top: 10px;height: 30px\">\n" +
        // "                        <a id=\"menu_a_event\" href=\"event.html\"><span id=\"menu_span_event\" style=\"font-size: 14px;\" data-name=\"Event\" class=\"mouse-over-event-menu-item bzb_title_text_color\">Event</span></a>\n" +
        // "                    </div>" +
        "                    <div class=\"no_pad\" style=\"   margin-top: 10px;height: 30px\">\n" +
        "                        <a id=\"menu_a_setup\" href=\"setup.html\"><span id=\"menu_span_setup\" style=\"font-size: 14px;\" data-name=\"Setup\" class=\"mouse-over-event-menu-item siig_title_text_color\">Setup</span></a>\n" +
        "                    </div>" +
        "                    <div class=\"no_pad\" style=\"   margin-top: 10px;height: 30px;\">\n" +
        "                        <a id=\"menu_a_history\" href=\"history.html\"><span id=\"menu_span_history\" style=\"font-size: 14px;\" data-name=\"History\" class=\"mouse-over-event-menu-item siig_title_text_color\">History</span></a>\n" +
        "                    </div>" +

        "                    <div class=\"no_pad\" style=\"   margin-top: 10px;height: 30px;\">\n" +
        "                        <a id=\"menu_a_account\" href=\"account.html\"><span id=\"menu_span_account\" style=\"font-size: 14px;\" data-name=\"Account\" class=\"mouse-over-event-menu-item siig_title_text_color\">Account</span></a>\n" +
        "                    </div>" +


        "                    <div class=\"no_pad\" style=\"margin-top: 80px;padding-bottom: 8.1px\">\n" +
        "                        <a onclick=\"logout()\" style=\"cursor: pointer;\"><span style=\"font-size: 14px;\" class=\"siig_title_text_color\">Log out</span></a>" +
        "                    </div>" +
        "                </div>" +
        "            </div>";
    $("#mySidenav").append(sideBar);

    $.get("footer.html", function (data) {
        $("#container").append(data);
        $("#span_web_version").text(webVersion);
    });
    //footer web version

    // var versionHTML = "<div style='  position: fixed;bottom: 0;width: 100%;'>" +
    //     "<span id=\"span_menu_version\" class=\"bzb_title_text_color\">" + webVersion + "</span>" +
    //     "</div>";
    // $("#mySidenav").append(versionHTML);

    // //website version
    // var versionLabel = "<div style=\"overflow:hidden;text-align:center;bottom:0px;position: absolute;\">" +
    //     "<span id=\"nav_mapping\" style=\"display:inline-block;font-size:23px;color:#818181; margin-left: 10px;\">" + webVersion + "</span></div>";
    //
    // $("#mySidenav").append(versionLabel);
}

function openNav() {
    document.getElementById("mySidenav").style.width = "250px";
}

function closeNav() {
    document.getElementById("mySidenav").style.width = "0";
}

function logout() {
    //  document.getElementById("mySidenav").style.width = "0";
    $('#logout-modal').modal('show');
}

// /**
//  * Log-out yes button click event
//  */
// function logoutYesBtClickEvent(){
//     $("#bt-logout").click(function () {
//         console.log("logoutYesBtClickEvent");
//         eraseCookie(cookie_login_name);
//         window.location.href = "log_in.html";
//     });
// }

/**
 * Loading logout modal to every page
 */
function addLogoutModalHtml() {
    $(".logout-modal-area").load("log_out.html");
    $(document).on('click', '#bt-logout', function () {
        console.log("logoutYesBtClickEvent");
        eraseCookie(COOKIE_LOGIN_NAME);
        window.location.href = "log_in.html";
    });
}


var dbServerInfo = {
    //ip: "http://astpi4b:8080"
    ip: ""
};

var jsonKey = {
    ip: "ip",
    is_host: "is_host",
    status: "status",
    host_name: "host_name"
};

function showSuccessToast(message) {
    $.toast({
        heading: 'Success',
        text: message,
        icon: 'success',
        position: 'top-right',
    })
}

function showWarningToast(message) {
    $.toast({
        heading: 'Warning',
        text: message,
        icon: 'warning',
        position: 'top-right',
    })
}

function showErrorToast(message) {
    $.toast({
        heading: 'Error',
        text: message,
        icon: 'error',
        position: 'top-right',
    })
}

/**
 * calculate  device opening time
 * @param s : total seconds
 * @returns {string}
 */
function secondsTimeSpanToHMS(s) {
    var h = Math.floor(s / 3600); //Get hours
    s -= h * 3600;//remain seconds
    var m = Math.floor(s / 60); //Get minutes
    s -= m * 60;//remain seconds
    if (h >= 24) {
        var days = Math.floor(h / 24); //Get days
        h = Math.floor(h % 24);
        return days + " days - " + h + " hr : " + (m < 10 ? '0' + m : m) + " m : " + (s < 10 ? '0' + Math.floor(s) : Math.floor(s)) + " s";
    } else {
        return h + " hr : " + (m < 10 ? '0' + m : m) + " m : " + (s < 10 ? '0' + Math.floor(s) : Math.floor(s)) + " s";
    }
    //  return h+":"+(m < 10 ? '0'+m : m)+":"+(s < 10 ? '0'+s : s); //zero padding on minutes and seconds
}

/**
 * make mac formate
 * @param ori_mac : original mac data
 * @returns {string} : new formate mac data
 */
function macFormat(ori_mac) {
    var mac = ""
    for (var index = 0; index < ori_mac.length; index = index + 2) {
        mac += ori_mac[index] + ori_mac[index + 1] + ":";
    }
    if (mac.length > 0) {
        mac = mac.slice(0, -1);
    }
    return mac;
}

/**
 * calculate object list size
 * @param obj : object list
 * @returns {number} : size of object list
 */
Object.size = function (obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

/**
 * create group IP
 * @param device_id
 * @returns {string}
 */
function createGroupIP(device_id) {
    //group ip
    //format: 255.0. + device id (half.half)
    if ((device_id.trim()) && (device_id.length == 4)) {
        return group_ip = "255.0." + device_id.charAt(0) + device_id.charAt(1) + "." + device_id.charAt(2) + device_id.charAt(3);
    } else {
        return group_ip = "N/A";
    }
}

/**
 * create status circle html string
 *
 * on-line : green circle
 * off-line : red circle
 *
 * @param status : device status y: on-line, n: off-line
 * @param isItemStyle : is used to datatable row or list item
 * @returns {string} : status circle html
 */
function statusHtml(status, isItemStyle) {
    if (!isItemStyle) {
        if (status === "y") {
            return "<span class=\"green_dot\"></span>";
        } else {
            return "<span class=\"red_dot\"></span>";
        }
    } else {
        if (status === "y") {
            return "<span class=\"green_item_dot\"></span>";
        } else {
            return "<span class=\"red_item_dot\"></span>";
        }
    }
}

/**
 * check file is exist, first time initial UI
 * @param urlToFile : file path.
 * @returns {boolean} : true: is exist, false: isn't exist.
 */
function doesFileExistForInitial(urlToFile) {
    var xhr = new XMLHttpRequest();
    xhr.open('HEAD', urlToFile, false);
    xhr.send();
    if (isDebugMode) {
        console.log("preview size = " + parseInt(xhr.getResponseHeader("Content-Length")));
    }

    if (xhr.status === "404") {
        return "../snapshot/nosignal.bmp";
    } else {
        //check image size
        if (parseInt(xhr.getResponseHeader("Content-Length")) > 10000) {
            return urlToFile;
        } else {
            return "../snapshot/nosignal.bmp";
        }
    }
}


/**
 * check file is exist
 * @param urlToFile : file path.
 * @returns {boolean} : true: is exist, false: isn't exist.
 */
function doesFileExist(urlToFile) {
    var xhr = new XMLHttpRequest();
    xhr.open('HEAD', urlToFile, false);
    xhr.send();
    if (isDebugMode) {
        console.log("preview size = " + parseInt(xhr.getResponseHeader("Content-Length")));
    }

    if (xhr.status === "404") {
        return CHECK_IMAGE_EVENT_NOT_FOUND;
    } else {
        //check image size
        if (parseInt(xhr.getResponseHeader("Content-Length")) > 10000) {
            return CHECK_IMAGE_EVENT_OK;
        } else {
            return CHECK_IMAGE_EVENT_SIZE_ISSUE;
        }
    }
}

/**
 * Check file is exist
 * @param urlToFile : path to file
 */
function checkFileIsExist(urlToFile){

    var http = new XMLHttpRequest();
    http.open('HEAD', urlToFile, false);
    http.send();
    return http.status!=404;
}


/**
 * create login cookie
 * @param name : cookie name
 * @param value : cookie value
 * @param days : valid date
 */
function createCookie(name, value, days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        var expires = "; expires=" + date.toGMTString();
    } else var expires = "";
    document.cookie = name + "=" + value + expires + "; path=/";
}

/**
 * Read cookie
 * @param name : cookie name
 * @returns {string|null} : cookie value
 */
function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
    }
    return null;
}

/**
 * Delete Cookie
 * @param name : cookie name
 */
function eraseCookie(name) {
    createCookie(name, "", -1);
}

/**
 * Check login before or not
 */
function checkLoginCookie() {
    var feedback = readCookie(COOKIE_LOGIN_NAME);
    if (feedback === "true") {
    } else {
        window.location.href = "./log_in.html";
    }
}

/**
 * Get Device name
 * @param jsonObject : return json object
 * @returns {string} : if rhost_name isn't empty return rhost_name
 *                     else return host_name;
 */
function getDeviceName(jsonObject) {
    //check rhost_name is empty or not
    if (jsonObject.rhost_name.length > 0) {
        return jsonObject.rhost_name;
    } else {
        return jsonObject.host_name;
    }
}

/**
 * Check ip address is correct format
 * @param ip : user enter IP
 * @returns {boolean} : true: is correct, false: isn't correct
 * @constructor
 */
function ValidateIPAddress(ip) {
    var ipformat = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
    if (ip.match(ipformat)) {
        return true;
    } else {
        return false;
    }
}

/**
 * Check MAC address is correct format
 * @param mac_address : MAC Address
 * @returns {boolean} : true: is correct, false: isn't correct
 * @constructor
 */
function ValidateMACAddress(mac_address) {
    var regexp = /^(([A-Fa-f0-9]{2}[:]){5}[A-Fa-f0-9]{2}[,]?)+$/i;
    if (regexp.test(mac_address)) {
        return true;
    } else {
        return false;
    }
}

function MenuMouseOverEvent() {

    //mouse in
    $(".mouse-over-event-change").mouseover(function () {
        $(".mouse-over-show-area").css("visibility", "visible");
        $("#img_bzb_small_logo").css("visibility", "hidden");
        $('.bzb-logo-small-area').css({
            'border-top-left-radius': 0,
            'border-top-right-radius': 0,
            'border-bottom-right-radius': 0,
            'border-bottom-left-radius': 0
        });
        $('.bzb-menu-left-area').css({
            'border-top-left-radius': 0,
            'border-top-right-radius': 0,
            'border-bottom-right-radius': 0,
            'border-bottom-left-radius': 10
        });

        $("#menu_icon_area").css("border-right-width", "0px");
        $("#menu_icon_empty_area").css("border-top-width", "0px");
        $("#menu_icon_empty_area").css("border-right-width", "0px");
    });

    //mouse out
    $(".mouse-over-event-change").mouseout(function () {
        $(".mouse-over-show-area").css("visibility", "hidden");
        $("#img_bzb_small_logo").css("visibility", "visible");
        $('.bzb-logo-small-area').css({
            'border-top-left-radius': 10,
            'border-top-right-radius': 10,
            'border-bottom-right-radius': 0,
            'border-bottom-left-radius': 0
        });

        $('.bzb-menu-left-area').css({
            'border-top-left-radius': 0,
            'border-top-right-radius': 0,
            'border-bottom-right-radius': 10,
            'border-bottom-left-radius': 10
        });

        $("#menu_icon_area").css("border-right-width", "3px");
        $("#menu_icon_empty_area").css("border-top-width", "3px");
        $("#menu_icon_empty_area").css("border-right-width", "3px");
    });

}

/**
 * Get URL Parameter
 * @param sParam : key
 * @returns {string} : value
 */
function getUrlParameter(sParam) {
    var sPageURL = window.location.search.substring(1),
        sURLVariables = sPageURL.split('&'),
        sParameterName,
        i;

    for (i = 0; i < sURLVariables.length; i++) {
        sParameterName = sURLVariables[i].split('=');

        if (sParameterName[0] === sParam) {
            return decodeURIComponent(sParameterName[1]);
        }
    }
    return "";
}

function isEmail(email) {
    var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
    return regex.test(email);
}

function borderChange(id, color)
{
    document.getElementById(id).style.borderColor = color;
}


/**
 * padding zero to string left
 * @param data : original data
 * @param max :  max lengt
 * @returns {*|string}
 */
function pad(data, max) {
    data = data.toString();
    return data.length < max ? pad("0" + data, max) : data;
}

