var emailTable;
var connectionLostTable;
var videoLostTable;
var emailMap = new Object();
var rxMap = new Object();
var txMap = new Object();

$(document).ready(function () {

    $("#menu_a_event").css("color", "orangered");
    $("#menu_span_event").css("color", "orangered");
    $("#menu_icon_event").css("color", "orangered");

    checkLoginCookie();
    emailTable = $('#email-table-dt').DataTable({
        responsive: true,
        searching: false,
        paging: false,
        ordering: false,
        info: true
    });

    connectionLostTable = $('#connection-lost-table-dt').DataTable({
        responsive: true,
        searching: true,
        paging: false,
        ordering: false,
        info: true
    });

    videoLostTable = $('#video-lost-table-dt').DataTable({
        responsive: true,
        searching: true,
        paging: false,
        ordering: false,
        info: true
    });
    // getUserID();
    getEmailList();
    addEmailBtClickListener();
    connectionLostModifyApply();
    videoLostModifyApply();
    modalEmailApplyClickListener();
    btShowConnectionLostModal();
    btShowVideoLostModal();
    connectionLoseDeviceTypeChangeListener();
    addConnectionLostBtCLick();
    addVideoLostBtCLick();
    tabClickEvent();
});


/**
 * Tab click event
 */
function tabClickEvent() {
    $("#tab-connection-lost").click(function () {
        getConnectionLostEventList();
    });

    $("#tab-video-lost").click(function () {
        getVideoLostEventList();
    });

    $("#tab-email-lost").click(function () {
        getEmailList();
    });
}


/**
 * Get Email List
 */
function getEmailList() {
    emailTable.clear().draw();

    var emailRows = "";
    var emailSelectorList = "";

    $.ajax({
        url: dbServerInfo.ip + "/api/list_mail",
        type: "GET",
        success: function (data) {

            for (mailIndex in data.mail) {
                emailMap[data.mail[mailIndex].index] = new emailObject(data.mail[mailIndex].name, data.mail[mailIndex].index);
                var emailContent = "";

                if (data.mail[mailIndex].email.length > 0) {
                    emailContent = data.mail[mailIndex].email.split(";");
                    if (emailContent.length > 2) {
                        emailContent = emailContent[0] + "...";
                    } else {
                        emailContent = emailContent[0];
                    }
                }
                emailRows = "<tr style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + data.mail[mailIndex].index + "</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + data.mail[mailIndex].name
                    + "</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + emailContent + "</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + "<button  type=\"button\" " +
                    "  data-index=\"" + data.mail[mailIndex].index + "\" data-name=\"" + data.mail[mailIndex].name + "\" class=\"btn bt-edit\" style=\"color: rgb(100, 108, 128);background: rgb(188, 221, 206)\" title=\"Edit\">" +
                    "  <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\" ></span>" +
                    "  </button>" + "</td></tr>";
                emailSelectorList += "<option value=\"" + data.mail[mailIndex].index + "\">" + data.mail[mailIndex].name + "</option>"
                emailTable.row.add($(emailRows)).draw();
            }
            $("#modal-mail-list").empty();
            $("#modal-mail-list").append(emailSelectorList);
            $("#modal-mail-list").val($("#email-modal").attr("data-index"));
            editBtClickListener();
            mailSelectorChangeListener();
            getDeviceList();
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get Email info list error !");
        }
    });


}

/**
 * Edit button click listener
 */
function editBtClickListener() {
    $(".bt-edit").click(function () {
        var emailGroupIndex = parseInt($(this).attr("data-index")) - 1;
        $("#input-email-group-name").val($(this).attr("data-name"));
        $("#modal-mail-list").val($(this).attr("data-index"));
        $("#email-modal").attr("data-index", $(this).attr("data-index"));
        $.ajax({
            url: dbServerInfo.ip + "/api/list_mail",
            type: "GET",
            success: function (data) {
                var emailHTML = "";
                $("#email-container").empty();
                $("#remove-email-container").empty();
                if (data.mail[emailGroupIndex].email.length > 0) {
                    var emailContent = data.mail[emailGroupIndex].email.split(";");
                    for (emailIndex in emailContent) {
                        if (emailContent[emailIndex].length > 0) {
                            emailHTML += "   <div id=\"" + emailContent[emailIndex] + "\" data-mail=\"" + emailContent[emailIndex] + "\" " +
                                "                           class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                "                            <span  class=\"btn btn-warning\" ><i class=\"fa fa-envelope\" aria-hidden=\"true\"></i>" +
                                "                            </span><span  class=\"btn btn-primary\" >" + emailContent[emailIndex] + "</span>\n" +
                                "                        </div>"
                        }
                    }
                }
                $("#email-container").append(emailHTML);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Get Email info list error !");
            }
        });
        $("#input-email").val("");
        $("#email-modal").modal('show');
    });
}

/**
 * Edit button click listener
 */
function addEmailBtClickListener() {
    $("#bt-add-email").click(function () {
        if (isDebugMode) {
            console.log("#bt-add-email");
            console.log("add mail = " + $("#input-email").val());
            console.log("is validate email : " + validateEmail($("#input-email").val()));
        }
        if (validateEmail($("#input-email").val())) {
            var isExist = false;

            $('#email-container').children('div').each(function () {

                if ($(this).attr("data-mail") === $("#input-email").val()) {
                    isExist = true;
                }
            });

            $('#remove-email-container').children('div').each(function () {

                if ($(this).attr("data-mail") === $("#input-email").val()) {
                    isExist = true;
                }
            });

            if (!isExist) {
                $("#email-container").append("   <div id=\"" + $("#input-email").val() + "\" data-mail=\"" + $("#input-email").val() + "\" " +
                    "                           class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                    "                            <span  class=\"btn btn-warning\" ><i class=\"fa fa-envelope\" aria-hidden=\"true\"></i>" +
                    "                            </span><span  class=\"btn btn-primary\" >" + $("#input-email").val() + "</span>\n" +
                    "                        </div>");
            } else {
                showWarningToast("This mail was applied !");
            }

        } else {
            showErrorToast("Invalid email address !");
        }
    });
}

/**
 * validate email address
 * @param email : email address want to validate
 * @returns {boolean}
 */
function validateEmail(email) {
    const re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}

/**
 * Email Modal Apply click listener
 */
function modalEmailApplyClickListener() {
    $("#bt-email-apply").click(function () {

        var emailList = "";

        if ($("#input-email-group-name").val().length > 0) {
        } else {
            showErrorToast("Group name can't be empty !");
            return;
        }

        $('#email-container').children('div').each(function () {
            emailList += $(this).attr("data-mail") + ";";
        });

        var data = {
            index: $("#email-modal").attr("data-index"),
            name: $("#input-email-group-name").val(),
            email: emailList
        };

        if (isDebugMode) {
            console.log("json data = " + JSON.stringify(data));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/modify_mail",
            data: JSON.stringify(data),
            type: "POST",
            dataType: "json",
            success: function (data) {
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (data.result != "OK") {
                    showErrorToast("Setting mail group failed !");
                } else {
                    showSuccessToast("Setting mail group successful");
                    getEmailList();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Setting mail group failed !");
            }
        });
    });
}

/**
 * Drag listener
 * */
function Drag(event) {
    event.dataTransfer.setData("Text", event.currentTarget.id);
}

/**
 * Allow drop listener
 * */
function AllowDrop(event) {
    if (isDebugMode) {
        console.log("AllowDrop");
    }
    event.preventDefault();
}

/**
 * Email Drop listener
 * */
function EmailAreaDrop(event) {
    event.preventDefault();
    // $("#target-container").appendTo(this);
    var data = event.dataTransfer.getData("Text");
    // console.log("target = " + event.target.id);

    // event.target.appendChild(document.getElementById(data));
    $("#email-container").append(document.getElementById(data));
}

/**
 * Remove Email Drop listener (Preset)
 * */
function RemoveAreaDrop(event) {
    event.preventDefault();
    var data = event.dataTransfer.getData("Text");
    $("#remove-email-container").append(document.getElementById(data));
}

/**
 * Email selector change listener
 */
function mailSelectorChangeListener() {

    $("#modal-mail-list").on('change', function () {

        $("#email-modal").attr("data-index", $(this).val());
        var emailGroupIndex = parseInt($(this).val()) - 1;

        $.ajax({
            url: dbServerInfo.ip + "/api/list_mail",
            type: "GET",
            success: function (data) {
                var emailHTML = "";
                $("#email-container").empty();
                $("#remove-email-container").empty();

                if (data.mail[emailGroupIndex].email.length > 0) {
                    var emailContent = data.mail[emailGroupIndex].email.split(";");
                    for (emailIndex in emailContent) {
                        if (emailContent[emailIndex].length > 0) {
                            emailHTML += "   <div id=\"" + emailContent[emailIndex] + "\" data-mail=\"" + emailContent[emailIndex] + "\" " +
                                "                           class=\"btn-group\" role=\"group\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px\">\n" +
                                "                            <span  class=\"btn btn-warning\" ><i class=\"fa fa-envelope\" aria-hidden=\"true\"></i>" +
                                "                            </span><span  class=\"btn btn-primary\" >" + emailContent[emailIndex] + "</span>\n" +
                                "                        </div>"
                        }
                    }
                }
                $("#input-email").val("");
                $("#input-email-group-name").val(data.mail[emailGroupIndex].name);
                $("#email-container").append(emailHTML);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Get Email info list error !");
            }
        });

    });
}

/**
 *  Show Connection lost modal
 */
function btShowConnectionLostModal() {
    $("#btn-connection-lost").click(function () {
        $("#connection-type-list").val("r");
        refreshModalDeviceList(true, false);
        getEmailListForModalSelect();
        $("#connection-lost-modal").modal('show');
    });
}

/**
 * Show Video lost modal
 */
function btShowVideoLostModal() {
    $("#btn-video-lost").click(function () {
        refreshModalDeviceList(false, true);
        getEmailListForModalSelect();
        $("#video-lost-modal").modal('show');
    });
}

/**
 * Device type change listener (Connection lost modal)
 */
function connectionLoseDeviceTypeChangeListener() {

    $("#connection-type-list").on('change', function () {
        if (this.value === "r") {
            refreshModalDeviceList(true, false);
        } else {
            refreshModalDeviceList(true, true);
        }
    });
}

/**
 * Get Email list for lost event modal
 */
function getEmailListForModalSelect() {
    $.ajax({
        url: dbServerInfo.ip + "/api/list_mail",
        type: "GET",
        success: function (data) {
            var emailList = "";
            for (mailIndex in data.mail) {
                emailList += "<option value=\"" + data.mail[mailIndex].index + "\">" + data.mail[mailIndex].name + "</option>"
            }
            $("#connection-email-list").empty();
            $("#connection-email-list").append(emailList);
            $("#video-email-list").empty();
            $("#video-email-list").append(emailList);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get Email info list error !");
        }
    });
}

/**
 * Refresh modal device list
 */
function refreshModalDeviceList(isConnection, isTX) {
    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        success: function (data) {

            var optionConnectionList = "";
            var optionVideoList = "";

            $("#connection-device-list").empty();
            $("#video-device-list").empty();

            if (isConnection) {
                if (isTX) {
                    for (jsonArrayIndex = 0; jsonArrayIndex < data.length; jsonArrayIndex++) {


                        var isExist = false;
                        if (data[jsonArrayIndex].type === "t") {
                            $('#connection-lost-table-dt > tbody  > tr').each(function () {
                                if ($(this).attr("data-mac") === data[jsonArrayIndex].mac) {
                                    isExist = true;
                                }
                            });
                            if (!isExist) {
                                optionConnectionList += "<option value=\"" + data[jsonArrayIndex].mac + "\">" + data[jsonArrayIndex].host_name + "</option>";
                            }
                        }

                    }
                    $("#connection-device-list").append(optionConnectionList);
                } else {
                    for (jsonArrayIndex = 0; jsonArrayIndex < data.length; jsonArrayIndex++) {


                        var isExist = false;
                        if (data[jsonArrayIndex].type === "r") {
                            $('#connection-lost-table-dt > tbody  > tr').each(function () {
                                if ($(this).attr("data-mac") === data[jsonArrayIndex].mac) {
                                    isExist = true;
                                }
                            });
                            if (!isExist) {
                                optionConnectionList += "<option value=\"" + data[jsonArrayIndex].mac + "\">" + data[jsonArrayIndex].host_name + "</option>";
                            }
                        }


                    }
                    $("#connection-device-list").append(optionConnectionList);
                }
            } else {
                //video lost event
                for (jsonArrayIndex = 0; jsonArrayIndex < data.length; jsonArrayIndex++) {


                    var isExist = false;
                    if (data[jsonArrayIndex].type === "t") {
                        $('#video-lost-table-dt > tbody  > tr').each(function () {
                            if ($(this).attr("data-mac") === data[jsonArrayIndex].mac) {
                                isExist = true;
                            }
                        });
                        if (!isExist) {
                            optionVideoList += "<option value=\"" + data[jsonArrayIndex].mac + "\">" + data[jsonArrayIndex].host_name + "</option>";
                        }
                    }


                }
                $("#video-device-list").append(optionVideoList);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get device list error !");
        }
    });
}

/**
 * Get device list
 */
function getDeviceList() {
    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        success: function (data) {
            rxMap = new Object();
            txMap = new Object();

            for (jsonArrayIndex = 0; jsonArrayIndex < data.length; jsonArrayIndex++) {


                if (data[jsonArrayIndex].type === "r") {
                    rxMap[data[jsonArrayIndex].mac] = new rxObject(data[jsonArrayIndex].id, getDeviceName(data[jsonArrayIndex]),
                        data[jsonArrayIndex].ip, data[jsonArrayIndex].mac, data[jsonArrayIndex].alive, data[jsonArrayIndex].pin);
                } else {
                    txMap[data[jsonArrayIndex].mac] = new txObject(data[jsonArrayIndex].id,
                        getDeviceName(data[jsonArrayIndex]), data[jsonArrayIndex].mac, data[jsonArrayIndex].alive);
                }

            }
            getConnectionLostEventList();
            getVideoLostEventList();
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get device list error !");
        }
    });
}

/**
 * Add connection lost event
 */
function addConnectionLostBtCLick() {
    $("#bt-connection-apply").click(function () {
        if (isDebugMode) {
            console.log("bt-connection-apply");
        }

        if ($("#connection-device-list option").length > 0) {
            console.log("not  empty");
            var data = {
                email_index: $("#connection-email-list").val(),
                mac: $("#connection-device-list").val(),
                type: $("#connection-type-list").val()
            };

            if (isDebugMode) {
                console.log("json data = " + JSON.stringify(data));
            }
            $.ajax({
                url: dbServerInfo.ip + "/api/connection_lost/update",
                data: JSON.stringify(data),
                type: "POST",
                dataType: "json",
                success: function (data) {
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    if (data.result != "OK") {
                        showErrorToast("Add connection lose event failed !");
                    } else {
                        showSuccessToast("Add connection lose event successful");
                        getConnectionLostEventList();
                        $("#connection-lost-modal").modal('hide');
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    showErrorToast("Add connection lose event failed !");
                }
            });
        } else {
            showWarningToast("Device can't be empty");
        }
    });
}

/**
 * Add video lost event
 */
function addVideoLostBtCLick() {
    $("#bt-video-apply").click(function () {
        if (isDebugMode) {
            console.log("bt-video-apply");
        }

        if ($("#video-device-list option").length > 0) {
            var data = {
                email_index: $("#video-email-list").val(),
                mac: $("#video-device-list").val(),
                type: "t"
            };

            if (isDebugMode) {
                console.log("json data = " + JSON.stringify(data));
            }

            $.ajax({
                url: dbServerInfo.ip + "/api/video_lost/update",
                data: JSON.stringify(data),
                type: "POST",
                dataType: "json",
                success: function (data) {
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    if (data.result != "OK") {
                        showErrorToast("Add video lost event failed !");
                    } else {
                        showSuccessToast("Add video lost event successful");
                        getVideoLostEventList();
                        $("#video-lost-modal").modal('hide');
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    showErrorToast("Add video lost event failed !");
                }
            });
        } else {
            showWarningToast("Device can't be empty");
        }

    });
}

/**
 * Get connection lost event list
 */
function getConnectionLostEventList() {

    connectionLostTable.clear().draw();

    $.ajax({
        url: dbServerInfo.ip + "/api/connection_lost",
        type: "GET",
        success: function (data) {

            connectionLostTable.clear().draw();
            var connectionLostRow = "";
            var counter = 1;

            for (index in data) {
                var deviceName = "";
                var type = "";

                if (data[index].type === "r") {
                    type = "RX";
                    if (typeof rxMap[data[index].mac] === "undefined") {
                        deviceName = data[index].mac;
                    } else {
                        deviceName = rxMap[data[index].mac].name;
                    }
                } else {
                    type = "TX";
                    if (typeof txMap[data[index].mac] === "undefined") {
                        deviceName = data[index].mac;
                    } else {
                        deviceName = txMap[data[index].mac].name;
                    }
                }

                connectionLostRow = "<tr data-mac=\"" + data[index].mac + "\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + counter + ".</td><td style=\"vertical-align: middle;border-right: 0px;color: rgb(94,102,121)\">" + deviceName + "</td><td style=\"vertical-align: middle;border-right: 0px;color: rgb(94,102,121)\">"
                    + type + "</td><td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\">"
                    + emailMap[data[index].email_index].name + "</td><td style=\"vertical-align: middle;border-right: 0px;color: rgb(94,102,121)\"><button type=\"button\" data-name=\"" + deviceName + "\" data-type=\"" + type + "\" data-email=\"" + data[index].email_index
                    + "\" data-mac=\"" + data[index].mac + "\" class=\"btn bt-edit-connection-lost\" title=\"Edit\" style=\"color: rgb(100, 108, 128);background: rgb(188, 221, 206)\">"
                    + "<span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span></button>" +
                    "  <button type=\"button\"  data-mac=\"" + data[index].mac + "\" class=\"btn bt-delete-connection-lost\" title=\"Delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\"><span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span></button></td></tr>";
                counter++;
                connectionLostTable.row.add($(connectionLostRow)).draw();
            }
            showConnectionLostEditModal();
            delConnectionLostEditModal();
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get connection lost event list error !");
        }
    });
}

/**
 * Show connection lost edit modal
 */
function showConnectionLostEditModal() {
    $(".bt-edit-connection-lost").click(function () {
        $("#input-connection-edit-type").val($(this).attr("data-type"));
        $("#input-connection-device-name").val($(this).attr("data-name"));
        var mailOptionList = "";
        for (index in emailMap) {
            mailOptionList += "<option value=\"" + emailMap[index].id + "\">" + emailMap[index].name + " </option>";
        }
        $("#connection-email-edit-list").empty();
        $("#connection-email-edit-list").append(mailOptionList);
        $("#connection-email-edit-list").val($(this).attr("data-email"));
        $("#bt-connection-lost-edit-apply").attr("data-mac", $(this).attr("data-mac"));
        if ($(this).attr("data-type") === "RX") {
            $("#bt-connection-lost-edit-apply").attr("data-type", "r");
        } else {
            $("#bt-connection-lost-edit-apply").attr("data-type", "t");
        }
        $("#connection-lost-edit-modal").modal("show");
    });
}

/**
 * Show video lost edit modal
 */
function showVideoLostEditModal() {
    $(".bt-edit-video-lost").click(function () {
        $("#input-video-edit-type").val($(this).attr("data-type"));
        $("#input-video-device-name").val($(this).attr("data-name"));
        var mailOptionList = "";
        for (index in emailMap) {
            mailOptionList += "<option value=\"" + emailMap[index].id + "\">" + emailMap[index].name + " </option>";
        }
        $("#video-email-edit-list").empty();
        $("#video-email-edit-list").append(mailOptionList);
        $("#video-email-edit-list").val($(this).attr("data-email"));
        $("#bt-video-lost-edit-apply").attr("data-mac", $(this).attr("data-mac"));
        if ($(this).attr("data-type") === "RX") {
            $("#bt-video-lost-edit-apply").attr("data-type", "r");
        } else {
            $("#bt-video-lost-edit-apply").attr("data-type", "t");
        }
        $("#video-lost-edit-modal").modal("show");
    });
}

/**
 * Delete connection lost edit modal
 */
function delConnectionLostEditModal() {
    $(".bt-delete-connection-lost").click(function () {
        $.ajax({
            url: dbServerInfo.ip + "/api/connection_lost/delete/" + $(this).attr("data-mac"),
            type: "GET",
            success: function (data) {
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (data.result != "OK") {
                    showErrorToast("Delete connection lost event failed !");
                } else {
                    showSuccessToast("Delete connection lost event successful");
                    getConnectionLostEventList();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Delete connection lost event failed !");
            }
        });
    });
}

/**
 * Delete video lost edit modal
 */
function delVideoLostEditModal() {
    $(".bt-delete-video-lost").click(function () {
        $.ajax({
            url: dbServerInfo.ip + "/api/video_lost/delete/" + $(this).attr("data-mac"),
            type: "GET",
            success: function (data) {
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (data.result != "OK") {
                    showErrorToast("Delete video lost event failed !");
                } else {
                    showSuccessToast("Delete video lost event successful");
                    getVideoLostEventList();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Delete video lost event failed !");
            }
        });
    });
}

/**
 * Connection Lost edit modal apply button click event
 */
function connectionLostModifyApply() {
    $("#bt-connection-lost-edit-apply").click(function () {

        var data = {
            email_index: $("#connection-email-edit-list").val(),
            mac: $(this).attr("data-mac"),
            type: $(this).attr("data-type")
        };

        if (isDebugMode) {
            console.log("json data = " + JSON.stringify(data));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/connection_lost/update",
            data: JSON.stringify(data),
            type: "POST",
            dataType: "json",
            success: function (data) {
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (data.result != "OK") {
                    showErrorToast("Modify connection lost event failed !");
                } else {
                    showSuccessToast("Modify connection lost event successful");
                    getConnectionLostEventList();
                    $("#connection-lost-edit-modal").modal('hide');
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Modify connection lost event failed !");
            }
        });
    });
}


/**
 * Get video lost event list
 */
function getVideoLostEventList() {
    $.ajax({
        url: dbServerInfo.ip + "/api/video_lost",
        type: "GET",
        success: function (data) {
            videoLostTable.clear().draw();
            var videoLostRow = "";
            var counter = 1;

            for (index in data) {
                var deviceName = "";
                var type = "";

                if (data[index].type === "r") {
                } else {
                    type = "TX";
                    if (typeof txMap[data[index].mac] === "undefined") {
                        deviceName = data[index].mac;
                    } else {
                        deviceName = txMap[data[index].mac].name;
                    }
                }

                videoLostRow = "<tr data-mac=\"" + data[index].mac + "\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\"><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + counter + ".</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + deviceName + "</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">" + type
                    + "</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\">"
                    + emailMap[data[index].email_index].name + "</td><td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\"><button type=\"button\" data-name=\"" + deviceName + "\" data-type=\"" + type + "\" data-email=\"" + data[index].email_index
                    + "\" data-mac=\"" + data[index].mac + "\" class=\"btn bt-edit-video-lost\" title=\"Edit\" style=\"color: rgb(100, 108, 128);background: rgb(188, 221, 206)\">"
                    + "<span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span></button>" +
                    "  <button type=\"button\"  data-mac=\"" + data[index].mac + "\" class=\"btn bt-delete-video-lost\" title=\"Delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\">" +
                    "<span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span></button></td></tr>";
                counter++;
                videoLostTable.row.add($(videoLostRow)).draw();

            }
            delVideoLostEditModal();
            showVideoLostEditModal();
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get connection lost event list error !");
        }
    });
}

/**
 * Video Lost edit modal apply button click event
 */
function videoLostModifyApply() {
    $("#bt-video-lost-edit-apply").click(function () {

        var data = {
            email_index: $("#video-email-edit-list").val(),
            mac: $(this).attr("data-mac"),
            type: $(this).attr("data-type")
        };

        if (isDebugMode) {
            console.log("json data = " + JSON.stringify(data));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/video_lost/update",
            data: JSON.stringify(data),
            type: "POST",
            dataType: "json",
            success: function (data) {
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (data.result != "OK") {
                    showErrorToast("Modify video lost event failed !");
                } else {
                    showSuccessToast("Modify video lost event successful");
                    getVideoLostEventList();
                    $("#video-lost-edit-modal").modal('hide');
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Modify video lost event failed !");
            }
        });
    });
}