var historyTable;
var datePickerStartDate = "";
var datePickerEndDate = "";

$(document).ready(function () {
    checkLoginCookie();

    $("#menu_a_history").css("color","orangered");
    $("#menu_span_history").css("color","orangered");
    $("#menu_icon_history").css("color","orangered");

    var currentDate = new Date();

    var month = currentDate.getMonth() + 1;
    var day = currentDate.getDate();

    var currentDate = currentDate.getFullYear() + '/' +
        (month < 10 ? '0' : '') + month + '/' +
        (day < 10 ? '0' : '') + day;

    datePickerStartDate = currentDate;
    datePickerEndDate = currentDate;

    historyTable = $('#history-table-dt').DataTable({
        responsive: true
    });

    $('input[name="daterange"]').daterangepicker({
        locale: {
            format: 'YYYY-MM-DD'
        },
        startDate: datePickerStartDate,
        endDate: datePickerEndDate
    });
    getHistory();
    initialDatePicker();
    btDownloadListener();
    btShowCleanModalListener();
    btCleanApplyListener()
});

/**
 * Get history
 * */
function getHistory() {

    $(".loading").show();

    historyTable.clear().draw();

    $.ajax({
        url: dbServerInfo.ip + "/api/history_list",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {

            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }
            for (index = 0; index < returnData.length; index++) {
                var time = returnData[index].time;
                if (time.length == 12) {
                    var date = time.charAt(0) + time.charAt(1) + time.charAt(2) + time.charAt(3) + "/" + time.charAt(4) + time.charAt(5) + "/"
                        + time.charAt(6) + time.charAt(7) + "-" + time.charAt(8) + time.charAt(9) + ":" + time.charAt(10) + time.charAt(11);
                }
                var row = "<tr style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128);\">" +
                    "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + date + "</td>" +
                    "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + returnData[index].type + "</td>" +
                    "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + returnData[index].event + "</td></tr>";

                historyTable.row.add($(row)).draw();
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Get history failed !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
            $(".loading").hide();
        }
    });
}

/**
 * initial datepicker
 */
function initialDatePicker() {
    var startDate = datePickerStartDate;
    var endtDate = datePickerEndDate;

    $('#input-datepicker').on('change.datepicker', function (ev) {
        var picker = $(ev.target).data('daterangepicker');
        startDate = picker.startDate.format('YYYY/MM/DD');
        endtDate = picker.endDate.format('YYYY/MM/DD');
        console.log(startDate);
        console.log(endtDate);
        historyTable.draw();
    });

    $.fn.dataTableExt.afnFiltering.push(
        function (settings, row) {
            if (row[0].length > 0) {
                rowDate = row[0].split("-")[0];
            }
            return (new Date(rowDate) >= new Date(startDate)) && (new Date(rowDate) <= new Date(endtDate));
        }
    );

}

//download excel button click event
function btDownloadListener() {
    $("#bt-download-excel").click(function () {
        if(isDebugMode){
            console.log("download excel");
        }
        cvsDownload();
    });
}

//show clean modal button click event
function btShowCleanModalListener() {
    $("#bt-clean").click(function () {
        $("#history-clean-modal").modal("show");
    });
}

//clean all history button click event
function btCleanApplyListener() {
    $("#bt-clean-apply").click(function () {

        $.ajax({
            url: dbServerInfo.ip + "/api/history_list/delete",
            type: "GET",
            crossDomain: true,
            dataType: 'json',
            success: function (returnData) {
                if (returnData.result != "OK") {
                    showErrorToast("Delete all history failed !");
                }else{
                    showSuccessToast("Delete all history successful !");
                    $("#history-clean-modal").modal("hide");
                    getHistory();
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error");
                    console.log(xhr.status);
                    console.log(thrownError);
                }
                showErrorToast("Delete all history failed !");
                if (XMLHttpRequest.readyState == 4) {
                    if (isDebugMode) {
                        console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                    }
                    // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
                } else if (XMLHttpRequest.readyState == 0) {
                    if (isDebugMode) {
                        console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                    }
                    // Network error (i.e. connection refused, access denied due to CORS, etc.)
                } else {
                    if (isDebugMode) {
                        console.log("something weird is happening");
                    }
                    // something weird is happening
                }
            }
        });
    });
}

//download excel function - Method 1
//to make datatable to excel and download
//need to create <iframe id="txtArea1" style="display:none"></iframe> in html file.
function fnExcelReport() {
    if (isDebugMode) {
        console.log("fnExcelReport");
    }
    var tab_text = "<table border='2px'><tr bgcolor='#87AFC6'>";
    var textRange;
    var j = 0;
    tab = document.getElementById('history-table-dt'); // id of table
    if (isDebugMode) {
        console.log("row count = " + tab.rows.length);
    }
    for (j = 0; j < tab.rows.length; j++) {
        tab_text = tab_text + tab.rows[j].innerHTML + "</tr>";
        //tab_text=tab_text+"</tr>";
    }

    tab_text = tab_text + "</table>";
    tab_text = tab_text.replace(/<A[^>]*>|<\/A>/g, "");//remove if u want links in your table
    tab_text = tab_text.replace(/<img[^>]*>/gi, ""); // remove if u want images in your table
    tab_text = tab_text.replace(/<input[^>]*>|<\/input>/gi, ""); // reomves input params

    var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");

    if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./))      // If Internet Explorer
    {
        if (isDebugMode) {
            console.log("Is IE");
        }
        txtArea1.document.open("txt/html", "replace");
        txtArea1.document.write(tab_text);
        txtArea1.document.close();
        txtArea1.focus();
        sa = txtArea1.document.execCommand("SaveAs", true, "Matrix_History.csv");
    } else {                 //other browser not tested on IE 11
        if (isDebugMode) {
            console.log("Not IE");
        }
        sa = window.open('data:application/vnd.ms-excel,' + encodeURIComponent(tab_text));
        //window.document.execCommand('saveas', '', filename + '.xls');
    }
    return (sa);
}

//download excel function - Method 2
//to make datatable to excel and download
function cvsDownload() {
    var titles = [];
    var data = [];

    /*
     * Get the table headers, this will be CSV headers
     * The count of headers will be CSV string separator
     */
    $('#history-table-dt th').each(function () {
        titles.push($(this).text());
    });

    /*
     * Get the actual data, this will contain all the data, in 1 array
     */
    $('#history-table-dt td').each(function () {
        data.push($(this).text());
    });

    /*
     * Convert our data to CSV string
     */
    var CSVString = prepCSVRow(titles, titles.length, '');
    CSVString = prepCSVRow(data, titles.length, CSVString);

    /*
     * Make CSV downloadable
     */
    var downloadLink = document.createElement("a");
    var blob = new Blob(["\ufeff", CSVString]);
    var url = URL.createObjectURL(blob);
    downloadLink.href = url;
    downloadLink.download = "Matrix-History.csv";
    /*
     * Actually download CSV
     */
    if (window.navigator.msSaveOrOpenBlob) {
        window.navigator.msSaveOrOpenBlob(blob, "Matrix-History.csv");
    } else {
        document.body.appendChild(downloadLink);
        downloadLink.click();
        document.body.removeChild(downloadLink);
    }
}

/*
* Convert data array to CSV string
* @param arr {Array} - the actual data
* @param columnCount {Number} - the amount to split the data into columns
* @param initial {String} - initial string to append to CSV string
* return {String} - ready CSV string
*/
function prepCSVRow(arr, columnCount, initial) {
    var row = ''; // this will hold data
    var delimeter = ','; // data slice separator, in excel it's `;`, in usual CSv it's `,`
    var newLine = '\r\n'; // newline separator for CSV row

    /*
     * Convert [1,2,3,4] into [[1,2], [3,4]] while count is 2
     * @param _arr {Array} - the actual array to split
     * @param _count {Number} - the amount to split
     * return {Array} - splitted array
     */
    function splitArray(_arr, _count) {
        var splitted = [];
        var result = [];
        _arr.forEach(function (item, idx) {
            if ((idx + 1) % _count === 0) {
                splitted.push(item);
                result.push(splitted);
                splitted = [];
            } else {
                splitted.push(item);
            }
        });
        return result;
    }

    var plainArr = splitArray(arr, columnCount);
    // don't know how to explain this
    // you just have to like follow the code
    // and you understand, it's pretty simple
    // it converts `['a', 'b', 'c']` to `a,b,c` string
    plainArr.forEach(function (arrItem) {
        arrItem.forEach(function (item, idx) {
            row += item + ((idx + 1) === arrItem.length ? '' : delimeter);
        });
        row += newLine;
    });
    return initial + row;
}