var pi4Mac = "";

$(document).ready(function () {
    getPi4Mac();
    loginBtClickEvent();
    btForgetPW();

    setTimeout(function() {
        // $(".footer").hide();
        //  $(".footer").children(0).css({
        //      marginLeft:'3%',
        //  });

        $("#span_web_version").hide();
    }, 300);
});

/**
 * Login button click event
 */
function loginBtClickEvent() {
    $("#login-bt").click(function (e) {

        console.log("loginBtClickEvent");

        if ($("#input-account").val().length > 0) {
            if (isDebugMode) {
                console.log("account not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("account empty");
            }
            showWarningToast("Please enter username !");
            return;
        }

        if ($("#input-password").val().length > 0) {
            if (isDebugMode) {
                console.log("password not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("password empty");
            }
            showWarningToast("Please enter password !");
            return;
        }

        if (pi4Mac.length > 0) {
            if (isDebugMode) {
                console.log("login has pi4 mac");
            }
            login(pi4Mac);
        } else {
            if (isDebugMode) {
                console.log("login no pi4 mac");
            }
            $.ajax({
                url: dbServerInfo.ip + "/api/get_mac",
                type: "GET",
                crossDomain: true,
                dataType: 'json',
                success: function (returnData) {
                    if (isDebugMode) {
                        console.log("success" + JSON.stringify(returnData));
                        console.log("mac = " + returnData.mac);
                    }
                    login(returnData.mac);
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error");
                        console.log(xhr.status);
                        console.log(thrownError);
                    }
                    showErrorToast("Request timeout !");
                    if (XMLHttpRequest.readyState == 4) {
                        if (isDebugMode) {
                            console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                        }
                        // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
                    } else if (XMLHttpRequest.readyState == 0) {
                        if (isDebugMode) {
                            console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                        }
                        // Network error (i.e. connection refused, access denied due to CORS, etc.)
                    } else {
                        if (isDebugMode) {
                            console.log("something weird is happening");
                        }
                        // something weird is happening
                    }
                    $(".loading").hide();
                }
            });
        }
    });
}




/**
 * Get Pi4 mac address
 */
function getPi4Mac() {
    $.ajax({
        url: dbServerInfo.ip + "/api/get_mac",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
                console.log("mac = " + returnData.mac);
            }
            pi4Mac = returnData.mac;
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
            $(".loading").hide();
        }
    });
}

/**
 * Send account & password to PI4
 * @param pi4Mac : pi4 mac address
 */
function login(pi4Mac) {

    if (isDebugMode) {
        console.log("account = " + $("#input-account").val());
        console.log("password = " + $("#input-password").val());
    }

    var beforeMD5 = pi4Mac + $("#input-account").val() + $("#input-password").val();
    var md5 = "" + CryptoJS.MD5(beforeMD5);
    md5 = md5.toUpperCase();
    if (isDebugMode) {
        console.log("beforeMD5 = " + beforeMD5);
        console.log("md5 = " + md5);
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/login",
        //  data: "password=" + md5,
        data: "account=" + $("#input-account").val() + "&password=" + $("#input-password").val(),
        type: "POST",
        success: function (data) {
            // var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);
            if (obj.result != "OK") {
                showErrorToast(obj.message);
            } else {
                createCookie(COOKIE_USER_INFO, obj.id, 0.1);
                createCookie(COOKIE_LOGIN_NAME, "true", 0.1);
                window.location.href = "./mapping.html";
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            // $(".loading").hide();
            showErrorToast("Switch failed !");
        }
    });
}

/**
 * Button Forget Password click event
 */
function btForgetPW(){
    $("#forget-pw-bt").click(function (e) {
        window.location.href = "./forgot_password.html";
    });
}