var isKVMInitial = true;
var isARPInitial = true;
var isCastingInitial = true;

$(document).ready(function () {
    checkLoginCookie();
    getDeviceInfo();
    getDeviceSetup();
    modifyNameBtClickListener();
    rotateBtClickListener();
    rotateDropDownListener();
    baudRateBtClickListener();
    baudRateDropDownListener();
    scaleBtClickListener();
    scaleDropDownListener();
    bubbleClickListener();
    rebootClickListener();
    resetClickListener();
    streamingCheckBoxListener();
    factoryResetApplyModel();
    audioChannelApplyClickListener();
    arpCheckBoxListener();
    btCECOFF();
    btCECON();
    castingListener();
});

function arpCheckBoxListener() {
    $('#input-arp').change(function () {
        if (isARPInitial) {
            isARPInitial = false;
        } else {
            if ($(this).is(':checked')) {

                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#rx_ip").text() + "&param=a_arp_input&value=toslink",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (true) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn on Audio Return Path Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn on Audio Return Path failed !");
                    }
                });

            } else {

                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#rx_ip").text() + "&param=a_arp_input&value=hdmiout",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (true) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn off Audio Return Path Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn off Audio Return Path failed !");
                    }
                });

            }
        }
    });
}

function getAudioChannel(deviceIP) {
    $.ajax({
        url: dbServerInfo.ip + "/api/astparam_g/" + deviceIP + "/audio_return",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("audio channel data = " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);
            $("#input-audio-channel").val(obj.result);
            getDeviceARP(deviceIP);
        },
        error: function (xhr, ajaxOptions, thrownError) {
        }
    });
}

//Get Casting Mode
function getCastingMode(deviceIP) {

    $.ajax({
        url: dbServerInfo.ip + "/api/astparam_g/" + deviceIP + "/multicast_on",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("Casting Mode data = " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);

            if (isDebugMode) {
                console.log("Casting Mode data = " + obj.result);
            }

            if (obj.result.toLowerCase().indexOf("n") >= 0) {
                $("#input-casting_mode").bootstrapToggle('off');
            } else {
                $("#input-casting_mode").bootstrapToggle('on');
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
        }
    });
}

//Get Audio Return Path status
function getDeviceARP(deviceIP) {
    $.ajax({
        url: dbServerInfo.ip + "/api/astparam_g/" + deviceIP + "/a_arp_input",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("audio channel data = " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);
            if (obj.result.toLowerCase() === "hdmiout") {
                $("#input-arp").bootstrapToggle('off');
            } else {
                $("#input-arp").bootstrapToggle('on');
            }
            getCastingMode(deviceIP);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            getCastingMode(deviceIP);
        }
    });
}

/**
 * Audio Channel Apply
 */
function audioChannelApplyClickListener() {

    $("#bt-audio-channel-apply").click(function () {
        if (isDebugMode) {
            console.log("data= " + $("#input-audio-channel").val());
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/astparam_s",
            data: "ip=" + $("#rx_ip").text() + "&param=audio_return&value=" + pad($("#input-audio-channel").val(), 4),
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (true) {
                    console.log("success " + JSON.stringify(data));
                }
                $("#input-audio-channel").val(pad($("#input-audio-channel").val(), 4));
                showSuccessToast("Set audio channel Successful !");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Set audio channel failed !");
            }
        });
    });
}


/**
 * Streaming Video checkBox listener
 */
function streamingCheckBoxListener() {

    $('#input-streaming').change(function () {
        if ($(this).is(':checked')) {
            // Checkbox is checked..
            var post_data = "ip=" + $("#rx_ip").text() + "&switch_id=" + $("#rx_id").attr("data-id") + "&switch_type=z";
            if (isDebugMode) {
                console.log("checked " + post_data);
            }
            $.ajax({
                url: dbServerInfo.ip + "/api/astswitch",
                data: post_data,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    if (obj.result == "OK") {
                        showSuccessToast("Turn on video streaming Successful !");
                    } else {
                        showErrorToast("Turn on video streaming failed !");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    showErrorToast("Turn on video streaming failed !");
                }
            });
        } else {
            // Checkbox is not checked..
            var post_data = "ip=" + $("#rx_ip").text() + "&switch_type=z";
            if (isDebugMode) {
                console.log("unchecked " + post_data);
            }

            $.ajax({
                url: dbServerInfo.ip + "/api/astlinkoff",
                data: post_data,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }

                    if (obj.result == "OK") {
                        showSuccessToast("Turn off video streaming Successful !");
                    } else {
                        showErrorToast("Turn off video streaming failed !");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }

                    showErrorToast("Turn off video streaming failed !");
                }
            });
        }
    });
}

/**
 * Get URL parameter
 * @param sParam
 * @returns {boolean|string}
 */
function getUrlParameter(sParam) {
    var sPageURL = window.location.search.substring(1),
        sURLVariables = sPageURL.split('&'),
        sParameterName,
        i;

    for (i = 0; i < sURLVariables.length; i++) {
        sParameterName = sURLVariables[i].split('=');

        if (sParameterName[0] === sParam) {
            return sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
        }
    }
}

/**
 * According to MAC to get device info
 */
function getDeviceInfo() {

    var userSelectedMAC = getUrlParameter('mac');
    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                //cal mac address --- start
                var ori_mac = returnData[jsonArrayIndex].mac;
                var mac = macFormat(ori_mac.toString());
                //cal mac address --- end
                if (returnData[jsonArrayIndex].mac == userSelectedMAC) {
                    $("#rx_name").text(returnData[jsonArrayIndex].host_name);
                    $("#rx_ip").text(returnData[jsonArrayIndex].ip);
                    $("#rx_id").text(returnData[jsonArrayIndex].id);
                    $("#rx_id").attr("data-id", returnData[jsonArrayIndex].id);
                    $("#rx_alive_time").text(secondsTimeSpanToHMS(returnData[jsonArrayIndex].uptime));
                    $("#rx_mac").text(mac);
                    $("#rx_mac").attr("data-mac", returnData[jsonArrayIndex].mac);
                    $("#input-name").val(getDeviceName(returnData[jsonArrayIndex]));
                    $("#input-id").val(returnData[jsonArrayIndex].id);
                    // $("#rx_fw").text(returnData[jsonArrayIndex].fw);
                    getAudioChannel(returnData[jsonArrayIndex].ip);
                    return;
                }
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
        }
    });
}


/**
 * According to MAC to get device setup
 */
function getDeviceSetup() {

    var userSelectedMAC = getUrlParameter('mac');

    $.ajax({
        url: dbServerInfo.ip + "/api/setup_info/" + userSelectedMAC,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {

            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            //system version
            if (returnData.fw === "DIAL_ERR") {
                $("#rx_sv").text("");
            } else {
                $("#rx_sv").text(returnData.fw);
            }

            //tv status
            if (returnData.rx_tv != "off") {
                $("#rx_tv").text("On");
            } else {
                $("#rx_tv").text("Loss");
            }

            //rotate status
            switch (returnData.rx_rotate) {
                case "0"://0
                    $("#rx_rotate").attr("data-rotate", "0");
                    $("#rx_rotate").text(" 0");
                    break;

                case "3"://180
                    $("#rx_rotate").attr("data-rotate", "3");
                    $("#rx_rotate").text(" 180");
                    break;

                case "5"://90
                    $("#rx_rotate").attr("data-rotate", "5");
                    $("#rx_rotate").text(" 90");
                    break;

                case "6"://270
                    $("#rx_rotate").attr("data-rotate", "6");
                    $("#rx_rotate").text(" 270");
                    break;
            }

            //rs232
            switch (returnData.rs232) {

                case "300-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "300-8n1");
                    $("#rx_baudrate").text(" 300");
                    break;

                case "600-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "600-8n1");
                    $("#rx_baudrate").text(" 600");
                    break;

                case "1200-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "1200-8n1");
                    $("#rx_baudrate").text(" 1200");
                    break;

                case "2400-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "2400-8n1");
                    $("#rx_baudrate").text(" 2400");
                    break;

                case "4800-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "4800-8n1");
                    $("#rx_baudrate").text(" 4800");
                    break;

                case "9600-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "9600-8n1");
                    $("#rx_baudrate").text(" 9600");
                    break;

                case "19200-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "19200-8n1");
                    $("#rx_baudrate").text(" 19200");
                    break;

                case "38400-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "38400-8n1");
                    $("#rx_baudrate").text(" 38400");
                    break;

                case "57600-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "57600-8n1");
                    $("#rx_baudrate").text(" 57600");
                    break;

                case "115200-8n1":
                    $("#rx_baudrate").attr("data-baudrate", "115200-8n1");
                    $("#rx_baudrate").text(" 115200");
                    break;
            }

            //scaling
            switch (returnData.rx_scale) {

                case "00000000":
                    $("#rx_scaling").attr("data-scale", "00000000");
                    $("#rx_scaling").text(" Pass-Through");
                    break;

                case "80000010":
                    $("#rx_scaling").attr("data-scale", "80000010");
                    $("#rx_scaling").text(" Full HD 1080p60");
                    break;

                case "8000001F":
                    $("#rx_scaling").attr("data-scale", "8000001F");
                    $("#rx_scaling").text(" Full HD 1080p50");
                    break;

                case "80000061":
                    $("#rx_scaling").attr("data-scale", "80000061");
                    $("#rx_scaling").text(" Ultra HD 2160p60");
                    break;

                case "8000005F":
                    $("#rx_scaling").attr("data-scale", "8000005F");
                    $("#rx_scaling").text(" Ultra HD 2160p30");
                    break;

                case "8000005E":
                    $("#rx_scaling").attr("data-scale", "8000005E");
                    $("#rx_scaling").text(" Ultra HD 2160p25");
                    break;

                case "80000004":
                    $("#rx_scaling").attr("data-scale", "80000004");
                    $("#rx_scaling").text(" HD 720p60");
                    break;

                case "81004048":
                    $("#rx_scaling").attr("data-scale", "81004048");
                    $("#rx_scaling").text(" WXGA 1366 x 768");
                    break;

                case "81004021":
                    $("#rx_scaling").attr("data-scale", "81004021");
                    $("#rx_scaling").text(" WXGA+ 1440 x 900");
                    break;


                case "81004032":
                    $("#rx_scaling").attr("data-scale", "81004032");
                    $("#rx_scaling").text(" WUXGA 1920 x 1200");
                    break;

                case "8100401D":
                    $("#rx_scaling").attr("data-scale", "8100401D");
                    $("#rx_scaling").text(" SXGA+ 1400 x 1050");
                    break;
            }


        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }

            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
        }
    });
}


/**
 * modify name apply button click event listener
 */
function modifyNameBtClickListener() {
    $("#bt-name-apply").click(function () {
        var data = "mac=" + $("#rx_mac").attr("data-mac") + "&value=" + $("#input-name").val();
        if (isDebugMode) {
            console.log("data = " + data);
        }
        if ($("#input-name").val().length > 0) {
            $.ajax({
                url: dbServerInfo.ip + "/api/set_hostname",
                data: data,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (isDebugMode) {
                        console.log("success " + JSON.stringify(data));
                    }
                    if (obj.result == "OK") {
                        showSuccessToast("Set name Successful !");
                        $("#rx_name").text($("#input-name").val());
                    } else {
                        showErrorToast("Set name failed !");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error ");
                    }
                    showErrorToast("Set name failed !");
                }
            });
        } else {
            showErrorToast("Name can't be empty !");
        }
    });
}

/**
 * rotate apply button click event listener
 */
function rotateBtClickListener() {
    $("#bt-rotate-apply").click(function () {
        var rotateValue = $("#rx_rotate").attr("data-rotate");
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: "ip=" + $("#rx_ip").text() + "&value=e e_vw_rotate_" + rotateValue,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                showSuccessToast("Set rotate Successful !");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Set rotate failed !");
            }
        });
    });
}

/**
 * Rotate dropdown menu click listener
 * */
function rotateDropDownListener() {

    $('.dropdown').on('click', '.rotate_item', function () {
        if (isDebugMode) {
            console.log("rotate_item " + $(this).attr("data-value"));
        }
        switch ($(this).attr("data-value")) {

            case "0"://0
                $("#rx_rotate").attr("data-rotate", "0");
                $("#rx_rotate").text(" 0");
                break;

            case "3"://180
                $("#rx_rotate").attr("data-rotate", "3");
                $("#rx_rotate").text(" 180");
                break;

            case "5"://90
                $("#rx_rotate").attr("data-rotate", "5");
                $("#rx_rotate").text(" 90");
                break;

            case "6"://270
                $("#rx_rotate").attr("data-rotate", "6");
                $("#rx_rotate").text(" 270");
                break;
        }
    });
}

/**
 * baudRate apply button click event listener
 */
function baudRateBtClickListener() {
    $("#bt-baudrate-apply").click(function () {
        var baudRateValue = $("#rx_baudrate").attr("data-baudrate");
        var data = "ip=" + $("#rx_ip").text() + "&param=s0_baudrate&value=" + baudRateValue;
        if (isDebugMode) {
            console.log("data= " + data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/astparam_s",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (obj.result == "OK") {
                    showSuccessToast("Set baud rate Successful !");
                } else {
                    showErrorToast("Set baud rate failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Set baud rate failed !");
            }
        });
    });
}

/**
 * baudRate dropdown menu click listener
 * */
function baudRateDropDownListener() {

    $('.dropdown').on('click', '.baudrate_item', function () {
        if (isDebugMode) {
            console.log("baudrate_item " + $(this).attr("data-value"));
        }
        switch ($(this).attr("data-value")) {

            case "300":
                $("#rx_baudrate").attr("data-baudrate", "300-8n1");
                $("#rx_baudrate").text(" 300");
                break;

            case "600":
                $("#rx_baudrate").attr("data-baudrate", "600-8n1");
                $("#rx_baudrate").text(" 600");
                break;

            case "1200":
                $("#rx_baudrate").attr("data-baudrate", "1200-8n1");
                $("#rx_baudrate").text(" 1200");
                break;

            case "2400":
                $("#rx_baudrate").attr("data-baudrate", "2400-8n1");
                $("#rx_baudrate").text(" 2400");
                break;

            case "4800":
                $("#rx_baudrate").attr("data-baudrate", "4800-8n1");
                $("#rx_baudrate").text(" 4800");
                break;

            case "9600":
                $("#rx_baudrate").attr("data-baudrate", "9600-8n1");
                $("#rx_baudrate").text(" 9600");
                break;

            case "19200":
                $("#rx_baudrate").attr("data-baudrate", "19200-8n1");
                $("#rx_baudrate").text(" 19200");
                break;

            case "38400":
                $("#rx_baudrate").attr("data-baudrate", "38400-8n1");
                $("#rx_baudrate").text(" 38400");
                break;

            case "57600":
                $("#rx_baudrate").attr("data-baudrate", "57600-8n1");
                $("#rx_baudrate").text(" 57600");
                break;

            case "115200":
                $("#rx_baudrate").attr("data-baudrate", "115200-8n1");
                $("#rx_baudrate").text(" 115200");
                break;
        }
    });
}

/**
 * baudRate apply button click event listener
 */
function scaleBtClickListener() {
    $("#bt-scale-apply").click(function () {
        var baudRateValue = $("#rx_scaling").attr("data-scale");
        var data = "ip=" + $("#rx_ip").text() + "&param=v_output_timing_convert&value=" + baudRateValue;
        if (isDebugMode) {
            console.log("data= " + data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/astparam_s",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (obj.result == "OK") {
                    showSuccessToast("Set scaling Successful !");
                    rebootDevice($("#rx_ip").text());
                } else {
                    showErrorToast("Set scaling failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Set scaling failed !");
            }
        });
    });
}


/**
 * scale dropdown menu click listener
 * */
function scaleDropDownListener() {

    $('.dropdown').on('click', '.scaling_item', function () {
        if (isDebugMode) {
            console.log("scaling_item " + $(this).attr("data-value"));
        }
        switch ($(this).attr("data-value")) {

            case "00000000":
                $("#rx_scaling").attr("data-scale", "00000000");
                $("#rx_scaling").text(" Pass-Through");
                break;

            case "80000010":
                $("#rx_scaling").attr("data-scale", "80000010");
                $("#rx_scaling").text(" Full HD 1080p60");
                break;

            case "8000001F":
                $("#rx_scaling").attr("data-scale", "8000001F");
                $("#rx_scaling").text(" Full HD 1080p50");
                break;

            case "80000061":
                $("#rx_scaling").attr("data-scale", "80000061");
                $("#rx_scaling").text(" Ultra HD 2160p60");
                break;

            case "8000005F":
                $("#rx_scaling").attr("data-scale", "8000005F");
                $("#rx_scaling").text(" Ultra HD 2160p30");
                break;

            case "8000005E":
                $("#rx_scaling").attr("data-scale", "8000005E");
                $("#rx_scaling").text(" Ultra HD 2160p25");
                break;

            case "80000004":
                $("#rx_scaling").attr("data-scale", "80000004");
                $("#rx_scaling").text(" HD 720p60");
                break;

            case "81004048":
                $("#rx_scaling").attr("data-scale", "81004048");
                $("#rx_scaling").text(" WXGA 1366 x 768");
                break;

            case "81004021":
                $("#rx_scaling").attr("data-scale", "81004021");
                $("#rx_scaling").text(" WXGA+ 1440 x 900");
                break;


            case "81004032":
                $("#rx_scaling").attr("data-scale", "81004032");
                $("#rx_scaling").text(" WUXGA 1920 x 1200");
                break;

            case "8100401D":
                $("#rx_scaling").attr("data-scale", "8100401D");
                $("#rx_scaling").text(" SXGA+ 1400 x 1050");
                break;
        }
    });
}

/**
 * Bubble LED click listener
 * */
function bubbleClickListener() {
    $("#bt-blink").click(function () {
        var post_data = "ip=" + $("#rx_ip").text() + "&value=cat /sys/devices/platform/leds/leds/button_link/N_Led";

        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Blink LED failed !");
            }
        });
    });
}

/**
 * Reboot LED click listener
 * */
function rebootClickListener() {
    $("#bt-reboot").click(function () {

        var post_data = "ip=" + $("#rx_ip").text() + "&value=reboot";
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                // if (isDebugMode) {
                //     console.log("success " + JSON.stringify(data));
                // }
                // var obj = jQuery.parseJSON(data);
                // if (isDebugMode) {
                //     console.log("success " + obj.result);
                // }
                // if (obj.result == "OK") {
                //     showSuccessToast("Reboot Successful !");
                // } else {
                //     showErrorToast("Reboot failed !");
                // }

            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("Reboot failed !");
            }
        });
        showSuccessToast("Reboot Successful !");
    });
}

/**
 * Reset click listener
 * */
function resetClickListener() {
    $("#bt-reset").click(function () {
        $('#factory-reset-modal').modal('show');
    });
}

/**
 *  Factory reset apply button on the model, and will reboot extender,
 *  after factory reset success.
 */
function factoryResetApplyModel() {
    $("#bt-factory-reset-apply-modal").click(function () {
        var post_data = "ip=" + $("#rx_ip").text() + "&value=reset_to_default.sh\n";
        if (isDebugMode) {
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + obj.result);
                }
                if (obj.result == "OK") {
                    showSuccessToast("Factory reset Successful !");
                    var post_data = "ip=" + $("#rx_ip").text() + "&value=reboot";
                    $.ajax({
                        url: dbServerInfo.ip + "/api/ast_sendcmd",
                        data: post_data,
                        type: "POST",
                        success: function (data) {
                            if (isDebugMode) {
                                console.log("success " + JSON.stringify(data));
                            }
                            var obj = jQuery.parseJSON(data);
                            if (isDebugMode) {
                                console.log("success " + obj.result);
                            }
                            if (obj.result == "OK") {
                                showSuccessToast("Reboot Successful !");
                            } else {
                                // showErrorToast("Reboot failed !");
                            }
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            showErrorToast("Reboot failed !");
                        }
                    });
                } else {
                    showErrorToast("Factory reset failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("Factory reset failed !");
            }
        });
    });
}


/**
 * Reboot device
 * @param deviceIP : device ip
 */
function rebootDevice(deviceIP) {

    var post_data = "ip=" + deviceIP + "&value=reboot";
    $.ajax({
        url: dbServerInfo.ip + "/api/ast_sendcmd",
        data: post_data,
        type: "POST",
        success: function (data) {
            if (isDebugMode) {
                console.log("success " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log("success " + obj.result);
            }
            if (obj.result == "OK") {
                showSuccessToast("Reboot Successful ! Please wait 20 seconds, it will auto refresh.");
            } else {
                showErrorToast("Reboot failed !");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            showErrorToast("Reboot failed !");
        }
    });
}

/**
 * HDMI-CEC on
 */
function btCECON() {
    $("#bt-cec-on").click(function (e) {
        var post_data = "ip=" + $("#rx_ip").text() + "&value=cec_send 40:04\n";
        if (isDebugMode) {
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                showSuccessToast("HDMI CEC turn on successful !");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("HDMI CEC turn on failed !");
            }
        });
    });
}

/**
 * HDMI-CEC off
 */
function btCECOFF() {
    $("#bt-cec-off").click(function (e) {
        var post_data = "ip=" + $("#rx_ip").text() + "&value=cec_send f0:36\n";
        if (isDebugMode) {
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                showSuccessToast("HDMI CEC turn off successful !");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("HDMI CEC turn off failed !");
            }
        });
    });
}

function castingListener() {
    $('#input-casting_mode').change(function () {
        if (isCastingInitial) {
            isCastingInitial = false;
        } else {
            if ($(this).is(':checked')) {

                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#rx_ip").text() + "&param=multicast_on&value=y",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (isDebugMode) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn on Multicast Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn on Multicast - 2 failed!");
                    }
                });

            } else {
                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#rx_ip").text() + "&param=multicast_on&value=n",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (isDebugMode) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn off Multicast Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn on Multicast - 2 failed !");
                    }
                });
            }
        }
    });
}