var setupTable;
var systemTimeWorker;
var setupWorker;
var clusterMap = new Object();
var deviceByclusterMap = new Object();
var systemDate;
var systemTimer;

function deviceObject(group, name, ip, mac, status, pin, uptime, type) {
    this.group = group;
    this.name = name;
    this.ip = ip;
    this.mac = mac;
    this.status = status;
    this.pin = pin;
    this.uptime = uptime;
    this.type = type;
}

/**
 * calculate object list size
 * @param obj : object list
 * @returns {number} : size of object list
 */
Object.size = function (obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

$(document).ready(function () {
    if (isDebugMode) {
        console.log("setup js");
    }

    $("#menu_a_setup").css("color", "orangered");
    $("#menu_span_setup").css("color", "orangered");
    $("#menu_icon_setup").css("color", "orangered");

    checkLoginCookie();
    setupTable = $('#setup-table-dt').DataTable({
        responsive: true,
        "paging": false,
        "ordering": true,
        "info": true
    });
    $('.collapse').collapse();
    getUserRole();
    // getUserID();
    //initial();
    editClickListener();
    deleteClickListener();
    bubbleClickListener();
    timezoneDropItemListener();
    confirmNewPassword();
    tabClickEvent();
    mappingUITypeListener();
    networkTypeListener();
    btApplyNetworkClickListener();
    getClusterList();
    //  systemTypeListener();
    $(".dropzone").change(function () {
        readFile(this);
    });
});


/**
 * Get user info
 */
function getUserRole() {

    var userId = readCookie(COOKIE_USER_INFO);

    $.ajax({
        url: dbServerInfo.ip + "/api/user_info/" + userId,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            if (returnData.result.toUpperCase() != "OK") {
                $("#tab-fw-update").prop("disabled", true);
                $("#tab-system-config").prop("disabled", true);
                $("#tab-fw-update").css('cursor', 'no-drop');
                ;
                $("#tab-system-config").css('cursor', 'no-drop');
                ;
            } else {
                //check role is Administrator or not, 1:Administrator, 2:Member
                if (returnData.role != 1) {
                    $("#tab-fw-update").prop("disabled", true);
                    $("#tab-system-config").prop("disabled", true);
                    $("#tab-fw-update").css('cursor', 'no-drop');
                    ;
                    $("#tab-system-config").css('cursor', 'no-drop');
                    ;

                } else {
                    $("#tab-fw-update").prop("disabled", false);
                    $("#tab-system-config").prop("disabled", false);
                    $("#tab-fw-update").css('cursor', 'pointer');
                    ;
                    $("#tab-system-config").css('cursor', 'pointer');
                    ;
                }
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
        }
    });
}

/**
 * Update device info every 10 seconds
 */
function startUpdateSetupInfoWorker() {
    if (typeof (Worker) !== "undefined") {
        if (typeof (aspeedWorker) == "undefined") {
            setupWorker = new Worker("../js/updateSetupInfoWorker.js");
        }

        setupWorker.postMessage(WORKER_START_EVENT);

        setupWorker.onmessage = function (event) {

            if (isDebugMode) {
                console.log("worker receive = " + JSON.stringify(event.data.data));
            }

            switch (event.data.event) {

                case WORKER_UPDATE_INFO_EVENT:
                    if (isDebugMode) {
                        console.log("Update device info");
                    }
                    if (readCookie(COOKIE_SYSTEM_TYPE) === "true") {
                        //ASpeed
                        if (isDebugMode) {
                            console.log("Update ASpeed info");
                        }
                        updateASpeed();
                    } else {
                        //ITE
                        if (isDebugMode) {
                            console.log("Update ITE info");
                        }
                        //updateITE();
                    }
                    break;

                case WORKER_UPDATE_TIMER_EVENT:
                    if (isDebugMode) {
                        console.log("Update timer");
                    }
                    $("#update-timer").text("Update in " + event.data.data + " seconds");
                    break;
            }
        };
    } else {
        if (isDebugMode) {
            console.log("Sorry, your browser does not support Web Workers...");
        }
        showErrorToast("Sorry, your browser does not support Web Workers...");
    }
}

/**
 * Initial to check system type is ASpeed or ITE
 */
function initial() {

    if (readCookie(COOKIE_SYSTEM_TYPE) === "true") {
        //ASpeed
        if (isDebugMode) {
            console.log("ASpeed Mode");
        }
       // getASpeedDeviceList();

    } else {
        //ITE
        if (isDebugMode) {
            console.log("ITE Mode");
        }
        //  getITEDeviceList();
    }
    // getASpeedDeviceList();
    // startUpdateSetupInfoWorker();
}

/**
 * Update device info every 10 seconds
 */
function startSystemTimer() {
    if (typeof (Worker) !== "undefined") {
        if (typeof (systemTimeWorker) === "undefined") {
            systemTimeWorker = new Worker("../js/systemTimeWorker.js");
        }
        systemTimeWorker.onmessage = function (event) {
            if (isDebugMode) {
                console.log("systemTimeWorker receive = " + event.data.toString());
            }
            $("#input-system_time").val(event.data.toString())
        };
    } else {
        if (isDebugMode) {
            console.log("Sorry, your browser does not support Web Workers...");
        }
    }
}

/**
 * Update ITE List
 */
// function updateITE() {
//     $.ajax({
//         url: dbServerInfo.ip + "/api/ite/device_info",
//         type: "GET",
//         crossDomain: true,
//         dataType: 'json',
//         success: function (returnData) {
//
//             if (isDebugMode) {
//                 console.log("Update ITE : " + JSON.stringify(returnData));
//             }
//
//             for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
//
//                 //cal mac address --- start
//                 var ori_mac = returnData[jsonArrayIndex].mac;
//                 var mac = macFormat(ori_mac.toString());
//                 var bt_edit_status = "";
//                 if (returnData[jsonArrayIndex].lan_status === "y") {
//                     bt_edit_status = "display: inline-block;";
//                 } else {
//                     bt_edit_status = "display: none;";
//                 }
//                 //cal mac address --- end
//
//                 if ($(".form-control").val().length > 0) {
//
//                     if (isDebugMode) {
//                         console.log("user search...");
//                     }
//
//                     if ($("#" + returnData[jsonArrayIndex].mac).length > 0) {
//                         //old device
//                         if ($("#" + returnData[jsonArrayIndex].mac + "_group").length > 0) {
//                             $("#" + returnData[jsonArrayIndex].mac + "_group").text(returnData[jsonArrayIndex].group_id);
//                         }
//
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(2).empty();//name
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(2).append(returnData[jsonArrayIndex].name);//name
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(3).empty();//ip
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(3).append(returnData[jsonArrayIndex].ip);//ip
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(4).empty();//mac
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(4).append(mac);//mac
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(5).empty();//uptime
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(5).append(statusHtml(returnData[jsonArrayIndex].lan_status));//online-status
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(6).empty();//action
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(6).append("<button data-type=\"" + returnData[jsonArrayIndex].type + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn btn-primary bt-ite-edit\" title=\"Edit\" style=\"" + bt_edit_status + "\">\n" +
//                             "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>\n" +
//                             "                </button>");//action
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(7).empty();//action
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(7).append(
//                             "                <button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn btn-danger bt-ite-delete\" title=\"Delete\">\n" +
//                             "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>\n" +
//                             "                </button>");//action
//                     }
//                 } else {
//
//                     if (isDebugMode) {
//                         console.log("user not search...");
//                     }
//
//                     if ($("#" + returnData[jsonArrayIndex].mac).length > 0) {
//
//                         //old device
//                         if ($("#" + returnData[jsonArrayIndex].mac + "_group").length > 0) {
//                             $("#" + returnData[jsonArrayIndex].mac + "_group").text(returnData[jsonArrayIndex].group_id);
//                         }
//
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(2).empty();//name
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(2).append(returnData[jsonArrayIndex].name);//name
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(3).empty();//ip
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(3).append(returnData[jsonArrayIndex].ip);//ip
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(4).empty();//mac
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(4).append(mac);//mac
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(5).empty();//uptime
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(5).append(statusHtml(returnData[jsonArrayIndex].lan_status));//online-status
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(6).empty();//action
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(6).append("<button data-type=\"" + returnData[jsonArrayIndex].type + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn btn-primary bt-ite-edit\" title=\"Edit\" style=\"" + bt_edit_status + "\">\n" +
//                             "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>\n" +
//                             "                </button>");//action
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(7).empty();//action
//                         $("#" + returnData[jsonArrayIndex].mac).children().eq(7).append(
//                             "                <button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn btn-danger bt-delete\" title=\"Delete\">\n" +
//                             "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>\n" +
//                             "                </button>");//action
//                     } else {
//                         //new device
//                         var type = "";
//                         if (returnData[jsonArrayIndex].type === "t") {
//                             type = "TX";
//                         } else {
//                             type = "RX";
//                         }
//
//                         var tx_table_rows = "<tr id=\"" + returnData[jsonArrayIndex].mac + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" >" +
//                             "<td> <img data-type=\"" + returnData[jsonArrayIndex].type + "\" data-ip=\""
//                             + returnData[jsonArrayIndex].ip + "\" class=\"shiny\" src=\"../img/lightbulb.png\" style=\"max-width: 40px;cursor: pointer;" +
//                             "  height: 32px;\" > " + returnData[jsonArrayIndex].group_id + "</td>" +
//                             "<td>" + type + "</td>" +
//                             "<td>" + returnData[jsonArrayIndex].name + "</td>" +
//                             "<td>" + returnData[jsonArrayIndex].ip + "</td>" +
//                             "<td>" + mac + "</td>" +
//                             "<td>" + statusHtml(returnData[jsonArrayIndex].lan_status) + "</td>" +
//                             "<td>  <button  data-type=\"" + returnData[jsonArrayIndex].type + "\" type=\"button\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" class=\"btn btn-primary bt-edit\" title=\"Edit\" style=\"" + bt_edit_status + "\">" +
//                             "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>" +
//                             "  </button></td>" +
//                             "<td><button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\"  class=\"btn btn-danger bt-delete\" title=\"Delete\">" +
//                             "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>" +
//                             "                </button></td></tr>";
//
//                         setupTable.row.add($(tx_table_rows)).draw();
//                     }
//                 }
//             }
//
//         },
//         error: function (xhr, ajaxOptions, thrownError) {
//             if (isDebugMode) {
//                 console.log("error");
//                 console.log(xhr.status);
//                 console.log(thrownError);
//             }
//             showErrorToast("Request timeout !");
//             if (XMLHttpRequest.readyState == 4) {
//                 if (isDebugMode) {
//                     console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
//                 }
//
//                 // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
//             } else if (XMLHttpRequest.readyState == 0) {
//                 if (isDebugMode) {
//                     console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
//                 }
//                 // Network error (i.e. connection refused, access denied due to CORS, etc.)
//             } else {
//                 if (isDebugMode) {
//                     console.log("something weird is happening");
//                 }
//                 // something weird is happening
//             }
//         }
//     });
// }


/**
 * Get ITE device list
 */
// function getITEDeviceList() {
//     $.ajax({
//         url: dbServerInfo.ip + "/api/ite/device_info",
//         type: "GET",
//         crossDomain: true,
//         dataType: 'json',
//         success: function (returnData) {
//             if (isDebugMode) {
//                 console.log("success" + JSON.stringify(returnData));
//             }
//             setupTable.clear().draw();
//
//             var type = "";
//             var bt_edit_status = "";
//             for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
//
//                 if (returnData[jsonArrayIndex].lan_status == "y") {
//                     bt_edit_status = "display: inline-block;";
//                 } else {
//                     bt_edit_status = "display: none;";
//                 }
//
//                 if (returnData[jsonArrayIndex].type != "r") {
//                     type = "TX";
//                 } else {
//                     type = "RX";
//                 }
//
//                 //cal mac address --- start
//                 var ori_mac = returnData[jsonArrayIndex].mac;
//                 var mac = macFormat(ori_mac.toString());
//                 //cal mac address --- end
//
//                 var tx_table_rows = "<tr id=\"" + ori_mac + "\" data-mac=\"" + ori_mac + "\" >" +
//                     "<td> <img data-type=\"" + returnData[jsonArrayIndex].type + "\" data-ip=\""
//                     + returnData[jsonArrayIndex].ip + "\" class=\"shiny\" src=\"../img/lightbulb.png\" style=\"max-width: 40px;cursor: pointer;" +
//                     "  height: 32px;\" > <span id=\"" + ori_mac + "_group\">" + returnData[jsonArrayIndex].group_id + "</span></td>" +
//                     "<td>" + type + "</td>" +
//                     "<td>" + returnData[jsonArrayIndex].name + "</td>" +
//                     "<td>" + returnData[jsonArrayIndex].ip + "</td>" +
//                     "<td>" + mac + "</td>" +
//                     "<td>" + ITEStatusHtml(returnData[jsonArrayIndex].lan_status) + "</td>" +
//                     "<td>  <button  data-type=\"" + returnData[jsonArrayIndex].type + "\" type=\"button\" data-mac=\"" + ori_mac + "\" class=\"btn btn-primary bt-ite-edit\" title=\"Edit\" style=\"" + bt_edit_status + "\">" +
//                     "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>" +
//                     "  </button></td>" +
//                     "<td><button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\"  class=\"btn btn-danger bt-ite-delete\" title=\"Delete\">" +
//                     "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>" +
//                     "                </button></td></tr>";
//
//                 setupTable.row.add($(tx_table_rows)).draw();
//             }
//
//         },
//         error: function (xhr, ajaxOptions, thrownError) {
//             if (isDebugMode) {
//                 console.log("error");
//                 console.log(xhr.status);
//                 console.log(thrownError);
//             }
//             showErrorToast("Request timeout !");
//             if (XMLHttpRequest.readyState == 4) {
//                 if (isDebugMode) {
//                     console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
//                 }
//
//                 // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
//             } else if (XMLHttpRequest.readyState == 0) {
//                 if (isDebugMode) {
//                     console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
//                 }
//                 // Network error (i.e. connection refused, access denied due to CORS, etc.)
//             } else {
//                 if (isDebugMode) {
//                     console.log("something weird is happening");
//                 }
//                 // something weird is happening
//             }
//         }
//     });
// }

/**
 * Get ASpeed device list
 * */
function getASpeedDeviceList() {

    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }
            //    setupTable.clear().draw();

            var type = "";
            var bt_edit_status = "";
            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {


                if (returnData[jsonArrayIndex].alive == "y") {
                    bt_edit_status = "display: inline-block;";
                } else {
                    bt_edit_status = "display: none;";
                }

                if (returnData[jsonArrayIndex].type != "r") {
                    type = "TX";
                } else {
                    type = "RX";
                }

                //cal mac address --- start
                var ori_mac = returnData[jsonArrayIndex].mac;
                var mac = macFormat(ori_mac.toString());
                //cal mac address --- end
                var cluster = "";

                if(typeof (clusterMap[deviceByclusterMap[returnData[jsonArrayIndex].mac]])  !== "undefined"){
                    cluster = clusterMap[deviceByclusterMap[returnData[jsonArrayIndex].mac]];
                }else{
                    cluster = "";
                }

                var tx_table_rows = "<tr id=\"" + ori_mac + "\" data-mac=\"" + ori_mac + "\"  style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\">" +
                    "<td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\"> <img data-type=\"" + returnData[jsonArrayIndex].type + "\" data-ip=\""
                    + returnData[jsonArrayIndex].ip + "\" class=\"shiny\" src=\"../img/lightbulb.png\" style=\"max-width: 40px;cursor: pointer;" +
                    "  height: 32px;\" > <span id=\"" + ori_mac + "_group\" style=\"color: white\">" + returnData[jsonArrayIndex].id + "</span></td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + type + "</td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + returnData[jsonArrayIndex].host_name + "</td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + cluster + "</td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + returnData[jsonArrayIndex].ip + "</td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + mac + "</td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">" + statusHtml(returnData[jsonArrayIndex].alive, true) + "  " + secondsTimeSpanToHMS(returnData[jsonArrayIndex].uptime) + "</td>" +
                    "<td style=\"border-right: 0px;color: white; vertical-align: middle;\">  <button  data-type=\"" + returnData[jsonArrayIndex].type + "\" type=\"button\" data-mac=\"" + ori_mac + "\" class=\"btn  bt-aspeed-edit\" title=\"Edit\" style=\"color: rgb(100, 108, 128);" +
                    "background: rgb(188, 221, 206);" + bt_edit_status + "\">" +
                    "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>" +
                    "  </button></td>" +
                    "<td style=\"border-right: 0px;color: rgb(94,102,121); vertical-align: middle;\"><button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\"  class=\"btn  bt-delete\" title=\"Delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\">" +
                    "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>" +
                    "                </button></td></tr>";


                setupTable.row.add($(tx_table_rows)).draw();
                //  }
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }

                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
        }
    });
}

function getClusterList() {
    $.ajax({
        url: dbServerInfo.ip + "/api/group_list",
        type: "GET",
        dataType: 'json',
        success: function (data) {

            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
                console.log("feedback =  " + data.message[0].name);
            }

            clusterMap = new Object();

            if (data.result != "OK") {
                showErrorToast("Get cluster info failed !");
            } else {
                for (jsonArrayIndex = 0; jsonArrayIndex < data.message.length; jsonArrayIndex++) {
                     clusterMap[data.message[jsonArrayIndex].id] = data.message[jsonArrayIndex].name
                }
                getDeviceListByGroup();
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ", thrownError);
            }
            showErrorToast("Get cluster info failed !");
        }
    });
}

function getDeviceListByGroup(){

    $.ajax({
        url: dbServerInfo.ip + "/api/all_device_by_group",
        type: "GET",
        success: function (data) {

            var obj = jQuery.parseJSON(data);

            if (obj.result != "OK") {
                showErrorToast("Get group info failed !");
            } else {
                deviceByclusterMap = new Object();
                for (index in obj.message) {
                    deviceByclusterMap[obj.message[index].mac] = obj.message[index].group_id
                }
            }
            getASpeedDeviceList();
            startUpdateSetupInfoWorker();
        }
        ,
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error " + thrownError);
            }
            //  $(".loading").hide();
            showErrorToast("Get group info failed !");
        }
    });
}


/**
 * Update device list
 */
function updateASpeed() {

    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("Update ASpeed" + JSON.stringify(returnData));
            }

            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {


                //cal mac address --- start
                var ori_mac = returnData[jsonArrayIndex].mac;
                var mac = macFormat(ori_mac.toString());
                var bt_edit_status = "";
                if (returnData[jsonArrayIndex].alive === "y") {
                    bt_edit_status = "display: inline-block;";
                } else {
                    bt_edit_status = "display: none;";
                }
                //cal mac address --- end

                if ($(".form-control").val().length > 0) {

                    if (isDebugMode) {
                        console.log("user search...");
                    }

                    if ($("#" + returnData[jsonArrayIndex].mac).length > 0) {
                        //old device
                        if ($("#" + returnData[jsonArrayIndex].mac + "_group").length > 0) {
                            $("#" + returnData[jsonArrayIndex].mac + "_group").text(returnData[jsonArrayIndex].id);
                        }

                        $("#" + returnData[jsonArrayIndex].mac).children().eq(2).empty();//name
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(2).append(returnData[jsonArrayIndex].host_name);//name
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(3).empty();//cluster
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(3).append(clusterMap[deviceByclusterMap[returnData[jsonArrayIndex].mac]]);//cluster
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(4).empty();//ip
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(4).append(returnData[jsonArrayIndex].ip);//ip
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(5).empty();//mac
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(5).append(mac);//mac
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(6).empty();//uptime
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(6).append(statusHtml(returnData[jsonArrayIndex].alive, true) + "   " + secondsTimeSpanToHMS(returnData[jsonArrayIndex].uptime));//uptime
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(7).empty();//action
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(7).append("<button data-type=\"" + returnData[jsonArrayIndex].type + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn  bt-aspeed-edit\" title=\"Edit\" " +
                            " style=\"color: rgb(100, 108, 128);background: rgb(188, 221, 206);" + bt_edit_status + "\">\n" +
                            "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>\n" +
                            "                </button>");//action
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(8).empty();//action
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(8).append(
                            "                <button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn  bt-delete\" title=\"Delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\">\n" +
                            "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>\n" +
                            "                </button>");//action
                    }
                } else {

                    if (isDebugMode) {
                        console.log("user not search...");
                    }

                    if ($("#" + returnData[jsonArrayIndex].mac).length > 0) {

                        //old device
                        if ($("#" + returnData[jsonArrayIndex].mac + "_group").length > 0) {
                            $("#" + returnData[jsonArrayIndex].mac + "_group").text(returnData[jsonArrayIndex].id);
                        }

                        $("#" + returnData[jsonArrayIndex].mac).children().eq(2).empty();//name
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(2).append(returnData[jsonArrayIndex].host_name);//name
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(3).empty();//cluster
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(3).append(clusterMap[deviceByclusterMap[returnData[jsonArrayIndex].mac]]);//cluster
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(4).empty();//ip
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(4).append(returnData[jsonArrayIndex].ip);//ip
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(5).empty();//mac
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(5).append(mac);//mac
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(6).empty();//uptime
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(6).append(statusHtml(returnData[jsonArrayIndex].alive, true) + "   " + secondsTimeSpanToHMS(returnData[jsonArrayIndex].uptime));//uptime
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(7).empty();//action
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(7).append("<button data-type=\"" + returnData[jsonArrayIndex].type + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn bt-aspeed-edit\" title=\"Edit\" style=\"color: rgb(100, 108, 128);background: rgb(188, 221, 206);" +
                            "" + bt_edit_status + "\">\n" +
                            "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>\n" +
                            "                </button>");//action
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(8).empty();//action
                        $("#" + returnData[jsonArrayIndex].mac).children().eq(8).append(
                            "                <button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\" class=\"btn bt-delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\" title=\"Delete\">\n" +
                            "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>\n" +
                            "                </button>");//action
                    } else {
                        //new device
                        var type = "";
                        if (returnData[jsonArrayIndex].type === "t") {
                            type = "TX";
                        } else {
                            type = "RX";
                        }


                        var cluster = "";

                        if(typeof (clusterMap[deviceByclusterMap[returnData[jsonArrayIndex].mac]])  !== "undefined"){
                            cluster = clusterMap[deviceByclusterMap[returnData[jsonArrayIndex].mac]];
                        }else{
                            cluster = "";
                        }


                        var tx_table_rows = "<tr id=\"" + returnData[jsonArrayIndex].mac + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" style=\"background: radial-gradient(ellipse,rgb(11, 41, 66),rgb(2, 6, 13));border-color: rgb(100, 108, 128)\">" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\"> <img data-type=\"" + returnData[jsonArrayIndex].type + "\" data-ip=\""
                            + returnData[jsonArrayIndex].ip + "\" class=\"shiny\" src=\"../img/lightbulb.png\" style=\"max-width: 40px;cursor: pointer;" +
                            "  height: 32px;\" > " + returnData[jsonArrayIndex].id + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + type + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + returnData[jsonArrayIndex].host_name + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + cluster + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + returnData[jsonArrayIndex].ip + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + mac + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">" + statusHtml(returnData[jsonArrayIndex].alive, true) + "   " + secondsTimeSpanToHMS(returnData[jsonArrayIndex].uptime) + "</td>" +
                            "<td style=\"border-right: 0px;color: white;vertical-align: middle;\">  <button  data-type=\"" + returnData[jsonArrayIndex].type + "\" type=\"button\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" class=\"btn  bt-aspeed-edit\" title=\"Edit\" style=\"color: rgb(100, 108, 128);background: rgb(188, 221, 206);" + bt_edit_status + "\">" +
                            "                    <span class=\"glyphicon glyphicon-pencil\" aria-hidden=\"true\"></span>" +
                            "  </button></td>" +
                            "<td style=\"border-right: 0px;color: rgb(94,102,121);vertical-align: middle;\"><button data-mac=\"" + returnData[jsonArrayIndex].mac + "\" type=\"button\"  class=\"btn  bt-delete\" title=\"Delete\" style=\"color: rgb(100, 108, 128);background: rgb(231, 197, 189);\">" +
                            "                    <span class=\"glyphicon glyphicon-trash\" aria-hidden=\"true\"></span>" +
                            "                </button></td></tr>";

                        setupTable.row.add($(tx_table_rows)).draw();


                    }
                }
                // }

            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }

        }
    });
}

/**
 * Edit click listener
 */
function editClickListener() {
    $("body").on("click", ".bt-aspeed-edit", function () {
        if (isDebugMode) {
            console.log("type = " + $(this).attr("data-type"));
        }

        if ($(this).attr("data-type") != "r") {
            window.location.href = "transmitter_info.html?mac=" + $(this).attr("data-mac");
            //  window.location.href = "ite_transmitter.html?mac=" + $(this).attr("data-mac");
        } else {
            window.location.href = "receiver_info.html?mac=" + $(this).attr("data-mac");
            //   window.location.href = "ite_receiver.html?mac=" + $(this).attr("data-mac");
        }
    });

    $("body").on("click", ".bt-ite-edit", function () {
        if (isDebugMode) {
            console.log("type = " + $(this).attr("data-type"));
        }

        if ($(this).attr("data-type") != "r") {
            window.location.href = "ite_transmitter.html?mac=" + $(this).attr("data-mac");
        } else {
            window.location.href = "ite_receiver.html?mac=" + $(this).attr("data-mac");
        }
    });
}

/**
 * Delete click listener
 */
function deleteClickListener() {
    $("body").on("click", ".bt-delete", function () {
        var mac = $(this).attr("data-mac");
        if (isDebugMode) {
            console.log("bt-delete " + mac);
        }
        var rowObject = $(this).parents('tr');
        $.ajax({
            url: dbServerInfo.ip + "/api/del_node/" + mac,
            type: "GET",
            crossDomain: true,
            dataType: 'json',
            success: function (returnData) {
                if (isDebugMode) {
                    console.log("success" + JSON.stringify(returnData));
                }
                setupTable.row(rowObject).remove().draw();
                showSuccessToast("Delete successful");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error");
                    console.log(xhr.status);
                    console.log(thrownError);
                }
                showErrorToast("Delete failed");
                if (XMLHttpRequest.readyState == 4) {
                    if (isDebugMode) {
                        console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                    }
                    // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
                } else if (XMLHttpRequest.readyState == 0) {
                    if (isDebugMode) {
                        console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                    }
                    // Network error (i.e. connection refused, access denied due to CORS, etc.)
                } else {
                    if (isDebugMode) {
                        console.log("something weird is happening");
                    }
                    // something weird is happening
                }
            }
        });
    });
}

/**
 * Bubble button click
 */
function bubbleClickListener() {
    $("body").on("click", ".shiny", function () {
        var imgObject = $(this);
        var device_ip = $(this).attr("data-ip");
        if (isDebugMode) {
            console.log("device ip = " + device_ip);
        }

        $(this).attr("src", "../img/red_bubble.png");

        post_data = "ip=" + device_ip + "&value=cat /sys/devices/platform/leds/leds/button_link/N_Led";

        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                imgObject.attr("src", "../img/lightbulb.png");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                imgObject.attr("src", "../img/lightbulb.png");
                showErrorToast("Blink LED failed !");
            }
        });
    });
}

/**
 * Confirm new password
 */
function confirmNewPassword() {

    $("#confirm-password-bt").click(function () {
        if ($("#input-old-password").val().length > 0) {
            if (isDebugMode) {
                console.log("old-password not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("old-password is empty");
            }
            return;
        }

        if ($("#input-new-password1").val().length > 0) {
            if (isDebugMode) {
                console.log("new-password 1 not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("new-password 1 is empty");
            }
            return;
        }

        if ($("#input-new-password2").val().length > 0) {
            if (isDebugMode) {
                console.log("new-password 2 not empty");
            }
        } else {
            if (isDebugMode) {
                console.log("new-password 2 is empty");
            }
            return;
        }

        if ($("#input-new-password1").val() === $("#input-new-password2").val()) {
            if (isDebugMode) {
                console.log("new-password is the same");
            }
        } else {
            if (isDebugMode) {
                console.log("new-password not the same");
            }
            showErrorToast("New password not the same !");
            return;
        }

        var data = "id=" + $("#span_user_account").attr("data-id") + "&old=" + $("#input-old-password").val() + "&new=" + $("#input-new-password1").val();
        $.ajax({
            url: dbServerInfo.ip + "/api/change_password",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                // console.log("parser result = " + obj.result);
                if (obj.result != "OK") {
                    showErrorToast("Change password failed !");
                } else {
                    showSuccessToast("Change password successful");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }

                showErrorToast("Change password failed !");
            }
        });

        // $.ajax({
        //     url: dbServerInfo.ip + "/api/get_mac",
        //     type: "GET",
        //     crossDomain: true,
        //     dataType: 'json',
        //     success: function (returnData) {
        //         if (isDebugMode) {
        //             console.log("success" + JSON.stringify(returnData));
        //             console.log("mac = " + returnData.mac);
        //         }
        //
        //         var beforeMD5 = returnData.mac + "admin" + $("#input-old-password").val();
        //         var md5 = "" + CryptoJS.MD5(beforeMD5);
        //         md5 = md5.toUpperCase();
        //
        //         var data = "old=" + md5 + "&new=" + $("#input-new-password1").val();
        //
        //         if (isDebugMode) {
        //             console.log("data = " + data);
        //         }
        //
        //         $.ajax({
        //             url: dbServerInfo.ip + "/api/change_password",
        //             data: data,
        //             type: "POST",
        //             success: function (data) {
        //                 var obj = jQuery.parseJSON(data);
        //                 if (isDebugMode) {
        //                     console.log("success " + JSON.stringify(data));
        //                 }
        //                 // console.log("parser result = " + obj.result);
        //                 if (obj.result != "OK") {
        //                     showErrorToast("Change password failed !");
        //                 } else {
        //                     showSuccessToast("Change password successful");
        //                 }
        //             },
        //             error: function (xhr, ajaxOptions, thrownError) {
        //                 if (isDebugMode) {
        //                     console.log("error ");
        //                 }
        //
        //                 showErrorToast("Change password failed !");
        //             }
        //         });
        //     },
        //     error: function (xhr, ajaxOptions, thrownError) {
        //         if (isDebugMode) {
        //             console.log("error");
        //             console.log(xhr.status);
        //             console.log(thrownError);
        //         }
        //         showErrorToast("Request timeout !");
        //         if (XMLHttpRequest.readyState == 4) {
        //             if (isDebugMode) {
        //                 console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
        //             }
        //             // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
        //         } else if (XMLHttpRequest.readyState == 0) {
        //             if (isDebugMode) {
        //                 console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
        //             }
        //             // Network error (i.e. connection refused, access denied due to CORS, etc.)
        //         } else {
        //             if (isDebugMode) {
        //                 console.log("something weird is happening");
        //             }
        //             // something weird is happening
        //         }
        //
        //     }
        // });
    });
}

/**
 * Read upload file
 * @param input : upload file
 */
function readFile(input) {

    openProgressBar();

    if (isDebugMode) {
        console.log("readFile");
    }
    if (input.files && input.files[0]) {
        if (isDebugMode) {
            console.log("type = " + input.files[0].type.split('/')[1]);
            console.log("javascript zip = x-zip-compressed");
        }
        if ((input.files[0].type.split('/')[1] === "x-zip-compressed") || (input.files[0].type.split('/')[1] === "zip")) {
            if (isDebugMode) {
                console.log("input.files[0] = " + input.files[0]);
            }
            var reader = new FileReader();
            reader.onload = function (e) {
                if (isDebugMode) {
                    console.log("file type = " + e.target.result.split(',')[1]);
                    console.log("file name = " + input.files[0].name.split('.').slice(0, -1).join('.'));
                }
                var data = e.target.result.split(',')[1].match(/.{1,2000000}/g);//separate base64 string every 2M words
                if (data.length > 0) {
                    recursionFWUpdate(data, 0, data.length);
                } else {
                    closeProgressBar();
                    showErrorToast("FW update failed !");
                }
                $('input[type="file"]').val(null);
            };
            reader.readAsDataURL(input.files[0]);
        } else {
            closeProgressBar();
            $('input[type="file"]').val(null);
            showWarningToast("Only accept .zip file !");
        }
    } else {

        $('input[type="file"]').val(null);
        showErrorToast("Upload failed !");
    }
}

/**
 * Recursion FW Update, according to data after split size
 * @param data : original data
 * @param index : current handle index
 * @param total " data after split size
 */
function recursionFWUpdate(oriData, currentIndex, totals) {

    var md5 = "" + CryptoJS.MD5(oriData[currentIndex]);
    md5 = md5.toUpperCase();
    var jsonData = {
        total: totals,
        index: (parseInt(currentIndex) + 1),
        md5: md5,
        base64: oriData[currentIndex]
    };

    if (isDebugMode) {
        console.log("update data = " + JSON.stringify(jsonData));
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/fw_update",
        data: jsonData,
        type: "POST",
        success: function (data) {
            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);
            if (obj.result != "OK") {
                closeProgressBar();
                showErrorToast("FW update failed !");
            } else {
                var progress = ((parseInt(currentIndex) + 1) / totals) * 100;
                updateProgressBar(parseInt(progress));
                if (totals > (parseInt(currentIndex) + 1)) {
                    recursionFWUpdate(oriData, (parseInt(currentIndex) + 1), totals);
                } else {
                    updateProgressBar(100);
                    closeProgressBar();
                    updateProgressBar(0);
                    showSuccessToast("FW update successful !");
                }
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            closeProgressBar();
            showErrorToast("FW update failed !");
        }
    });
}

/**
 * Open progress bar
 */
function openProgressBar() {
    document.getElementById("myNav").style.width = "100%";
}

/**
 * Close progress bar
 */
function closeProgressBar() {
    document.getElementById("myNav").style.width = "0%";
}

/**
 * Update progress bar
 * @param value : current percent
 */
function updateProgressBar(value) {
    $('.progress-bar').css('width', value + '%').attr('aria-valuenow', value);
    $('.progress-bar').text(value + "%");
}

/**
 * Allow drop file area change color
 * @param event
 */
function allowDrop(event) {
    var data = event.currentTarget.id;
    document.getElementById(data).classList.remove("dropzone-wrapper-drag-out");
    document.getElementById(data).classList.add("dropzone-wrapper-drag-in");
    event.preventDefault();
}

/**
 * Drag file leave area change color
 * @param event
 */
function leaveDropZone(event) {
    var data = event.currentTarget.id;
    document.getElementById(data).classList.add("dropzone-wrapper-drag-out");
    document.getElementById(data).classList.remove("dropzone-wrapper-drag-in");
    event.preventDefault();
}

/**
 * Set system time zone
 */
function timezoneDropItemListener() {
    $('.dropdown').on('click', '.timezone_item', function () {

        var content = "";
        var newTimeZoneIndex = "";
        var new_flag = $(this).attr("data-flag");
        $(this).children('span').each(function () {
            if ($(this).hasClass("flag-icon")) {
            } else {
                content = $(this).text();
            }
        });

        newTimeZoneIndex = $(this).attr("data-index");

        var jsonData = {
            "ip_mode": $("input[name=network_type]").filter(":checked").attr("data-type"),       //DHCP or STATIC
            "ip": $("#input-ip").val(),    //if ip_mode is static need to change ip
            "mask": $("#input-network-mask").val(),
            "gateway": $("#input-network-gateway").val(),
            "timezone": $(this).attr("data-index"),
            "date": "",
            "type": $("input[name=ui_type]").filter(":checked").attr("data-type")
        }

        if (isDebugMode) {
            console.log("json data = " + JSON.stringify(jsonData));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/system_config",
            data: jsonData,
            type: "POST",
            success: function (data) {
                if (isDebugMode) {
                    console.log("feedback =  " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast("Set system time zone failed !");
                } else {
                    $("#bt-set-timezone").attr("data-index", newTimeZoneIndex);
                    $("#timezone_flag").removeClass();
                    $("#timezone_flag").addClass(new_flag);
                    $("#timezone_flag").addClass("flag-icon");
                    $("#timezone_flag").addClass("flag-icon-squared");
                    $("#timezone_content").text(content);
                    getSystemConfig();
                    showSuccessToast("Set system time zone successful !");

                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Set system time zone failed !");
            }
        });
    });
}

/**
 *  Get system time zone
 */
function getSystemConfig() {
    //get System Type type --- start
    var $systemTypeRadio = $('input:radio[name=system_type]');
    if (readCookie(COOKIE_SYSTEM_TYPE) === "true") {
        //ASpeed
        if (isDebugMode) {
            console.log("Now is ASpeed");
        }
        $systemTypeRadio.filter('[id=system_type_aspeed]').prop('checked', true);
    } else {
        //ITE
        if (isDebugMode) {
            console.log("Now is ITE");
        }
        $systemTypeRadio.filter('[id=system_type_ite]').prop('checked', true);
    }
    //get System Type type --- end

    $.ajax({
        url: dbServerInfo.ip + "/api/system_config",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
            }
            var timezone;
            //get time zone --- start
            $("#bt-set-timezone").attr("data-index", data.timezone);
            $('.timezone_item').each(function (i, obj) {
                if ($(this).attr("data-index") === data.timezone) {
                    timezone = $(this).attr("data-offset");
                    $("#timezone_flag").removeClass();
                    $("#timezone_flag").addClass($(this).attr("data-flag"));
                    $("#timezone_flag").addClass("flag-icon");
                    $("#timezone_flag").addClass("flag-icon-squared");
                    var content = "";
                    $(this).children('span').each(function () {
                        if ($(this).hasClass("flag-icon")) {
                        } else {
                            content = $(this).text();
                        }
                    });
                    $("#timezone_content").text(content);
                    return false;
                }
            });
            //get time zone --- end

            //get Mapping UI type --- start
            var $mappingUIRadio = $('input:radio[name=ui_type]');
            if (data.type === "false") {
                $mappingUIRadio.filter('[id=mapping_table]').prop('checked', true);
            } else {
                $mappingUIRadio.filter('[id=mapping_drag_drop]').prop('checked', true);
            }
            //get  Mapping UI type --- end

            //get Network type --- start
            var $networkRadio = $('input:radio[name=network_type]');
            if (data.ip_mode === "DHCP") {
                $networkRadio.filter('[id=network_dhcp]').prop('checked', true);
            } else {
                $("#input-ip").prop('disabled', false);
                $("#input-network-mask").prop('disabled', false);
                $("#input-network-gateway").prop('disabled', false);
                $networkRadio.filter('[id=network_static]').prop('checked', true);
            }
            $("#input-ip").val(data.ip);
            $("#input-network-gateway").val(data.gateway);
            $("#input-network-mask").val(data.mask);
            //get  Network type --- end

            // //get System time --- start
            // startSystemTimer();
            // var jsonData = {
            //     time: data.time,
            //     timezone: timezone
            // }
            // systemTimeWorker.postMessage(jsonData);
            //get System time --- end
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Get system time zone failed !");
        }
    });
}

/**
 * Stop system time worker
 */
function stopSystemTimeWorker() {
    if (typeof (systemTimeWorker) != "undefined") {
        systemTimeWorker.terminate();
        systemTimeWorker = undefined;
        if (isDebugMode) {
            console.log("stop System Time Worker");
        }
    }
}

/**
 * Stop Setup worker
 */
function stopSetupWorker() {
    if (typeof (setupWorker) != "undefined") {
        setupWorker.terminate();
        setupWorker = undefined;
        if (isDebugMode) {
            console.log("stop Setup Worker");
        }
    }
}

/**
 * Tab click event
 */
function tabClickEvent() {
    $("#tab-devices").click(function () {
        setupTable.clear().draw();
        stopSystemTimeWorker();
        getASpeedDeviceList();
        startUpdateSetupInfoWorker();
        //initial();
        clearInterval(systemTimer);
    });

    $("#tab-password").click(function () {
        stopSetupWorker();
        stopSystemTimeWorker();
        clearInterval(systemTimer);
    });

    $("#tab-system-config").click(function () {
        stopSetupWorker();
        getSystemConfig();
        getSystemTime();
    });

    $("#tab-fw-update").click(function () {
        stopSetupWorker();
        stopSystemTimeWorker();
        clearInterval(systemTimer);
    });
}

function getSystemTime() {
    $.ajax({
        url: dbServerInfo.ip + "/api/system_time",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
            }
            systemDate = new Date(data.time.toString());
            systemTimer = setInterval(function () {
                console.log("time up");
                systemDate.setSeconds(systemDate.getSeconds() + 1);
                var system_month = (parseInt(systemDate.getMonth()) + 1);
                var system_date = parseInt(systemDate.getDate());
                var system_hour = parseInt(systemDate.getHours());
                var system_min = parseInt(systemDate.getMinutes());
                var system_sec = parseInt(systemDate.getSeconds());

                if(parseInt(systemDate.getMonth()) < 10){
                    system_month = "0" + (parseInt(systemDate.getMonth()) + 1);
                }
                if(parseInt(systemDate.getDate()) < 10){
                    system_date = "0" + parseInt(systemDate.getDate());
                }

                if(parseInt(systemDate.getHours()) < 10){
                    system_hour = "0" + parseInt(systemDate.getHours());
                }

                if(parseInt(systemDate.getMinutes()) < 10){
                    system_min = "0" + parseInt(systemDate.getMinutes());
                }

                if(parseInt(systemDate.getSeconds()) < 10){
                    system_sec = "0" + parseInt(systemDate.getSeconds());
                }

                var datestring = system_date + "/" + system_month + "/" + systemDate.getFullYear() + " " +
                    system_hour + ":" + system_min + ":" + system_sec;
                $("#input-system_time").val(datestring);
            }, 1000);

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
        }
    });
}


/**
 * System Type Listener
 */
function systemTypeListener() {
    $('input:radio[name="system_type"]').change(
        function () {
            if ($(this).is(':checked')) {
                if ($(this).attr("data-type") === "true") {
                    //ASpeed
                    if (isDebugMode) {
                        console.log("ASpeed");
                    }
                    createCookie(COOKIE_SYSTEM_TYPE, true, 2);
                    $("#page-title").text("☰ EVOIP");
                    document.title = "EVOIP";
                    $("#nav_video_wall").show();
                    $("#nav_osd").show();
                    $("#nav_event").show();
                    showSuccessToast("Set system successful !");
                } else {
                    //ITE
                    if (isDebugMode) {
                        console.log("ITE");
                    }
                    createCookie(COOKIE_SYSTEM_TYPE, false, 2);
                    $("#page-title").text("☰ EVOIP - Lite");
                    document.title = "EVOIP - Lite";
                    $("#nav_video_wall").hide();
                    $("#nav_osd").hide();
                    $("#nav_event").hide();
                    showSuccessToast("Set system successful !");
                }
            }
        });
}


/**
 * Mapping UI type radio button listener
 */
function mappingUITypeListener() {

    $('input:radio[name="ui_type"]').change(
        function () {

            if ($(this).is(':checked')) {
                console.log($(this).attr("data-type"))

                var jsonData = {
                    "ip_mode": $("input[name=network_type]").filter(":checked").attr("data-type"),       //DHCP or STATIC
                    "ip": $("#input-ip").val(),    //if ip_mode is static need to change ip
                    "mask": $("#input-network-mask").val(),
                    "gateway": $("#input-network-gateway").val(),
                    "timezone": $("#bt-set-timezone").attr("data-index"),
                    "date": "",
                    "type": $(this).attr("data-type")
                }

                if (isDebugMode) {
                    console.log("json data = " + JSON.stringify(jsonData));
                }

                $.ajax({
                    url: dbServerInfo.ip + "/api/system_config",
                    data: jsonData,
                    type: "POST",
                    success: function (data) {
                        if (isDebugMode) {
                            console.log("feedback =  " + JSON.stringify(data));
                        }
                        var obj = jQuery.parseJSON(data);
                        if (obj.result != "OK") {
                            showErrorToast("Set Mapping UI mode failed !");
                        } else {
                            showSuccessToast("Set Mapping UI mode successful !");
                        }
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Set Mapping UI mode failed !");
                    }
                });
            }
        });
}

/**
 * Network type radio button listener
 */
function networkTypeListener() {

    $('input:radio[name="network_type"]').change(
        function () {
            if ($(this).is(':checked')) {
                console.log($(this).attr("data-type"));
                switch ($(this).attr("data-type")) {

                    case "DHCP":
                        $("#input-ip").prop('disabled', true);
                        $("#input-network-mask").prop('disabled', true);
                        $("#input-network-gateway").prop('disabled', true);
                        break;

                    case "STATIC":
                        $("#input-ip").prop('disabled', false);
                        $("#input-network-mask").prop('disabled', false);
                        $("#input-network-gateway").prop('disabled', false);
                        break;
                }
            }
        });
}

/**
 * Apply network click listener
 */
function btApplyNetworkClickListener() {
    $("#btn-apply-network").click(function () {

        if ($("#input-ip").val().length < 1) {
            showWarningToast("IP can't be empty");
            return;
        }

        if ($("#input-network-mask").val().length < 1) {
            showWarningToast("Mask can't be empty");
            return;
        }

        if ($("#input-network-gateway").val().length < 1) {
            showWarningToast("Gateway can't be empty");
            return;
        }

        if (ValidateIPAddress($("#input-ip").val())) {
        } else {
            showWarningToast("Can't enter invalid IP address !")
            return;
        }

        if (ValidateIPAddress($("#input-network-mask").val())) {
        } else {
            showWarningToast("Can't enter invalid Mask address !")
            return;
        }


        if (ValidateIPAddress($("#input-network-gateway").val())) {
        } else {
            showWarningToast("Can't enter invalid Gateway address !")
            return;
        }

        var jsonData = {
            "ip_mode": $("input[name=network_type]").filter(":checked").attr("data-type"),       //DHCP or STATIC
            "ip": $("#input-ip").val(),    //if ip_mode is static need to change ip
            "mask": $("#input-network-mask").val(),
            "gateway": $("#input-network-gateway").val(),
            "timezone": $("#bt-set-timezone").attr("data-index"),
            "date": "",
            "type": $("input[name=ui_type]").filter(":checked").attr("data-type")
        }

        if (isDebugMode) {
            console.log("json data = " + JSON.stringify(jsonData));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/system_config",
            data: jsonData,
            type: "POST",
            success: function (data) {
                if (isDebugMode) {
                    console.log("feedback =  " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    showErrorToast("Set network config failed !");
                } else {
                    showSuccessToast("Set network config successful !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Set network config failed !");
            }
        });
    });
}

/**
 * create status circle html string
 *
 * on-line : green circle
 * off-line : red circle
 *
 * @param status : device status 1: on-line, others: off-line
 * @returns {string} : status circle html
 */
function ITEStatusHtml(status) {
    if (status === "y") {
        return "<span class=\"green_item_dot\"></span>";
    } else {
        return "<span class=\"red_item_dot\"></span>";
    }
}
