var isKVMInitial = true;
var isARPInitial = true;
var isCastingInitial = true;

$(document).ready(function () {
    checkLoginCookie();
    getDeviceInfo();
    getDeviceSetup();
    baudRateBtClickListener();
    baudRateDropDownListener();
    speedDropDownListener();
    factoryResetClickListener();
    txSpeedBtClickListener();
    rebootClickListener();
    bubbleClickListener();
    modifyNameBtClickListener();
   // loopOutCheckBoxListener();
    videoStreamCheckBoxListener();
    groupIDbtClickListener();
    factoryResetApplyModel();
    arpCheckBoxListener();
    castingListener();
});

//Get Casting Mode
function getCastingMode(deviceIP) {

    $.ajax({
        url: dbServerInfo.ip + "/api/astparam_g/" + deviceIP + "/multicast_on",
        type: "GET",
        success: function (data) {
          //  if (isDebugMode) {
                console.log("Casting Mode data = " + JSON.stringify(data));
          //  }
            var obj = jQuery.parseJSON(data);

            if (isDebugMode) {
                console.log("Casting Mode data = " + obj.result);
            }

            if (obj.result.toLowerCase().indexOf("n") >= 0) {
                $("#input-casting_mode").bootstrapToggle('off');
            } else {
                $("#input-casting_mode").bootstrapToggle('on');
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {

        }
    });
}

//Get Audio Return Path status
function getDeviceARP(deviceIP) {
    $.ajax({
        url: dbServerInfo.ip + "/api/astparam_g/" + deviceIP + "/a_arp_input",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log("audio channel data = " + JSON.stringify(data));
            }
            var obj = jQuery.parseJSON(data);
            if (obj.result.toLowerCase() === "hdmiout") {
                $("#input-arp").bootstrapToggle('off');
            } else {
                $("#input-arp").bootstrapToggle('on');
            }
            getCastingMode(deviceIP);
        },
        error: function (xhr, ajaxOptions, thrownError) {
            getCastingMode(deviceIP);
        }
    });
}


function arpCheckBoxListener() {
    $('#input-arp').change(function () {
        if (isARPInitial) {
            isARPInitial = false;
        } else {
            if ($(this).is(':checked')) {

                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#tx_ip").text() + "&param=a_arp_input&value=toslink",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (true) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn on Audio Return Path Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn on Audio Return Path failed !");
                    }
                });

            } else {

                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#tx_ip").text() + "&param=a_arp_input&value=hdmiout",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (true) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn off Audio Return Path Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn off Audio Return Path failed !");
                    }
                });

            }
        }
    });
}
/**
 * Get URL parameter
 * @param sParam
 * @returns {boolean|string}
 */
function getUrlParameter(sParam) {
    var sPageURL = window.location.search.substring(1),
        sURLVariables = sPageURL.split('&'),
        sParameterName,
        i;

    for (i = 0; i < sURLVariables.length; i++) {
        sParameterName = sURLVariables[i].split('=');

        if (sParameterName[0] === sParam) {
            return sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
        }
    }
}

/**
 * According to MAC to get device info
 */
function getDeviceInfo() {

    var userSelectedMAC = getUrlParameter('mac');
    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if(isDebugMode){
                console.log("success" + JSON.stringify(returnData));
            }

            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                //cal mac address --- start
                var ori_mac = returnData[jsonArrayIndex].mac;
                var mac = macFormat(ori_mac.toString());
                //cal mac address --- end
                if (returnData[jsonArrayIndex].mac == userSelectedMAC) {
                    $("#tx_name").text(returnData[jsonArrayIndex].host_name);
                    $("#tx_ip").text(returnData[jsonArrayIndex].ip);
                    $("#tx_id").text(returnData[jsonArrayIndex].id);
                    $("#tx_alive_time").text(secondsTimeSpanToHMS(returnData[jsonArrayIndex].uptime));
                    $("#tx_mac").text(mac);
                    $("#tx_mac").attr("data-mac", returnData[jsonArrayIndex].mac);
                    $("#input-name").val(getDeviceName(returnData[jsonArrayIndex]));
                    $("#input-id").val(returnData[jsonArrayIndex].id);
                    // $("#tx_fw").text(returnData[jsonArrayIndex].fw);
                    getDeviceARP(returnData[jsonArrayIndex].ip);
                    return;
                }
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if(isDebugMode){
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if(isDebugMode){
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if(isDebugMode){
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if(isDebugMode){
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
        }
    });
}


/**
 * According to MAC to get device setup
 */
function getDeviceSetup() {

    var userSelectedMAC = getUrlParameter('mac');

    $.ajax({
        url: dbServerInfo.ip + "/api/setup_info/" + userSelectedMAC,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if(isDebugMode){
                console.log("success" + JSON.stringify(returnData));
            }

            //system version
            $("#tx_sv").text(returnData.fw);

            //tv status
            if (returnData.tx_src != "off") {
                $("#tx_source").text("On");
            } else {
                $("#tx_source").text("Loss");
            }

            //tx speed
            switch (returnData.tx_net) {

                case "auto":
                    $("#tx_speed").attr("data-speed", "auto");
                    $("#tx_speed").text(" auto");
                    break;

                case "10M":
                    $("#tx_speed").attr("data-speed", "10M");
                    $("#tx_speed").text(" 10M");
                    break;

                case "50M":
                    $("#tx_speed").attr("data-speed", "50M");
                    $("#tx_speed").text(" 50M");
                    break;

                case "100M":
                    $("#tx_speed").attr("data-speed", "100M");
                    $("#tx_speed").text(" 100M");
                    break;

                case "150M":
                    $("#tx_speed").attr("data-speed", "150M");
                    $("#tx_speed").text(" 150M");
                    break;

                case "200M":
                    $("#tx_speed").attr("data-speed", "200M");
                    $("#tx_speed").text(" 200M");
                    break;
            }

            //rs232
            switch (returnData.rs232) {

                case "300-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "300-8n1");
                    $("#tx_baudrate").text(" 300");
                    break;

                case "600-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "600-8n1");
                    $("#tx_baudrate").text(" 600");
                    break;

                case "1200-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "1200-8n1");
                    $("#tx_baudrate").text(" 1200");
                    break;

                case "2400-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "2400-8n1");
                    $("#tx_baudrate").text(" 2400");
                    break;

                case "4800-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "4800-8n1");
                    $("#tx_baudrate").text(" 4800");
                    break;

                case "9600-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "9600-8n1");
                    $("#tx_baudrate").text(" 9600");
                    break;

                case "19200-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "19200-8n1");
                    $("#tx_baudrate").text(" 19200");
                    break;

                case "38400-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "38400-8n1");
                    $("#tx_baudrate").text(" 38400");
                    break;

                case "57600-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "57600-8n1");
                    $("#tx_baudrate").text(" 57600");
                    break;

                case "115200-8n1":
                    $("#tx_baudrate").attr("data-baudrate", "115200-8n1");
                    $("#tx_baudrate").text(" 115200");
                    break;
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if(isDebugMode){
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if(isDebugMode){
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if(isDebugMode){
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if(isDebugMode){
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
        }
    });
}

/**
 * modify name apply button click event listener
 */
function modifyNameBtClickListener() {
    $("#bt-name-apply").click(function () {

        var data = "mac=" + $("#tx_mac").attr("data-mac") + "&value=" + $("#input-name").val();

        if ($("#input-name").val().length > 0) {
            $.ajax({
                url: dbServerInfo.ip + "/api/set_hostname",
                data: data,
                type: "POST",
                success: function (data) {
                    var obj = jQuery.parseJSON(data);
                    if(isDebugMode){
                        console.log("success " + JSON.stringify(data));
                    }
                    if (obj.result == "OK") {
                        showSuccessToast("Set name Successful !");
                        $("#tx_name").text($("#input-name").val());
                    } else {
                        showErrorToast("Set name failed !");
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if(isDebugMode){
                        console.log("error ");
                    }
                    showErrorToast("Set name failed !");
                }
            });
        } else {
            showErrorToast("Name can't be empty !");
        }
    });
}

/**
 * baudRate apply button click event listener
 */
function baudRateBtClickListener() {
    $("#bt-baudrate-apply").click(function () {
        var baudRateValue = $("#tx_baudrate").attr("data-baudrate");
        var data = "ip=" + $("#tx_ip").text() + "&param=s0_baudrate&value=" + baudRateValue;
        if(isDebugMode){
            console.log("data= " + data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/astparam_s",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if(isDebugMode){
                    console.log("success " + JSON.stringify(data));
                }
                if (obj.result == "OK") {
                    showSuccessToast("Set baud rate Successful !");
                } else {
                    showErrorToast("Set baud rate failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if(isDebugMode){
                    console.log("error ");
                }
                showErrorToast("Set baud rate failed !");
            }
        });
    });
}

/**
 * baudRate dropdown menu click listener
 * */
function baudRateDropDownListener() {

    $('.dropdown').on('click', '.baudrate_item', function () {
        if(isDebugMode){
            console.log("baudrate_item " + $(this).attr("data-value"));
        }
        switch ($(this).attr("data-value")) {

            case "300":
                $("#tx_baudrate").attr("data-baudrate", "300-8n1");
                $("#tx_baudrate").text(" 300");
                break;

            case "600":
                $("#tx_baudrate").attr("data-baudrate", "600-8n1");
                $("#tx_baudrate").text(" 600");
                break;

            case "1200":
                $("#tx_baudrate").attr("data-baudrate", "1200-8n1");
                $("#tx_baudrate").text(" 1200");
                break;

            case "2400":
                $("#tx_baudrate").attr("data-baudrate", "2400-8n1");
                $("#tx_baudrate").text(" 2400");
                break;

            case "4800":
                $("#tx_baudrate").attr("data-baudrate", "4800-8n1");
                $("#tx_baudrate").text(" 4800");
                break;

            case "9600":
                $("#tx_baudrate").attr("data-baudrate", "9600-8n1");
                $("#tx_baudrate").text(" 9600");
                break;

            case "19200":
                $("#tx_baudrate").attr("data-baudrate", "19200-8n1");
                $("#tx_baudrate").text(" 19200");
                break;

            case "38400":
                $("#tx_baudrate").attr("data-baudrate", "38400-8n1");
                $("#tx_baudrate").text(" 38400");
                break;

            case "57600":
                $("#tx_baudrate").attr("data-baudrate", "57600-8n1");
                $("#tx_baudrate").text(" 57600");
                break;

            case "115200":
                $("#tx_baudrate").attr("data-baudrate", "115200-8n1");
                $("#tx_baudrate").text(" 115200");
                break;
        }
    });
}


/**
 * tx speed apply button click event listener
 */
function txSpeedBtClickListener() {
    $("#bt-speed-apply").click(function () {
        var speedValue = $("#tx_speed").attr("data-speed");
        var data = "ip=" + $("#tx_ip").text() + "&param=profile&value=" + speedValue;
        if(isDebugMode){
            console.log("data= " + data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/astparam_s",
            data: data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if(isDebugMode){
                    console.log("success " + JSON.stringify(data));
                }

                if (obj.result == "OK") {
                    showSuccessToast("Set TX speed Successful !");
                } else {
                    showErrorToast("Set TX speed failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("Set TX speed failed !");
            }
        });
    });
}

/**
 * tx speed dropdown menu click listener
 */
function speedDropDownListener() {
    $('.dropdown').on('click', '.speed_item', function () {
        if(isDebugMode){
            console.log("speed_item " + $(this).attr("data-value"));
        }
        switch ($(this).attr("data-value")) {

            case "auto":
                $("#tx_speed").attr("data-speed", "auto");
                $("#tx_speed").text(" auto");
                break;

            case "10M":
                $("#tx_speed").attr("data-speed", "10M");
                $("#tx_speed").text(" 10M");
                break;

            case "50M":
                $("#tx_speed").attr("data-speed", "50M");
                $("#tx_speed").text(" 50M");
                break;

            case "100M":
                $("#tx_speed").attr("data-speed", "100M");
                $("#tx_speed").text(" 100M");
                break;

            case "150M":
                $("#tx_speed").attr("data-speed", "150M");
                $("#tx_speed").text(" 150M");
                break;

            case "200M":
                $("#tx_speed").attr("data-speed", "200M");
                $("#tx_speed").text(" 200M");
                break;
        }
    });

}

/**
 * Bubble LED click listener
 * */
function bubbleClickListener() {
    $("#bt-blink").click(function () {
        var post_data = "ip=" +  $("#tx_ip").text() + "&value=cat /sys/devices/platform/leds/leds/button_link/N_Led";

        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                showErrorToast("Blink LED failed !");
            }
        });
    });
}

/**
 * Reboot LED click listener
 * */
function rebootClickListener() {
    $("#bt-reboot").click(function () {
        var post_data = "ip=" + $("#tx_ip").text() + "&value=reboot";
        if(isDebugMode){
            console.log("bt-reboot " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                // if(isDebugMode){
                //     console.log("success " + JSON.stringify(data));
                // }
                // var obj = jQuery.parseJSON(data);
                // if(isDebugMode){
                //     console.log("success " + obj.result);
                // }
                // if (obj.result == "OK") {
                //     showSuccessToast("Reboot Successful !");
                // } else {
                //     showErrorToast("Reboot failed !");
                // }

            },
            error: function (xhr, ajaxOptions, thrownError) {
                if(isDebugMode){
                    console.log("error ");
                }
                showErrorToast("Reboot failed !");
            }
        });

        showSuccessToast("Reboot Successful !");
    });
}

/**
 * Factory Reset click listener
 * */
function factoryResetClickListener() {
    $("#bt-reset").click(function () {
        $('#factory-reset-modal').modal('show');
    });
}

/**
 *  Factory reset apply button on the model, and will reboot extender,
 *  after factory reset success.
 */
function factoryResetApplyModel(){
    $("#bt-factory-reset-apply-modal").click(function () {
        var post_data = "ip=" + $("#tx_ip").text() + "&value=reset_to_default.sh\n";
        if(isDebugMode){
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                if(isDebugMode){
                    console.log("success " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if(isDebugMode){
                    console.log("success " + obj.result);
                }
                if (obj.result == "OK") {
                    showSuccessToast("Factory reset Successful !");
                    var post_data = "ip=" + $("#tx_ip").text() + "&value=reboot";
                    if(isDebugMode){
                        console.log("bt-reboot " + post_data);
                    }
                    $.ajax({
                        url: dbServerInfo.ip + "/api/ast_sendcmd",
                        data: post_data,
                        type: "POST",
                        success: function (data) {
                            if(isDebugMode){
                                console.log("success " + JSON.stringify(data));
                            }
                            var obj = jQuery.parseJSON(data);
                            if(isDebugMode){
                                console.log("success " + obj.result);
                            }
                            if (obj.result == "OK") {
                                showSuccessToast("Reboot Successful !");
                            } else {
                               // showErrorToast("Reboot failed !");
                            }
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            if(isDebugMode){
                                console.log("error ");
                            }
                            showErrorToast("Reboot failed !");
                        }
                    });
                } else {
                    showErrorToast("Factory reset failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if(isDebugMode){
                    console.log("error ");
                }
                showErrorToast("Factory reset failed !");
            }
        });
    });
}

/**
 * Loop-out checkBox listener
 */
function loopOutCheckBoxListener() {

    $('#input-loop-out').change(function () {
        var checkBoxStatus;
        var status = "";
        if ($(this).is(':checked')) {
            checkBoxStatus = true;
            status = 1;
        } else {
            checkBoxStatus = false;
            status = 0;
        }

        var post_data = "ip=" + $("#tx_ip").text() + "&value=echo " + status + " > /sys/devices/platform/ast1500_led.2/leds:button_link/ CM_MUTELOOPOUTh";
        if(isDebugMode){
            console.log("post_data = " + post_data);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                if(isDebugMode){
                    console.log("success " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if(isDebugMode){
                    console.log("success " + obj.result);
                }
                if (obj.result == "OK") {
                    if (checkBoxStatus) {
                        showSuccessToast("Turn on loop-out Successful !");
                    } else {
                        showSuccessToast("Turn off loop-out Successful !");
                    }
                } else {
                    showErrorToast("Factory reset failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if(isDebugMode){
                    console.log("error ");
                }
                if ($(this).is(':checked')) {
                    showErrorToast("Turn on loop-out failed !");
                } else {
                    showErrorToast("Turn off loop-out failed !");
                }
            }
        });


    });
}

/**
 * Video streaming checkBox listener
 */
function videoStreamCheckBoxListener() {

    $('#input-streaming').change(function () {
        var checkBoxStatus;
        var videoStatus = "";
        if ($(this).is(':checked')) {
            checkBoxStatus = true;
            videoStatus = 0;
        } else {
            checkBoxStatus = false;
            videoStatus = 1;
        }

        var post_data = "ip=" + $("#tx_ip").text() + "&value=echo " + videoStatus + " > /sys/devices/platform/ast1500_led.2/leds:button_link/CM_MUTEOUTPUTh";
        if(isDebugMode){
            console.log("post data = " + post_data);
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/ast_sendcmd",
            data: post_data,
            type: "POST",
            success: function (data) {
                if(isDebugMode){
                    console.log("success " + JSON.stringify(data));
                }
                var obj = jQuery.parseJSON(data);
                if(isDebugMode){
                    console.log("success " + obj.result);
                }

                if (obj.result == "OK") {
                    if (checkBoxStatus) {
                        showSuccessToast("Turn on video streaming Successful !");
                    } else {
                        showSuccessToast("Turn off video streaming Successful !");
                    }
                } else {
                    showErrorToast("Factory reset failed !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if(isDebugMode){
                    console.log("error ");
                }
                if ($(this).is(':checked')) {
                    showErrorToast("Turn on video streaming failed !");
                } else {
                    showErrorToast("Turn off video streaming failed !");
                }
            }
        });
    });
}

/**
 * check input max length
 * @param object:input value
 */
function maxLengthCheck(object) {
    if (object.value.length > object.maxLength)
        object.value = object.value.slice(0, object.maxLength)
}

/**
 * Group ID apply button click listener
 */
function groupIDbtClickListener() {
    $("#bt-id-apply").click(function () {
        if(isDebugMode){
            console.log("data= " + $("#input-id").val());
        }

        var post_data = "ip=" + $("#tx_ip").text();

        $.ajax({
            url: dbServerInfo.ip + "/api/device_switch_pin",
            data: post_data,
            type: "POST",
            success: function (returnData) {
                var obj = jQuery.parseJSON(returnData);
                if (isDebugMode) {
                    console.log("success" + JSON.stringify(returnData));
                }
                if (parseInt(obj.result, 10) === 0) {

                    var post_data = "ip=" + $("#tx_ip").text() + "&switch_id=" + pad($("#input-id").val(), 4) + "&switch_type=z";

                    $.ajax({
                        url: dbServerInfo.ip + "/api/astswitch",
                        data: post_data,
                        type: "POST",
                        success: function (data) {
                            var obj = jQuery.parseJSON(data);
                            if(isDebugMode){
                                console.log("success " + JSON.stringify(data));
                            }
                            if (obj.result == "OK") {
                                showSuccessToast("Set group ID Successful !");
                                $("#input-id").val(pad($("#input-id").val(), 4));
                                $("#tx_id").text(pad($("#input-id").val(), 4));
                            } else {
                                showErrorToast("Set group ID failed !");
                            }
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            if(isDebugMode){
                                console.log("error ");
                            }
                            showErrorToast("Set group ID failed !");
                        }
                    });

                } else {
                    showErrorToast("This device can't switch channel, pin value must be zero !");
                }

            },
            error: function (xhr, ajaxOptions, thrownError) {
                showErrorToast("To get Device switch pin status occurred error !" + thrownError);
            }
        });
    });
}


/**
 * padding zero to string left
 * @param data : original data
 * @param max :  max lengt
 * @returns {*|string}
 */
function pad(data, max) {
    data = data.toString();
    return data.length < max ? pad("0" + data, max) : data;
}

function castingListener() {
    $('#input-casting_mode').change(function () {
        if (isCastingInitial) {
            isCastingInitial = false;
        } else {
            if ($(this).is(':checked')) {

                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#tx_ip").text() + "&param=multicast_on&value=y",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (isDebugMode) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn on Multicast Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn on Multicast - 2 failed!");
                    }
                });

            } else {
                $.ajax({
                    url: dbServerInfo.ip + "/api/astparam_s",
                    data: "ip=" + $("#tx_ip").text() + "&param=multicast_on&value=n",
                    type: "POST",
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);
                        if (isDebugMode) {
                            console.log("success " + JSON.stringify(data));
                        }
                        showSuccessToast("Turn off Multicast Successful !");
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        if (isDebugMode) {
                            console.log("error ");
                        }
                        showErrorToast("Turn on Multicast - 2 failed !");
                    }
                });
            }
        }
    });
}