var display_wall_height = 640;
var display_wall_width = 100;
var txMap = new Object(); // or var map = {};
var rxMap = new Object();
var clusterMap = new Object();
var warningVWMap = new Object();
var updateRXWorker;

$(document).ready(function () {

    $("#menu_a_video_wall").css("color", "orangered");
    $("#menu_span_video_wall").css("color", "orangered");
    $("#menu_icon_video_wall").css("color", "orangered");
    //getUserID();
    checkLoginCookie();
    initial();
    $('.collapse').collapse();
    positionDropDownListener();
    rangeInitial();
    bezelApplyBtClickEvent();
    resetClickEvent();
    layoutChangeListener();
    shiftInputChangeListener();
    infoClickEvent();
    presetSaveModifyClickListener();
    presetChangeListener();
    presetApplyClickListener();
    presetResetClickListener();
    multipleBezelApplyBtClickEvent();
    presetRXClickEvent();
    presetBezelApplyBtClickListener();
    singleVideoWallApply();

    //initial layout input (keyboard)
    $('input[type="number"].input-layout').on('input', function () {
        var value = $(this).val();
        if (value !== '') {
            if (value > 6) {
                $(this).val(6);
            } else if (value < 1) {
                $(this).val(1);
            }
        }
    });

    //initial layout input (keyboard)
    $('input[type="number"].input-ite-row').on('input', function () {
        var value = $(this).val();
        if (value !== '') {
            if (value > 8) {
                $(this).val(8);
            } else if (value < 1) {
                $(this).val(1);
            }
        }
    });

    $('input[type="number"].input-ite-col').on('input', function () {
        var value = $(this).val();
        if (value !== '') {
            if (value > 16) {
                $(this).val(16);
            } else if (value < 1) {
                $(this).val(1);
            }
        }
    });

    //initial shift input (keyboard)
    $('input[type="number"].input-bezel').on('input', function () {
        var value = $(this).val();
        if (value !== '') {
            if (value > 50) {
                $(this).val(50);
            } else if (value < -50) {
                $(this).val(-50);
            }
        }
    });

    warningVWModalApplyClickListener();

});

function bezelInputMin(el){
    if(el.value != ""){
        if(parseInt(el.value) < parseInt(el.min)){
            el.value = el.min;
        }
    }
}

/**
 * Get Cluster List
 */
function getCluster() {

    $.ajax({
        url: dbServerInfo.ip + "/api/group_list",
        type: "GET",
        dataType: 'json',
        success: function (data) {

            if (isDebugMode) {
                console.log("feedback =  " + JSON.stringify(data));
                //     console.log("feedback =  " + data.message[0].name);
            }

            $('#select_cluster_option').find('option').remove();
            $('#preset_select_cluster_option').find('option').remove();

            var jsonArrayIndex = 0;

            var select_group_list = "";
            var preset_select_group_list = "";
            //  select_group_list = " <option selected value=\"0\" > -- Without Group -- </option>";

            select_group_list = "<option class=\"group_item\" data-id=\"0\" value==\"0\"  data-name=\"ALL DEVICES\" data-offset=\"-11\" >" +
                "<img src=\"../group/all.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> ALL RX DEVICES</span> </option>";

            preset_select_group_list = "<option class=\"group_item\" data-id=\"0\" value==\"0\"  data-name=\"ALL DEVICES\" data-offset=\"-11\" >" +
                "<img src=\"../group/all.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> ALL DEVICES</span> </option>";

            if (data.result != "OK") {
                //    showErrorToast(obj.message);
            } else {

                for (jsonArrayIndex = 0; jsonArrayIndex < data.message.length; jsonArrayIndex++) {
                    select_group_list = select_group_list + "<option class=\"group_item\"   value=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                        "<img src=\"../group/bzb.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </option>";

                    preset_select_group_list = preset_select_group_list + "<option class=\"preset_group_item\"   value=\"" + data.message[jsonArrayIndex].id + "\" data-name=\"" + data.message[jsonArrayIndex].name + "\" data-offset=\"-11\" >" +
                        "<img src=\"../group/bzb.png\"  style=\"border-radius: 10px;height: 40px;width: 40px\"><span> " + data.message[jsonArrayIndex].name + "</span> </option>";
                }
                $("#select_cluster_option").append(select_group_list);
                $("#preset_select_cluster_option").append(preset_select_group_list);
                groupDropItemListener();
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ", thrownError);
            }
            showErrorToast("Get group info failed !");
        }
    });

}


function groupDropItemListener() {

    $('#select_cluster_option').on('change', function () {
        var optionSelected = $("option:selected", this);
        var valueSelected = this.value;

        $("#select_rx_advanced_option").empty();
        if (valueSelected > 0) {
            getDeviceByGroup(valueSelected);
        } else {
            //all rx devices
            var rx_advanced_options_list = "";
            for (rxMapIndex in rxMap) {
                rx_advanced_options_list += "<option value=\"" + rxMap[rxMapIndex].mac + "\" data-mac=\"" + rxMap[rxMapIndex].mac + "\">"
                    + rxMap[rxMapIndex].name + "</option>"
            }
            $("#select_rx_advanced_option").append(rx_advanced_options_list);
        }
    });


    $('#preset_select_cluster_option').on('change', function () {
        var optionSelected = $("option:selected", this);
        var valueSelected = this.value;
        $("#preset-rx-area-list").empty();
        $("#preset_tx_ul").empty();
        if (valueSelected > 0) {
            console.log("device by group");
            presetGetDeviceByGroup(valueSelected);
        } else {
            //all rx devices
            console.log("all devices");
            var rx_preset = "";
            var tx_preset = "";

            for (rxMapIndex in rxMap) {
                rx_preset += " <button id=\"" + rxMap[rxMapIndex].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-preset-event draggable\" data-mac=\"" + rxMap[rxMapIndex].mac + "\" " +
                    "data-name=\"" + rxMap[rxMapIndex].name
                    + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                    + rxMap[rxMapIndex].name + "</h4></button>";
            }

            for (txMapIndex in txMap) {
                tx_preset += "  <li class=\"preset_tx_li\" data-name=\"" + txMap[txMapIndex].name + "\" data-mac=\"" + txMap[txMapIndex].mac + "\"><a>" + txMap[txMapIndex].name + "</a></li>";
            }
            $("#preset_tx_ul").append(tx_preset);
            $("#preset-rx-area-list").append(rx_preset);
        }
    });
}

function presetGetDeviceByGroup(selected_group_id) {

    var data = "group_id=" + selected_group_id

    $.ajax({
        url: dbServerInfo.ip + "/api/device_by_group",
        data: data,
        type: "GET",
        success: function (data) {

            var obj = jQuery.parseJSON(data);

            if (obj.result != "OK") {
                showErrorToast("Get group info failed !");
            } else {
                var rx_advanced_options_list = "";
                var tx_advanced_options_list = "";
                clusterMap = new Object();
                for (index in obj.message) {
                    if (typeof (rxMap[obj.message[index].mac]) !== "undefined") {
                        rx_advanced_options_list += " <button id=\"" + rxMap[obj.message[index].mac].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-preset-event draggable\" data-mac=\"" + rxMap[obj.message[index].mac].mac + "\" " +
                            "data-name=\"" + rxMap[obj.message[index].mac].name
                            + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                            + rxMap[obj.message[index].mac].name + "</h4></button>";
                    }

                    if (typeof (txMap[obj.message[index].mac]) !== "undefined") {
                        tx_advanced_options_list += "  <li class=\"preset_tx_li\" data-name=\"" + txMap[obj.message[index].mac].name + "\" data-mac=\"" + txMap[obj.message[index].mac].mac + "\"><a>" + txMap[obj.message[index].mac].name + "</a></li>";
                    }
                }
                $("#preset_tx_ul").append(tx_advanced_options_list);
                $("#preset-rx-area-list").append(rx_advanced_options_list);
            }
        }
        ,
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error " + thrownError);
            }
            //  $(".loading").hide();
            showErrorToast("Get group info failed !");
        }
    });
}

function getDeviceByGroup(selected_group_id) {

    var data = "group_id=" + selected_group_id

    $.ajax({
        url: dbServerInfo.ip + "/api/device_by_group",
        data: data,
        type: "GET",
        success: function (data) {

            var obj = jQuery.parseJSON(data);

            if (obj.result != "OK") {
                showErrorToast("Get group info failed !");
            } else {
                var rx_advanced_options_list = "";
                clusterMap = new Object();
                for (index in obj.message) {
                    console.log("mac = ", obj.message[index].mac);
                    if (typeof (rxMap[obj.message[index].mac]) !== "undefined") {
                        rx_advanced_options_list += "<option value=\"" + rxMap[obj.message[index].mac].mac + "\" data-mac=\"" + rxMap[obj.message[index].mac].mac + "\">"
                            + rxMap[obj.message[index].mac].name + "</option>"
                    }
                }
                $("#select_rx_advanced_option").append(rx_advanced_options_list);
            }
        }
        ,
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error " + thrownError);
            }
            //  $(".loading").hide();
            showErrorToast("Get group info failed !");
        }
    });
}

/**
 * RX multiple selected on the modal
 */
function warningVWModalApplyClickListener() {
    $("#bt-warning-vw-apply").click(function () {
        setTimeout(
            function () {
                $(".loading").hide();
            }, 1000);
        $("#warning-modal").modal("hide");
        saveVideoWallPresetContent(true);
    });
}


function group_select_listener() {

    $('#select_preset_group').on('change', function () {


        if ($("#select_preset_group").find(":selected").index() > 0) {
            var data = "id=" + $(this).val();

            // console.log("group id = " + data);

            $.ajax({
                url: dbServerInfo.ip + "/api/rx_device_group_info",
                data: data,
                type: "POST",
                success: function (data) {


                    var obj = jQuery.parseJSON(data);
                    if (obj.result != "OK") {
                        showErrorToast("Get group info failed !");
                    } else {

                        // if (typeof txMap[obj.tx_mac] === "undefined") {
                        //     $("#select_group_tx").val(0);
                        // } else {
                        //     $("#select_group_tx").val(obj.tx_mac);
                        // }

                        var rxContentMap = new Object();
                        var group_rx_content = "";
                        var group_rx_others = "";

                        for (index in obj.rx_mac_json.rx_mac) {
                            rxContentMap[obj.rx_mac_json.rx_mac[index]] = new rxObject("", "", "", "", "", "");
                        }
                        var rx_preset = "";
                        for (index in rxContentMap) {

                            if (typeof (rxMap[index]) === "undefined") {

                            } else {
                                rx_preset += " <button id=\"" + rxMap[index].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-preset-event draggable\" data-mac=\"" + rxMap[index].mac + "\" " +
                                    "data-name=\"" + rxMap[index].name
                                    + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                                    + rxMap[index].name + "</h4></button>";
                            }
                        }
                        $("#preset-rx-area-list").empty();
                        $("#preset-rx-area-list").append(rx_preset);
                        delete rxContentMap;
                    }
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (isDebugMode) {
                        console.log("error " + thrownError);
                    }
                    //  $(".loading").hide();
                    showErrorToast("Get group info failed !");
                }
            });
        } else {

            //without group means show all rx
            var rx_preset = "";
            for (index in rxMap) {
                console.log("find");
                rx_preset += " <button id=\"" + rxMap[index].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-preset-event draggable\" data-mac=\"" + rxMap[index].mac + "\" " +
                    "data-name=\"" + rxMap[index].name
                    + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                    + rxMap[index].name + "</h4></button>";

            }
            $("#preset-rx-area-list").empty();
            $("#preset-rx-area-list").append(rx_preset);

        }
    });
}


/**
 * Preset RX Click Event
 */
function presetRXClickEvent() {
    $(document).on('click', ".rx_preset_item", function () {

        if (isDebugMode) {
            console.log("rx_preset_item");
        }

        var vw_l = $(this).attr("data-vw_l");
        var vw_r = $(this).attr("data-vw_r");
        var vw_u = $(this).attr("data-vw_u");
        var vw_b = $(this).attr("data-vw_b");
        var rotation = $(this).attr("data-rotation");

        if (isDebugMode) {
            console.log("rx_preset_item " + $(this).attr("data-name"));
            console.log("vw_l = " + vw_l + " vw_r = " + vw_r + " vw_u = " + vw_u + " vw_b = " + vw_b);
        }

        $("#input_preset_hss").val(vw_l);
        $("#input_preset_hls").val(vw_r);
        $("#input_preset_vss").val(vw_u);
        $("#input_preset_vls").val(vw_b);

        $("#preset-slider-v-start").val(vw_u);
        $("#preset-slider-v-length").val(vw_b);
        $("#preset-slider-h-length").val(vw_r);
        $("#preset-slider-h-start").val(vw_l);
        $("#select_rx_rotation").val(rotation);

        $("#bt-preset-rx-bezel-apply").attr("data-mac", $(this).attr("data-mac"));
        $("#bt-preset-rx-bezel-apply").attr("data-pos", $(this).attr("data-pos"));
        $('#preset-rx-bezel-modal-total').text("Bezel Adjustment - " + $(this).attr("data-name"));
        $("#preset-rx-bezel-modal").modal("show");
    });

    $(document).on('click', ".rx_ite_preset_item", function () {
        if (isDebugMode) {
            console.log("presetRXClickEvent");
        }
        var ow = $(this).attr("data-ow");
        var oh = $(this).attr("data-oh");
        var vw = $(this).attr("data-vw");
        var vh = $(this).attr("data-vh");

        if (isDebugMode) {
            console.log("rx_ite_preset_item " + $(this).attr("data-name"));
            console.log("ow = " + ow + " oh = " + oh + " vw = " + vw + " vh = " + vh);
        }

        $("#input_preset_ow").val(ow);
        $("#input_preset_oh").val(oh);
        $("#input_preset_vw").val(vw);
        $("#input_preset_vh").val(vh);

        $("#preset-ow").val(ow);
        $("#preset-oh").val(oh);
        $("#preset-vw").val(vw);
        $("#preset-vh").val(vh);

        $("#bt-ite-preset-rx-bezel-apply").attr("data-mac", $(this).attr("data-mac"));
        $("#bt-ite-preset-rx-bezel-apply").attr("data-pos", $(this).attr("data-pos"));
        $('#ite_preset-rx-bezel-modal-total').text("Bezel Adjustment - " + $(this).attr("data-name"));
        $("#ite_preset-rx-bezel-modal").modal("show");
    });
}

/**
 * Preset Bezel Apply Bt Click Listener
 */
function presetBezelApplyBtClickListener() {
    $("#bt-preset-rx-bezel-apply").click(function () {

        // var vw_l = $("#input_preset_hss").val() * (-1);
        // var vw_r = $("#input_preset_hls").val() * (-1);
        var vw_l = $("#input_preset_hss").val();
        var vw_r = $("#input_preset_hls").val();
        var vw_u = $("#input_preset_vss").val();
        var vw_b = $("#input_preset_vls").val();
        var vwv = $("#preset-row-count").val();
        var vwh = $("#preset-col-count").val();
        var pos = $(this).attr("data-pos");
        var rotation = $("#select_rx_rotation").val();

        if (isDebugMode) {
            console.log("bt-preset-rx-bezel-apply " + "mac = " + $(this).attr("data-mac"));
            console.log("vwv = " + vwv + " vwh = " + vwh + " pos = " + pos);
            console.log("vw_l = " + vw_l + " vw_r = " + vw_r + " vw_u = " + vw_u + " vw_b = " + vw_b);
            console.log("rotation = " + rotation);
        }

        var x1 = 0, x2 = 0, y1 = 0, y2 = 0;
        x2 = parseInt(10000 / vwh);
        x1 = parseInt((pos - 1) % vwh);
        x1 = parseInt(x1 * x2);
        x2 = parseInt(x2 * (((pos - 1) % vwh) + 1));


        y1 = parseInt((pos - 1) / vwh);
        y2 = y1 + 1;
        y1 = parseInt(y1 * (10000 / vwv));
        y2 = parseInt(y2 * (10000 / vwv));

        y1 = y1 + (vw_u * 10);
        if (isDebugMode) {
            console.log("vw_u y1 = " + y1 + "y2 = " + y2 + " " + (y1 < 0) + " - " + (y1 >= y2));
        }
        if ((y1 < 0) || (y1 >= y2)) {
            showErrorToast("Top Edge Shift out of range !");
            return
        }

        y2 = y2 + (vw_b * 10);
        if (y2 > 10000 || y2 <= y1) {
            showErrorToast("Bottom Edge Shift out of range !");
            return
        }

        x1 = x1 + (vw_l * 10)
        if (x1 < 0 || x1 >=  x2) {
            showErrorToast("Left Edge Shift out of range !");
            return
        }

        // if (x1 < 0 || x1 >= x2) {
        //     showErrorToast("Left Edge Shift out of range !");
        //     return
        // }

        x2 = x2 + (vw_r * 10)
        if (x2 > 10000 || x2 <= x1) {
            showErrorToast("Right Edge Shift out of range !");
            return
        }
        // if (x2 > 10000 || x2 <= x1) {
        //     showErrorToast("Right Edge Shift out of range !");
        //     return
        // }

        $("#preset_" + $(this).attr("data-mac")).attr("data-vw_l", $("#input_preset_hss").val());
        $("#preset_" + $(this).attr("data-mac")).attr("data-vw_r", $("#input_preset_hls").val());
        $("#preset_" + $(this).attr("data-mac")).attr("data-vw_u", $("#input_preset_vss").val());
        $("#preset_" + $(this).attr("data-mac")).attr("data-vw_b", $("#input_preset_vls").val());
        $("#preset_" + $(this).attr("data-mac")).attr("data-rotation", $("#select_rx_rotation").val());
        showSuccessToast("Keep RX info successfully !")
    });

    //ite-video wall apply button
    $("#bt-ite-preset-rx-bezel-apply").click(function () {

        var ow = $("#input_preset_ow").val();
        var oh = $("#input_preset_oh").val();
        var vw = $("#input_preset_vw").val();
        var vh = $("#input_preset_vh").val();


        if (isDebugMode) {
            console.log("bt-ite-preset-rx-bezel-apply" + "mac = " + $(this).attr("data-mac"));
            console.log("ow = " + ow + " oh = " + oh + " vw = " + vw + " vh = " + vh);
        }

        $("#ite_preset_" + $(this).attr("data-mac")).attr("data-ow", $("#input_preset_ow").val());
        $("#ite_preset_" + $(this).attr("data-mac")).attr("data-oh", $("#input_preset_oh").val());
        $("#ite_preset_" + $(this).attr("data-mac")).attr("data-vw", $("#input_preset_vw").val());
        $("#ite_preset_" + $(this).attr("data-mac")).attr("data-vh", $("#input_preset_vh").val());
        showSuccessToast("Apply bezel successfully !")
    });
}

/**
 * Update ASpeed device info every 15 seconds
 */
function startUpdateRXWorker() {

    if (isDebugMode) {
        console.log("Start Update RX Worker");
    }

    if (typeof (Worker) !== "undefined") {
        if (typeof (updateRXWorker) == "undefined") {
            updateRXWorker = new Worker("../js/updateVideoWallRXWorker.js");
        }

        updateRXWorker.postMessage(WORKER_START_EVENT);

        updateRXWorker.onmessage = function (event) {

            if (isDebugMode) {
                console.log("worker receive = " + JSON.stringify(event.data.data));
            }
            for (index in event.data.data) {

                if (event.data.data[index].type != "r") {
                    txMap[event.data.data[index].mac] = new txObject(event.data.data[index].id, event.data.data[index].host_name, event.data.data[index].mac,
                        event.data.data[index].alive, event.data.data[index].ip);

                } else {
                    // console.log(" " + event.data.data[index].type);
                    rxMap[event.data.data[index].mac] = new rxObject(event.data.data[index].id, event.data.data[index].host_name, event.data.data[index].ip,
                        event.data.data[index].mac, event.data.data[index].alive, event.data.data[index].pin);
                }
            }
        };
    } else {
        if (isDebugMode) {
            console.log("Sorry, your browser does not support Web Workers...");
        }
        showErrorToast("Sorry, your browser does not support Web Workers...");
    }
}

/**
 * Silder initial
 */
function rangeInitial() {

    //Bezel Adjustment
    // var vsSlider = document.getElementById("slider-v-start");
    // vsSlider.oninput = function () {
    //     $("#input_vss").val(this.value);
    // }
    //
    // var vlSlider = document.getElementById("slider-v-length");
    // vlSlider.oninput = function () {
    //     $("#input_vls").val(this.value);
    // }
    //
    // var hlSlider = document.getElementById("slider-h-length");
    // hlSlider.oninput = function () {
    //     $("#input_hls").val(this.value);
    // }
    //
    // var hsSlider = document.getElementById("slider-h-start");
    // hsSlider.oninput = function () {
    //     $("#input_hss").val(this.value);
    // }

    //Multiple RX bezel
    var vsSlider = document.getElementById("multiple-slider-v-start");
    vsSlider.oninput = function () {
        $("#input_multiple_vss").val(this.value);
    }

    var vlSlider = document.getElementById("multiple-slider-v-length");
    vlSlider.oninput = function () {
        $("#input_multiple_vls").val(this.value);
    }

    var hlSlider = document.getElementById("multiple-slider-h-length");
    hlSlider.oninput = function () {
        $("#input_multiple_hls").val(this.value);
    }

    var hsSlider = document.getElementById("multiple-slider-h-start");
    hsSlider.oninput = function () {
        $("#input_multiple_hss").val(this.value);
    }

    //Preset RX bezel modal
    var vsSlider = document.getElementById("preset-slider-v-start");
    vsSlider.oninput = function () {
        $("#input_preset_vss").val(this.value);
    }

    var vlSlider = document.getElementById("preset-slider-v-length");
    vlSlider.oninput = function () {
        $("#input_preset_vls").val(this.value);
    }

    var hlSlider = document.getElementById("preset-slider-h-length");
    hlSlider.oninput = function () {
        $("#input_preset_hls").val(this.value);
    }

    var hsSlider = document.getElementById("preset-slider-h-start");
    hsSlider.oninput = function () {
        $("#input_preset_hss").val(this.value);
    }


    //ITE Preset RX bezel modal
    // var owSlider = document.getElementById("preset-ow");
    // owSlider.oninput = function () {
    //     $("#input_preset_ow").val(this.value);
    // }
    //
    // var ohlSlider = document.getElementById("preset-oh");
    // ohlSlider.oninput = function () {
    //     $("#input_preset_oh").val(this.value);
    // }
    //
    // var vwSlider = document.getElementById("preset-vw");
    // vwSlider.oninput = function () {
    //     $("#input_preset_vw").val(this.value);
    // }
    //
    // var vhSlider = document.getElementById("preset-vh");
    // vhSlider.oninput = function () {
    //     $("#input_preset_vh").val(this.value);
    // }
}

/**
 * Shift input change listener
 */
function shiftInputChangeListener() {

    //Bezel Adjustment
    $("#input_hss").on("change paste keyup", function () {
        $("#slider-h-start").val($(this).val());
    });

    $("#input_hls").on("change paste keyup", function () {
        $("#slider-h-length").val($(this).val());
    });

    $("#input_vss").on("change paste keyup", function () {
        $("#slider-v-start").val($(this).val());
    });

    $("#input_vls").on("change paste keyup", function () {
        $("#slider-v-length").val($(this).val());
    });


    //Multiple RX bezel
    $("#input_multiple_hss").on("change paste keyup", function () {
        $("#multiple-slider-h-start").val($(this).val());
    });

    $("#input_multiple_hls").on("change paste keyup", function () {
        $("#multiple-slider-h-length").val($(this).val());

    });

    $("#input_multiple_vss").on("change paste keyup", function () {
        $("#multiple-slider-v-start").val($(this).val());
    });

    $("#input_multiple_vls").on("change paste keyup", function () {
        $("#multiple-slider-v-length").val($(this).val());
    });

    //Preset RX bezel modal
    $("#input_preset_hss").on("change paste keyup", function () {
        $("#preset-slider-h-start").val($(this).val());
    });

    $("#input_preset_hls").on("change paste keyup", function () {
        $("#preset-slider-h-length").val($(this).val());

    });

    $("#input_preset_vss").on("change paste keyup", function () {
        $("#preset-slider-v-start").val($(this).val());
    });

    $("#input_preset_vls").on("change paste keyup", function () {
        $("#preset-slider-v-length").val($(this).val());
    });

    //ITE Preset RX bezel modal
    $("#input_preset_ow").on("change paste keyup", function () {
        $("#preset-ow").val($(this).val());
    });

    $("#input_preset_oh").on("change paste keyup", function () {
        $("#preset-oh").val($(this).val());

    });

    $("#input_preset_vw").on("change paste keyup", function () {
        $("#preset-vw").val($(this).val());
    });

    $("#input_preset_vh").on("change paste keyup", function () {
        $("#preset-vh").val($(this).val());
    });
}

/**
 * Initial - Get RX online list
 */
function initial() {
    var rows = $('#row-count').val();
    var cols = $('#col-count').val();
    if (isDebugMode) {
        console.log("rows = " + rows + " cols = " + cols);
    }
    var rowIndex = 0;
    var colsIndex = 0;
    var wall_html = "";
    var preset_wall_html = "";
    var counter = 1;
    var preset_counter = 1;
    if (isDebugMode) {
        console.log("div width = " + $("#wall-area").width());
    }
    var width = (display_wall_width / cols);
    // var height = (500 / rows);
    var height = (display_wall_height / rows);

    //Preset Draw video wall --- End

    //Get Device List (TX & RX) --- Start
    $.ajax({
        url: dbServerInfo.ip + "/api/node_info",
        //  url: dbServerInfo.ip +"/api/astparam_g/169.254.13.26/coder",
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }
            var rx_list = "";
            var tx_list = "";
            var rx_preset = "";
            var rx_ite_preset = "";
            var rx_multiple_list = "";
            var rx_counter = 0;
            var ite_rx_preset = "";//set ite preset video wall
            var ite_tx_preset = "";//set ite preset video wall
            var rx_advanced_options_list = "";//set single RX ADVANCED OPTIONS

            for (jsonArrayIndex = 0; jsonArrayIndex < returnData.length; jsonArrayIndex++) {
                if (returnData[jsonArrayIndex].type != "r") {
                    //TX
                    tx_list += "  <li class=\"preset_tx_li\" data-name=\"" + getDeviceName(returnData[jsonArrayIndex]) + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\"><a>" + returnData[jsonArrayIndex].host_name + "</a></li>";
                    // ite_tx_preset += "  <li class=\"ite_preset_tx_li\" data-name=\"" + getDeviceName(returnData[jsonArrayIndex]) + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\"><a>" + returnData[jsonArrayIndex].host_name + "</a></li>";
                    //  tx_list += "<option value=\"" + returnData[jsonArrayIndex].mac + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\">" + returnData[jsonArrayIndex].host_name + "</option>";
                    txMap[returnData[jsonArrayIndex].mac] = new txObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]),
                        returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].ip);
                } else {
                    //RX


                    rxMap[returnData[jsonArrayIndex].mac] = new rxObject(returnData[jsonArrayIndex].id, getDeviceName(returnData[jsonArrayIndex]),
                        returnData[jsonArrayIndex].ip, returnData[jsonArrayIndex].mac, returnData[jsonArrayIndex].alive, returnData[jsonArrayIndex].pin);

                    rx_preset += " <button id=\"" + returnData[jsonArrayIndex].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-preset-event draggable\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" " +
                        "data-name=\"" + returnData[jsonArrayIndex].host_name
                        + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                        + returnData[jsonArrayIndex].host_name + "</h4></button>";

                    if (returnData[jsonArrayIndex].alive != "n") {


                        //   if (checkDevicePermission(returnData[jsonArrayIndex].mac)) {
                        rx_advanced_options_list += "<option value=\"" + returnData[jsonArrayIndex].mac + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\">"
                            + returnData[jsonArrayIndex].host_name + "</option>"
                        //  }

                        // ite_rx_preset += " <button id=\"" + returnData[jsonArrayIndex].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-preset-event draggable\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" " +
                        //     "data-name=\"" + returnData[jsonArrayIndex].host_name
                        //     + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                        //     + returnData[jsonArrayIndex].host_name + "</h4></button>";

                        rx_list += " <button id=\"" + returnData[jsonArrayIndex].mac + "\" class=\"btn btn-light rx-event\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" " +
                            "data-name=\"" + returnData[jsonArrayIndex].host_name
                            + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                            + returnData[jsonArrayIndex].host_name + "</h4></button>";


                        // rx_ite_preset += " <button id=\"" + returnData[jsonArrayIndex].mac + "\" draggable=\"true\" ondragstart=\"Drag(event)\" class=\"btn btn-light rx-ite-preset-event draggable\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" " +
                        //     "data-name=\"" + returnData[jsonArrayIndex].host_name
                        //     + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                        //     + returnData[jsonArrayIndex].host_name + "</h4></button>";

                        rx_multiple_list += " <button id=\"" + returnData[jsonArrayIndex].mac + "_modal\" class=\"btn btn-light rx-multiple-event\" data-name=\"" + returnData[jsonArrayIndex].host_name + "\" data-mac=\"" + returnData[jsonArrayIndex].mac + "\" " +
                            "data-name=\"" + getDeviceName(returnData[jsonArrayIndex])
                            + "\" data-type =\"rx\" " + "type=\"button\" class=\"btn\" " + "style=\"margin: 8px 2px 2px 2px;color: white;\"><h4 style=\"padding: 0px;margin: 0px;\">"
                            + returnData[jsonArrayIndex].host_name + "</h4></button>";

                        rx_counter++;
                    }
                }
            }


            $("#select_rx_advanced_option").empty();
            $("#select_rx_advanced_option").append(rx_advanced_options_list);

            $("#rx-area-list").empty();
            $("#rx-area-list").append(rx_list);

            $("#rx-multiple-area-list").empty();
            $("#rx-multiple-area-list").append(rx_multiple_list);

            $("#preset-rx-area-list").empty();
            $("#preset-rx-area-list").append(rx_preset);

            // $("#ite_preset-rx-area-list").empty();
            // $("#ite_preset-rx-area-list").append(ite_rx_preset);

            $("#preset_tx_ul").empty();
            $("#preset_tx_ul").append(tx_list);

            // $("#ite_preset_tx_ul").empty();
            // $("#ite_preset_tx_ul").append(ite_tx_preset);
            singleRXItemClickEvent();
            rxModalItemClickEvent();
            presetTXSelectListener();
            getVideoWallPreset(0);//show first preset content
            // getVideoWallITEPreset(0);//show first preset content
            startUpdateRXWorker();
            simpleRXVWChangeListener();
            initialSingleVideoWall(true);
            getCluster();
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error");
                console.log(xhr.status);
                console.log(thrownError);
            }
            showErrorToast("Request timeout !");
            if (XMLHttpRequest.readyState == 4) {
                if (isDebugMode) {
                    console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                }
                // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
            } else if (XMLHttpRequest.readyState == 0) {
                if (isDebugMode) {
                    console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                }
                // Network error (i.e. connection refused, access denied due to CORS, etc.)
            } else {
                if (isDebugMode) {
                    console.log("something weird is happening");
                }
                // something weird is happening
            }
            $(".loading").hide();
        }
    });
    //Get Device List (TX & RX) --- End
}

/**
 * Drag listener (TX)
 * */
function Drag(event) {
    event.dataTransfer.setData("Text", event.currentTarget.id);
}

/**
 * Allow drop listener
 * */
function AllowDrop(event) {
    var data = event.currentTarget.id;
    if (isDebugMode) {
        console.log("AllowDrop id = " + data);
    }
    event.preventDefault();
}

/**
 * Preset Leave drop listener (RX)
 * */
function PresetLeaveDrop(event) {
    if (isDebugMode) {
        console.log("PresetLeaveDrop");
    }
    event.preventDefault();
}

/**
 * Drop listener, will switch rx channel
 * */
function Drop(event) {
    event.preventDefault();
    if (isDebugMode) {
        console.log("rx name = " + $("#" + event.dataTransfer.getData("text")).attr("data-name"));
        console.log("rx mac = " + $("#" + event.dataTransfer.getData("text")).attr("data-mac"));
        console.log("video wall = " + event.currentTarget.id);
    }

    if (checkDevicePermission($("#" + event.dataTransfer.getData("text")).attr("data-mac"))) {
        //  var isRXExist = false;
        var rx_name = $("#" + event.dataTransfer.getData("text")).attr("data-name");
        var rx_mac = $("#" + event.dataTransfer.getData("text")).attr("data-mac");
        //  var is_in_pos = 0;

        //check current RX used before or not, and remove it
        $('.preset_screen').each(function (i, obj) {
            if ($(this).find(".inner").find(".content").find(".rx_content").children().length > 0) {
                var temp_rx_mac = $(this).find(".inner").find(".content").find(".rx_content").find(".btn").attr("data-mac");
                if (temp_rx_mac === rx_mac) {
                    $(this).find(".inner").find(".content").find(".rx_content").find(".btn").remove();
                }
            }
        });

        $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").empty();
        $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").append("<button id=\"preset_" + rx_mac + "\" data-name=\"" + rx_name
            + "\"class='draggable btn  rx_preset_item' " + "data-mac=\"" + rx_mac +
            "\"data-pos=\"" + $("#" + event.currentTarget.id).attr("data-pos") + "\" draggable=\"true\" ondragstart=\"Drag(event)\" data-mac=\"" + rx_mac + "\" style=\"color:white;background: rgb(100, 108, 128);margin: 5px;cursor:pointer;" +
            "display:block;white-space: normal;\"" + " data-vw_l=\"0\"" + " data-vw_r=\"0\"" + " data-vw_u=\"0\"" + " data-vw_b=\"0\"  data-rotation=\"0\">" +
            "<h4 style=\"padding: 0px;margin: 0px;\">" + rx_name + "</h4></button>");

        // if (!isRXExist) {
        //     $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").empty();
        //     $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").append("<button class='btn btn-warning' " +
        //         "data-pos=\"" + $(this).attr("data-pos") + "\" data-mac=\"" + rx_mac + "\" style=\"margin-top: 5px;margin-left: 5px;cursor:auto;\">" + rx_name + "</button>");
        // } else {
        //     showWarningToast("This RX is used in position " + is_in_pos);
        // }
    } else {
        showWarningToast("Sorry ! You don't have this device permission !");
    }
}

/**
 * Drop listener, will switch rx channel
 * */
// function ITEDrop(event) {
//     event.preventDefault();
//     if (isDebugMode) {
//         console.log("rx name = " + $("#" + event.dataTransfer.getData("text")).attr("data-name"));
//         console.log("rx mac = " + $("#" + event.dataTransfer.getData("text")).attr("data-mac"));
//         console.log("video wall = " + event.currentTarget.id);
//     }
//
//     //  var isRXExist = false;
//     var rx_name = $("#" + event.dataTransfer.getData("text")).attr("data-name");
//     var rx_mac = $("#" + event.dataTransfer.getData("text")).attr("data-mac");
//     //  var is_in_pos = 0;
//
//     //check current RX used before or not, and remove it
//     $('.ite_preset_screen').each(function (i, obj) {
//         if ($(this).find(".inner").find(".content").find(".rx_content").children().length > 0) {
//             var temp_rx_mac = $(this).find(".inner").find(".content").find(".rx_content").find(".btn").attr("data-mac");
//             if (temp_rx_mac === rx_mac) {
//                 $(this).find(".inner").find(".content").find(".rx_content").find(".btn").remove();
//             }
//         }
//     });
//
//     $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").empty();
//     $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").append("<button id=\"ite_preset_" + rx_mac + "\" data-name=\"" + rx_name
//         + "\"class='draggable btn rx_ite_preset_item' " + "data-mac=\"" + rx_mac +
//         "\"data-pos=\"" + $("#" + event.currentTarget.id).attr("data-pos") + "\" draggable=\"true\" ondragstart=\"Drag(event)\" data-mac=\"" + rx_mac + "\" style=\"color:white;margin: 5px;cursor:pointer;background: rgb(100, 108, 128);" +
//         "display:block;white-space: normal;\"" + " data-ow=\"0\"" + " data-oh=\"0\"" + " data-vw=\"0\"" + " data-vh=\"0\" >" +
//         "<h4 style=\"padding: 0px;margin: 0px;\">" + rx_name + "</h4></button>");
//
//     // if (!isRXExist) {
//     //     $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").empty();
//     //     $("#" + event.currentTarget.id).find(".inner").find(".content").find(".rx_content").append("<button class='btn btn-warning' " +
//     //         "data-pos=\"" + $(this).attr("data-pos") + "\" data-mac=\"" + rx_mac + "\" style=\"margin-top: 5px;margin-left: 5px;cursor:auto;\">" + rx_name + "</button>");
//     // } else {
//     //     showWarningToast("This RX is used in position " + is_in_pos);
//     // }
// }

/**
 * Draw TV Wall
 * @param rowCount : row counts
 * @param colCount : col counts
 * @param position : selected position of TV Wall
 */
function drawTVWallByPosition(rowCount, colCount, position) {
    if (isDebugMode) {
        console.log("drawTVWallByPosition");
    }
    var wall_html = "";
    var counter = 1;
    var width = (display_wall_width / colCount);
    var height = (display_wall_height / rowCount);
    var position_item_list = "";
    for (rowIndex = 0; rowIndex < rowCount; rowIndex++) {
        for (colsIndex = 0; colsIndex < colCount; colsIndex++) {
            wall_html += "<div id=\"wall_" + counter + "\" data-pos=\"" + (counter) + "\" class=\"screen\" " +
                "style=\"cursor: pointer;width:" + width + "%; height:" + height + "px; outline: rgb(255, 255, 255) solid 5px; outline-offset: -5px; float: left;border-width:3px;border-style:solid; \" " + ">" +
                "<div class=\"inner\"><div class=\"content\" style=\"padding-top: 3px\"><div class=\"circle\" style=\"text-align:center;font-weight: bold;\">" + counter + "</div>" +
                "<div class=\"tx_content\"></div><div class=\"rx_content\"></div><div></div></div></div></div>";
            position_item_list += "<li class=\"position_item\" data-value=\"" + counter + "\"><a> " + counter + "</a></li>";
            counter += 1;
        }
    }
    $("#dropdown-position").empty();
    $("#dropdown-position").append(position_item_list);
    $("#wall-area").empty();
    $("#wall-area").append(wall_html);

    if (isDebugMode) {
        console.log("rowCount = " + rowCount + " colCount = " + colCount);
        console.log("position = " + position + " sum = " + (parseInt(rowCount) * parseInt(colCount)));
    }

    if (position > (parseInt(rowCount) * parseInt(colCount))) {
        $("#span-position").attr("data-position", 1);
        $("#span-position").text(" " + 1);
        //  $("#wall_1").children(1).css('background-color', '#C6A300');
        $("#wall_1").children(1).css('background-color', '#C6A300');
    } else {
        $("#wall_" + position).children(1).css('background-color', '#C6A300');
    }

    $(".screen").click(function () {
        var counter = 1;
        for (rowIndex = 0; rowIndex < rowCount; rowIndex++) {
            for (colsIndex = 0; colsIndex < colCount; colsIndex++) {
                $("#wall_" + counter).children(1).css('background-color', '#aaa');
                counter += 1;
            }
        }

        $(this).children(1).css('background-color', '#C6A300');
        var new_pos = $(this).attr("data-pos");
        $("#span-position").attr("data-position", new_pos);
        $("#span-position").text(" " + new_pos);

        if (typeof $("#bt-bezel-apply").attr("data-mac") === "undefined") {
            showWarningToast("Please select receiver first !");
            return;
        }

        var postData = "mac=" + $("#bt-bezel-apply").attr("data-mac") + "&vwh=" + $("#col-count").val() + "&vwv=" + $("#row-count").val() +
            "&vwp=" + $("#span-position").attr("data-position") + "&vwl=" + $("#slider-h-start").val() + "&vwr=" + $("#slider-h-length").val()
            + "&vwu=" + $("#slider-v-start").val() + "&vwb=" + $("#slider-v-length").val();

        if (isDebugMode) {
            console.log("postData = " + postData);
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/set_vw",
            data: postData,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (obj.result != "OK") {
                    if (isDebugMode) {
                        console.log("failed ");
                    }
                    var result = "";
                    switch (obj.result) {

                        case "L_OUT":
                            result = "Left Edge Shift out of range !"
                            break;

                        case "R_OUT":
                            result = "Right Edge Shift out of range !"
                            break;

                        case "U_OUT":
                            result = "Top Edge Shift out of range !"
                            break;

                        case "B_OUT":
                            result = "Bottom Edge Shift out of range !"
                            break;

                        default:
                            result = "Set Video Wall failed !"
                            break;
                    }
                    showErrorToast(result);
                } else {
                    if (isDebugMode) {
                        console.log("success ");
                    }
                    showSuccessToast("Set Video Wall Successful");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                $(".loading").hide();
                showErrorToast("Set Video Wall failed !");
            }
        });
    });
}

/**
 * Draw TV Wall
 * @param rowCount : row counts
 * @param colCount : col counts
 * @param position : selected position of TV Wall
 */
function presetDrawTVWall(rowCount, colCount) {
    if (isDebugMode) {
        console.log("preset Draw TV Wall");
    }
    var wall_html = "";
    var counter = 1;
    var width = (display_wall_width / colCount);
    var height = (display_wall_height / rowCount);
    var position_item_list = "";
    for (rowIndex = 0; rowIndex < rowCount; rowIndex++) {
        for (colsIndex = 0; colsIndex < colCount; colsIndex++) {
            wall_html += "<div id=\"preset_wall_" + counter + "\" data-pos=\"" + (counter) + "\" class=\"preset_screen\" " + "ondrop=\"Drop(event)\" ondragover=\"AllowDrop(event)\" ondragleave=\"PresetLeaveDrop(event)\"" +
                "style=\"cursor: auto;width:" + width + "%; height:" + height + "px; outline: rgb(125,158,187) solid 5px;border-radius: 18px; outline-offset: -5px; float: left;border-width:3px;border-style:solid;border-color: rgb(246, 246, 249); \" " + ">" +
                "<div class=\"inner\" style=\"border-radius: 18px;\"><div class=\"content\" style=\"padding-top: 3px\"><div class=\"circle preset_circle\" style=\"text-align:center;font-weight: bold;cursor: pointer\" title='Clean RX'>" + counter + "</div>" +
                "<div class=\"rx_content\"></div><div></div></div></div></div>";
            position_item_list += "<li class=\"position_item\" data-value=\"" + counter + "\"><a> " + counter + "</a></li>";
            counter += 1;
        }
    }

    $("#preset-wall-area").empty();
    $("#preset-wall-area").append(wall_html);
    presetVideoWallNumberClickListener();
}

/**
 * Draw TV Wall
 * @param rowCount : row counts
 * @param colCount : col counts
 * @param position : selected position of TV Wall
 */
function presetDrawITETVWall(rowCount, colCount) {
    if (isDebugMode) {
        console.log("preset Draw ITE TV Wall");
    }
    var wall_html = "";
    var counter = 1;
    var width = (display_wall_width / colCount);
    var height = (display_wall_height / rowCount);
    var position_item_list = "";
    for (rowIndex = 0; rowIndex < rowCount; rowIndex++) {
        for (colsIndex = 0; colsIndex < colCount; colsIndex++) {
            wall_html += "<div id=\"ite_preset_wall_" + counter + "\" data-pos=\"" + (counter) + "\" class=\"ite_preset_screen\" " + "ondrop=\"ITEDrop(event)\" ondragover=\"AllowDrop(event)\" ondragleave=\"PresetLeaveDrop(event)\"" +
                "style=\"cursor: auto;width:" + width + "%; height:" + height + "px; outline: rgb(246, 246, 249) solid 5px; outline-offset: -5px; float: left;border-width:3px;border-style:solid;border-color: rgb(246, 246, 249); \">" +
                "<div class=\"inner\" style=\"border-radius: 18px;\"><div class=\"content\" style=\"padding-top: 3px\"><div class=\"circle ite_preset_circle\" style=\"text-align:center;font-weight: bold;cursor: pointer\" title='Clean RX'>" + counter + "</div>" +
                "<div class=\"rx_content\"></div><div></div></div></div></div>";
            position_item_list += "<li class=\"position_item\" data-value=\"" + counter + "\"><a> " + counter + "</a></li>";
            counter += 1;
        }
    }

    $("#ite_preset-wall-area").empty();
    $("#ite_preset-wall-area").append(wall_html);
    // presetVideoWallNumberClickListener();
}

/**
 * Bezel Adjustment Apply button click event
 */
function bezelApplyBtClickEvent() {
    $("#bt-bezel-apply").click(function () {
        if (isDebugMode) {
            console.log("bt-bezel-apply");
        }

        var postData = "mac=" + $(this).attr("data-mac") + "&vwh=" + $("#col-count").val() + "&vwv=" + $("#row-count").val() +
            "&vwp=" + $("#span-position").attr("data-position") + "&vwl=" + $("#slider-h-start").val() + "&vwr=" + $("#slider-h-length").val()
            + "&vwu=" + $("#slider-v-start").val() + "&vwb=" + $("#slider-v-length").val();

        if (isDebugMode) {
            console.log("postData = " + postData);
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/set_vw",
            data: postData,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (obj.result != "OK") {
                    if (isDebugMode) {
                        console.log("failed ");
                    }
                    var result = "";
                    switch (obj.result) {

                        case "L_OUT":
                            result = "Left Edge Shift out of range !"
                            break;

                        case "R_OUT":
                            result = "Right Edge Shift out of range !"
                            break;

                        case "U_OUT":
                            result = "Top Edge Shift out of range !"
                            break;

                        case "B_OUT":
                            result = "Bottom Edge Shift out of range !"
                            break;

                        default:
                            result = "Set Video Wall failed !"
                            break;
                    }

                    showErrorToast(result);
                } else {
                    if (isDebugMode) {
                        console.log("success ");
                    }
                    showSuccessToast("Set Video Wall Successful");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                $(".loading").hide();
                showErrorToast("Set Video Wall failed !");
            }
        });
    });
}

/**
 * Reset button click event
 */
function resetClickEvent() {
    $("#bt-reset").click(function () {
        if (isDebugMode) {
            console.log("bt-reset");
        }
        var postData = "mac=" + $(this).attr("data-mac") + "&vwh=1&vwv=1&vwp=1&vwl=0&vwr=0&vwu=0&vwb=0";
        if (isDebugMode) {
            console.log("postData = " + postData);
        }
        $.ajax({
            url: dbServerInfo.ip + "/api/set_vw",
            data: postData,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (isDebugMode) {
                    console.log("success " + JSON.stringify(data));
                }
                if (obj.result != "OK") {
                    var result = "";
                    switch (obj.result) {

                        case "L_OUT":
                            result = "Left Edge Shift out of range !"
                            break;

                        case "R_OUT":
                            result = "Right Edge Shift out of range !"
                            break;

                        case "U_OUT":
                            result = "Top Edge Shift out of range !"
                            break;

                        case "B_OUT":
                            result = "Bottom Edge Shift out of range !"
                            break;

                        default:
                            result = "Set Video Wall failed !"
                            break;
                    }
                    showErrorToast(result);
                } else {
                    $("#col-count").val(1);
                    $("#row-count").val(1);
                    $("#span-position").attr("data-position", 1);
                    $("#span-position").text(" " + 1);
                    $("#slider-v-start").val(0);
                    $("#input_vss").val(0);

                    $("#slider-v-length").val(0);
                    $("#input_vls").val(0);

                    $("#slider-h-start").val(0);
                    $("#input_hss").val(0);

                    $("#slider-h-length").val(0);
                    $("#input_hls").val(0);
                    drawTVWallByPosition(1, 1, 1);
                    showSuccessToast("Reset Successful");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                $(".loading").hide();
                showErrorToast("Reset failed !");
            }
        });
    });
}

/**
 * RX multiple selected on the modal
 */
function rxModalItemClickEvent() {
    $(".rx-multiple-event").click(function () {
        if ($(this).hasClass("btn-primary")) {
            $(this).removeClass("btn-primary");
            $(this).addClass("btn-light");
        } else {
            $(this).removeClass("btn-light");
            $(this).addClass("btn-primary");
        }
    });
}

/**
 * RX list item click listener
 */
function singleRXItemClickEvent() {
    $(".rx-event").click(function () {
        if (isDebugMode) {
            console.log("single rx-event");
        }
        $("#bt-bezel-apply").prop("disabled", false);
        $("#bt-bezel-apply").attr("data-mac", $(this).attr("data-mac"));
        $("#bt-reset").prop("disabled", false);
        $("#bt-reset").attr("data-mac", $(this).attr("data-mac"));
        $(".rx-event").each(function () {
            if ($(this).hasClass("btn-primary")) {
                $(this).removeClass("btn-primary");
                $(this).addClass("btn-light");
            }
        });
        $(this).removeClass("btn-light");
        $(this).addClass("btn-primary");
        //  $("#rx-name").text(" - " + $(this).attr("data-name"));
        if (isDebugMode) {
            console.log("mac = " + $(this).attr("data-mac"));
        }

        //Get Device List (TX & RX) --- Start
        $.ajax({
            url: dbServerInfo.ip + "/api/vw_info/" + $(this).attr("data-mac"),
            //  url: dbServerInfo.ip +"/api/astparam_g/169.254.13.26/coder",
            type: "GET",
            crossDomain: true,
            dataType: 'json',
            success: function (returnData) {
                if (isDebugMode) {
                    console.log("success" + JSON.stringify(returnData));
                }

                if ((returnData.vw_h.length > 0) && (returnData.vw_v.length > 0)) {
                    $("#col-count").val((parseInt(returnData.vw_h)));
                    $("#row-count").val((parseInt(returnData.vw_v)));
                    $("#span-position").attr("data-position", returnData.vw_pos);
                    $("#span-position").text(" " + returnData.vw_pos);
                    $("#slider-v-start").val(returnData.vw_u);
                    $("#input_vss").val(returnData.vw_u);

                    $("#slider-v-length").val(returnData.vw_b);
                    $("#input_vls").val(returnData.vw_b);

                    $("#slider-h-start").val(returnData.vw_l);
                    $("#input_hss").val(returnData.vw_l);

                    $("#slider-h-length").val(returnData.vw_r);
                    $("#input_hls").val(returnData.vw_r);
                    if (isDebugMode) {
                        console.log("c = " + $("#col-count").val());
                        console.log("r = " + $("#row-count").val());
                        console.log("data c = " + (parseInt(returnData.vw_h)));
                        console.log("data r = " + (parseInt(returnData.vw_v)));
                    }
                    drawTVWallByPosition((parseInt(returnData.vw_v)), (parseInt(returnData.vw_h)), returnData.vw_pos);
                } else {
                    showErrorToast("Get RX video wall info failed ! \n Please try again.");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error");
                    console.log(xhr.status);
                    console.log(thrownError);
                }
                showErrorToast("Request timeout !");
                if (XMLHttpRequest.readyState == 4) {
                    if (isDebugMode) {
                        console.log("HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)");
                    }
                    // HTTP error (can be checked by XMLHttpRequest.status and XMLHttpRequest.statusText)
                } else if (XMLHttpRequest.readyState == 0) {
                    if (isDebugMode) {
                        console.log("Network error (i.e. connection refused, access denied due to CORS, etc.)");
                    }
                    // Network error (i.e. connection refused, access denied due to CORS, etc.)
                } else {
                    if (isDebugMode) {
                        console.log("something weird is happening");
                    }
                    // something weird is happening
                }
                $(".loading").hide();
            }
        });
        //Get Device List (TX & RX) --- End
    });
}

/**
 * position dropdown menu click listener
 * */
function positionDropDownListener() {
    $('.dropdown').on('click', '.position_item', function () {
        if (isDebugMode) {
            console.log("position_item " + $(this).attr("data-value"));
        }
        $("#span-position").attr("data-position", $(this).attr("data-value"));
        $("#span-position").text(" " + $(this).attr("data-value"));
        $('#wall-area').children('div').each(function () {
            $(this).children(1).css('background-color', ' #aaa');
        });
        $("#wall_" + $(this).attr("data-value")).children(1).css('background-color', '#C6A300');
    });
}

/**
 * Layout change listener
 */
function layoutChangeListener() {
    $("#col-count").on("change paste keyup", function () {
        if (isDebugMode) {
            console.log("col-count change");
        }
        drawTVWallByPosition($('#row-count').val(), $('#col-count').val(), $("#span-position").attr("data-position"));
    });

    $("#row-count").on("change paste keyup", function () {
        if (isDebugMode) {
            console.log("row-count change");
        }
        drawTVWallByPosition($('#row-count').val(), $('#col-count').val(), $("#span-position").attr("data-position"));
    });

    $("#preset-col-count").on("change paste keyup", function () {
        if (isDebugMode) {
            console.log("preset-col-count change");
        }
        presetDrawTVWall($('#preset-row-count').val(), $('#preset-col-count').val());
    });

    $("#preset-row-count").on("change paste keyup", function () {
        if (isDebugMode) {
            console.log("preset-row-count change");
        }
        presetDrawTVWall($('#preset-row-count').val(), $('#preset-col-count').val());
    });

    $("#ite_preset-col-count").on("change paste keyup", function () {
        if (isDebugMode) {
            console.log("preset-col-count change");
        }
        presetDrawITETVWall($('#ite_preset-row-count').val(), $('#ite_preset-col-count').val());
    });

    $("#ite_preset-row-count").on("change paste keyup", function () {
        if (isDebugMode) {
            console.log("preset-row-count change");
        }
        presetDrawITETVWall($('#ite_preset-row-count').val(), $('#ite_preset-col-count').val());
    });
}

/**
 * Info label click event
 */
function infoClickEvent() {
    $("#label-info").click(function () {
        if ($(this).hasClass("info-image")) {
            $(this).removeClass("info-image");
            $(".img-fluid").css("display", "none");
        } else {
            $(this).addClass("info-image");
            $(".img-fluid").css("display", "");
        }
    });
}

/**
 * Reset RX device list in the preset content
 */
function presetResetClickListener() {
    $("#btn-preset-reset").click(function () {
        $(".loading").show();
        var userSelectedIndex = (parseInt($("#select_preset").val()) - 1);
        var tempRxMap = new Object();
        if (isDebugMode) {
            console.log("presetResetClickListener index = " + (parseInt($("#select_preset").val()) - 1));
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/video_wall_preset",
            type: "GET",
            success: function (data) {
                if (isDebugMode) {
                    console.log(JSON.stringify(data));
                }

                var index = 0;
                for (index in data[userSelectedIndex].rx_list) {
                    if (isDebugMode) {
                        console.log(data[userSelectedIndex].rx_list[index].mac);
                    }
                    tempRxMap[index] = new rxObject("", "",
                        "", data[userSelectedIndex].rx_list[index].mac, "", "");
                    index++;
                }

                if (data[userSelectedIndex].rx_list.length > 0) {
                    if (isDebugMode) {
                        console.log("Have rx in this preset content !");
                    }
                    resetVideoWallPresetRecursive(tempRxMap, 0);
                } else {
                    if (isDebugMode) {
                        console.log("Here is rx in this preset content !");
                    }
                    $(".loading").hide();
                    showSuccessToast("Reset finish !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                $(".loading").hide();
                showSuccessToast("Reset failed !");
            }
        });
    });

    $("#btn-ite-preset-reset").click(function () {
        $(".loading").show();
        var userSelectedIndex = (parseInt($("#select_ite_preset").val()) - 1);
        var tempRxMap = new Object();
        if (isDebugMode) {
            console.log("ite presetResetClickListener index = " + userSelectedIndex);
        }


        $.ajax({
            url: dbServerInfo.ip + "/api/video_wall_ite_preset",
            type: "GET",
            success: function (data) {
                if (isDebugMode) {
                    console.log(JSON.stringify(data));
                }

                var index = 0;
                for (index in data[userSelectedIndex].rx_list) {
                    if (isDebugMode) {
                        console.log(data[userSelectedIndex].rx_list[index].mac);
                    }
                    tempRxMap[index] = new rxObject("", "",
                        "", data[userSelectedIndex].rx_list[index].mac, "", "");
                    index++;
                }

                if (data[userSelectedIndex].rx_list.length > 0) {
                    if (isDebugMode) {
                        console.log("Have rx in this preset content !");
                    }
                    resetITEVideoWallPresetRecursive(tempRxMap, 0);
                } else {
                    if (isDebugMode) {
                        console.log("Here is rx in this preset content !");
                    }
                    $(".loading").hide();
                    showSuccessToast("Reset finish !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("error ");
                }
                $(".loading").hide();
                showSuccessToast("Reset failed !");
            }
        });
    });
}

/**
 * Reset ITE Video Wall Preset Recursive
 * @param rxArray : rx in the video wall preset
 * @param currentIndex : current handle index
 */
function resetITEVideoWallPresetRecursive(rxArray, currentIndex) {

    var index = currentIndex;
    var postData = "mac=" + rxArray[currentIndex].mac + "&v_count=0&h_count=0&row=0&col=0&vw=0&ow=0&vh=0&oh=0";

    if (isDebugMode) {
        console.log("postData = " + postData);
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/set_ite_vw",
        data: postData,
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log(JSON.stringify(data));
            }
            index = index + 1;
            if (Object.size(rxArray) > index) {
                resetITEVideoWallPresetRecursive(rxArray, index);
            } else {
                showSuccessToast("Reset finish !");
                $(".loading").hide();
            }

        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("set rx video wall - error ");
            }
            index = index + 1;
            if (Object.size(rxArray) > index) {
                resetITEVideoWallPresetRecursive(rxArray, index);
            } else {
                showSuccessToast("Reset finish !");
                $(".loading").hide();
            }
        }
    });
}

/**
 * Reset Video Wall Preset Recursive
 * @param rxArray : rx in the video wall preset
 * @param currentIndex : current handle index
 */
function resetVideoWallPresetRecursive(rxArray, currentIndex) {

    var index = currentIndex;
    var postData = "mac=" + rxArray[currentIndex].mac + "&vwh=1&vwv=1&vwp=1&vwl=0&vwr=0&vwu=0&vwb=0";

    if (isDebugMode) {
        console.log("reset video wall rx = " + postData);
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/set_vw",
        data: postData,
        type: "POST",
        success: function (data) {
            if (isDebugMode) {
                console.log("video wall : " + JSON.stringify(data));
                console.log("rx map size : " + Object.size(rxArray));
            }
            index = index + 1;
            if (Object.size(rxArray) > index) {
                resetVideoWallPresetRecursive(rxArray, index);
            } else {
                showSuccessToast("Reset finish !");
                $(".loading").hide();
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("reset Video Wall Preset Recursive - error ");
            }
            index = index + 1;
            if (Object.size(rxArray) > index) {
                resetVideoWallPresetRecursive(rxArray, index);
            } else {
                showSuccessToast("Reset finish !");
                $(".loading").hide();
            }
        }
    });
}

/**
 * Preset modify save click listener
 */
function presetSaveModifyClickListener() {

    $("#btn-preset-save").click(function () {
        $(".loading").hide();
        saveVideoWallPresetContent(false);
    });

    //ite video wall preset
    // $("#btn-ite-preset-save").click(function () {
    //     saveITEVideoWallPresetContent(false);
    // });
}

/**
 * Save Video Wall Preset Content
 */
function saveVideoWallPresetContent(isNeedApply) {

    var currentPresetIndex = $("#select_preset").val();

    //get preset name
    if ($("#input-preset-name").val().length > 0) {
    } else {
        showWarningToast("Preset name can't be empty");
        $(".loading").hide();
        return false;
    }

    //get TX mac
    if ($("#preset_tx_span").attr("data-mac").length > 0) {
    } else {
        showWarningToast("Transmitters can't be empty");
        $(".loading").hide();
        return false;
    }

    var jsonData = {
        name: $("#input-preset-name").val(),
        index: currentPresetIndex,
        tx_mac: $("#preset_tx_span").attr("data-mac"),
        row: $("#preset-row-count").val(),
        col: $("#preset-col-count").val(),
        rx_list: []
    };

    //check current RX used before or not, and remove it
    $('.preset_screen').each(function (i, obj) {
        if ($(this).find(".inner").find(".content").find(".rx_content").children().length > 0) {
            var rx_json = {
                name: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-name"),
                mac: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-mac"),
                pos: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-pos"),
                vs_shift: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-vw_u"),
                ve_shift: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-vw_b"),
                hs_shift: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-vw_l"),
                he_shift: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-vw_r"),
                rotation: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-rotation")
            }
            jsonData.rx_list.push(rx_json);
        }
    });

    if (isDebugMode) {
        console.log("json data = " + JSON.stringify(jsonData));
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/video_wall_preset",
        data: JSON.stringify(jsonData),
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (isDebugMode) {
                console.log(JSON.stringify(data));
            }
            if (obj.result == "OK") {
                getVideoWallPreset(parseInt(currentPresetIndex) - 1);
                if (isNeedApply) {
                    if (isDebugMode) {
                        console.log("It's need to apply video wall preset !");
                    }
                    applyVideoWallPreset();
                } else {
                    if (isDebugMode) {
                        console.log("Didn't need to apply video wall preset !");
                    }
                    showSuccessToast("Set video wall preset Successful !");
                }
            } else {
                showErrorToast("Set video wall preset failed !");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            showErrorToast("Set video wall preset failed !");
        }
    });
}

/**
 * Save ITE Video Wall Preset Content
 */
// function saveITEVideoWallPresetContent(isNeedApply) {
//
//     var currentPresetIndex = $("#select_ite_preset").val();
//
//     //get preset name
//     if ($("#input-ite-preset-name").val().length > 0) {
//     } else {
//         showWarningToast("Preset name can't be empty");
//         $(".loading").hide();
//         return false;
//     }
//
//     //get TX mac
//     if ($("#ite_preset_tx_span").attr("data-mac").length > 0) {
//     } else {
//         showWarningToast("Transmitters can't be empty");
//         $(".loading").hide();
//         return false;
//     }
//
//     var jsonData = {
//         name: $("#input-ite-preset-name").val(),
//         index: currentPresetIndex,
//         tx_mac: $("#ite_preset_tx_span").attr("data-mac"),
//         row: $("#ite_preset-row-count").val(),
//         col: $("#ite_preset-col-count").val(),
//         rx_list: []
//     };
//
//     //check current RX used before or not, and remove it
//     $('.ite_preset_screen').each(function (i, obj) {
//         if ($(this).find(".inner").find(".content").find(".rx_content").children().length > 0) {
//             var rx_json = {
//                 name: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-name"),
//                 mac: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-mac"),
//                 pos: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-pos"),
//                 ow: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-ow"),
//                 oh: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-oh"),
//                 vw: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-vw"),
//                 vh: $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-vh")
//             }
//             jsonData.rx_list.push(rx_json);
//         }
//     });
//
//     if (isDebugMode) {
//         console.log("json data = " + JSON.stringify(jsonData));
//     }
//
//     $.ajax({
//         url: dbServerInfo.ip + "/api/video_wall_ite_preset",
//         data: JSON.stringify(jsonData),
//         type: "POST",
//         success: function (data) {
//             var obj = jQuery.parseJSON(data);
//             if (isDebugMode) {
//                 console.log(JSON.stringify(data));
//             }
//             if (obj.result == "OK") {
//                 getVideoWallITEPreset(parseInt(currentPresetIndex) - 1);
//                 if (isNeedApply) {
//                     if (isDebugMode) {
//                         console.log("It's need to apply video wall preset !");
//                     }
//                     applyITEVideoWallPreset();
//                 } else {
//                     if (isDebugMode) {
//                         console.log("Didn't need to apply video wall preset !");
//                     }
//                     showSuccessToast("Set video wall preset Successful !");
//                 }
//             } else {
//                 showErrorToast("Set video wall preset failed !");
//             }
//         },
//         error: function (xhr, ajaxOptions, thrownError) {
//             if (isDebugMode) {
//                 console.log("error ");
//             }
//             showErrorToast("Set video wall preset failed !");
//         }
//     });
// }

/**
 * Apply ITE Video Wall Preset
 */
// function applyITEVideoWallPreset() {
//
//     if (isDebugMode) {
//         console.log("Apply ITE Video Wall Preset");
//     }
//
//     $.ajax({
//         url: dbServerInfo.ip + "/api/video_wall_ite_preset",
//         type: "GET",
//         success: function (data) {
//             if (isDebugMode) {
//                 console.log(JSON.stringify(data));
//             }
//             var txGroup = "";
//             var presetIndex = parseInt($("#select_ite_preset").val()) - 1;
//
//             if (typeof txMap[data[presetIndex].tx_mac] === "undefined") {
//                 if (isDebugMode) {
//                     console.log("Apply video wall - tx is null");
//                 }
//                 showWarningToast("Please select transmitter first !");
//                 $(".loading").hide();
//             } else {
//
//                 if (isDebugMode) {
//                     console.log("RX size = " + data[presetIndex].rx_list.length + " tx id = " + txMap[data[presetIndex].tx_mac].id);
//                 }
//
//                 if (data[presetIndex].rx_list.length > 0) {
//                     txGroup = txMap[data[presetIndex].tx_mac].id;
//                     var index = 0;
//
//                     function sendCmdLoop(total, jsonData) {
//
//                         setTimeout(function () {
//                             switchChannel(rxMap[jsonData[presetIndex].rx_list[index].mac].ip, txGroup);
//                             var name = rxMap[jsonData[presetIndex].rx_list[index].mac].name;
//
//                             var col_count = $("#ite_preset-col-count").val();
//                             var row_count = $("#ite_preset-row-count").val();
//
//                             var row = jsonData[presetIndex].rx_list[index].pos / col_count;
//                             var col = jsonData[presetIndex].rx_list[index].pos % col_count;
//
//                             if (row > 1) {
//                                 row = Math.ceil(row) - 1;
//                             } else {
//                                 row = 0;
//                             }
//
//                             if (col > 0) {
//                                 col = col - 1;
//                             } else {
//                                 col = col_count - 1;
//                             }
//
//                             if (isDebugMode) {
//                                 console.log("row = " + row);
//                                 console.log("col = " + col);
//                             }
//
//                             var postData = "mac=" + jsonData[presetIndex].rx_list[index].mac + "&v_count=" + (row_count - 1) + "&h_count=" + (col_count - 1)
//                                 + "&row=" + row + "&col=" + col + "&vw=" + jsonData[presetIndex].rx_list[index].vw + "&ow=" + jsonData[presetIndex].rx_list[index].ow
//                                 + "&vh=" + jsonData[presetIndex].rx_list[index].vh + "&oh=" + jsonData[presetIndex].rx_list[index].oh;
//                             if (isDebugMode) {
//                                 console.log("postData = " + postData);
//                             }
//
//                             $.ajax({
//                                 url: dbServerInfo.ip + "/api/set_ite_vw",
//                                 data: postData,
//                                 type: "POST",
//                                 success: function (data) {
//                                     if (isDebugMode) {
//                                         console.log("applpy video wall - " + name + ": " + JSON.stringify(data));
//                                     }
//                                     var obj = jQuery.parseJSON(data);
//
//
//                                 },
//                                 error: function (xhr, ajaxOptions, thrownError) {
//                                     if (isDebugMode) {
//                                         console.log("error ");
//                                     }
//                                 }
//                             });
//                             //set video wall --- end
//                             index++;
//                             if (index < total) {
//                                 sendCmdLoop(total, jsonData);
//                             } else {
//                                 $(".loading").hide();
//                                 showSuccessToast("Apply video wall preset finish !");
//                             }
//                         }, 500);
//                     }
//
//                     sendCmdLoop(data[presetIndex].rx_list.length, data);
//                 } else {
//                     if (isDebugMode) {
//                         console.log("Didn't have any RX !");
//                     }
//                     $(".loading").hide();
//                     showSuccessToast("Apply video wall preset finish !");
//                 }
//
//                 //   $(".loading").hide();
//             }
//         },
//         error: function (xhr, ajaxOptions, thrownError) {
//             if (isDebugMode) {
//                 console.log("error ");
//             }
//             $(".loading").hide();
//             showSuccessToast("Recall video wall preset failed !");
//         }
//     });
//
//
// }


/**
 * Preset TX selected listener
 */
function presetTXSelectListener() {
    $('.dropdown').on('click', '.preset_tx_li', function () {
        if (isDebugMode) {
            console.log("" + $(this).attr("data-mac"));
        }

        //check device permission
        if (checkDevicePermission($(this).attr("data-mac"))) {
            $("#preset_tx_span").attr("data-mac", $(this).attr("data-mac"));
            $("#preset_tx_span").text($(this).attr("data-name"));
        } else {
            showWarningToast("Sorry ! You don't have this device permission !");
        }

    });

    // $('.dropdown').on('click', '.ite_preset_tx_li', function () {
    //     if (isDebugMode) {
    //         console.log("" + $(this).attr("data-mac"));
    //     }
    //
    //     $("#ite_preset_tx_span").attr("data-mac", $(this).attr("data-mac"));
    //     $("#ite_preset_tx_span").text($(this).attr("data-name"));
    // });
}

/**
 * Preset change listener
 */
function presetChangeListener() {
    $('#select_preset').on('change', function () {
        getVideoWallPreset(parseInt($(this).val()) - 1);
    });

    // $('#select_ite_preset').on('change', function () {
    //     getVideoWallITEPreset(parseInt($(this).val()) - 1);
    // });
}

/**
 *
 * Get Video Wall preset config
 *
 * @param showIndex : show preset content by index (preset index -1 for array to used)
 */
function getVideoWallPreset(showIndex) {

    $.ajax({
        url: dbServerInfo.ip + "/api/video_wall_preset",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log(JSON.stringify(data));
            }

            var error_message = "";
            var presetSelectList = "";

            for (index in data) {
                presetSelectList += " <option value=\"" + data[index].index + "\">" + data[index].name + "</option>";
            }

            $("#select_preset").empty();
            $("#select_preset").append(presetSelectList);
            $("#select_preset").val(parseInt(showIndex) + 1);

            //set first preset content
            $("#input-preset-name").val(data[showIndex].name);
            $("#preset-row-count").val(data[showIndex].row);
            $("#preset-col-count").val(data[showIndex].col);
            presetDrawTVWall(data[showIndex].row, data[showIndex].col);

            for (index in data[showIndex].rx_list) {
                $('.preset_screen').each(function (i, obj) {
                    if ($(this).attr("data-pos") === data[showIndex].rx_list[index].pos) {
                        $(this).find(".inner").find(".content").find(".rx_content").empty();
                        if (typeof rxMap[data[showIndex].rx_list[index].mac] === "undefined") {
                            //error message
                            error_message += "RX - mac is " + data[showIndex].rx_list[index].mac + " isn't exist. \n\n";
                        } else {

                            if (rxMap[data[showIndex].rx_list[index].mac].status != "y") {
                                //error message
                                error_message += "RX - " + data[showIndex].rx_list[index].name + " is offline. \n\n";
                            }


                            $(this).find(".inner").find(".content").find(".rx_content").append("<button id=\"preset_" + data[showIndex].rx_list[index].mac + "\" data-name=\"" + rxMap[data[showIndex].rx_list[index].mac].name
                                + "\"class='draggable btn rx_preset_item' " + "data-mac=\"" + data[showIndex].rx_list[index].mac + "\" data-rotation=\"" +data[showIndex].rx_list[index].rotation + "\" data-vw_l=\"" + data[showIndex].rx_list[index].hs_shift
                                + "\" data-vw_r=\"" + data[showIndex].rx_list[index].he_shift + "\" data-vw_u=\"" + data[showIndex].rx_list[index].vs_shift + "\" data-vw_b=\"" + data[showIndex].rx_list[index].ve_shift +
                                "\" data-pos=\"" + data[showIndex].rx_list[index].pos + "\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px;cursor:pointer;color:white;background-color:rgb(100, 108, 128);" +
                                "display:block;white-space: normal;\"><h4 style=\"padding: 0px;margin: 0px;\">" + rxMap[data[showIndex].rx_list[index].mac].name + "</h4></button>");
                        }
                    }
                });
            }

            if (typeof txMap[data[showIndex].tx_mac] === "undefined") {
                //error message
                if (data[showIndex].tx_mac.length > 0) {
                    error_message += "TX - mac is " + data[showIndex].tx_mac + " isn't exist. \n\n";
                } else {
                    // error_message += "TX is empty.\n\n";
                }
                $("#preset_tx_span").attr("data-mac", "");
                $("#preset_tx_span").text("");
            } else {
                $("#preset_tx_span").attr("data-mac", data[showIndex].tx_mac);
                $("#preset_tx_span").text(txMap[data[showIndex].tx_mac].name);
            }

            // $("#preset-error-message-area").empty();
            // if (error_message.length > 0) {
            //     error_message += "You can modify new contents and click save button to solve it.";
            //     $("#preset-error-message-area").append(error_message);
            // }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
        }
    });
}

// function getVideoWallITEPreset(showIndex) {
//     //get ITE video wall preset
//     $.ajax({
//         url: dbServerInfo.ip + "/api/video_wall_ite_preset",
//         type: "GET",
//         success: function (data) {
//             if (isDebugMode) {
//                 console.log("ITE vw preset = " + JSON.stringify(data));
//             }
//
//             var error_message = "";
//             var presetSelectList = "";
//
//             for (index in data) {
//                 presetSelectList += " <option value=\"" + data[index].index + "\">" + data[index].name + "</option>";
//             }
//
//             $("#select_ite_preset").empty();
//             $("#select_ite_preset").append(presetSelectList);
//             $("#select_ite_preset").val(parseInt(showIndex) + 1);
//
//             //set first preset content
//             $("#input-ite-preset-name").val(data[showIndex].name);
//             $("#ite_preset-row-count").val(data[showIndex].row);
//             $("#ite_preset-col-count").val(data[showIndex].col);
//             presetDrawITETVWall(data[showIndex].row, data[showIndex].col);
//
//             for (index in data[showIndex].rx_list) {
//                 if (isDebugMode) {
//                     console.log("rx ite ");
//                 }
//                 $('.ite_preset_screen').each(function (i, obj) {
//                     if ($(this).attr("data-pos") === data[showIndex].rx_list[index].pos) {
//                         $(this).find(".inner").find(".content").find(".rx_content").empty();
//                         if (typeof rxMap[data[showIndex].rx_list[index].mac] === "undefined") {
//                             //error message
//                             error_message += "RX - mac is " + data[showIndex].rx_list[index].mac + " isn't exist. \n\n";
//                         } else {
//
//                             $(this).find(".inner").find(".content").find(".rx_content").append("<button id=\"ite_preset_" + data[showIndex].rx_list[index].mac + "\" data-name=\"" + rxMap[data[showIndex].rx_list[index].mac].name
//                                 + "\"class='draggable btn rx_ite_preset_item' " + "data-mac=\"" + data[showIndex].rx_list[index].mac + "\" data-ow=\"" + data[showIndex].rx_list[index].ow
//                                 + "\" data-oh=\"" + data[showIndex].rx_list[index].oh + "\" data-vw=\"" + data[showIndex].rx_list[index].vw + "\" data-vh=\"" + data[showIndex].rx_list[index].vh +
//                                 "\" data-pos=\"" + data[showIndex].rx_list[index].pos + "\" draggable=\"true\" ondragstart=\"Drag(event)\" style=\"margin: 5px;cursor:pointer;color:white;background-color:rgb(100, 108, 128);" +
//                                 "display:block;white-space: normal;\"><h4 style=\"padding: 0px;margin: 0px;\">" + rxMap[data[showIndex].rx_list[index].mac].name + "</h4></button>");
//                         }
//                     }
//                 });
//             }
//
//             if (typeof txMap[data[showIndex].tx_mac] === "undefined") {
//                 $("#ite_preset_tx_span").attr("data-mac", "");
//                 $("#ite_preset_tx_span").text("");
//             } else {
//                 $("#ite_preset_tx_span").attr("data-mac", data[showIndex].tx_mac);
//                 $("#ite_preset_tx_span").text(txMap[data[showIndex].tx_mac].name);
//             }
//         },
//         error: function (xhr, ajaxOptions, thrownError) {
//             if (isDebugMode) {
//                 console.log("error ");
//             }
//         }
//     });
// }


/**
 * Warning - Check RX Video Wall info
 */
function warningRXVWRecursive(vwRXinfoArray, currentIndex, vw_h, vw_v, warningMessage) {

    var index = currentIndex;
    $.ajax({
        url: dbServerInfo.ip + "/api/vw_info/" + vwRXinfoArray[index].mac,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
                console.log("vw_h = " + returnData.vw_h + " - " + vw_h);
                console.log("vw_v = " + returnData.vw_v + " - " + vw_v);
                console.log("vw_pos = " + returnData.vw_pos + " - " + vwRXinfoArray[index].pos);
            }


            if (((returnData.vw_h === vw_h) && (returnData.vw_v === vw_v)) || ((returnData.vw_h === "1") && (returnData.vw_v === "1"))) {
                console.log("can do video wall");
            } else {
                console.log("is in the another video wall");
                warningMessage = warningMessage + "\n" + rxMap[vwRXinfoArray[index].mac].name;
            }

            index = index + 1;
            if (Object.size(vwRXinfoArray) > index) {
                warningRXVWRecursive(vwRXinfoArray, index, vw_h, vw_v, warningMessage);
            } else {

                if (warningMessage.length > 0) {
                    setTimeout(
                        function () {
                            $(".loading").hide();
                        }, 1000);
                    warningMessage = warningMessage + "\n is used in other currently active video wall. \n " +
                        "If you enable this video wall, another video wall will be deactivated. Continue?";
                    $("#preset-warning-message-area").empty();
                    $("#preset-warning-message-area").append(warningMessage);

                    setTimeout(
                        function () {
                            $("#warning-modal").modal("show");
                        }, 1500);

                    return
                }
                console.log("warning check finish !");
                saveVideoWallPresetContent(true);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
        }
    });
}

/**
 * Preset apply click listener
 */
function presetApplyClickListener() {
    $("#btn-preset-apply").click(function () {
        $(".loading").show();

        var warning_message = "";
        var row = $("#preset-row-count").val();
        var col = $("#preset-col-count").val();

        warningVWMap = new Map();
        waringVMMapIndex = 0;

        $('.preset_screen').each(function (i, obj) {
            if ($(this).find(".inner").find(".content").find(".rx_content").children().length > 0) {
                var mac = $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-mac")
                var pos = $(this).find(".inner").find(".content").find(".rx_content").children().attr("data-pos")
                warningVWMap[waringVMMapIndex] = new warningVWObject(mac, pos);
                waringVMMapIndex++;
            }
        });

        if (Object.keys(warningVWMap).length > 0) {
            warningRXVWRecursive(warningVWMap, 0, row, col, warning_message);
        } else {
            $(".loading").hide();
            showErrorToast("Didn't have any receivers in this video wall preset !");
        }

        // saveVideoWallPresetContent(true);
    });

    // $("#btn-ite-preset-apply").click(function () {
    //  $(".loading").show();
    // saveITEVideoWallPresetContent(true);
    // });
}

/**
 * Apply Video Wall Preset
 */
function applyVideoWallPreset() {

    if (isDebugMode) {
        console.log("Apply Video Wall Preset");
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/video_wall_preset",
        type: "GET",
        success: function (data) {
            if (isDebugMode) {
                console.log(JSON.stringify(data));
            }
            var txGroup = "";
            var presetIndex = parseInt($("#select_preset").val()) - 1;

            if (typeof txMap[data[presetIndex].tx_mac] === "undefined") {
                //error message
                showWarningToast("Please select transmitter first !");
                $(".loading").hide();
            } else {

                if (data[presetIndex].rx_list.length > 0) {
                    txGroup = txMap[data[presetIndex].tx_mac].id;
                    var index = 0;

                    function sendCmdLoop(total, jsonData) {
                        setTimeout(function () {
                            switchChannel(rxMap[jsonData[presetIndex].rx_list[index].mac].ip, txGroup);
                            var name = rxMap[jsonData[presetIndex].rx_list[index].mac].name;
                            //set video wall --- start
                            // var postData = "mac=" + jsonData[presetIndex].rx_list[index].mac + "&vwh=" + jsonData[presetIndex].col + "&vwv=" + jsonData[presetIndex].row +
                            //     "&vwp=" + jsonData[presetIndex].rx_list[index].pos + "&vwl=" + (parseInt(jsonData[presetIndex].rx_list[index].hs_shift) * -1) + "&vwr=" + (parseInt(jsonData[presetIndex].rx_list[index].he_shift) * -1)
                            //     + "&vwu=" + jsonData[presetIndex].rx_list[index].vs_shift + "&vwb=" + jsonData[presetIndex].rx_list[index].ve_shift+"&rotation=" + jsonData[presetIndex].rx_list[index].rotation;
                            var postData = "mac=" + jsonData[presetIndex].rx_list[index].mac + "&vwh=" + jsonData[presetIndex].col + "&vwv=" + jsonData[presetIndex].row +
                                "&vwp=" + jsonData[presetIndex].rx_list[index].pos + "&vwl=" + (parseInt(jsonData[presetIndex].rx_list[index].hs_shift)) + "&vwr=" + (parseInt(jsonData[presetIndex].rx_list[index].he_shift))
                                + "&vwu=" + jsonData[presetIndex].rx_list[index].vs_shift + "&vwb=" + jsonData[presetIndex].rx_list[index].ve_shift+"&rotation=" + jsonData[presetIndex].rx_list[index].rotation;
                            if (isDebugMode) {
                                console.log("APPLY postData = " + postData);
                            }
                            $.ajax({
                                url: dbServerInfo.ip + "/api/set_vw",
                                data: postData,
                                type: "POST",
                                success: function (data) {
                                    if (isDebugMode) {
                                        console.log("applpy video wall - " + name + ": " + JSON.stringify(data));
                                    }
                                    var obj = jQuery.parseJSON(data);

                                    if (obj.result != "OK") {
                                        var result = "";
                                        switch (obj.result) {

                                            case "L_OUT":
                                                result = " Left Edge Shift out of range !"
                                                break;

                                            case "R_OUT":
                                                result = " Right Edge Shift out of range !"
                                                break;

                                            case "U_OUT":
                                                result = " Top Edge Shift out of range !"
                                                break;

                                            case "B_OUT":
                                                result = " Bottom Edge Shift out of range !"
                                                break;

                                            default:
                                                result = " set video wall failed !"
                                                break;
                                        }
                                        showErrorToast(name + result);
                                    }
                                },
                                error: function (xhr, ajaxOptions, thrownError) {
                                    if (isDebugMode) {
                                        console.log("error ");
                                    }
                                }
                            });
                            //set video wall --- end
                            index++;
                            if (index < total) {
                                sendCmdLoop(total, jsonData);
                            } else {
                                $(".loading").hide();
                                showSuccessToast("Apply video wall preset finish !");
                            }
                        }, 500);
                    }

                    sendCmdLoop(data[presetIndex].rx_list.length, data);
                } else {
                    if (isDebugMode) {
                        console.log("Didn't have any RX !");
                    }
                    $(".loading").hide();
                    showSuccessToast("Apply video wall preset finish !");
                }
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
            $(".loading").hide();
            showSuccessToast("Recall video wall preset failed !");
        }
    });
}

/**
 * switch channel
 * @param rx_ip : rx's IP
 * @param tx_group : tx's group ID
 */
function switchChannel(rx_ip, tx_group) {

    if (isDebugMode) {
        console.log("switch cmd = " + "ip=" + rx_ip + "&switch_id=" + tx_group + "&switch_type=z");
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/astswitch",
        data: "ip=" + rx_ip + "&switch_id=" + tx_group + "&switch_type=z",
        type: "POST",
        success: function (data) {
            if (isDebugMode) {
                console.log("switch = " + JSON.stringify(data));
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("error ");
            }
        }
    });
}

/**
 * Clean preset video wall RX
 */
function presetVideoWallNumberClickListener() {
    $(".preset_circle").click(function () {
        $(this).parent().find(".rx_content").empty();
    });
}

/**
 * Multiple Bezel Apply button click event
 */
function multipleBezelApplyBtClickEvent() {

    $("#bt-mul-bezel-apply").click(function () {
        $(".loading").show();
        if (isDebugMode) {
            console.log("multiple Bezel Apply Bt ClickEvent");
        }
        var rxArray = new Object();
        var index = 0;
        var checkUserHasSelected = false;

        $(".rx-multiple-event").each(function () {
            if ($(this).hasClass("btn-primary")) {
                if (isDebugMode) {
                    console.log("mac " + $(this).attr("data-mac"));
                }
                rxArray[index] = new rxObject("", $(this).attr("data-name"), "", $(this).attr("data-mac"), "", "");
                index++;
                checkUserHasSelected = true;
            }
        });

        if (checkUserHasSelected) {
            if (isDebugMode) {
                console.log("vw_l " + $("#input_multiple_hss").val());
                console.log("vw_r " + $("#input_multiple_hls").val());
                console.log("vw_u " + $("#input_multiple_vss").val());
                console.log("vw_b " + $("#input_multiple_vls").val());
            }
            // setRXVideoWallRecursive(rxArray, 0, parseInt($("#input_multiple_hss").val()) * (-1), parseInt($("#input_multiple_hls").val()) * (-1),
            //     $("#input_multiple_vss").val(), $("#input_multiple_vls").val());
            setRXVideoWallRecursive(rxArray, 0, parseInt($("#input_multiple_hss").val()), parseInt($("#input_multiple_hls").val()) ,
                $("#input_multiple_vss").val(), $("#input_multiple_vls").val());
        } else {
            $(".loading").hide();
            showWarningToast("Please select at least one receiver !");
        }
    });
}

/**
 * Set RX Video Wall Recursive
 * @param rxArray : user selected RX list
 * @param currentIndex : current handle index
 */
function setRXVideoWallRecursive(rxArray, currentIndex, vw_l, vw_r, vw_u, vw_b) {

    var index = currentIndex;

    $.ajax({
        url: dbServerInfo.ip + "/api/vw_info/" + rxArray[index].mac,
        type: "GET",
        crossDomain: true,
        dataType: 'json',
        success: function (returnData) {
            if (isDebugMode) {
                console.log("success" + JSON.stringify(returnData));
            }

            setRXVideoWall(rxArray[index].name, rxArray[index].mac, returnData.vw_h, returnData.vw_v, returnData.vw_pos, vw_l, vw_r, vw_u, vw_b);

            index = index + 1;
            if (Object.size(rxArray) > index) {
                setRXVideoWallRecursive(rxArray, index, vw_l, vw_r, vw_u, vw_b);
            } else {
                if (isDebugMode) {
                    console.log("finish 1");
                }
                $(".loading").hide();
                showSuccessToast("Set multiple RX bezel finish !");
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("get multiple rx video wall settings error");
            }
            index = index + 1;
            if (Object.size(rxArray) > index) {
                setRXVideoWallRecursive(rxArray, index, vw_l, vw_r, vw_u, vw_b);
            } else {
                if (isDebugMode) {
                    console.log("finish 2");
                }
                $(".loading").hide();
                showSuccessToast("Set multiple RX bezel finish !");
            }
        }
    });
}

/**
 * Set RX Video Wall Settings
 * @param mac : mac address
 * @param row : row count
 * @param col : col count
 * @param vw_l : left shifts
 * @param vw_r : right shifts
 * @param vw_u : top shifts
 * @param vw_b : bottom shifts
 */
function setRXVideoWall(name, mac, col, row, pos, vw_l, vw_r, vw_u, vw_b) {
    if (isDebugMode) {
        console.log("mac " + mac);
        console.log("row " + row);
        console.log("col " + col);
        console.log("pos " + pos);
        console.log("vw_l " + vw_l);
        console.log("vw_r " + vw_r);
        console.log("vw_u " + vw_u);
        console.log("vw_b " + vw_b);
    }

    var postData = "mac=" + mac + "&vwh=" + col + "&vwv=" + row + "&vwp=" + pos + "&vwl="
        + vw_l + "&vwr=" + vw_r + "&vwu=" + vw_u + "&vwb=" + vw_b;

    if (isDebugMode) {
        console.log("postData = " + postData);
    }

    $.ajax({
        url: dbServerInfo.ip + "/api/set_vw",
        data: postData,
        type: "POST",
        success: function (data) {
            var obj = jQuery.parseJSON(data);
            if (obj.result != "OK") {
                if (isDebugMode) {
                    console.log("set rx video wall - failed " + JSON.stringify(data));
                }
                var result = "";
                switch (obj.result) {

                    case "L_OUT":
                        result = " Left Edge Shift out of range !"
                        break;

                    case "R_OUT":
                        result = " Right Edge Shift out of range !"
                        break;

                    case "U_OUT":
                        result = " Top Edge Shift out of range !"
                        break;

                    case "B_OUT":
                        result = " Bottom Edge Shift out of range !"
                        break;

                    default:
                        result = " set failed !"
                        break;
                }
                showErrorToast(name + result);
            } else {
                if (isDebugMode) {
                    console.log("set rx video wall - success " + JSON.stringify(data));
                }
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            if (isDebugMode) {
                console.log("set rx video wall - error ");
            }
            showErrorToast(name + " is setting failed !");
        }
    });
}

/**
 * Single RX Video Wall apply change Listener
 */
function simpleRXVWChangeListener() {
    $('#select_rx_advanced_option').on('change', function () {
        $("#btn-single-video-wall-apply").attr("data-mac", $(this).val());
        //initialSingleVideoWall(false);
    });
}

/**
 * Initial Single Video Wall
 */
function initialSingleVideoWall(isInitial) {


    if (isInitial) {

        if ($("#select_rx_advanced_option").children().length > 0) {

            $("#btn-single-video-wall-apply").attr("data-mac", $('#select_rx_advanced_option').children().eq(0).attr("data-mac"));

            $.ajax({
                url: dbServerInfo.ip + "/api/vw_info/" + $("#btn-single-video-wall-apply").attr("data-mac"),
                type: "GET",
                crossDomain: true,
                dataType: 'json',
                success: function (returnData) {
                    // console.log("vw_info = " + JSON.stringify(returnData));
                    //  $("#single-vw-row-count").val(returnData.vw_v);
                    //  $("#single-vw-col-count").val(returnData.vw_h);
                    //   $("#ite-video-wall-pos").val(returnData.vw_pos);
                },
                error: function (xhr, ajaxOptions, thrownError) {

                }
            });
        }

    } else {
        // $.ajax({
        //     url: dbServerInfo.ip + "/api/vw_info/" + $("#btn-single-video-wall-apply").attr("data-mac"),
        //     type: "GET",
        //     crossDomain: true,
        //     dataType: 'json',
        //     success: function (returnData) {
        //         console.log("success" + JSON.stringify(returnData));
        //         $("#single-vw-row-count").val(returnData.vw_v);
        //         $("#single-vw-col-count").val(returnData.vw_h);
        //        // $("#ite-video-wall-pos").val(returnData.vw_pos);
        //     },
        //     error: function (xhr, ajaxOptions, thrownError) {
        //
        //     }
        // });
    }

}


/**
 * Single Video Wall Apply
 */
function singleVideoWallApply() {

    $("#btn-single-video-wall-apply").click(function () {

        console.log("btn-single-video-wall-apply");

        var ow, oh, vw, vh;

        if ($(this).attr("data-mac") != "") {

        } else {
            showErrorToast("Receiver can't be empty !");
            return;
        }

        if ($("#input-video-wall-ow").val().length > 0) {
            ow = $("#input-video-wall-ow").val();
        } else {
            showErrorToast("OW can't be empty !");
            return;
        }

        if ($("#input-video-wall-oh").val().length > 0) {
            oh = $("#input-video-wall-oh").val();
        } else {
            showErrorToast("OH can't be empty !");
            return;
        }

        if ($("#input-video-wall-vw").val().length > 0) {
            vw = $("#input-video-wall-vw").val();

            if (parseInt(vw) > parseInt(ow)) {
                if (isDebugMode) {
                    console.log("vw = " + vw + " ow = " + ow);
                }
                showErrorToast("VW can't bigger than OW !");
                return;
            }
        } else {
            showErrorToast("VW can't be empty !");
            return;
        }

        if ($("#input-video-wall-vh").val().length > 0) {
            vh = $("#input-video-wall-vh").val();
            if (parseInt(vh) > parseInt(oh)) {
                showErrorToast("VH can't bigger than OH !");
                return;
            }
        } else {
            showErrorToast("VH can't be empty !");
            return;
        }

        if ($("#single-vw-video-wall-row").val().length > 0) {

            if (parseInt($("#single-vw-video-wall-row").val()) >= 0) {

            } else {
                showErrorToast("Row Position must be positive !");
                return;
            }

            if (parseInt($("#single-vw-video-wall-row").val()) < parseInt($("#single-vw-row-count").val())) {

            } else {
                showErrorToast("Row Position must smaller than Row count !");
                return;
            }

        } else {
            showErrorToast("Row Position can't be empty !");
            return;
        }


        if ($("#single-vw-video-wall-col").val().length > 0) {

            if (parseInt($("#single-vw-video-wall-col").val()) >= 0) {

            } else {
                showErrorToast("Column Position must be positive !");
                return;
            }

            if (parseInt($("#single-vw-video-wall-col").val()) < parseInt($("#single-vw-col-count").val())) {

            } else {
                showErrorToast("Column Position must smaller than Column count !");
                return;
            }

        } else {
            showErrorToast("Column Position can't be empty !");
            return;
        }

        var postData = "mac=" + $(this).attr("data-mac") + "&v_count=" + ($("#single-vw-row-count").val() - 1) + "&h_count=" + ($("#single-vw-col-count").val() - 1)
            + "&row=" + $("#single-vw-video-wall-row").val() + "&col=" + $("#single-vw-video-wall-col").val() + "&vw=" + parseInt(vw) + "&ow=" + parseInt(ow) + "&vh=" + parseInt(vh) + "&oh=" + parseInt(oh);

        if (isDebugMode) {
            console.log("postData = " + postData);
        }

        $.ajax({
            url: dbServerInfo.ip + "/api/set_ite_vw",
            data: postData,
            type: "POST",
            success: function (data) {
                var obj = jQuery.parseJSON(data);
                if (obj.result != "OK") {
                    if (isDebugMode) {
                        console.log("set video wall failed !" + JSON.stringify(data));
                    }
                } else {
                    if (isDebugMode) {
                        console.log("set video wall success !" + JSON.stringify(data));
                    }
                    showSuccessToast("set video wall successfully !");
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                if (isDebugMode) {
                    console.log("set rx video wall - error ");
                }
                showErrorToast("set video wall failed !");
            }
        });
    });
}